#!@PYTHON@
# -*- coding: utf-8 -*-
#
# fx001.py -- classes for Korg Krome Music Workstation
#
# (c) 2014  Brian M. Ames <bmames@apk.net>

__all__ = ['mode2param_dict']

from toneadjust import tone_adjust_assign_dict

#===============================================================================
mode2param_dict = {
	0x00 :  {
						# P1 Basic/Controllers
						# {0:'Off',1:'SW1 Mod. (CC#80)'2,:'Porta.SW (CC#65)',3:'Octave Down',4:'Octave Up',5:'JS X Lock',6:'JS Y Lock',7:'JS+Y Lock',8:'JS-Y Lock',}
						# {0:'Off',1:'SW2 Mod. (CC#81)'2,:'Porta.SW (CC#65)',3:'Octave Down',4:'Octave Up',5:'JS X Lock',6:'JS Y Lock',7:'JS+Y Lock',8:'JS-Y Lock',}
						# {0:'Toggle', 1:'Momentary'}
						0x00 : {'offset':846,'bit':4,'bits':5,'parameter':'Main Category','range':(0,17),'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x00},
						0x01 : {'offset':846,'bit':7,'bits':3,'parameter':'Sub Category','range':(0,7),'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x01},
						0x02 : {'offset':836,'bit':5,'bits':1,'parameter':'OSC Mode Favorite','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x02},
						0x03 : {'offset':843,'bit':4,'bits':5,'parameter':'Bus(IFX/Output) Select','range':(0,0x0C),'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x03},# 0x00
						0x04 : {'offset':843,'bit':6,'bits':2,'parameter':'FX Control Bus','range':(0,0x02),'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x04},# 0x00
						0x05 : {'offset':843,'bit':7,'bits':1,'parameter':'Use DKit Setting','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x05},# 0x00
						0x06 : {'offset':850,'bit':5,'bits':6,'parameter':'Switch 1 Assign','range':{0:'Off',1:'SW1 Mod. (CC#80)',2:'Porta.SW (CC#65)',3:'Octave Down',4:'Octave Up',5:'JS X Lock',6:'JS Y Lock',7:'JS+Y Lock',8:'JS-Y Lock',},'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x06},
						0x07 : {'offset':851,'bit':5,'bits':6,'parameter':'Switch 2 Assign','range':{0:'Off',1:'SW2 Mod. (CC#81)',2:'Porta.SW (CC#65)',3:'Octave Down',4:'Octave Up',5:'JS X Lock',6:'JS Y Lock',7:'JS+Y Lock',8:'JS-Y Lock',},'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x07},
						0x08 : {'offset':850,'bit':7,'bits':1,'parameter':'Switch 1 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x08},
						0x09 : {'offset':851,'bit':7,'bits':1,'parameter':'Switch 2 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x09},
						0x0A : {'offset':850,'bit':6,'bits':1,'parameter':'Switch 1 Mode','range':{0:'Toggle', 1:'Momentary'},'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x0A},
						0x0B : {'offset':851,'bit':6,'bits':1,'parameter':'Switch 2 Mode','range':{0:'Toggle', 1:'Momentary'},'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x0B},
						0x0C : {'offset':852,'bit':7,'bits':8,'parameter':'RT Knob-1 Assign','range':(0,0x8E),'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x0C},
						0x0D : {'offset':853,'bit':7,'bits':8,'parameter':'RT Knob-2 Assign','range':(0,0x8E),'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x0D},
						0x0E : {'offset':854,'bit':7,'bits':8,'parameter':'RT Knob-3 Assign','range':(0,0x8E),'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x0E},
						0x0F : {'offset':855,'bit':7,'bits':8,'parameter':'RT Knob-4 Assign','range':(0,0x8E),'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x0F},
						0x10 : {'offset':632,'bit':7,'bits':8,'parameter':'Control Assign','range':{0:'Tone',1:'User',2:'Arp'},'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x10},# 0x02
						0x12 : {'offset':932,'bit':7,'bits':8,'parameter':'OSC1 Patch Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x12},# 0x7E
						0x13 : {'offset':933,'bit':7,'bits':8,'parameter':'OSC2 Patch Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x13},# 0x7E
						0x14 : {'offset':932,'bit':7,'bits':1,'parameter':'OSC1 Mute','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x14},# 0x01
						0x15 : {'offset':933,'bit':7,'bits':1,'parameter':'OSC2 Mute','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x15},# 0x01
						0x16 : {'offset':-1,'bit':7,'bits':1,'parameter':'OSC1 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x16},# 0x01
						0x17 : {'offset':-1,'bit':7,'bits':1,'parameter':'OSC2 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x17},# 0x01
						0x18 : {'offset':934,'bit':7,'bits':8,'parameter':'OSC 1 Picture','range':(0,0x35),'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x18},# 0x01
						0x19 : {'offset':935,'bit':7,'bits':8,'parameter':'OSC 2 Picture','range':(0,0x35),'bias':0,'step':None,'mode':0x02,'id':0x00,'subid':0x19},# 0x03
					},
	0x01 :  {
						0x00 : {'offset':896,'bit':7,'bits':8,'parameter':'Tone Adjust Switch 1 Assign','range':tone_adjust_assign_dict,'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x00},
						0x01 : {'offset':897,'bit':7,'bits':8,'parameter':'Tone Adjust Switch 1 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x01},
						0x02 : {'offset':898,'bit':7,'bits':16,'parameter':'Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x02},
						0x03 : {'offset':900,'bit':7,'bits':8,'parameter':'Tone Adjust Switch 2 Assign','range':tone_adjust_assign_dict,'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x03},
						0x04 : {'offset':901,'bit':7,'bits':8,'parameter':'Tone Adjust Switch 2 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x04},
						0x05 : {'offset':902,'bit':7,'bits':16,'parameter':'Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x05},
						0x06 : {'offset':904,'bit':7,'bits':8,'parameter':'Tone Adjust Switch 3 Assign','range':tone_adjust_assign_dict,'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x06},
						0x07 : {'offset':905,'bit':7,'bits':8,'parameter':'Tone Adjust Switch 3 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x07},
						0x08 : {'offset':906,'bit':7,'bits':16,'parameter':'Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x08},
						0x09 : {'offset':908,'bit':7,'bits':8,'parameter':'Tone Adjust Switch 4 Assign','range':tone_adjust_assign_dict,'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x09},
						0x0A : {'offset':909,'bit':7,'bits':8,'parameter':'Tone Adjust Switch 4 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x0A},
						0x0B : {'offset':910,'bit':7,'bits':16,'parameter':'Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x0B},
						0x0C : {'offset':912,'bit':7,'bits':8,'parameter':'Tone Adjust Switch 5 Assign','range':tone_adjust_assign_dict,'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x0C},
						0x0D : {'offset':913,'bit':7,'bits':8,'parameter':'Tone Adjust Switch 5 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x0D},
						0x0E : {'offset':914,'bit':7,'bits':16,'parameter':'Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x0E},
						0x0F : {'offset':916,'bit':7,'bits':8,'parameter':'Tone Adjust Switch 6 Assign','range':tone_adjust_assign_dict,'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x0F},
						0x10 : {'offset':917,'bit':7,'bits':8,'parameter':'Tone Adjust Switch 6 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x10},
						0x11 : {'offset':918,'bit':7,'bits':16,'parameter':'Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x11},
						0x12 : {'offset':920,'bit':7,'bits':8,'parameter':'Tone Adjust Switch 7 Assign','range':tone_adjust_assign_dict,'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x12},
						0x13 : {'offset':921,'bit':7,'bits':8,'parameter':'Tone Adjust Switch 7 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x13},
						0x14 : {'offset':922,'bit':7,'bits':16,'parameter':'Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x14},
						0x15 : {'offset':924,'bit':7,'bits':8,'parameter':'Tone Adjust Switch 8 Assign','range':tone_adjust_assign_dict,'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x15},
						0x16 : {'offset':925,'bit':7,'bits':8,'parameter':'Tone Adjust Switch 8 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x16},
						0x17 : {'offset':926,'bit':7,'bits':16,'parameter':'Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x17},
						0x18 : {'offset':864,'bit':7,'bits':8,'parameter':'Tone Adjust Slider 1 Assign','range':tone_adjust_assign_dict,'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x18},
						0x19 : {'offset':866,'bit':7,'bits':16,'parameter':'Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x19},
						0x1A : {'offset':868,'bit':7,'bits':8,'parameter':'Tone Adjust Slider 2 Assign','range':tone_adjust_assign_dict,'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x1A},
						0x1B : {'offset':870,'bit':7,'bits':16,'parameter':'Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x1B},
						0x1C : {'offset':872,'bit':7,'bits':8,'parameter':'Tone Adjust Slider 3 Assign','range':tone_adjust_assign_dict,'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x1C},
						0x1D : {'offset':874,'bit':7,'bits':16,'parameter':'Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x1D},
						0x1E : {'offset':876,'bit':7,'bits':8,'parameter':'Tone Adjust Slider 4 Assign','range':tone_adjust_assign_dict,'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x1E},
						0x1F : {'offset':878,'bit':7,'bits':16,'parameter':'Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x1F},
						0x20 : {'offset':880,'bit':7,'bits':8,'parameter':'Tone Adjust Slider 5 Assign','range':tone_adjust_assign_dict,'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x20},
						0x21 : {'offset':882,'bit':7,'bits':16,'parameter':'Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x21},
						0x22 : {'offset':884,'bit':7,'bits':8,'parameter':'Tone Adjust Slider 6 Assign','range':tone_adjust_assign_dict,'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x22},
						0x23 : {'offset':886,'bit':7,'bits':16,'parameter':'Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x23},
						0x24 : {'offset':888,'bit':7,'bits':8,'parameter':'Tone Adjust Slider 7 Assign','range':tone_adjust_assign_dict,'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x24},
						0x25 : {'offset':890,'bit':7,'bits':16,'parameter':'Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x25},
						0x26 : {'offset':892,'bit':7,'bits':8,'parameter':'Tone Adjust Slider 8 Assign','range':tone_adjust_assign_dict,'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x26},
						0x27 : {'offset':894,'bit':7,'bits':16,'parameter':'Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x02,'id':0x01,'subid':0x27},

					},
	0x02 :  {
					},
	0x03 :  {
					},
	0x04 :  {
					},
	0x05 :  {
					},
	0x06 :  {
						0x00 : {'offset':792,'bit':7,'bits':16,'parameter':'Arp Tempo','range':(0xFA0,0x7530),'bias':0,'step':None,'mode':0x02,'id':0x06,'subid':0x00},
						0x01 : {'offset':794,'bit':7,'bits':8,'parameter':'Arp Switch','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x06,'subid':0x01},
						0x02 : {'offset':796,'bit':7,'bits':8,'parameter':'Arp Gate','range':(-0x40,0x3F),'bias':0,'step':None,'mode':0x02,'id':0x06,'subid':0x02},
						0x03 : {'offset':797,'bit':7,'bits':8,'parameter':'Arp Velocity','range':(-0x40,0x3F),'bias':0,'step':None,'mode':0x02,'id':0x06,'subid':0x03},
						0x04 : {'offset':798,'bit':7,'bits':8,'parameter':'Arp Swing','range':(-0x40,0x3F),'bias':0,'step':None,'mode':0x02,'id':0x06,'subid':0x04},
						0x05 : {'offset':799,'bit':7,'bits':8,'parameter':'Arp Step','range':(-0x40,0x3F),'bias':0,'step':None,'mode':0x02,'id':0x06,'subid':0x05},
					},
	0x07 :  {
						0x00 : {'offset':800,'bit':7,'bits':16,'parameter':'Arp Pattern','range':(0,0x408),'bias':0,'step':None,'mode':0x02,'id':0x07,'subid':0x00},
						0x01 : {'offset':802,'bit':1,'bits':2,'parameter':'Arp Resolution','range':{0:'16T', 1:'16', 2:'8T', 3:'8', 4:'4T', 5:'4', 6:'32T', 7:'32'},'bias':0,'step':None,'mode':0x02,'id':0x07,'subid':0x01},
						0x02 : {'offset':802,'bit':4,'bits':3,'parameter':'Arp Octave','range':(0,0x03),'bias':1,'step':1,'mode':0x02,'id':0x07,'subid':0x02},
						0x03 : {'offset':804,'bit':7,'bits':8,'parameter':'Arp Gate','range':{(0,0x64):'%',65:'Step'},'bias':0,'step':None,'mode':0x02,'id':0x07,'subid':0x03},
						0x04 : {'offset':805,'bit':7,'bits':8,'parameter':'Arp Velocity','range':{(1,0x7F):'',80:'Key', 81:'Step'},'bias':0,'step':None,'mode':0x02,'id':0x07,'subid':0x04},
						0x05 : {'offset':806,'bit':7,'bits':8,'parameter':'Arp Swing','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x07,'subid':0x05},
						0x06 : {'offset':803,'bit':0,'bits':1,'parameter':'Arp Sort','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x07,'subid':0x06},
						0x07 : {'offset':803,'bit':1,'bits':1,'parameter':'Arp Latch','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x07,'subid':0x07},
						0x08 : {'offset':803,'bit':2,'bits':1,'parameter':'Arp Key Sync.','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x07,'subid':0x08},
						0x09 : {'offset':803,'bit':3,'bits':1,'parameter':'Arp Keyboard','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x07,'subid':0x09},
						0x0A : {'offset':807,'bit':7,'bits':8,'parameter':'Top Key','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x07,'subid':0x0A},
						0x0B : {'offset':808,'bit':7,'bits':8,'parameter':'Arp Bottom Key','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x07,'subid':0x0B},
						0x0C : {'offset':809,'bit':7,'bits':8,'parameter':'Arp Top Velocity','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x07,'subid':0x0C},
						0x0D : {'offset':810,'bit':7,'bits':8,'parameter':'Arp Bottom Velocity','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x07,'subid':0x0D},
					},
	0x08 :  {
						0x00 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x08,'subid':0x00},# 0x62
						0x01 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x08,'subid':0x01},# 0x01
						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x08,'subid':0x02},# 0x53
						0x03 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x08,'subid':0x03},# 0x0F
						0x04 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x08,'subid':0x04},# 0x03
						0x05 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x08,'subid':0x05},# 0x03
					},
	0x09 :  {
						0x00 : {'offset':616,'bit':7,'bits':8,'parameter':'LFO1 Frequency [Hz]','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x09,'subid':0x00},
						0x01 : {'offset':617,'bit':7,'bits':8,'parameter':'LFO1 Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x09,'subid':0x01},
						0x02 : {'offset':618,'bit':7,'bits':8,'parameter':'LFO1 Source','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x09,'subid':0x02},
						0x03 : {'offset':619,'bit':7,'bits':8,'parameter':'LFO1 MIDI Channel','range':(0x10,0x10),'bias':0,'step':None,'mode':0x02,'id':0x09,'subid':0x03},
						0x04 : {'offset':620,'bit':7,'bits':16,'parameter':'LFO1 BPM','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x09,'subid':0x04},
						0x05 : {'offset':622,'bit':3,'bits':4,'parameter':'LFO1 Base Note','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x09,'subid':0x05},
						0x06 : {'offset':622,'bit':7,'bits':1,'parameter':'LFO1 MIDI/Tempo Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x09,'subid':0x06},
						0x07 : {'offset':623,'bit':7,'bits':8,'parameter':'LFO1 MIDI Sync Time','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x09,'subid':0x07},
					},
	0x0A :  {
						0x00 : {'offset':624,'bit':7,'bits':8,'parameter':'LFO2 Frequency [Hz]','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0A,'subid':0x00},
						0x01 : {'offset':625,'bit':7,'bits':8,'parameter':'LFO2 Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x0A,'subid':0x01},
						0x02 : {'offset':626,'bit':7,'bits':8,'parameter':'LFO2 Source','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0A,'subid':0x02},
						0x03 : {'offset':627,'bit':7,'bits':8,'parameter':'LFO2 MIDI Channel','range':(0x10,0x10),'bias':0,'step':None,'mode':0x02,'id':0x0A,'subid':0x03},
						0x04 : {'offset':628,'bit':7,'bits':16,'parameter':'LFO2 BPM','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0A,'subid':0x04},
						0x05 : {'offset':630,'bit':3,'bits':4,'parameter':'LFO2 Base Note','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0A,'subid':0x05},
						0x06 : {'offset':630,'bit':7,'bits':1,'parameter':'LFO2 MIDI/Tempo Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x0A,'subid':0x06},
						0x07 : {'offset':631,'bit':7,'bits':8,'parameter':'LFO2 MIDI Sync Time','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0A,'subid':0x07},
					},
	0x0B :  {
						0x00 : {'offset':638,'bit':7,'bits':8,'parameter':'Drum Track Pattern Bank','range':{0:'Preset', 1:'User'},'bias':0,'step':None,'mode':0x02,'id':0x0B,'subid':0x00},# 0x01
						0x01 : {'offset':636,'bit':7,'bits':16,'parameter':'Drum Track Pattern Number','range':(0,0x3E7),'bias':0,'step':None,'mode':0x02,'id':0x0B,'subid':0x01},# 0x29
						0x02 : {'offset':639,'bit':0,'bits':1,'parameter':'Mode','range':{0:'Start Immediately',1:'Wait KBD Trigger'},'bias':0,'step':None,'mode':0x02,'id':0x0B,'subid':0x02},# 0x00
						0x03 : {'offset':639,'bit':2,'bits':2,'parameter':'Latch','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x0B,'subid':0x03},# 0x01
						0x04 : {'offset':639,'bit':3,'bits':1,'parameter':'Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x0B,'subid':0x04},# 0x00
						0x05 : {'offset':640,'bit':7,'bits':8,'parameter':'Keyboard Bottom','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0B,'subid':0x05},# 0x00
						0x06 : {'offset':641,'bit':7,'bits':8,'parameter':'Keyboard Top','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0B,'subid':0x06},# 0x7F
						0x07 : {'offset':642,'bit':7,'bits':8,'parameter':'Velocity Bottom','range':(1,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0B,'subid':0x07},# 0x01
						0x08 : {'offset':643,'bit':7,'bits':8,'parameter':'Velocity Top','range':(1,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0B,'subid':0x08},# 0x7F
						0x09 : {'offset':644,'bit':7,'bits':8,'parameter':'Shift','range':(-0x18,0x18),'bias':0,'step':None,'mode':0x02,'id':0x0B,'subid':0x09},# 0x00
						0x0A : {'offset':639,'bit':4,'bits':1,'parameter':'Drum Track On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x0B,'subid':0x0A},# 0x01
					},
	0x0C :  {
						0x00 : {'offset':830,'bit':7,'bits':16,'parameter':'Drum Track Program','range':(0,2047),'bias':0,'step':None,'mode':0x02,'id':0x0C,'subid':0x00},# 0x11
						0x01 : {'offset':832,'bit':7,'bits':8,'parameter':'Drum Track Volume','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0C,'subid':0x01},# 0x5A
						0x02 : {'offset':829,'bit':1,'bits':1,'parameter':'Drum Track Timbre Mute','range':{0:'Play',1:'Mute'},'bias':0,'step':None,'mode':0x02,'id':0x0C,'subid':0x02},
						0x04 : {'offset':829,'bit':0,'bits':1,'parameter':'Auto Load Program EQ','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0C,'subid':0x04},# 0x01
						0x05 : {'offset':812,'bit':7,'bits':1,'parameter':'Bypass','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x0C,'subid':0x05},# 0x01
						0x06 : {'offset':812,'bit':6,'bits':7,'parameter':'Input Trim','range':(0,0x63),'bias':0,'step':None,'mode':0x02,'id':0x0C,'subid':0x06},# 0x63
						0x07 : {'offset':815,'bit':7,'bits':8,'parameter':'Drum Track Low Gain','range':(-0x24,0x24),'bias':0,'step':0.5,'mode':0x02,'id':0x0C,'subid':0x07},# 0x01
#						Step = 10 for 0-0x28, 20 for 0x28-0x41,50 for 0x41-0x55, 100 for 0x55-0xA5
						0x08 : {'offset':814,'bit':7,'bits':8,'parameter':'Drum Track Mid Freq','range':(0,0xA5),'bias':100,'step':lambda value:(value*10 if value<=0x28 else 400+(value-0x28)*20 if value<=0x41 else 900+(value-0x41)*50 if value <=0x55 else 1900+(value-0x55)*100)+100,'mode':0x02,'id':0x0C,'subid':0x08},# 0x61
						0x09 : {'offset':816,'bit':7,'bits':8,'parameter':'Drum Track Mid Gain','range':(-0x24,0x24),'bias':0,'step':0.5,'mode':0x02,'id':0x0C,'subid':0x09},# 0x07
						0x0A : {'offset':817,'bit':7,'bits':8,'parameter':'Drum Track High Gain','range':(-0x24,0x24),'bias':0,'step':0.5,'mode':0x02,'id':0x0C,'subid':0x0A},# 0x03
						0x0B : {'offset':827,'bit':5,'bits':6,'parameter':'Bus Select','range':{0:'DKit',1:'L/R',2:'IFX1',3:'IFX2',4:'IFX3',5:'IFX4',6:'IFX5',13:'Off'},'bias':0,'step':None,'mode':0x02,'id':0x0C,'subid':0x0B},
						0x0C : {'offset':827,'bit':7,'bits':2,'parameter':'FX Control Bus','range':{0:'Off', 1:'FX Ctrl1', 2:'FX Ctrl2'},'bias':0,'step':None,'mode':0x02,'id':0x0C,'subid':0x0C},# 0x00
						0x0E : {'offset':833,'bit':7,'bits':8,'parameter':'Drum Track Send1','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0C,'subid':0x0E},# 0x00
						0x0F : {'offset':834,'bit':7,'bits':8,'parameter':'Drum Track Send2','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0C,'subid':0x0F},# 0x0B
						0x10 : {'offset':822,'bit':7,'bits':8,'parameter':'IFX 1 Patch','range':{0:'L/R',1:'IFX1',2:'IFX2',3:'IFX3',4:'IFX4',5:'IFX5',12:'OFF'},'bias':0,'step':None,'mode':0x02,'id':0x0C,'subid':0x10},# 0x00
						0x11 : {'offset':823,'bit':7,'bits':8,'parameter':'IFX 2 Patch','range':{0:'L/R',1:'IFX1',2:'IFX2',3:'IFX3',4:'IFX4',5:'IFX5',12:'OFF'},'bias':0,'step':None,'mode':0x02,'id':0x0C,'subid':0x11},# 0x00
						0x12 : {'offset':824,'bit':7,'bits':8,'parameter':'IFX 3 Patch','range':{0:'L/R',1:'IFX1',2:'IFX2',3:'IFX3',4:'IFX4',5:'IFX5',12:'OFF'},'bias':0,'step':None,'mode':0x02,'id':0x0C,'subid':0x12},# 0x00
						0x13 : {'offset':825,'bit':7,'bits':8,'parameter':'IFX 4 Patch','range':{0:'L/R',1:'IFX1',2:'IFX2',3:'IFX3',4:'IFX4',5:'IFX5',12:'OFF'},'bias':0,'step':None,'mode':0x02,'id':0x0C,'subid':0x13},# 0x00
						0x14 : {'offset':826,'bit':7,'bits':8,'parameter':'IFX 5 Patch','range':{0:'L/R',1:'IFX1',2:'IFX2',3:'IFX3',4:'IFX4',5:'IFX5',12:'OFF'},'bias':0,'step':None,'mode':0x02,'id':0x0C,'subid':0x14},# 0x01
						0x15 : {'offset':-1,'bit':7,'bits':8,'parameter':'Drum Track Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x0C,'subid':0x15},#Note Not in table 1
					},
	0x0D :  {
						# Insert Effect 1-5 Parameters
						0x00 : {'offset': 88,'bit':7,'bits':8,'parameter':'IFX1 Effect Type','range':(0,0xC1),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x00},
						0x01 : {'offset':164,'bit':7,'bits':8,'parameter':'IFX2 Effect Type','range':(0,0xC1),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x01},
						0x02 : {'offset':240,'bit':7,'bits':8,'parameter':'IFX3 Effect Type','range':(0,0xC1),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x02},
						0x03 : {'offset':316,'bit':7,'bits':8,'parameter':'IFX4 Effect Type','range':(0,0xC1),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x03},
						0x04 : {'offset':392,'bit':7,'bits':8,'parameter':'IFX5 Effect Type','range':(0,0xC1),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x04},
						0x05 : {'offset': 89,'bit':6,'bits':1,'parameter':'IFX1 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x05},
						0x06 : {'offset':165,'bit':6,'bits':1,'parameter':'IFX2 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x06},
						0x07 : {'offset':241,'bit':6,'bits':1,'parameter':'IFX3 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x07},
						0x08 : {'offset':317,'bit':6,'bits':1,'parameter':'IFX4 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x08},
						0x09 : {'offset':393,'bit':6,'bits':1,'parameter':'IFX5 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x09},
						0x0A : {'offset': 92,'bit':7,'bits':8,'parameter':'IFX1 Pan','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x0A},
						0x0B : {'offset':168,'bit':7,'bits':8,'parameter':'IFX2 Pan','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x0B},
						0x0C : {'offset':244,'bit':7,'bits':8,'parameter':'IFX3 Pan','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x0C},
						0x0D : {'offset':320,'bit':7,'bits':8,'parameter':'IFX4 Pan','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x0D},
						0x0E : {'offset':396,'bit':7,'bits':8,'parameter':'IFX5 Pan','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x0E},
						0x0F : {'offset': 93,'bit':3,'bits':4,'parameter':'IFX1 Bus Select','range':{00:'L/R', 07:'Off'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x0F},
						0x10 : {'offset':169,'bit':3,'bits':4,'parameter':'IFX2 Bus Select','range':{00:'L/R', 07:'Off'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x10},
						0x11 : {'offset':245,'bit':3,'bits':4,'parameter':'IFX3 Bus Select','range':{00:'L/R', 07:'Off'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x11},
						0x12 : {'offset':321,'bit':3,'bits':4,'parameter':'IFX4 Bus Select','range':{00:'L/R', 07:'Off'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x12},
						0x13 : {'offset':397,'bit':3,'bits':4,'parameter':'IFX5 Bus Select','range':{00:'L/R', 07:'Off'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x13},
						0x14 : {'offset': 94,'bit':7,'bits':8,'parameter':'IFX1 Send 1 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x14},
						0x15 : {'offset':170,'bit':7,'bits':8,'parameter':'IFX2 Send 1 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x15},
						0x16 : {'offset':246,'bit':7,'bits':8,'parameter':'IFX3 Send 1 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x16},
						0x17 : {'offset':322,'bit':7,'bits':8,'parameter':'IFX4 Send 1 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x17},
						0x18 : {'offset':398,'bit':7,'bits':8,'parameter':'IFX5 Send 1 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x18},
						0x19 : {'offset': 95,'bit':7,'bits':8,'parameter':'IFX1 Send 2 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x19},
						0x1A : {'offset':171,'bit':7,'bits':8,'parameter':'IFX2 Send 2 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x1A},
						0x1B : {'offset':247,'bit':7,'bits':8,'parameter':'IFX3 Send 2 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x1B},
						0x1C : {'offset':323,'bit':7,'bits':8,'parameter':'IFX4 Send 2 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x1C},
						0x1D : {'offset':399,'bit':7,'bits':8,'parameter':'IFX5 Send 2 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x1D},
						0x1E : {'offset': 93,'bit':5,'bits':2,'parameter':'IFX1 FX Control','range':{0:'Off',01:'FX Ctrl1',02:'FX Ctrl2'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x1E},
						0x1F : {'offset':169,'bit':5,'bits':2,'parameter':'IFX2 FX Control','range':{0:'Off',01:'FX Ctrl1',02:'FX Ctrl2'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x1F},
						0x20 : {'offset':245,'bit':5,'bits':2,'parameter':'IFX3 FX Control','range':{0:'Off',01:'FX Ctrl1',02:'FX Ctrl2'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x20},
						0x21 : {'offset':321,'bit':5,'bits':2,'parameter':'IFX4 FX Control','range':{0:'Off',01:'FX Ctrl1',02:'FX Ctrl2'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x21},
						0x22 : {'offset':397,'bit':5,'bits':2,'parameter':'IFX5 FX Control','range':{0:'Off',01:'FX Ctrl1',02:'FX Ctrl2'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x22},
#						0x23-0x28?
#						0x28 : {'offset':-1,'bit':7,'bits':1,'parameter':'Chain','range':{0:'Not chain', 1:'Chain'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x28},# 0x00
						0x28 : {'offset': 89,'bit':7,'bits':1,'parameter':'IFX1 Chain','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x28},
						0x29 : {'offset':165,'bit':7,'bits':1,'parameter':'IFX2 Chain','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x29},
						0x2A : {'offset':241,'bit':7,'bits':1,'parameter':'IFX3 Chain','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x2A},
						0x2B : {'offset':317,'bit':7,'bits':1,'parameter':'IFX4 Chain','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x2B},
						0x2C : {'offset': 90,'bit':7,'bits':8,'parameter':'IFX1 Chain To','range':{0:'IF2',1:'IFX3',2:'IFX4',3:'IFX5'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x2C},
						0x2D : {'offset':166,'bit':7,'bits':8,'parameter':'IFX2 Chain To','range':{0:'IF3',1:'IFX4',2:'IFX5'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x2D},
						0x2E : {'offset':242,'bit':7,'bits':8,'parameter':'IFX3 Chain To','range':{0:'IF4',1:'IFX5'},'bias':0,'step':None,'mode':0x02,'id':0x0D,'subid':0x2E},
					},
	0x0E :  {
						# Insert Effect 1 Parameter Structure
					},
	0x0F :  {
						# Insert Effect 2 Parameter Structure
					},
	0x10 :  {
						# Insert Effect 3 Parameter Structure
					},
	0x11 :  {
						# Insert Effect 4 Parameter Structure
					},
	0x12 :  {
						# Insert Effect 5 Parameter Structure
					},
	0x13 :  {
						0x00 : {'offset':468,'bit':7,'bits':8,'parameter':'MFX1 Effect Type','range':(0,0xC1),'bias':0,'step':None,'mode':0x02,'id':0x13,'subid':0x00},# 0x1D
						0x01 : {'offset':536,'bit':7,'bits':8,'parameter':'MFX2 Effect Type','range':(0,0xC1),'bias':0,'step':None,'mode':0x02,'id':0x13,'subid':0x01},# 0x55
						0x02 : {'offset':469,'bit':6,'bits':1,'parameter':'MFX1 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x13,'subid':0x02},# 0x01
						0x03 : {'offset':537,'bit':6,'bits':1,'parameter':'MFX2 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x13,'subid':0x03},# 0x00
						0x04 : {'offset':540,'bit':7,'bits':8,'parameter':'MFX1 Return Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x13,'subid':0x04},# 0x5B
						0x05 : {'offset':541,'bit':7,'bits':8,'parameter':'MFX2 Return Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x13,'subid':0x05},# 0x5A
						0x06 : {'offset':542,'bit':1,'bits':1,'parameter':'MFX Chain On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x13,'subid':0x06},# 0x01
						0x07 : {'offset':542,'bit':0,'bits':1,'parameter':'MFX Chain Direction','range':{0:'MFX1->MFX2', 1:'MFX2->MFX1'},'bias':0,'step':None,'mode':0x02,'id':0x13,'subid':0x07},# 0x01
						0x08 : {'offset':543,'bit':7,'bits':8,'parameter':'MFX Chain Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x13,'subid':0x08},
					},
	0x14 :  {
						# Master Effect 1 Parameter Structure
					},
	0x15 :  {
						# Master Effect 2 Parameter Structure
					},
	0x16 :  {
						0x00 : {'offset':608,'bit':7,'bits':8,'parameter':'TFX Effect Type','range':(0,0xAB),'bias':0,'step':None,'mode':0x02,'id':0x16,'subid':0x00},# 0x05
						0x01 : {'offset':609,'bit':6,'bits':1,'parameter':'TFX On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x02,'id':0x16,'subid':0x01},# 0x00
						0x02 : {'offset':612,'bit':7,'bits':8,'parameter':'TFX Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x02,'id':0x16,'subid':0x02},# 0x7F
					},
	0x17 :  {
						# Total Effect Parameter Structure
					},
}


