#!@PYTHON@
# -*- coding: utf-8 -*-
#
# fx001.py -- classes for Korg Krome Music Workstation
#
# (c) 2014  Brian M. Ames <bmames@apk.net>

__all__ = ['mode3param_dict']

#===============================================================================
mode3param_dict = {
	0x00 :  {
						0x00 : {'offset':836,'bit':2,'bits':3,'parameter':'OSC Mode','range':{0:'Single', 1:'Double', 2:'Drums', 5:'Double Drums'},'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x00},
						0x01 : {'offset':836,'bit':6,'bits':1,'parameter':'OSC Hold','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x01},
						0x02 : {'offset':836,'bit':7,'bits':1,'parameter':'OSC Poly/Mono','range':{0:'Poly',1:'Mono'},'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x02},
						0x03 : {'offset':837,'bit':0,'bits':1,'parameter':'Single Trigger','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x03},
						0x04 : {'offset':837,'bit':1,'bits':1,'parameter':'Poly Legato','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x04},
						0x05 : {'offset':837,'bit':2,'bits':2,'parameter':'Priority','range':{0:'Low',1:'High',2:'Last'},'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x05},
						0x06 : {'offset':837,'bit':4,'bits':1,'parameter':'Mono Legato','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x06},
						0x07 : {'offset':837,'bit':5,'bits':1,'parameter':'Mode','range':{0:'Normal',1:'Use Legato Offset'},'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x07},
						0x08 : {'offset':838,'bit':2,'bits':3,'parameter':'Number Of Voices','range':(2,0x06),'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x08},
						0x09 : {'offset':838,'bit':7,'bits':1,'parameter':'Unison','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x09},
						0x0A : {'offset':839,'bit':7,'bits':8,'parameter':'Detune','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x0A},
						0x0B : {'offset':840,'bit':7,'bits':8,'parameter':'Thickness','range':(0,0x09),'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x0B},
						0x0C : {'offset':837,'bit':6,'bits':1,'parameter':'Enable Half-Damper','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x0C},
						0x0D : {'offset':841,'bit':7,'bits':8,'parameter':'Hold Bottom','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x0D},
						0x0E : {'offset':842,'bit':7,'bits':8,'parameter':'Hold Top','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x0E},
						0x0F : {'offset':847,'bit':7,'bits':8,'parameter':'Scale Type','range':{0:'Equal Temperament',1:'Pure Major',2:'Pure Minor',3:'Arabic',4:'Pythagoras',5:'Werkmeister',6:'Kirnberger',7:'Slendro',8:'Pelog',9:'Stretch',10:'User All Notes Scale',11:'User Octave Scale 00',12:'User Octave Scale 01',13:'User Octave Scale 02',14:'User Octave Scale 03',15:'User Octave Scale 04',16:'User Octave Scale 05',17:'User Octave Scale 06',18:'User Octave Scale 07',19:'User Octave Scale 08',20:'User Octave Scale 09',21:'User Octave Scale 10',22:'User Octave Scale 11',23:'User Octave Scale 12',24:'User Octave Scale 13',25:'User Octave Scale 14',26:'User Octave Scale 15'},'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x0F},
						0x10 : {'offset':848,'bit':7,'bits':8,'parameter':'Scale Key','range':{0:'C',1:'C#',2:'D',3:'D#',4:'E',5:'F',6:'F#',7:'G',8:'G#',9:'A',10:'A#',11:'B'},'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x10},
						0x11 : {'offset':849,'bit':7,'bits':8,'parameter':'Scale Random','range':(0,0x07),'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x11},
						0x12 : {'offset':928,'bit':7,'bits':8,'parameter':'OSC1 Key Zone Bottom','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x12},
						0x13 : {'offset':929,'bit':7,'bits':8,'parameter':'OSC1 Key Zone Top','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x13},
						0x14 : {'offset':930,'bit':7,'bits':8,'parameter':'OSC2 Key Zone Bottom','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x14},
						0x15 : {'offset':931,'bit':7,'bits':8,'parameter':'OSC2 Key Zone Top','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x00,'subid':0x15},
					},
	0x01 :  {
					},
	0x02 :  {
					},
	0x03 :  {
#						0x01 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x03,'subid':0x01},# 0x03
#						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'OSC1 Number','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x03,'subid':0x02},# 0x00
#						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x03,'subid':0x02},# 0x07
						0x45 : {'offset':-1,'bit':7,'bits':8,'parameter':'OSC1 Note On Delay','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x03,'subid':0x45},# 0x01
						0x46 : {'offset':-1,'bit':7,'bits':8,'parameter':'OSC2 Note On Mode','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x03,'subid':0x46},# 0x00
					},
	0x04 :  {
					},
	0x05 :  {
					},
	0x06 :  {
					},
	0x07 :  {
						# PCM Filter OSC1 parameters
						0x00 : {'offset':1188,'bit':7,'bits':8,'parameter':'Filter Routing','range':{0:'Single',1:'Serial',2:'Parallel',3:'24db(4Pole)'},'bias':0,'step':None,'mode':0x03,'id':0x07,'subid':0x00},# 0x02
						0x01 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x07,'subid':0x01},# 0x19
						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x07,'subid':0x02},# 0x09
						0x03 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x07,'subid':0x03},# 0x12
						0x04 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x07,'subid':0x04},# 0x07
					},
	0x08 :  {
#[                                    0x0e, 0x00, 0x00, 0x00, 
# 0x14, 0x00, 0x00, 0x00, 0x14, 0xfe, 0x00, 0x00, 0x11, 0x00,
# 0x00, 0x00, 0x00, 0x63, 0x63, 0x02, 0x00, 0x32, 0x23, 0x46,
# 0x0c, 0x00, 0x00, 0x00, 0x00, 0x23, 0x00, 0x00, 0x00, 0x00,
# 0x00, 0x00]
						# PCM Filter Block OSC1 parameters
						0x00 : {'offset':1212,'bit':2,'bits':3,'parameter':'Filter A Type','range':{0:'Lowpass',1:'Highpass',2:'Bandpass',3:'BandReject'},'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x00},
						0x01 : {'offset':1212,'bit':7,'bits':1,'parameter':'Filter A Bypass','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x01},
						0x02 : {'offset':1213,'bit':7,'bits':8,'parameter':'Filter A Trim','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x02},
						0x03 : {'offset':1214,'bit':7,'bits':8,'parameter':'Filter A Output Level','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x03},
						0x04 : {'offset':1196,'bit':7,'bits':8,'parameter':'Filter A Output Level Source','range':(0,0x2E),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x04},#DIFF
						0x05 : {'offset':1197,'bit':7,'bits':8,'parameter':'Filter A Output Level Intensity','range':(-0x63,0x63),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x05},
						0x06 : {'offset':1215,'bit':7,'bits':8,'parameter':'Filter A Frequency','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x06},
						0x07 : {'offset':1216,'bit':7,'bits':8,'parameter':'Filter A Resonance','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x07},
						0x08 : {'offset':1200,'bit':7,'bits':8,'parameter':'Filter A AMS Source','range':(0,0x2E),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x08},#DIFF
						0x09 : {'offset':1201,'bit':7,'bits':8,'parameter':'Filter A AMTS Intensity','range':(-0x63,0x63),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x09},
						0x0A : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x0A},# 0x33
						0x0B : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x0B},# 0x15
						0x0C : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x0C},# 0xFFFFFFFF
						0x0D : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x0D},# 0x12
						0x0E : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x0E},# 0x01
						0x0F : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x0F},# 0x24
						0x10 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x10},# 0x47
						0x11 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x11},# 0x01
						0x12 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x12},# 0x01
						0x13 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x13},# 0x01
						0x14 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x14},# 0x01
						0x15 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x15},# 0x24
						0x16 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x16},# 0x01
						0x17 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x17},# 0x0D
						0x18 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x18},# 0x01
						0x19 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x19},# 0x01
						0x1A : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x08,'subid':0x1A},# 0x01
					},
	0x09 :  {
						# PCM Filter OSC1 Block 2 parameters
						0x00 : {'offset':1248,'bit':2,'bits':3,'parameter':'Filter B Type','range':{0:'Lowpass',1:'Highpass',2:'Bandpass',3:'BandReject'},'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x00},
						0x01 : {'offset':1248,'bit':7,'bits':1,'parameter':'Filter B Bypass','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x01},
						0x02 : {'offset':1249,'bit':7,'bits':8,'parameter':'Filter B Trim','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x02},
						0x03 : {'offset':1250,'bit':7,'bits':8,'parameter':'Filter B Output Level','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x03},
						0x04 : {'offset':1232,'bit':7,'bits':8,'parameter':'Filter B Output Level Source','range':(0,0x2E),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x04},#DIFF
						0x05 : {'offset':1233,'bit':7,'bits':8,'parameter':'Filter B Output Level Intensity','range':(-0x63,0x63),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x05},
						0x06 : {'offset':1251,'bit':7,'bits':8,'parameter':'Filter B Frequency','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x06},
						0x07 : {'offset':1252,'bit':7,'bits':8,'parameter':'Filter B Resonance','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x07},
						0x08 : {'offset':1236,'bit':7,'bits':8,'parameter':'Filter B AMS Source','range':(0,0x2E),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x08},#DIFF
						0x09 : {'offset':1237,'bit':7,'bits':8,'parameter':'Filter B AMTS Intensity','range':(-0x63,0x63),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x09},
						0x0A : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x0A},# 0x00
						0x0B : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x0B},# 0x13
						0x0C : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x0C},# 0x01
						0x0D : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x0D},# 0x12
						0x0E : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x0E},# 0x01
						0x0F : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x0F},# 0x01
						0x10 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x10},# 0x01
						0x11 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x11},# 0x01
						0x12 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x12},# 0x01
						0x13 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x13},# 0x01
						0x14 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x14},# 0x01
						0x15 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x15},# 0x01
						0x16 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x16},# 0x01
						0x17 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x17},# 0x01
						0x18 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x18},# 0x01
						0x19 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x19},# 0x01
						0x1A : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x09,'subid':0x1A},# 0x01
					},
	0x0A :  {
						0x00 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x00},# 0x62
						0x01 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x01},# 0x2C
						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x02},# 0x62
						0x03 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x03},# 0x48
						0x04 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x04},# 0x51
						0x05 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x05},# 0x63
						0x06 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x06},# 0x00
						0x07 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x07},# 0x59
						0x08 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x08},# 0x00
						0x09 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x09},# 0x0F
						0x0A : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x0A},# 0x01
						0x0B : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x0B},# 0x01
						0x0C : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x0C},# 0x01
						0x0D : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x0D},# 0x0F
						0x0E : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x0E},# 0x0F
						0x0F : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x0F},# 0x04
						0x10 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x10},# 0x01
						0x11 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x11},# 0x47
						0x12 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x12},# 0x0E
						0x13 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x13},# 0x01
						0x14 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x14},# 0xFFFFFFF0
						0x15 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x15},# 0x01
						0x16 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x16},# 0x01
						0x17 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x17},# 0x01
						0x18 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x18},# 0x01
						0x19 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x19},# 0x01
						0x1A : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x1A},# 0x01
						0x1B : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x1B},# 0x01
						0x1C : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x1C},# 0x01
						0x1D : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x1D},# 0x01
						0x1E : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x1E},# 0x03
						0x1F : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x1F},# 0x03
						0x20 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x20},# 0x03
						0x21 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0A,'subid':0x21},# 0x03
					},
	0x0B :  {
						# Filter Keytrack Parameters
						0x00 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0B,'subid':0x00},# 0x2A
						0x01 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0B,'subid':0x01},# 0x38
						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0B,'subid':0x02},# 0x5C
						0x03 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0B,'subid':0x03},# 0x2E
						0x04 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0B,'subid':0x04},# 0x29
						0x05 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0B,'subid':0x05},# 0x01
						0x06 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0B,'subid':0x06},# 0x01
					},
	0x0C :  {
						0x00 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x00},# 0x7F
						0x01 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x01},# 0x00
						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x02},# 0x00
						0x03 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x03},# 0x00
						0x04 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x04},# 0x00
						0x05 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x05},# 0x00
						0x06 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x06},# 0x00
						0x06 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x06},# 0x00
						0x07 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x07},# 0x00

						0x08 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x08},# 0x47
						0x09 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x09},# 0x12
						0x0A : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x0A},# 0x01
						0x0B : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x0B},# 0x01
						0x0D : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x0D},# 0x14
						0x0E : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x0E},# 0x4A
						0x0C : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x0C},# 0x01
						0x0F : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x0F},# 0x15
						0x10 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0C,'subid':0x10},# 0x01
					},
	0x0D :  {
						0x00 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x00},# 0x01
						0x01 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x01},# 0x01
						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x02},# 0x63
						0x03 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x03},# 0x29
						0x04 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x04},# 0x61
						0x05 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x05},# 0x27
						0x06 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x06},# 0x61
						0x07 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x07},# 0x28
						0x08 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x08},# 0x10
						0x09 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x09},# 0x01
						0x0A : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x0A},# 0x01
						0x0B : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x0B},# 0x01
						0x0C : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x0C},# 0x0B
						0x0D : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x0D},# 0x01
						0x0E : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x0E},# 0x01
						0x0F : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x0F},# 0x01
						0x10 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x10},# 0x29
						0x11 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x11},# 0x10
						0x12 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x12},# 0x01
						0x13 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x13},# 0x02
						0x14 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x14},# 0x01
						0x15 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x15},# 0x0A
						0x16 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x16},# 0x02
						0x17 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x17},# 0x01
						0x18 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x18},# 0x01
						0x19 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x19},# 0x01
						0x1A : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x1A},# 0x01
						0x1B : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x1B},# 0x01
						0x1C : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x1C},# 0x01
						0x1D : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x1D},# 0x01
						0x1E : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x1E},# 0x05
						0x1F : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x1F},# 0x04
						0x20 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0D,'subid':0x20},# 0x0A
					},
	0x0E :  {
						0x00 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0E,'subid':0x00},# 0x2A
						0x01 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0E,'subid':0x01},# 0x3D
						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0E,'subid':0x02},# 0x55
						0x03 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0E,'subid':0x03},# 0x11
						0x04 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0E,'subid':0x04},# 0x09
						0x05 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0E,'subid':0x05},# 0x00
						0x06 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0E,'subid':0x06},# 0xFFFFFFFF
					},
	0x0F :  {
						0x00 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0F,'subid':0x00},# 0x40
						0x01 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0F,'subid':0x01},# 0x0D
						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x0F,'subid':0x02},# 0x08
					},
	0x10 :  {
					},
	0x11 :  {
					},
	0x12 :  {
					},
	0x13 :  {
						0x01 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x13,'subid':0x01},# 0x03
						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x13,'subid':0x02},# 0x08
						0x45 : {'offset':-1,'bit':7,'bits':8,'parameter':'OSC2 Note On MDelay','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x13,'subid':0x45},# 0x00
						0x46 : {'offset':-1,'bit':7,'bits':8,'parameter':'OSC2 Note On Mode','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x13,'subid':0x46},# 0x01
					},
	0x14 :  {
					},
	0x15 :  {
					},
	0x16 :  {
					},
	0x17 :  {
						# PCM Filter OSC2 parameters
						0x00 : {'offset':1188+440,'bit':7,'bits':8,'parameter':'Filter Routing','range':{0:'Single',1:'Serial',2:'Parallel',3:'24db(4Pole)'},'bias':0,'step':None,'mode':0x03,'id':0x17,'subid':0x00},
					},
	0x18 :  {
						# PCM Filter OSC2 Block 1 parameters
						0x00 : {'offset':1212+440,'bit':2,'bits':3,'parameter':'Filter A Type','range':{0:'Lowpass',1:'Highpass',2:'Bandpass',3:'BandReject'},'bias':0,'step':None,'mode':0x03,'id':0x18,'subid':0x00},
						0x01 : {'offset':1212+440,'bit':7,'bits':1,'parameter':'Filter A Bypass','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x03,'id':0x18,'subid':0x01},
						0x02 : {'offset':1213+440,'bit':7,'bits':8,'parameter':'Filter A Trim','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x18,'subid':0x02},
						0x03 : {'offset':1214+440,'bit':7,'bits':8,'parameter':'Filter A Output Level','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x18,'subid':0x03},
						0x04 : {'offset':1196+440,'bit':7,'bits':8,'parameter':'Filter A Output Level Source','range':(0,0x2E),'bias':0,'step':None,'mode':0x03,'id':0x18,'subid':0x04},#DIFF
						0x05 : {'offset':1197+440,'bit':7,'bits':8,'parameter':'Filter A Output Level Intensity','range':(-0x63,0x63),'bias':0,'step':None,'mode':0x03,'id':0x18,'subid':0x05},
						0x06 : {'offset':1215+440,'bit':7,'bits':8,'parameter':'Filter A Frequency','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x18,'subid':0x06},
						0x07 : {'offset':1216+440,'bit':7,'bits':8,'parameter':'Filter A Resonance','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x18,'subid':0x07},
						0x08 : {'offset':1200+440,'bit':7,'bits':8,'parameter':'Filter A AMS Source','range':(0,0x2E),'bias':0,'step':None,'mode':0x03,'id':0x18,'subid':0x08},#DIFF
						0x09 : {'offset':1201+440,'bit':7,'bits':8,'parameter':'Filter A AMTS Intensity','range':(-0x63,0x63),'bias':0,'step':None,'mode':0x03,'id':0x18,'subid':0x09},
					},
	0x19 :  {
						# PCM Filter OSC2 Block 2 parameters
						0x00 : {'offset':1248+440,'bit':2,'bits':3,'parameter':'Filter B Type','range':{0:'Lowpass',1:'Highpass',2:'Bandpass',3:'BandReject'},'bias':0,'step':None,'mode':0x03,'id':0x19,'subid':0x00},
						0x01 : {'offset':1248+440,'bit':7,'bits':1,'parameter':'Filter B Bypass','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x03,'id':0x19,'subid':0x01},
						0x02 : {'offset':1249+440,'bit':7,'bits':8,'parameter':'Filter B Trim','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x19,'subid':0x02},
						0x03 : {'offset':1250+440,'bit':7,'bits':8,'parameter':'Filter B Output Level','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x19,'subid':0x03},
						0x04 : {'offset':1232+440,'bit':7,'bits':8,'parameter':'Filter B Output Level Source','range':(0,0x2E),'bias':0,'step':None,'mode':0x03,'id':0x19,'subid':0x04},#DIFF
						0x05 : {'offset':1233+440,'bit':7,'bits':8,'parameter':'Filter B Output Level Intensity','range':(-0x63,0x63),'bias':0,'step':None,'mode':0x03,'id':0x19,'subid':0x05},
						0x06 : {'offset':1251+440,'bit':7,'bits':8,'parameter':'Filter B Frequency','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x19,'subid':0x06},
						0x07 : {'offset':1252+440,'bit':7,'bits':8,'parameter':'Filter B Resonance','range':(0,0x63),'bias':0,'step':None,'mode':0x03,'id':0x19,'subid':0x07},
						0x08 : {'offset':1236+440,'bit':7,'bits':8,'parameter':'Filter B AMS Source','range':(0,0x2E),'bias':0,'step':None,'mode':0x03,'id':0x19,'subid':0x08},#DIFF
						0x09 : {'offset':1237+440,'bit':7,'bits':8,'parameter':'Filter B AMTS Intensity','range':(-0x63,0x63),'bias':0,'step':None,'mode':0x03,'id':0x19,'subid':0x09},
					},
	0x1A :  {
						0x00 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x00},# 0x62
						0x01 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x01},# 0x2C
						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x02},# 0x62
						0x03 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x03},# 0x48
						0x04 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x04},# 0x51
						0x05 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x05},# 0x63
						0x06 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x06},# 0x00
						0x07 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x07},# 0x59
						0x08 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x08},# 0x00
						0x09 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x09},# 0x0F
						0x0A : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x0A},# 0x01
						0x0B : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x0B},# 0x01
						0x0C : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x0C},# 0x01
						0x0D : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x0D},# 0x0F
						0x0E : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x0E},# 0x0F
						0x0F : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x0F},# 0x04
						0x10 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x10},# 0x01
						0x11 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x11},# 0x47
						0x12 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x12},# 0x0E
						0x13 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x13},# 0x01
						0x14 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x14},# 0xFFFFFFF0
						0x15 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x15},# 0x01
						0x16 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x16},# 0x01
						0x17 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x17},# 0x01
						0x18 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x18},# 0x01
						0x19 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x19},# 0x01
						0x1A : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x1A},# 0x01
						0x1B : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x1B},# 0x01
						0x1C : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x1C},# 0x01
						0x1D : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x1D},# 0x01
						0x1E : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x1E},# 0x03
						0x1F : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x1F},# 0x03
						0x20 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x20},# 0x03
						0x21 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1A,'subid':0x21},# 0x03
					},
	0x1B :  {
					},
	0x1C :  {
						0x00 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x00},# 0x7E
						0x01 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x01},# 0x02
						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x02},# 0x01
						0x03 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x03},# 0x01
						0x04 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x04},# 0x01
						0x05 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x05},# 0x01
						0x06 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x06},# 0x01
						0x07 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x07},# 0x01
						0x08 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x08},# 0x47
						0x09 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x09},# 0x12
						0x0A : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x0A},# 0x01
						0x0B : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x0B},# 0x01
						0x0D : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x0D},# 0x14
						0x0E : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x0E},# 0x4A
						0x0C : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x0C},# 0x01
						0x0F : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x0F},# 0x15
						0x10 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1C,'subid':0x10},# 0x01
					},
	0x1D :  {
						0x00 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x00},# 0x01
						0x01 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x01},# 0x01
						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x02},# 0x62
						0x03 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x03},# 0x29
						0x04 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x04},# 0x62
						0x05 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x05},# 0x29
						0x06 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x06},# 0x62
						0x07 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x07},# 0x29
						0x08 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x08},# 0x0F
						0x09 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x09},# 0x01
						0x0A : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x0A},# 0x01
						0x0B : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x0B},# 0x01
						0x0C : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x0C},# 0x0A
						0x0D : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x0D},# 0x01
						0x0E : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x0E},# 0x01
						0x0F : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x0F},# 0x01
						0x10 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x10},# 0x29
						0x11 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x11},# 0x10
						0x12 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x12},# 0x01
						0x13 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x13},# 0x01
						0x14 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x14},# 0x01
						0x15 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x15},# 0x0A
						0x16 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x16},# 0x02
						0x17 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x17},# 0x01
						0x18 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x18},# 0x01
						0x19 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x19},# 0x01
						0x1A : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x1A},# 0x01
						0x1B : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x1B},# 0x0D
						0x1C : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x1C},# 0x01
						0x1D : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x1D},# 0x01
						0x1E : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x1E},# 0x07
						0x1F : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x1F},# 0x08
						0x20 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1D,'subid':0x20},# 0x09
					},
	0x1E :  {
						0x00 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1E,'subid':0x00},# 0x2A
						0x01 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1E,'subid':0x01},# 0x3D
						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1E,'subid':0x02},# 0x55
						0x03 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1E,'subid':0x03},# 0x11
						0x04 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1E,'subid':0x04},# 0x09
						0x05 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1E,'subid':0x05},# 0x00
						0x06 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1E,'subid':0x06},# 0xFFFFFFFF
					},
	0x1F :  {
						0x00 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1F,'subid':0x00},# 0x41
						0x01 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1F,'subid':0x01},# 0x0E
						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1F,'subid':0x02},# 0x09
						0x02 : {'offset':-1,'bit':7,'bits':8,'parameter':'','range':(0,0x7F),'bias':0,'step':None,'mode':0x03,'id':0x1F,'subid':0x02},# 0x0A
					},
}


