#!@PYTHON@
# -*- coding: utf-8 -*-
#
# table10.py -- classes for Korg Krome Music Workstation
#
# (c) 2014  Brian M. Ames <bmames@apk.net>

from event import *
from table10 import SongTimbreSet
from table11 import SongControlData
from table12 import TrackEventList,MasterTrackEventList

#===============================================================================
class Song(object):
	def __init__(self):
		self._number = None
		self._timbre_set = SongTimbreSet()
		self._control_data = SongControlData()
#		self._events = []
		self._track_events = [TrackEventList() for i in xrange(16)]
		mtel = MasterTrackEventList()
		self._track_events.append(MasterTrackEventList())
#		mtel.append(MasterBarEvent(meas=0,size=2,beats=3,beat=1))
#		mtel.append(TempoChgEvent(tick=0,tempo=12000,last_tempo=0,last_tempo_unfixed=1))
#		mtel.append(TrkEndEvent(meas=0))

	
#-------------------------------------------------------------------------------
	def __iter__(self):
		return iter(self._events)

#-------------------------------------------------------------------------------
	def __getitem__(self,index):
		return self._events[index]

#-------------------------------------------------------------------------------
	def append_event(self,event):
		event_count = 0
		for t in xrange(17):
			event_count += len(self._track_events[t])
			next_address = 0xFFFFFFFE if t == 16 else self._control_data.master_track_event_address if t == 15 else self.track_list[t].event_address
			if next_address != 0xFFFFFFFF and event_count<next_address:
				break
		self._track_events[t].append(event)
#		print str(self._track_events[t][-1])
#		print t,len(self._track_events[t])

#-------------------------------------------------------------------------------
	def append_master_track_event(self,event):
		self._track_events[16].append(event)
#		print str(self._track_events[t][-1])
#		print t,len(self._track_events[t])
	
#-------------------------------------------------------------------------------
	def separate_events(self):
		ctl = self._control_data
		address_list = [ctl.track1_control_parameters.event_address,
										ctl.track2_control_parameters.event_address,
										ctl.track3_control_parameters.event_address,
										ctl.track4_control_parameters.event_address,
										ctl.track5_control_parameters.event_address,
										ctl.track6_control_parameters.event_address,
										ctl.track7_control_parameters.event_address,
										ctl.track8_control_parameters.event_address,
										ctl.track9_control_parameters.event_address,
										ctl.track10_control_parameters.event_address,
										ctl.track11_control_parameters.event_address,
										ctl.track12_control_parameters.event_address,
										ctl.track13_control_parameters.event_address,
										ctl.track15_control_parameters.event_address,
										ctl.track15_control_parameters.event_address,
										ctl.track16_control_parameters.event_address,
										ctl.master_track_event_address]
		address_list = [(i,addr/8) for i,addr in enumerate(address_list) if addr != 0xFFFFFFFF]
		address_list.append((-1,len(self._events)))
#		print address_list
		for i,t in enumerate(address_list[:-1]):
			track,start=t
			end = address_list[i+1][1]
#			print track,start,end
#			print self._events[start:end]
			self._track_events[track] = self._events[start:end]
		print self._timbre_set.song_name
		for i,evt in enumerate(self._track_events[16]):
#			print type(evt)
			if isinstance(evt,event.BarEvent):
				evt = self._track_events[16][i] = event.MasterBarEvent(evt.raw)
#			print i,evt.toJSON()
		for i,evt in enumerate(self._track_events[0]):
			print i,evt#.toJSON()

#-------------------------------------------------------------------------------
	@property
	def number(self):
		return self._number

	@number.setter
	def number(self,value):
		self._number = value

#-------------------------------------------------------------------------------
	@property
	def timbre_set(self):
		return self._timbre_set

	@timbre_set.setter
	def timbre_set(self,value):
		if isinstance(value,basestring):
			self._timbre_set = SongTimbreSet(value)
		else:
			self._timbre_set = value

#-------------------------------------------------------------------------------
	@property
	def control_data(self):
		return self._control_data

	@control_data.setter
	def control_data(self,value):
		if isinstance(value,basestring):
			ctl = self._control_data = SongControlData(value)
		else:
			ctl = self._control_data = value
		self.track_list = [ctl.track1_control_parameters,
										ctl.track2_control_parameters,
										ctl.track3_control_parameters,
										ctl.track4_control_parameters,
										ctl.track5_control_parameters,
										ctl.track6_control_parameters,
										ctl.track7_control_parameters,
										ctl.track8_control_parameters,
										ctl.track9_control_parameters,
										ctl.track10_control_parameters,
										ctl.track11_control_parameters,
										ctl.track12_control_parameters,
										ctl.track13_control_parameters,
										ctl.track15_control_parameters,
										ctl.track15_control_parameters,
										ctl.track16_control_parameters]


