#!@PYTHON@
# -*- coding: utf-8 -*-
#
# table10.py -- classes for Korg Krome Music Workstation
# 
# (c) 2014  Brian M. Ames <bmames@apk.net>

import struct
from event import *

#===============================================================================
# Table 12
class TrackEventList(object):
	def __init__(self,raw=None):
		if raw is None:
			self.events = []
		else:
			self.unpack(raw)

#-------------------------------------------------------------------------------
	def __iter__(self):
		return iter(self.events)

#-------------------------------------------------------------------------------
	def __len__(self):
		return len(self.events)

#-------------------------------------------------------------------------------
	def __getitem__(self,index):
		return self.events[index]
	
#-------------------------------------------------------------------------------
	def calcsize(self):
		return len(self.events)*8

#-------------------------------------------------------------------------------
	def append(self,event):
		if isinstance(event,basestring):
			kind = ord(event[0])
			if kind == 1:
				self.events.append(BarEvent(raw=event))
			elif kind == 2:
				self.events.append(PatEvent(raw=event))
			elif kind == 3:
				self.events.append(TrkEndEvent(raw=event))
			elif kind == 9:
				self.events.append(NoteEvent(raw=event))
			elif kind == 10:
				self.events.append(PolyPressEvent(raw=event))
			elif kind == 11:
				self.events.append(ControlChgEvent(raw=event))
			elif kind == 12:
				self.events.append(ProgramChgEvent(raw=event))
			elif kind == 13:
				self.events.append(ChPressEvent(raw=event))
			elif kind == 14:
				self.events.append(PitchBendEvent(raw=event))
		

#-------------------------------------------------------------------------------
	def unpack(self,raw):
		self.events = []
		for pos in xrange(0,len(raw),8):
			self.append(raw[pos:pos+8])

#===============================================================================
# Table 12
class MasterTrackEventList(object):
	def __init__(self,raw=None):
		if raw is None:
			self.events = []
		else:
			self.unpack(raw)

#-------------------------------------------------------------------------------
	def __iter__(self):
		return iter(self.events)

#-------------------------------------------------------------------------------
	def __len__(self):
		return len(self.events)

#-------------------------------------------------------------------------------
	def __getitem__(self,index):
		return self.events[index]
	
#-------------------------------------------------------------------------------
	def calcsize(self):
		return len(self.events)*8

#-------------------------------------------------------------------------------
	def append(self,event):
		if isinstance(event,basestring):
			kind = ord(event[0])
#			print 'kind: %d' % kind
			if kind == 1:
				self.events.append(MasterBarEvent(raw=event))
			elif kind == 3:
				self.events.append(TrkEndEvent(raw=event))
			elif kind == 11:
				self.events.append(TempoChgEvent(raw=event))

#-------------------------------------------------------------------------------
	def unpack(self,raw):
		self.events = []
		for pos in xrange(0,len(raw),8):
			self.append(raw[pos:pos+8])

