#!@PYTHON@
# -*- coding: utf-8 -*-
#
# table7.py -- classes for Korg Krome Music Workstation
# 
# (c) 2014  Brian M. Ames <bmames@apk.net>

import struct

#===============================================================================
# Table 7
class DrumTrackPattern(object):
	def __init__(self,raw=None):
		if raw is None:
			pass
		else:
			self.unpack(raw)

#-------------------------------------------------------------------------------
	def __str__(self):
		if self.event_address is None:
			return 'DrumTrackPattern: %s %3d %d 0x%x %s' % (self.pattern_name,self.length,self.meter,self._reserved26,self.event_address)
		else:
			return 'DrumTrackPattern: %s %3d %d 0x%x 0x%x' % (self.pattern_name,self.length,self.meter,self._reserved26,self.event_address)

#-------------------------------------------------------------------------------
	def unpack(self,raw):
		'''Unpack raw data into a  object'''
		v = list(struct.unpack('<24s2BHI',raw[0:32])) # 32 
		self.pattern_name = v.pop(0)
		self.length = v.pop(0)
		self.meter = v.pop(0)
		self._reserved26 = v.pop(0)
		self.event_address = v.pop(0)

#-------------------------------------------------------------------------------
	def pack(self):
		'''Pack a  object into raw data'''
		v = list()
		v.append(self.pattern_name)
		v.append(self.length)
		v.append(self.meter)
		v.append(self._reserved26)
		v.append(self.event_address)
		return struct.pack('>24s2BHI',*v) # 32

#-------------------------------------------------------------------------------
	@property
	def pattern_name(self):
		'''Pattern Name'''
		return self._pattern_name

	@pattern_name.setter
	def pattern_name(self,value):
		self._pattern_name = value

#-------------------------------------------------------------------------------
	@property
	def length(self):
		'''Length'''
		return self._length

	@length.setter
	def length(self,value):
#		if 1 <= value <= 99:
		self._length = value
#		else:
#			raise ValueError('not 1 <= value <= 99')

#-------------------------------------------------------------------------------
	@property
	def meter(self):
		'''Meter'''
		return self._meter

	@meter.setter
	def meter(self,value):
#		if 16 <= value <= 63:
		self._meter = value
#		else:
#			raise ValueError('not 16 <= value <= 63')

#-------------------------------------------------------------------------------
	@property
	def event_address(self):
		'''Event Address'''
		return self._event_address

	@event_address.setter
	def event_address(self,value):
		self._event_address = value


