#!@PYTHON@
# -*- coding: utf-8 -*-
#
# table10.py -- classes for Korg Krome Music Workstation
# 
# (c) 2014  Brian M. Ames <bmames@apk.net>

import struct

#===============================================================================
# Table 8
class PatternEventList(object):
	def __init__(self,raw=None):
		if raw is None:
			self.events = []
		else:
			self.unpack(raw)

#-------------------------------------------------------------------------------
	def __iter__(self):
		return iter(self.events)

#-------------------------------------------------------------------------------
	def __getitem__(self,index):
		return self.events[index]
	
#-------------------------------------------------------------------------------
	def unpack(self,raw):
		self.events = []
		for pos in xrange(0,len(raw),8):
			r = raw[pos:pos+8]
			kind = ord(r[0])
			if kind == 1:
				self.events.append(PatternBarEvent(raw=r))
			elif kind == 3:
				self.events.append(TrkEndEvent(raw=r))
			elif kind == 9:
				self.events.append(NoteEvent(raw=r))
			elif kind == 11:
				self.events.append(ControlChgEvent(raw=r))
			elif kind == 12:
				self.events.append(ProgramChgEvent(raw=r))
			elif kind == 14:
				self.events.append(PitchBendEvent(raw=r))
	

