#!@PYTHON@
# -*- coding: utf-8 -*-
#
# fx001.py -- classes for Korg Krome Music Workstation
#
# (c) 2014  Brian M. Ames <bmames@apk.net>

__all__ = ['mode0param_dict']

#===============================================================================
mode0param_dict = {
	0x00 :  {
					},
	0x01 :  {
						0x00 : {'offset':824,'bit':4,'bits':5,'parameter':'Category','range':(0, 17),'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x00},
						0x01 : {'offset':824,'bit':7,'bits':3,'parameter':'Sub Category','range':(0, 7),'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x01},
						0x02 : {'offset':825,'bit':7,'bits':8,'parameter':'Favorite','range':(0, 1),'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x02},
						0x03 : {'offset':827,'bit':7,'bits':8,'parameter':'Scale Type','range':(0, 26),'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x03},
						0x04 : {'offset':828,'bit':7,'bits':8,'parameter':'Scale Key','range':(0, 11),'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x04},
						0x05 : {'offset':829,'bit':7,'bits':8,'parameter':'Scale Random','range':(0, 7),'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x05},
						0x06 : {'offset':830,'bit':5,'bits':6,'parameter':'Switch 1 Assign','range':{0:'Off',1:'SW1 Mod. (CC#80)',2:'Porta.SW (CC#65)',3:'Octave Down',4:'Octave Up',5:'JS X Lock',6:'JS Y Lock',7:'JS+Y Lock',8:'JS-Y Lock',},'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x06},
						0x07 : {'offset':831,'bit':5,'bits':6,'parameter':'Switch 2 Assign','range':{0:'Off',1:'SW1 Mod. (CC#80)',2:'Porta.SW (CC#65)',3:'Octave Down',4:'Octave Up',5:'JS X Lock',6:'JS Y Lock',7:'JS+Y Lock',8:'JS-Y Lock',},'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x07},
						0x08 : {'offset':830,'bit':7,'bits':1,'parameter':'Switch 1 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x08},
						0x09 : {'offset':831,'bit':7,'bits':1,'parameter':'Switch 2 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x09},
						0x0A : {'offset':830,'bit':6,'bits':1,'parameter':'Switch 1 Mode','range':{0:'Toggle', 1:'Momentary'},'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x0A},
						0x0B : {'offset':831,'bit':6,'bits':1,'parameter':'Switch 2 Mode','range':{0:'Toggle', 1:'Momentary'},'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x0B},
						0x0C : {'offset':832,'bit':7,'bits':8,'parameter':'RT Knob-1 Assign','range':(0,0x8E),'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x0C},
						0x0D : {'offset':833,'bit':7,'bits':8,'parameter':'RT Knob-2 Assign','range':(0,0x8E),'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x0D},
						0x0E : {'offset':834,'bit':7,'bits':8,'parameter':'RT Knob-3 Assign','range':(0,0x8E),'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x0E},
						0x0F : {'offset':835,'bit':7,'bits':8,'parameter':'RT Knob-4 Assign','range':(0,0x8E),'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x0F},
						0x10 : {'offset':632,'bit':7,'bits':8,'parameter':'Control Assign','range':{0:'Tone Control', 1:'User Control', 2:'ARP'},'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x10},
						0x11 : {'offset':633,'bit':7,'bits':8,'parameter':'Selected Timbre','range':(0, 0x0F),'bias':1,'step':1,'mode':0x00,'id':0x01,'subid':0x11},
						0x12 : {'offset':826,'bit':0,'bits':1,'parameter':'Auto Load Tone Adjust','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x01,'subid':0x12},
					},
	0x02 :  {
					},
	0x03 :  {
					},
	0x04 :  {
					},
	0x05 :  {
					},
	0x06 :  {
						0x00 : {'offset':616,'bit':7,'bits':8,'parameter':'LFO1 Frequency','range':(0, 230),'bias':0,'step':None,'mode':0x00,'id':0x06,'subid':0x00},
						0x01 : {'offset':617,'bit':7,'bits':8,'parameter':'LFO1 Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x06,'subid':0x01},
						0x02 : {'offset':618,'bit':7,'bits':8,'parameter':'LFO1 DMod Src','range':(0, 37),'bias':0,'step':None,'mode':0x00,'id':0x06,'subid':0x02},
						0x03 : {'offset':619,'bit':7,'bits':8,'parameter':'LFO1 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x06,'subid':0x03},
						0x04 : {'offset':620,'bit':7,'bits':16,'parameter':'LFO1 BPM','range':(3999, 24000),'bias':0,'step':None,'mode':0x00,'id':0x06,'subid':0x04},
						0x05 : {'offset':622,'bit':3,'bits':4,'parameter':'LFO1 MIDI Sync Base Note','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x06,'subid':0x05},
						0x06 : {'offset':622,'bit':7,'bits':1,'parameter':'LFO1 MIDI Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x06,'subid':0x06},
						0x07 : {'offset':623,'bit':7,'bits':8,'parameter':'LFO1 MIDI Sync Time','range':(1, 32),'bias':0,'step':None,'mode':0x00,'id':0x06,'subid':0x07},
					},
	0x07 :  {
						0x00 : {'offset':624,'bit':7,'bits':8,'parameter':'LFO2 Frequency','range':(0, 230),'bias':0,'step':None,'mode':0x00,'id':0x07,'subid':0x00},
						0x01 : {'offset':625,'bit':7,'bits':8,'parameter':'LFO2 Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x07,'subid':0x01},
						0x02 : {'offset':626,'bit':7,'bits':8,'parameter':'LFO2 DMod Src','range':(0, 37),'bias':0,'step':None,'mode':0x00,'id':0x07,'subid':0x02},
						0x03 : {'offset':627,'bit':7,'bits':8,'parameter':'LFO2 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x07,'subid':0x03},
						0x04 : {'offset':628,'bit':7,'bits':16,'parameter':'LFO2 BPM','range':(3999, 24000),'bias':0,'step':None,'mode':0x00,'id':0x07,'subid':0x04},
						0x05 : {'offset':630,'bit':3,'bits':4,'parameter':'LFO2 MIDI Sync Base Note','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x07,'subid':0x05},
						0x06 : {'offset':630,'bit':7,'bits':1,'parameter':'LFO2 MIDI Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x07,'subid':0x06},
						0x07 : {'offset':631,'bit':7,'bits':8,'parameter':'LFO2 MIDI Sync Time','range':(1, 32),'bias':0,'step':None,'mode':0x00,'id':0x07,'subid':0x07},
					},
	0x08 :  {
						0x00 : {'offset':792,'bit':7,'bits':16,'parameter':'Tempo','range':(0x0FA0,0x7530),'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x00},
						0x01 : {'offset':794,'bit':0,'bits':1,'parameter':'ARP Switch','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x01},
						0x02 : {'offset':794,'bit':1,'bits':1,'parameter':'ARP Run A','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x02},
						0x03 : {'offset':794,'bit':2,'bits':1,'parameter':'ARP Run B','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x03},
						0x04 : {'offset':796,'bit':7,'bits':8,'parameter':'ARP Gate','range':(-64, 63),'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x04},
						0x05 : {'offset':797,'bit':7,'bits':8,'parameter':'ARP Velocity','range':(-64, 63),'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x05},
						0x06 : {'offset':798,'bit':7,'bits':8,'parameter':'ARP Swing','range':(-64, 63),'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x06},
						0x07 : {'offset':799,'bit':7,'bits':8,'parameter':'ARP Step','range':(-64, 63),'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x07},
					},
	0x09 :  {
						0x00 : {'offset':800,'bit':7,'bits':16,'parameter':'Arpeggiator A Pattern','range':(0, 1032),'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x00},
						0x01 : {'offset':802,'bit':4,'bits':3,'parameter':'Arpeggiator A Resolution','range':(0, 7),'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x01},
						0x02 : {'offset':802,'bit':1,'bits':2,'parameter':'Arpeggiator A Octave','range':(0, 4),'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x02},
						0x03 : {'offset':804,'bit':7,'bits':8,'parameter':'Arpeggiator A Gate','range':(0, 100),'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x03},
						0x04 : {'offset':805,'bit':7,'bits':8,'parameter':'Arpeggiator A Velocity','range':(1, 129),'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x04},
						0x05 : {'offset':806,'bit':7,'bits':8,'parameter':'Arpeggiator A Swing','range':(-100, 1100),'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x05},
						0x06 : {'offset':803,'bit':0,'bits':1,'parameter':'Arpeggiator A Sort','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x06},
						0x07 : {'offset':803,'bit':1,'bits':1,'parameter':'Arpeggiator A Latch','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x07},
						0x08 : {'offset':803,'bit':2,'bits':1,'parameter':'Arpeggiator A Key Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x08},
						0x09 : {'offset':803,'bit':3,'bits':1,'parameter':'Arpeggiator A Keyboard','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x09},
						0x0A : {'offset':807,'bit':7,'bits':8,'parameter':'Arpeggiator A Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x0A},
						0x0B : {'offset':808,'bit':7,'bits':8,'parameter':'Arpeggiator A Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x0B},
						0x0C : {'offset':809,'bit':7,'bits':8,'parameter':'Arpeggiator A Top Velocity','range':(1, 127),'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x0C},
						0x0D : {'offset':810,'bit':7,'bits':8,'parameter':'Arpeggiator A Bottom Velocity','range':(1, 127),'bias':0,'step':None,'mode':0x00,'id':0x08,'subid':0x0D},
					},
	0x0A :  {
						0x00 : {'offset':812,'bit':7,'bits':16,'parameter':'Arpeggiator B Pattern','range':(0, 1032),'bias':0,'step':None,'mode':0x00,'id':0x0A,'subid':0x00},
						0x01 : {'offset':814,'bit':4,'bits':3,'parameter':'Arpeggiator B Resolution','range':(0, 7),'bias':0,'step':None,'mode':0x00,'id':0x0A,'subid':0x01},
						0x02 : {'offset':814,'bit':1,'bits':2,'parameter':'Arpeggiator B Octave','range':(0, 4),'bias':0,'step':None,'mode':0x00,'id':0x0A,'subid':0x02},
						0x03 : {'offset':816,'bit':7,'bits':8,'parameter':'Arpeggiator B Gate','range':(0, 100),'bias':0,'step':None,'mode':0x00,'id':0x0A,'subid':0x03},
						0x04 : {'offset':817,'bit':7,'bits':8,'parameter':'Arpeggiator B Velocity','range':(1, 129),'bias':0,'step':None,'mode':0x00,'id':0x0A,'subid':0x04},
						0x05 : {'offset':818,'bit':7,'bits':8,'parameter':'Arpeggiator B Swing','range':(-100, 1100),'bias':0,'step':None,'mode':0x00,'id':0x0A,'subid':0x05},
						0x06 : {'offset':815,'bit':0,'bits':1,'parameter':'Arpeggiator B Sort','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x0A,'subid':0x06},
						0x07 : {'offset':815,'bit':1,'bits':1,'parameter':'Arpeggiator B Latch','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x0A,'subid':0x07},
						0x08 : {'offset':815,'bit':2,'bits':1,'parameter':'Arpeggiator B Key Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x0A,'subid':0x08},
						0x09 : {'offset':815,'bit':3,'bits':1,'parameter':'Arpeggiator B Keyboard','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x0A,'subid':0x09},
						0x0A : {'offset':819,'bit':7,'bits':8,'parameter':'Arpeggiator B Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0A,'subid':0x0A},
						0x0B : {'offset':820,'bit':7,'bits':8,'parameter':'Arpeggiator B Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0A,'subid':0x0B},
						0x0C : {'offset':821,'bit':7,'bits':8,'parameter':'Arpeggiator B Top Velocity','range':(1, 127),'bias':0,'step':None,'mode':0x00,'id':0x0A,'subid':0x0C},
						0x0D : {'offset':822,'bit':7,'bits':8,'parameter':'Arpeggiator B Bottom Velocity','range':(1, 127),'bias':0,'step':None,'mode':0x00,'id':0x0A,'subid':0x0D},
					},
	0x0B :  {
						0x00 : {'offset':638,'bit':7,'bits':8,'parameter':'Pattern Bank','range':{0:'Preset', 1:'User'},'bias':0,'step':None,'mode':0x00,'id':0x0B,'subid':0x00},
						0x01 : {'offset':636,'bit':7,'bits':16,'parameter':'Drum Track Pattern','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0B,'subid':0x01},
						0x02 : {'offset':639,'bit':0,'bits':1,'parameter':'Trigger Mode','range':{0:'Start Immediately', 1:'Wait KBD Trigger'},'bias':0,'step':None,'mode':0x00,'id':0x0B,'subid':0x02},
						0x03 : {'offset':639,'bit':2,'bits':2,'parameter':'Trigger Latch','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x0B,'subid':0x03},
						0x04 : {'offset':639,'bit':3,'bits':1,'parameter':'Trigger Sync','range':{0:'Off',1:'SEQ'},'bias':0,'step':None,'mode':0x00,'id':0x0B,'subid':0x04},
						0x05 : {'offset':640,'bit':7,'bits':8,'parameter':'Zone Keyboard Bottom','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0B,'subid':0x05},
						0x06 : {'offset':641,'bit':7,'bits':8,'parameter':'Zone Keyboard Top','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0B,'subid':0x06},
						0x07 : {'offset':642,'bit':7,'bits':8,'parameter':'Zone Velocity Bottom','range':(1, 127),'bias':0,'step':None,'mode':0x00,'id':0x0B,'subid':0x07},
						0x08 : {'offset':643,'bit':7,'bits':8,'parameter':'Zone Velocity Top','range':(1, 127),'bias':0,'step':None,'mode':0x00,'id':0x0B,'subid':0x08},
						0x09 : {'offset':644,'bit':7,'bits':8,'parameter':'Shift','range':(-24, 24),'bias':0,'step':None,'mode':0x00,'id':0x0B,'subid':0x09},
						0x0A : {'offset':639,'bit':4,'bits':1,'parameter':'Drum Track On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x0B,'subid':0x04},
						0x0B : {'offset':645,'bit':7,'bits':8,'parameter':'Output Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x0B,'subid':0x0B},
						0x0C : {'offset':646,'bit':7,'bits':8,'parameter':'Input Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x0B,'subid':0x0C},
					},
	0x0C :  {
						0x00 : {'offset':836,'bit':7,'bits':16,'parameter':'Tk1 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x00},
						0x01 : {'offset':850,'bit':7,'bits':8,'parameter':'Tk1 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x01},
						0x02 : {'offset':841,'bit':7,'bits':8,'parameter':'Tk1 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x02},
						0x03 : {'offset':838,'bit':7,'bits':3,'parameter':'Tk1 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x03},
						0x04 : {'offset':838,'bit':4,'bits':5,'parameter':'Tk1 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x04},
						0x05 : {'offset':839,'bit':7,'bits':8,'parameter':'Tk1 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x05},
						0x06 : {'offset':840,'bit':7,'bits':8,'parameter':'Tk1 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x06},
						0x07 : {'offset':864,'bit':1,'bits':2,'parameter':'Tk1 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x07},
						0x08 : {'offset':864,'bit':3,'bits':2,'parameter':'Tk1 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x08},
						0x09 : {'offset':864,'bit':6,'bits':2,'parameter':'Tk1 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x09},
						0x0A : {'offset':865,'bit':7,'bits':8,'parameter':'Tk1 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x0A},
						0x0B : {'offset':843,'bit':7,'bits':8,'parameter':'Tk1 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x0B},
						0x0C : {'offset':844,'bit':7,'bits':16,'parameter':'Tk1 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x0C},
						0x0D : {'offset':842,'bit':7,'bits':8,'parameter':'Tk1 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x0D},
						0x0E : {'offset':846,'bit':7,'bits':8,'parameter':'Tk1 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x0E},
						0x0F : {'offset':848,'bit':3,'bits':4,'parameter':'Tk1 Delay Tempo Base','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x0F},
						0x10 : {'offset':848,'bit':7,'bits':1,'parameter':'Tk1 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x10},
						0x11 : {'offset':849,'bit':7,'bits':8,'parameter':'Tk1 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x11},
						0x12 : {'offset':863,'bit':5,'bits':1,'parameter':'Tk1 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x12},
						0x13 : {'offset':861,'bit':0,'bits':1,'parameter':'Tk1 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x13},
						0x14 : {'offset':861,'bit':1,'bits':1,'parameter':'Tk1 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x14},
						0x15 : {'offset':861,'bit':2,'bits':1,'parameter':'Tk1 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x15},
						0x16 : {'offset':861,'bit':3,'bits':1,'parameter':'Tk1 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x16},
						0x17 : {'offset':861,'bit':4,'bits':1,'parameter':'Tk1 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x17},
						0x18 : {'offset':861,'bit':5,'bits':1,'parameter':'Tk1 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x18},
						0x19 : {'offset':861,'bit':6,'bits':1,'parameter':'Tk1 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x19},
						0x1A : {'offset':861,'bit':7,'bits':1,'parameter':'Tk1 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x1A},
						0x1B : {'offset':862,'bit':0,'bits':1,'parameter':'Tk1 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x1B},
						0x1C : {'offset':862,'bit':1,'bits':1,'parameter':'Tk1 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x1C},
						0x1D : {'offset':862,'bit':2,'bits':1,'parameter':'Tk1 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x1D},
						0x1E : {'offset':862,'bit':3,'bits':1,'parameter':'Tk1 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x1E},
						0x1F : {'offset':862,'bit':4,'bits':1,'parameter':'Tk1 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x1F},
						0x20 : {'offset':862,'bit':5,'bits':1,'parameter':'Tk1 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x20},
						0x21 : {'offset':862,'bit':6,'bits':1,'parameter':'Tk1 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x21},
						0x22 : {'offset':862,'bit':7,'bits':1,'parameter':'Tk1 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x22},
						0x23 : {'offset':863,'bit':0,'bits':1,'parameter':'Tk1 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x23},
						0x24 : {'offset':863,'bit':1,'bits':1,'parameter':'Tk1 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x24},
						0x25 : {'offset':863,'bit':2,'bits':1,'parameter':'Tk1 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x25},
						0x26 : {'offset':863,'bit':3,'bits':1,'parameter':'Tk1 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x26},
						0x27 : {'offset':863,'bit':4,'bits':1,'parameter':'Tk1 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x27},
						0x28 : {'offset':863,'bit':7,'bits':1,'parameter':'Tk1 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x28},
						0x29 : {'offset':-1,'bit':7,'bits':8,'parameter':'Track 1 Solo','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x29},
						0x2A : {'offset':863,'bit':6,'bits':1,'parameter':'Tk1 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x2A},
						0x2B : {'offset':872,'bit':6,'bits':7,'parameter':'Tk1 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x2B},
						0x2C : {'offset':872,'bit':7,'bits':1,'parameter':'Tk1 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x2C},
						0x2D : {'offset':874,'bit':7,'bits':8,'parameter':'Tk1 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x2D},
						0x2E : {'offset':875,'bit':7,'bits':8,'parameter':'Tk1 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x2E},
						0x2F : {'offset':876,'bit':7,'bits':8,'parameter':'Tk1 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x2F},
						0x30 : {'offset':877,'bit':7,'bits':8,'parameter':'Tk1 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x30},
						0x31 : {'offset':866,'bit':7,'bits':8,'parameter':'Tk1 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x31},
						0x32 : {'offset':868,'bit':3,'bits':4,'parameter':'Tk1 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x32},
						0x33 : {'offset':868,'bit':7,'bits':4,'parameter':'Tk1 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x33},
						0x34 : {'offset':867,'bit':7,'bits':8,'parameter':'Tk1 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x34},
						0x35 : {'offset':869,'bit':7,'bits':8,'parameter':'Tk1 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x35},
						0x36 : {'offset':871,'bit':3,'bits':4,'parameter':'Tk1 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x36},
						0x37 : {'offset':871,'bit':7,'bits':4,'parameter':'Tk1 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x37},
						0x38 : {'offset':870,'bit':7,'bits':8,'parameter':'Tk1 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x38},
						0x39 : {'offset':858,'bit':4,'bits':5,'parameter':'Tk1 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x39},
						0x3A : {'offset':858,'bit':6,'bits':2,'parameter':'Tk1 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x3A},
						0x3B : {'offset':851,'bit':7,'bits':8,'parameter':'Tk1 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x3B},
						0x3C : {'offset':852,'bit':7,'bits':8,'parameter':'Tk1 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x3C},
						0x3D : {'offset':853,'bit':7,'bits':8,'parameter':'Tk1 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x3D},
						0x3E : {'offset':854,'bit':7,'bits':8,'parameter':'Tk1 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x3E},
						0x3F : {'offset':855,'bit':7,'bits':8,'parameter':'Tk1 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x3F},
						0x40 : {'offset':856,'bit':7,'bits':8,'parameter':'Tk1 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x40},
						0x41 : {'offset':857,'bit':7,'bits':8,'parameter':'Tk1 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x41},
						0x42 : {'offset':864,'bit':7,'bits':1,'parameter':'Tk1 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0C,'subid':0x42},
					},
	0x0D :  {
						0x00 : {'offset':948,'bit':7,'bits':16,'parameter':'Tk2 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x00},
						0x01 : {'offset':962,'bit':7,'bits':8,'parameter':'Tk2 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x01},
						0x02 : {'offset':953,'bit':7,'bits':8,'parameter':'Tk2 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x02},
						0x03 : {'offset':950,'bit':7,'bits':3,'parameter':'Tk2 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x03},
						0x04 : {'offset':950,'bit':4,'bits':5,'parameter':'Tk2 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x04},
						0x05 : {'offset':951,'bit':7,'bits':8,'parameter':'Tk2 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x05},
						0x06 : {'offset':952,'bit':7,'bits':8,'parameter':'Tk2 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x06},
						0x07 : {'offset':976,'bit':1,'bits':2,'parameter':'Tk2 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x07},
						0x08 : {'offset':976,'bit':3,'bits':2,'parameter':'Tk2 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x08},
						0x09 : {'offset':976,'bit':6,'bits':2,'parameter':'Tk2 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x09},
						0x0A : {'offset':977,'bit':7,'bits':8,'parameter':'Tk2 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x0A},
						0x0B : {'offset':955,'bit':7,'bits':8,'parameter':'Tk2 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x0B},
						0x0C : {'offset':956,'bit':7,'bits':16,'parameter':'Tk2 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x0C},
						0x0D : {'offset':954,'bit':7,'bits':8,'parameter':'Tk2 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x0D},
						0x0E : {'offset':958,'bit':7,'bits':8,'parameter':'Tk2 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x0E},
						0x0F : {'offset':960,'bit':3,'bits':4,'parameter':'Tk2 Delay Tempo Base','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x0F},
						0x10 : {'offset':960,'bit':7,'bits':1,'parameter':'Tk2 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x10},
						0x11 : {'offset':961,'bit':7,'bits':8,'parameter':'Tk2 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x11},
						0x12 : {'offset':975,'bit':5,'bits':1,'parameter':'Tk2 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x12},
						0x13 : {'offset':973,'bit':0,'bits':1,'parameter':'Tk2 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x13},
						0x14 : {'offset':973,'bit':1,'bits':1,'parameter':'Tk2 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x14},
						0x15 : {'offset':973,'bit':2,'bits':1,'parameter':'Tk2 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x15},
						0x16 : {'offset':973,'bit':3,'bits':1,'parameter':'Tk2 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x16},
						0x17 : {'offset':973,'bit':4,'bits':1,'parameter':'Tk2 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x17},
						0x18 : {'offset':973,'bit':5,'bits':1,'parameter':'Tk2 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x18},
						0x19 : {'offset':973,'bit':6,'bits':1,'parameter':'Tk2 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x19},
						0x1A : {'offset':973,'bit':7,'bits':1,'parameter':'Tk2 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x1A},
						0x1B : {'offset':974,'bit':0,'bits':1,'parameter':'Tk2 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x1B},
						0x1C : {'offset':974,'bit':1,'bits':1,'parameter':'Tk2 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x1C},
						0x1D : {'offset':974,'bit':2,'bits':1,'parameter':'Tk2 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x1D},
						0x1E : {'offset':974,'bit':3,'bits':1,'parameter':'Tk2 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x1E},
						0x1F : {'offset':974,'bit':4,'bits':1,'parameter':'Tk2 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x1F},
						0x20 : {'offset':974,'bit':5,'bits':1,'parameter':'Tk2 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x20},
						0x21 : {'offset':974,'bit':6,'bits':1,'parameter':'Tk2 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x21},
						0x22 : {'offset':974,'bit':7,'bits':1,'parameter':'Tk2 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x22},
						0x23 : {'offset':975,'bit':0,'bits':1,'parameter':'Tk2 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x23},
						0x24 : {'offset':975,'bit':1,'bits':1,'parameter':'Tk2 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x24},
						0x25 : {'offset':975,'bit':2,'bits':1,'parameter':'Tk2 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x25},
						0x26 : {'offset':975,'bit':3,'bits':1,'parameter':'Tk2 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x26},
						0x27 : {'offset':975,'bit':4,'bits':1,'parameter':'Tk2 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x27},
						0x28 : {'offset':975,'bit':7,'bits':1,'parameter':'Tk2 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x28},
# 0x29
						0x29 : {'offset':-1,'bit':7,'bits':8,'parameter':'Track 2 Solo','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x29},
						0x2A : {'offset':975,'bit':6,'bits':1,'parameter':'Tk2 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x2A},
						0x2B : {'offset':984,'bit':6,'bits':7,'parameter':'Tk2 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x2B},
						0x2C : {'offset':984,'bit':7,'bits':1,'parameter':'Tk2 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x2C},
						0x2D : {'offset':986,'bit':7,'bits':8,'parameter':'Tk2 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x2D},
						0x2E : {'offset':987,'bit':7,'bits':8,'parameter':'Tk2 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x2E},
						0x2F : {'offset':988,'bit':7,'bits':8,'parameter':'Tk2 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x2F},
						0x30 : {'offset':989,'bit':7,'bits':8,'parameter':'Tk2 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x30},
						0x31 : {'offset':978,'bit':7,'bits':8,'parameter':'Tk2 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x31},
						0x32 : {'offset':980,'bit':3,'bits':4,'parameter':'Tk2 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x32},
						0x33 : {'offset':980,'bit':7,'bits':4,'parameter':'Tk2 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x33},
						0x34 : {'offset':979,'bit':7,'bits':8,'parameter':'Tk2 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x34},
						0x35 : {'offset':981,'bit':7,'bits':8,'parameter':'Tk2 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x35},
						0x36 : {'offset':983,'bit':3,'bits':4,'parameter':'Tk2 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x36},
						0x37 : {'offset':983,'bit':7,'bits':4,'parameter':'Tk2 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x37},
						0x38 : {'offset':982,'bit':7,'bits':8,'parameter':'Tk2 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x38},
						0x39 : {'offset':970,'bit':4,'bits':5,'parameter':'Tk2 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x39},
						0x3A : {'offset':970,'bit':6,'bits':2,'parameter':'Tk2 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x3A},
						0x3B : {'offset':963,'bit':7,'bits':8,'parameter':'Tk2 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x3B},
						0x3C : {'offset':964,'bit':7,'bits':8,'parameter':'Tk2 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x3C},
						0x3D : {'offset':965,'bit':7,'bits':8,'parameter':'Tk2 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x3D},
						0x3E : {'offset':966,'bit':7,'bits':8,'parameter':'Tk2 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x3E},
						0x3F : {'offset':967,'bit':7,'bits':8,'parameter':'Tk2 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x3F},
						0x40 : {'offset':968,'bit':7,'bits':8,'parameter':'Tk2 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x40},
						0x41 : {'offset':969,'bit':7,'bits':8,'parameter':'Tk2 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x41},
						0x42 : {'offset':976,'bit':7,'bits':1,'parameter':'Tk2 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0D,'subid':0x42},
					},
	0x0E :  {
						0x00 : {'offset':1060,'bit':7,'bits':16,'parameter':'Tk3 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x00},
						0x01 : {'offset':1074,'bit':7,'bits':8,'parameter':'Tk3 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x01},
						0x02 : {'offset':1065,'bit':7,'bits':8,'parameter':'Tk3 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x02},
						0x03 : {'offset':1062,'bit':7,'bits':3,'parameter':'Tk3 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x03},
						0x04 : {'offset':1062,'bit':4,'bits':5,'parameter':'Tk3 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x04},
						0x05 : {'offset':1063,'bit':7,'bits':8,'parameter':'Tk3 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x05},
						0x06 : {'offset':1064,'bit':7,'bits':8,'parameter':'Tk3 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x06},
						0x07 : {'offset':1088,'bit':1,'bits':2,'parameter':'Tk3 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x07},
						0x08 : {'offset':1088,'bit':3,'bits':2,'parameter':'Tk3 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x08},
						0x09 : {'offset':1088,'bit':6,'bits':2,'parameter':'Tk3 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x09},
						0x0A : {'offset':1089,'bit':7,'bits':8,'parameter':'Tk3 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x0A},
						0x0B : {'offset':1067,'bit':7,'bits':8,'parameter':'Tk3 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x0B},
						0x0C : {'offset':1068,'bit':7,'bits':16,'parameter':'Tk3 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x0C},
						0x0D : {'offset':1066,'bit':7,'bits':8,'parameter':'Tk3 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x0D},
						0x0E : {'offset':1070,'bit':7,'bits':8,'parameter':'Tk3 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x0E},
						0x0F : {'offset':1072,'bit':3,'bits':4,'parameter':'Tk3 Delay Tempo Base','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x0F},
						0x10 : {'offset':1072,'bit':7,'bits':1,'parameter':'Tk3 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x10},
						0x11 : {'offset':1073,'bit':7,'bits':8,'parameter':'Tk3 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x11},
						0x12 : {'offset':1087,'bit':5,'bits':1,'parameter':'Tk3 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x12},
						0x13 : {'offset':1085,'bit':0,'bits':1,'parameter':'Tk3 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x13},
						0x14 : {'offset':1085,'bit':1,'bits':1,'parameter':'Tk3 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x14},
						0x15 : {'offset':1085,'bit':2,'bits':1,'parameter':'Tk3 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x15},
						0x16 : {'offset':1085,'bit':3,'bits':1,'parameter':'Tk3 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x16},
						0x17 : {'offset':1085,'bit':4,'bits':1,'parameter':'Tk3 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x17},
						0x18 : {'offset':1085,'bit':5,'bits':1,'parameter':'Tk3 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x18},
						0x19 : {'offset':1085,'bit':6,'bits':1,'parameter':'Tk3 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x19},
						0x1A : {'offset':1085,'bit':7,'bits':1,'parameter':'Tk3 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x1A},
						0x1B : {'offset':1086,'bit':0,'bits':1,'parameter':'Tk3 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x1B},
						0x1C : {'offset':1086,'bit':1,'bits':1,'parameter':'Tk3 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x1C},
						0x1D : {'offset':1086,'bit':2,'bits':1,'parameter':'Tk3 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x1D},
						0x1E : {'offset':1086,'bit':3,'bits':1,'parameter':'Tk3 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x1E},
						0x1F : {'offset':1086,'bit':4,'bits':1,'parameter':'Tk3 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x1F},
						0x20 : {'offset':1086,'bit':5,'bits':1,'parameter':'Tk3 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x20},
						0x21 : {'offset':1086,'bit':6,'bits':1,'parameter':'Tk3 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x21},
						0x22 : {'offset':1086,'bit':7,'bits':1,'parameter':'Tk3 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x22},
						0x23 : {'offset':1087,'bit':0,'bits':1,'parameter':'Tk3 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x23},
						0x24 : {'offset':1087,'bit':1,'bits':1,'parameter':'Tk3 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x24},
						0x25 : {'offset':1087,'bit':2,'bits':1,'parameter':'Tk3 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x25},
						0x26 : {'offset':1087,'bit':3,'bits':1,'parameter':'Tk3 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x26},
						0x27 : {'offset':1087,'bit':4,'bits':1,'parameter':'Tk3 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x27},
						0x28 : {'offset':1087,'bit':7,'bits':1,'parameter':'Tk3 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x28},
# 0x29
						0x29 : {'offset':-1,'bit':7,'bits':8,'parameter':'Track 3 Solo','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x29},
						0x2A : {'offset':1087,'bit':6,'bits':1,'parameter':'Tk3 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x2A},
						0x2B : {'offset':1096,'bit':6,'bits':7,'parameter':'Tk3 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x2B},
						0x2C : {'offset':1096,'bit':7,'bits':1,'parameter':'Tk3 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x2C},
						0x2D : {'offset':1098,'bit':7,'bits':8,'parameter':'Tk3 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x2D},
						0x2E : {'offset':1099,'bit':7,'bits':8,'parameter':'Tk3 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x2E},
						0x2F : {'offset':1100,'bit':7,'bits':8,'parameter':'Tk3 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x2F},
						0x30 : {'offset':1101,'bit':7,'bits':8,'parameter':'Tk3 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x30},
						0x31 : {'offset':1090,'bit':7,'bits':8,'parameter':'Tk3 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x31},
						0x32 : {'offset':1092,'bit':3,'bits':4,'parameter':'Tk3 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x32},
						0x33 : {'offset':1092,'bit':7,'bits':4,'parameter':'Tk3 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x33},
						0x34 : {'offset':1091,'bit':7,'bits':8,'parameter':'Tk3 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x34},
						0x35 : {'offset':1093,'bit':7,'bits':8,'parameter':'Tk3 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x35},
						0x36 : {'offset':1095,'bit':3,'bits':4,'parameter':'Tk3 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x36},
						0x37 : {'offset':1095,'bit':7,'bits':4,'parameter':'Tk3 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x37},
						0x38 : {'offset':1094,'bit':7,'bits':8,'parameter':'Tk3 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x38},
						0x39 : {'offset':1082,'bit':4,'bits':5,'parameter':'Tk3 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x39},
						0x3A : {'offset':1082,'bit':6,'bits':2,'parameter':'Tk3 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x3A},
						0x3B : {'offset':1075,'bit':7,'bits':8,'parameter':'Tk3 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x3B},
						0x3C : {'offset':1076,'bit':7,'bits':8,'parameter':'Tk3 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x3C},
						0x3D : {'offset':1077,'bit':7,'bits':8,'parameter':'Tk3 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x3D},
						0x3E : {'offset':1078,'bit':7,'bits':8,'parameter':'Tk3 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x3E},
						0x3F : {'offset':1079,'bit':7,'bits':8,'parameter':'Tk3 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x3F},
						0x40 : {'offset':1080,'bit':7,'bits':8,'parameter':'Tk3 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x40},
						0x41 : {'offset':1081,'bit':7,'bits':8,'parameter':'Tk3 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x41},
						0x42 : {'offset':1088,'bit':7,'bits':1,'parameter':'Tk3 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0E,'subid':0x42},
					},
	0x0F :  {
						0x00 : {'offset':1172,'bit':7,'bits':16,'parameter':'Tk4 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x00},
						0x01 : {'offset':1186,'bit':7,'bits':8,'parameter':'Tk4 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x01},
						0x02 : {'offset':1177,'bit':7,'bits':8,'parameter':'Tk4 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x02},
						0x03 : {'offset':1174,'bit':7,'bits':3,'parameter':'Tk4 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x03},
						0x04 : {'offset':1174,'bit':4,'bits':5,'parameter':'Tk4 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x04},
						0x05 : {'offset':1175,'bit':7,'bits':8,'parameter':'Tk4 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x05},
						0x06 : {'offset':1176,'bit':7,'bits':8,'parameter':'Tk4 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x06},
						0x07 : {'offset':1200,'bit':1,'bits':2,'parameter':'Tk4 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x07},
						0x08 : {'offset':1200,'bit':3,'bits':2,'parameter':'Tk4 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x08},
						0x09 : {'offset':1200,'bit':6,'bits':2,'parameter':'Tk4 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x09},
						0x0A : {'offset':1201,'bit':7,'bits':8,'parameter':'Tk4 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x0A},
						0x0B : {'offset':1179,'bit':7,'bits':8,'parameter':'Tk4 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x0B},
						0x0C : {'offset':1180,'bit':7,'bits':16,'parameter':'Tk4 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x0C},
						0x0D : {'offset':1178,'bit':7,'bits':8,'parameter':'Tk4 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x0D},
						0x0E : {'offset':1182,'bit':7,'bits':8,'parameter':'Tk4 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x0E},
						0x0F : {'offset':1184,'bit':3,'bits':4,'parameter':'Tk4 Delay Tempo Base','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x0F},
						0x10 : {'offset':1184,'bit':7,'bits':1,'parameter':'Tk4 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x10},
						0x11 : {'offset':1185,'bit':7,'bits':8,'parameter':'Tk4 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x11},
						0x12 : {'offset':1199,'bit':5,'bits':1,'parameter':'Tk4 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x12},
						0x13 : {'offset':1197,'bit':0,'bits':1,'parameter':'Tk4 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x13},
						0x14 : {'offset':1197,'bit':1,'bits':1,'parameter':'Tk4 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x14},
						0x15 : {'offset':1197,'bit':2,'bits':1,'parameter':'Tk4 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x15},
						0x16 : {'offset':1197,'bit':3,'bits':1,'parameter':'Tk4 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x16},
						0x17 : {'offset':1197,'bit':4,'bits':1,'parameter':'Tk4 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x17},
						0x18 : {'offset':1197,'bit':5,'bits':1,'parameter':'Tk4 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x18},
						0x19 : {'offset':1197,'bit':6,'bits':1,'parameter':'Tk4 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x19},
						0x1A : {'offset':1197,'bit':7,'bits':1,'parameter':'Tk4 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x1A},
						0x1B : {'offset':1198,'bit':0,'bits':1,'parameter':'Tk4 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x1B},
						0x1C : {'offset':1198,'bit':1,'bits':1,'parameter':'Tk4 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x1C},
						0x1D : {'offset':1198,'bit':2,'bits':1,'parameter':'Tk4 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x1D},
						0x1E : {'offset':1198,'bit':3,'bits':1,'parameter':'Tk4 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x1E},
						0x1F : {'offset':1198,'bit':4,'bits':1,'parameter':'Tk4 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x1F},
						0x20 : {'offset':1198,'bit':5,'bits':1,'parameter':'Tk4 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x20},
						0x21 : {'offset':1198,'bit':6,'bits':1,'parameter':'Tk4 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x21},
						0x22 : {'offset':1198,'bit':7,'bits':1,'parameter':'Tk4 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x22},
						0x23 : {'offset':1199,'bit':0,'bits':1,'parameter':'Tk4 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x23},
						0x24 : {'offset':1199,'bit':1,'bits':1,'parameter':'Tk4 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x24},
						0x25 : {'offset':1199,'bit':2,'bits':1,'parameter':'Tk4 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x25},
						0x26 : {'offset':1199,'bit':3,'bits':1,'parameter':'Tk4 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x26},
						0x27 : {'offset':1199,'bit':4,'bits':1,'parameter':'Tk4 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x27},
						0x28 : {'offset':1199,'bit':7,'bits':1,'parameter':'Tk4 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x28},
# 0x29
						0x29 : {'offset':-1,'bit':7,'bits':8,'parameter':'Track 4 Solo','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x29},
						0x2A : {'offset':1199,'bit':6,'bits':1,'parameter':'Tk4 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x2A},
						0x2B : {'offset':1208,'bit':6,'bits':7,'parameter':'Tk4 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x2B},
						0x2C : {'offset':1208,'bit':7,'bits':1,'parameter':'Tk4 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x2C},
						0x2D : {'offset':1210,'bit':7,'bits':8,'parameter':'Tk4 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x2D},
						0x2E : {'offset':1211,'bit':7,'bits':8,'parameter':'Tk4 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x2E},
						0x2F : {'offset':1212,'bit':7,'bits':8,'parameter':'Tk4 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x2F},
						0x30 : {'offset':1213,'bit':7,'bits':8,'parameter':'Tk4 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x30},
						0x31 : {'offset':1202,'bit':7,'bits':8,'parameter':'Tk4 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x31},
						0x32 : {'offset':1204,'bit':3,'bits':4,'parameter':'Tk4 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x32},
						0x33 : {'offset':1204,'bit':7,'bits':4,'parameter':'Tk4 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x33},
						0x34 : {'offset':1203,'bit':7,'bits':8,'parameter':'Tk4 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x34},
						0x35 : {'offset':1205,'bit':7,'bits':8,'parameter':'Tk4 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x35},
						0x36 : {'offset':1207,'bit':3,'bits':4,'parameter':'Tk4 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x36},
						0x37 : {'offset':1207,'bit':7,'bits':4,'parameter':'Tk4 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x37},
						0x38 : {'offset':1206,'bit':7,'bits':8,'parameter':'Tk4 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x38},
						0x39 : {'offset':1194,'bit':4,'bits':5,'parameter':'Tk4 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x39},
						0x3A : {'offset':1194,'bit':6,'bits':2,'parameter':'Tk4 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x3A},
						0x3B : {'offset':1187,'bit':7,'bits':8,'parameter':'Tk4 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x3B},
						0x3C : {'offset':1188,'bit':7,'bits':8,'parameter':'Tk4 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x3C},
						0x3D : {'offset':1189,'bit':7,'bits':8,'parameter':'Tk4 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x3D},
						0x3E : {'offset':1190,'bit':7,'bits':8,'parameter':'Tk4 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x3E},
						0x3F : {'offset':1191,'bit':7,'bits':8,'parameter':'Tk4 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x3F},
						0x40 : {'offset':1192,'bit':7,'bits':8,'parameter':'Tk4 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x40},
						0x41 : {'offset':1193,'bit':7,'bits':8,'parameter':'Tk4 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x41},
						0x42 : {'offset':1200,'bit':7,'bits':1,'parameter':'Tk4 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x0F,'subid':0x42},
					},
	0x10 :  {
						0x00 : {'offset':1284,'bit':7,'bits':16,'parameter':'Tk5 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x00},
						0x01 : {'offset':1298,'bit':7,'bits':8,'parameter':'Tk5 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x01},
						0x02 : {'offset':1289,'bit':7,'bits':8,'parameter':'Tk5 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x02},
						0x03 : {'offset':1286,'bit':7,'bits':3,'parameter':'Tk5 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x03},
						0x04 : {'offset':1286,'bit':4,'bits':5,'parameter':'Tk5 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x04},
						0x05 : {'offset':1287,'bit':7,'bits':8,'parameter':'Tk5 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x05},
						0x06 : {'offset':1288,'bit':7,'bits':8,'parameter':'Tk5 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x06},
						0x07 : {'offset':1312,'bit':1,'bits':2,'parameter':'Tk5 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x07},
						0x08 : {'offset':1312,'bit':3,'bits':2,'parameter':'Tk5 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x08},
						0x09 : {'offset':1312,'bit':6,'bits':2,'parameter':'Tk5 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x09},
						0x0A : {'offset':1313,'bit':7,'bits':8,'parameter':'Tk5 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x0A},
						0x0B : {'offset':1291,'bit':7,'bits':8,'parameter':'Tk5 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x0B},
						0x0C : {'offset':1292,'bit':7,'bits':16,'parameter':'Tk5 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x0C},
						0x0D : {'offset':1290,'bit':7,'bits':8,'parameter':'Tk5 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x0D},
						0x0E : {'offset':1294,'bit':7,'bits':8,'parameter':'Tk5 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x0E},
						0x0F : {'offset':1296,'bit':3,'bits':4,'parameter':'Tk5 Delay Tempo Base','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x0F},
						0x10 : {'offset':1296,'bit':7,'bits':1,'parameter':'Tk5 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x10},
						0x11 : {'offset':1297,'bit':7,'bits':8,'parameter':'Tk5 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x11},
						0x12 : {'offset':1311,'bit':5,'bits':1,'parameter':'Tk5 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x12},
						0x13 : {'offset':1309,'bit':0,'bits':1,'parameter':'Tk5 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x13},
						0x14 : {'offset':1309,'bit':1,'bits':1,'parameter':'Tk5 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x14},
						0x15 : {'offset':1309,'bit':2,'bits':1,'parameter':'Tk5 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x15},
						0x16 : {'offset':1309,'bit':3,'bits':1,'parameter':'Tk5 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x16},
						0x17 : {'offset':1309,'bit':4,'bits':1,'parameter':'Tk5 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x17},
						0x18 : {'offset':1309,'bit':5,'bits':1,'parameter':'Tk5 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x18},
						0x19 : {'offset':1309,'bit':6,'bits':1,'parameter':'Tk5 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x19},
						0x1A : {'offset':1309,'bit':7,'bits':1,'parameter':'Tk5 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x1A},
						0x1B : {'offset':1310,'bit':0,'bits':1,'parameter':'Tk5 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x1B},
						0x1C : {'offset':1310,'bit':1,'bits':1,'parameter':'Tk5 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x1C},
						0x1D : {'offset':1310,'bit':2,'bits':1,'parameter':'Tk5 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x1D},
						0x1E : {'offset':1310,'bit':3,'bits':1,'parameter':'Tk5 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x1E},
						0x1F : {'offset':1310,'bit':4,'bits':1,'parameter':'Tk5 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x1F},
						0x20 : {'offset':1310,'bit':5,'bits':1,'parameter':'Tk5 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x20},
						0x21 : {'offset':1310,'bit':6,'bits':1,'parameter':'Tk5 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x21},
						0x22 : {'offset':1310,'bit':7,'bits':1,'parameter':'Tk5 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x22},
						0x23 : {'offset':1311,'bit':0,'bits':1,'parameter':'Tk5 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x23},
						0x24 : {'offset':1311,'bit':1,'bits':1,'parameter':'Tk5 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x24},
						0x25 : {'offset':1311,'bit':2,'bits':1,'parameter':'Tk5 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x25},
						0x26 : {'offset':1311,'bit':3,'bits':1,'parameter':'Tk5 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x26},
						0x27 : {'offset':1311,'bit':4,'bits':1,'parameter':'Tk5 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x27},
						0x28 : {'offset':1311,'bit':7,'bits':1,'parameter':'Tk5 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x28},
# 0x29
						0x29 : {'offset':-1,'bit':7,'bits':8,'parameter':'Track 5 Solo','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x29},
						0x2A : {'offset':1311,'bit':6,'bits':1,'parameter':'Tk5 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x2A},
						0x2B : {'offset':1320,'bit':6,'bits':7,'parameter':'Tk5 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x2B},
						0x2C : {'offset':1320,'bit':7,'bits':1,'parameter':'Tk5 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x2C},
						0x2D : {'offset':1322,'bit':7,'bits':8,'parameter':'Tk5 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x2D},
						0x2E : {'offset':1323,'bit':7,'bits':8,'parameter':'Tk5 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x2E},
						0x2F : {'offset':1324,'bit':7,'bits':8,'parameter':'Tk5 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x2F},
						0x30 : {'offset':1325,'bit':7,'bits':8,'parameter':'Tk5 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x30},
						0x31 : {'offset':1314,'bit':7,'bits':8,'parameter':'Tk5 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x31},
						0x32 : {'offset':1316,'bit':3,'bits':4,'parameter':'Tk5 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x32},
						0x33 : {'offset':1316,'bit':7,'bits':4,'parameter':'Tk5 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x33},
						0x34 : {'offset':1315,'bit':7,'bits':8,'parameter':'Tk5 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x34},
						0x35 : {'offset':1317,'bit':7,'bits':8,'parameter':'Tk5 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x35},
						0x36 : {'offset':1319,'bit':3,'bits':4,'parameter':'Tk5 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x36},
						0x37 : {'offset':1319,'bit':7,'bits':4,'parameter':'Tk5 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x37},
						0x38 : {'offset':1318,'bit':7,'bits':8,'parameter':'Tk5 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x38},
						0x39 : {'offset':1306,'bit':4,'bits':5,'parameter':'Tk5 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x39},
						0x3A : {'offset':1306,'bit':6,'bits':2,'parameter':'Tk5 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x3A},
						0x3B : {'offset':1299,'bit':7,'bits':8,'parameter':'Tk5 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x3B},
						0x3C : {'offset':1300,'bit':7,'bits':8,'parameter':'Tk5 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x3C},
						0x3D : {'offset':1301,'bit':7,'bits':8,'parameter':'Tk5 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x3D},
						0x3E : {'offset':1302,'bit':7,'bits':8,'parameter':'Tk5 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x3E},
						0x3F : {'offset':1303,'bit':7,'bits':8,'parameter':'Tk5 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x3F},
						0x40 : {'offset':1304,'bit':7,'bits':8,'parameter':'Tk5 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x40},
						0x41 : {'offset':1305,'bit':7,'bits':8,'parameter':'Tk5 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x41},
						0x42 : {'offset':1312,'bit':7,'bits':1,'parameter':'Tk5 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x10,'subid':0x42},
					},
	0x11 :  {
						0x00 : {'offset':1396,'bit':7,'bits':16,'parameter':'Tk6 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x00},
						0x01 : {'offset':1410,'bit':7,'bits':8,'parameter':'Tk6 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x01},
						0x02 : {'offset':1401,'bit':7,'bits':8,'parameter':'Tk6 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x02},
						0x03 : {'offset':1398,'bit':7,'bits':3,'parameter':'Tk6 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x03},
						0x04 : {'offset':1398,'bit':4,'bits':5,'parameter':'Tk6 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x04},
						0x05 : {'offset':1399,'bit':7,'bits':8,'parameter':'Tk6 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x05},
						0x06 : {'offset':1400,'bit':7,'bits':8,'parameter':'Tk6 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x06},
						0x07 : {'offset':1424,'bit':1,'bits':2,'parameter':'Tk6 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x07},
						0x08 : {'offset':1424,'bit':3,'bits':2,'parameter':'Tk6 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x08},
						0x09 : {'offset':1424,'bit':6,'bits':2,'parameter':'Tk6 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x09},
						0x0A : {'offset':1425,'bit':7,'bits':8,'parameter':'Tk6 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x0A},
						0x0B : {'offset':1403,'bit':7,'bits':8,'parameter':'Tk6 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x0B},
						0x0C : {'offset':1404,'bit':7,'bits':16,'parameter':'Tk6 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x0C},
						0x0D : {'offset':1402,'bit':7,'bits':8,'parameter':'Tk6 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x0D},
						0x0E : {'offset':1406,'bit':7,'bits':8,'parameter':'Tk6 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x0E},
						0x0F : {'offset':1408,'bit':3,'bits':4,'parameter':'Tk6 Delay Tempo Base','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x0F},
						0x10 : {'offset':1408,'bit':7,'bits':1,'parameter':'Tk6 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x10},
						0x11 : {'offset':1409,'bit':7,'bits':8,'parameter':'Tk6 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x11},
						0x12 : {'offset':1423,'bit':5,'bits':1,'parameter':'Tk6 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x12},
						0x13 : {'offset':1421,'bit':0,'bits':1,'parameter':'Tk6 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x13},
						0x14 : {'offset':1421,'bit':1,'bits':1,'parameter':'Tk6 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x14},
						0x15 : {'offset':1421,'bit':2,'bits':1,'parameter':'Tk6 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x15},
						0x16 : {'offset':1421,'bit':3,'bits':1,'parameter':'Tk6 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x16},
						0x17 : {'offset':1421,'bit':4,'bits':1,'parameter':'Tk6 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x17},
						0x18 : {'offset':1421,'bit':5,'bits':1,'parameter':'Tk6 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x18},
						0x19 : {'offset':1421,'bit':6,'bits':1,'parameter':'Tk6 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x19},
						0x1A : {'offset':1421,'bit':7,'bits':1,'parameter':'Tk6 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x1A},
						0x1B : {'offset':1422,'bit':0,'bits':1,'parameter':'Tk6 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x1B},
						0x1C : {'offset':1422,'bit':1,'bits':1,'parameter':'Tk6 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x1C},
						0x1D : {'offset':1422,'bit':2,'bits':1,'parameter':'Tk6 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x1D},
						0x1E : {'offset':1422,'bit':3,'bits':1,'parameter':'Tk6 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x1E},
						0x1F : {'offset':1422,'bit':4,'bits':1,'parameter':'Tk6 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x1F},
						0x20 : {'offset':1422,'bit':5,'bits':1,'parameter':'Tk6 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x20},
						0x21 : {'offset':1422,'bit':6,'bits':1,'parameter':'Tk6 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x21},
						0x22 : {'offset':1422,'bit':7,'bits':1,'parameter':'Tk6 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x22},
						0x23 : {'offset':1423,'bit':0,'bits':1,'parameter':'Tk6 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x23},
						0x24 : {'offset':1423,'bit':1,'bits':1,'parameter':'Tk6 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x24},
						0x25 : {'offset':1423,'bit':2,'bits':1,'parameter':'Tk6 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x25},
						0x26 : {'offset':1423,'bit':3,'bits':1,'parameter':'Tk6 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x26},
						0x27 : {'offset':1423,'bit':4,'bits':1,'parameter':'Tk6 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x27},
						0x28 : {'offset':1423,'bit':7,'bits':1,'parameter':'Tk6 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x28},
# 0x29
						0x29 : {'offset':-1,'bit':7,'bits':8,'parameter':'Track 6 Solo','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x29},
						0x2A : {'offset':1423,'bit':6,'bits':1,'parameter':'Tk6 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x2A},
						0x2B : {'offset':1432,'bit':6,'bits':7,'parameter':'Tk6 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x2B},
						0x2C : {'offset':1432,'bit':7,'bits':1,'parameter':'Tk6 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x2C},
						0x2D : {'offset':1434,'bit':7,'bits':8,'parameter':'Tk6 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x2D},
						0x2E : {'offset':1435,'bit':7,'bits':8,'parameter':'Tk6 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x2E},
						0x2F : {'offset':1436,'bit':7,'bits':8,'parameter':'Tk6 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x2F},
						0x30 : {'offset':1437,'bit':7,'bits':8,'parameter':'Tk6 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x30},
						0x31 : {'offset':1426,'bit':7,'bits':8,'parameter':'Tk6 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x31},
						0x32 : {'offset':1428,'bit':3,'bits':4,'parameter':'Tk6 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x32},
						0x33 : {'offset':1428,'bit':7,'bits':4,'parameter':'Tk6 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x33},
						0x34 : {'offset':1427,'bit':7,'bits':8,'parameter':'Tk6 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x34},
						0x35 : {'offset':1429,'bit':7,'bits':8,'parameter':'Tk6 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x35},
						0x36 : {'offset':1431,'bit':3,'bits':4,'parameter':'Tk6 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x36},
						0x37 : {'offset':1431,'bit':7,'bits':4,'parameter':'Tk6 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x37},
						0x38 : {'offset':1430,'bit':7,'bits':8,'parameter':'Tk6 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x38},
						0x39 : {'offset':1418,'bit':4,'bits':5,'parameter':'Tk6 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x39},
						0x3A : {'offset':1418,'bit':6,'bits':2,'parameter':'Tk6 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x3A},
						0x3B : {'offset':1411,'bit':7,'bits':8,'parameter':'Tk6 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x3B},
						0x3C : {'offset':1412,'bit':7,'bits':8,'parameter':'Tk6 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x3C},
						0x3D : {'offset':1413,'bit':7,'bits':8,'parameter':'Tk6 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x3D},
						0x3E : {'offset':1414,'bit':7,'bits':8,'parameter':'Tk6 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x3E},
						0x3F : {'offset':1415,'bit':7,'bits':8,'parameter':'Tk6 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x3F},
						0x40 : {'offset':1416,'bit':7,'bits':8,'parameter':'Tk6 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x40},
						0x41 : {'offset':1417,'bit':7,'bits':8,'parameter':'Tk6 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x41},
						0x42 : {'offset':1424,'bit':7,'bits':1,'parameter':'Tk6 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x11,'subid':0x42},
					},
	0x12 :  {
						0x00 : {'offset':1508,'bit':7,'bits':16,'parameter':'Tk7 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x00},
						0x01 : {'offset':1522,'bit':7,'bits':8,'parameter':'Tk7 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x01},
						0x02 : {'offset':1513,'bit':7,'bits':8,'parameter':'Tk7 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x02},
						0x03 : {'offset':1510,'bit':7,'bits':3,'parameter':'Tk7 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x03},
						0x04 : {'offset':1510,'bit':4,'bits':5,'parameter':'Tk7 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x04},
						0x05 : {'offset':1511,'bit':7,'bits':8,'parameter':'Tk7 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x05},
						0x06 : {'offset':1512,'bit':7,'bits':8,'parameter':'Tk7 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x06},
						0x07 : {'offset':1536,'bit':1,'bits':2,'parameter':'Tk7 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x07},
						0x08 : {'offset':1536,'bit':3,'bits':2,'parameter':'Tk7 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x08},
						0x09 : {'offset':1536,'bit':6,'bits':2,'parameter':'Tk7 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x09},
						0x0A : {'offset':1537,'bit':7,'bits':8,'parameter':'Tk7 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x0A},
						0x0B : {'offset':1515,'bit':7,'bits':8,'parameter':'Tk7 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x0B},
						0x0C : {'offset':1516,'bit':7,'bits':16,'parameter':'Tk7 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x0C},
						0x0D : {'offset':1514,'bit':7,'bits':8,'parameter':'Tk7 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x0D},
						0x0E : {'offset':1518,'bit':7,'bits':8,'parameter':'Tk7 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x0E},
						0x0F : {'offset':1520,'bit':3,'bits':4,'parameter':'Tk7 Delay Tempo Base','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x0F},
						0x10 : {'offset':1520,'bit':7,'bits':1,'parameter':'Tk7 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x10},
						0x11 : {'offset':1521,'bit':7,'bits':8,'parameter':'Tk7 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x11},
						0x12 : {'offset':1535,'bit':5,'bits':1,'parameter':'Tk7 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x12},
						0x13 : {'offset':1533,'bit':0,'bits':1,'parameter':'Tk7 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x13},
						0x14 : {'offset':1533,'bit':1,'bits':1,'parameter':'Tk7 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x14},
						0x15 : {'offset':1533,'bit':2,'bits':1,'parameter':'Tk7 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x15},
						0x16 : {'offset':1533,'bit':3,'bits':1,'parameter':'Tk7 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x16},
						0x17 : {'offset':1533,'bit':4,'bits':1,'parameter':'Tk7 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x17},
						0x18 : {'offset':1533,'bit':5,'bits':1,'parameter':'Tk7 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x18},
						0x19 : {'offset':1533,'bit':6,'bits':1,'parameter':'Tk7 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x19},
						0x1A : {'offset':1533,'bit':7,'bits':1,'parameter':'Tk7 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x1A},
						0x1B : {'offset':1534,'bit':0,'bits':1,'parameter':'Tk7 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x1B},
						0x1C : {'offset':1534,'bit':1,'bits':1,'parameter':'Tk7 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x1C},
						0x1D : {'offset':1534,'bit':2,'bits':1,'parameter':'Tk7 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x1D},
						0x1E : {'offset':1534,'bit':3,'bits':1,'parameter':'Tk7 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x1E},
						0x1F : {'offset':1534,'bit':4,'bits':1,'parameter':'Tk7 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x1F},
						0x20 : {'offset':1534,'bit':5,'bits':1,'parameter':'Tk7 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x20},
						0x21 : {'offset':1534,'bit':6,'bits':1,'parameter':'Tk7 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x21},
						0x22 : {'offset':1534,'bit':7,'bits':1,'parameter':'Tk7 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x22},
						0x23 : {'offset':1535,'bit':0,'bits':1,'parameter':'Tk7 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x23},
						0x24 : {'offset':1535,'bit':1,'bits':1,'parameter':'Tk7 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x24},
						0x25 : {'offset':1535,'bit':2,'bits':1,'parameter':'Tk7 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x25},
						0x26 : {'offset':1535,'bit':3,'bits':1,'parameter':'Tk7 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x26},
						0x27 : {'offset':1535,'bit':4,'bits':1,'parameter':'Tk7 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x27},
						0x28 : {'offset':1535,'bit':7,'bits':1,'parameter':'Tk7 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x28},
# 0x29
						0x29 : {'offset':-1,'bit':7,'bits':8,'parameter':'Track 7 Solo','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x29},
						0x2A : {'offset':1535,'bit':6,'bits':1,'parameter':'Tk7 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x2A},
						0x2B : {'offset':1544,'bit':6,'bits':7,'parameter':'Tk7 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x2B},
						0x2C : {'offset':1544,'bit':7,'bits':1,'parameter':'Tk7 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x2C},
						0x2D : {'offset':1546,'bit':7,'bits':8,'parameter':'Tk7 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x2D},
						0x2E : {'offset':1547,'bit':7,'bits':8,'parameter':'Tk7 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x2E},
						0x2F : {'offset':1548,'bit':7,'bits':8,'parameter':'Tk7 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x2F},
						0x30 : {'offset':1549,'bit':7,'bits':8,'parameter':'Tk7 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x30},
						0x31 : {'offset':1538,'bit':7,'bits':8,'parameter':'Tk7 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x31},
						0x32 : {'offset':1540,'bit':3,'bits':4,'parameter':'Tk7 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x32},
						0x33 : {'offset':1540,'bit':7,'bits':4,'parameter':'Tk7 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x33},
						0x34 : {'offset':1539,'bit':7,'bits':8,'parameter':'Tk7 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x34},
						0x35 : {'offset':1541,'bit':7,'bits':8,'parameter':'Tk7 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x35},
						0x36 : {'offset':1543,'bit':3,'bits':4,'parameter':'Tk7 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x36},
						0x37 : {'offset':1543,'bit':7,'bits':4,'parameter':'Tk7 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x37},
						0x38 : {'offset':1542,'bit':7,'bits':8,'parameter':'Tk7 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x38},
						0x39 : {'offset':1530,'bit':4,'bits':5,'parameter':'Tk7 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x39},
						0x3A : {'offset':1530,'bit':6,'bits':2,'parameter':'Tk7 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x3A},
						0x3B : {'offset':1523,'bit':7,'bits':8,'parameter':'Tk7 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x3B},
						0x3C : {'offset':1524,'bit':7,'bits':8,'parameter':'Tk7 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x3C},
						0x3D : {'offset':1525,'bit':7,'bits':8,'parameter':'Tk7 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x3D},
						0x3E : {'offset':1526,'bit':7,'bits':8,'parameter':'Tk7 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x3E},
						0x3F : {'offset':1527,'bit':7,'bits':8,'parameter':'Tk7 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x3F},
						0x40 : {'offset':1528,'bit':7,'bits':8,'parameter':'Tk7 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x40},
						0x41 : {'offset':1529,'bit':7,'bits':8,'parameter':'Tk7 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x41},
						0x42 : {'offset':1536,'bit':7,'bits':1,'parameter':'Tk7 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x12,'subid':0x42},
					},
	0x13 :  {
						0x00 : {'offset':1620,'bit':7,'bits':16,'parameter':'Tk8 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x00},
						0x01 : {'offset':1634,'bit':7,'bits':8,'parameter':'Tk8 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x01},
						0x02 : {'offset':1625,'bit':7,'bits':8,'parameter':'Tk8 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x02},
						0x03 : {'offset':1622,'bit':7,'bits':3,'parameter':'Tk8 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x03},
						0x04 : {'offset':1622,'bit':4,'bits':5,'parameter':'Tk8 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x04},
						0x05 : {'offset':1623,'bit':7,'bits':8,'parameter':'Tk8 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x05},
						0x06 : {'offset':1624,'bit':7,'bits':8,'parameter':'Tk8 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x06},
						0x07 : {'offset':1648,'bit':1,'bits':2,'parameter':'Tk8 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x07},
						0x08 : {'offset':1648,'bit':3,'bits':2,'parameter':'Tk8 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x08},
						0x09 : {'offset':1648,'bit':6,'bits':2,'parameter':'Tk8 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x09},
						0x0A : {'offset':1649,'bit':7,'bits':8,'parameter':'Tk8 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x0A},
						0x0B : {'offset':1627,'bit':7,'bits':8,'parameter':'Tk8 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x0B},
						0x0C : {'offset':1628,'bit':7,'bits':16,'parameter':'Tk8 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x0C},
						0x0D : {'offset':1626,'bit':7,'bits':8,'parameter':'Tk8 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x0D},
						0x0E : {'offset':1630,'bit':7,'bits':8,'parameter':'Tk8 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x0E},
						0x0F : {'offset':1632,'bit':3,'bits':4,'parameter':'Tk8 Delay Tempo Base','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x0F},
						0x10 : {'offset':1632,'bit':7,'bits':1,'parameter':'Tk8 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x10},
						0x11 : {'offset':1633,'bit':7,'bits':8,'parameter':'Tk8 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x11},
						0x12 : {'offset':1647,'bit':5,'bits':1,'parameter':'Tk8 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x12},
						0x13 : {'offset':1645,'bit':0,'bits':1,'parameter':'Tk8 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x13},
						0x14 : {'offset':1645,'bit':1,'bits':1,'parameter':'Tk8 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x14},
						0x15 : {'offset':1645,'bit':2,'bits':1,'parameter':'Tk8 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x15},
						0x16 : {'offset':1645,'bit':3,'bits':1,'parameter':'Tk8 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x16},
						0x17 : {'offset':1645,'bit':4,'bits':1,'parameter':'Tk8 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x17},
						0x18 : {'offset':1645,'bit':5,'bits':1,'parameter':'Tk8 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x18},
						0x19 : {'offset':1645,'bit':6,'bits':1,'parameter':'Tk8 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x19},
						0x1A : {'offset':1645,'bit':7,'bits':1,'parameter':'Tk8 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x1A},
						0x1B : {'offset':1646,'bit':0,'bits':1,'parameter':'Tk8 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x1B},
						0x1C : {'offset':1646,'bit':1,'bits':1,'parameter':'Tk8 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x1C},
						0x1D : {'offset':1646,'bit':2,'bits':1,'parameter':'Tk8 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x1D},
						0x1E : {'offset':1646,'bit':3,'bits':1,'parameter':'Tk8 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x1E},
						0x1F : {'offset':1646,'bit':4,'bits':1,'parameter':'Tk8 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x1F},
						0x20 : {'offset':1646,'bit':5,'bits':1,'parameter':'Tk8 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x20},
						0x21 : {'offset':1646,'bit':6,'bits':1,'parameter':'Tk8 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x21},
						0x22 : {'offset':1646,'bit':7,'bits':1,'parameter':'Tk8 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x22},
						0x23 : {'offset':1647,'bit':0,'bits':1,'parameter':'Tk8 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x23},
						0x24 : {'offset':1647,'bit':1,'bits':1,'parameter':'Tk8 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x24},
						0x25 : {'offset':1647,'bit':2,'bits':1,'parameter':'Tk8 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x25},
						0x26 : {'offset':1647,'bit':3,'bits':1,'parameter':'Tk8 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x26},
						0x27 : {'offset':1647,'bit':4,'bits':1,'parameter':'Tk8 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x27},
						0x28 : {'offset':1647,'bit':7,'bits':1,'parameter':'Tk8 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x28},
# 0x29
						0x29 : {'offset':-1,'bit':7,'bits':8,'parameter':'Track 8 Solo','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x29},
						0x2A : {'offset':1647,'bit':6,'bits':1,'parameter':'Tk8 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x2A},
						0x2B : {'offset':1656,'bit':6,'bits':7,'parameter':'Tk8 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x2B},
						0x2C : {'offset':1656,'bit':7,'bits':1,'parameter':'Tk8 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x2C},
						0x2D : {'offset':1658,'bit':7,'bits':8,'parameter':'Tk8 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x2D},
						0x2E : {'offset':1659,'bit':7,'bits':8,'parameter':'Tk8 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x2E},
						0x2F : {'offset':1660,'bit':7,'bits':8,'parameter':'Tk8 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x2F},
						0x30 : {'offset':1661,'bit':7,'bits':8,'parameter':'Tk8 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x30},
						0x31 : {'offset':1650,'bit':7,'bits':8,'parameter':'Tk8 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x31},
						0x32 : {'offset':1652,'bit':3,'bits':4,'parameter':'Tk8 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x32},
						0x33 : {'offset':1652,'bit':7,'bits':4,'parameter':'Tk8 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x33},
						0x34 : {'offset':1651,'bit':7,'bits':8,'parameter':'Tk8 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x34},
						0x35 : {'offset':1653,'bit':7,'bits':8,'parameter':'Tk8 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x35},
						0x36 : {'offset':1655,'bit':3,'bits':4,'parameter':'Tk8 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x36},
						0x37 : {'offset':1655,'bit':7,'bits':4,'parameter':'Tk8 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x37},
						0x38 : {'offset':1654,'bit':7,'bits':8,'parameter':'Tk8 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x38},
						0x39 : {'offset':1642,'bit':4,'bits':5,'parameter':'Tk8 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x39},
						0x3A : {'offset':1642,'bit':6,'bits':2,'parameter':'Tk8 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x3A},
						0x3B : {'offset':1635,'bit':7,'bits':8,'parameter':'Tk8 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x3B},
						0x3C : {'offset':1636,'bit':7,'bits':8,'parameter':'Tk8 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x3C},
						0x3D : {'offset':1637,'bit':7,'bits':8,'parameter':'Tk8 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x3D},
						0x3E : {'offset':1638,'bit':7,'bits':8,'parameter':'Tk8 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x3E},
						0x3F : {'offset':1639,'bit':7,'bits':8,'parameter':'Tk8 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x3F},
						0x40 : {'offset':1640,'bit':7,'bits':8,'parameter':'Tk8 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x40},
						0x41 : {'offset':1641,'bit':7,'bits':8,'parameter':'Tk8 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x41},
						0x42 : {'offset':1648,'bit':7,'bits':1,'parameter':'Tk8 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x13,'subid':0x42},
					},
	0x14 :  {
						0x00 : {'offset':1732,'bit':7,'bits':16,'parameter':'Tk9 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x00},
						0x01 : {'offset':1746,'bit':7,'bits':8,'parameter':'Tk9 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x01},
						0x02 : {'offset':1737,'bit':7,'bits':8,'parameter':'Tk9 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x02},
						0x03 : {'offset':1734,'bit':7,'bits':3,'parameter':'Tk9 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x03},
						0x04 : {'offset':1734,'bit':4,'bits':5,'parameter':'Tk9 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x04},
						0x05 : {'offset':1735,'bit':7,'bits':8,'parameter':'Tk9 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x05},
						0x06 : {'offset':1736,'bit':7,'bits':8,'parameter':'Tk9 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x06},
						0x07 : {'offset':1760,'bit':1,'bits':2,'parameter':'Tk9 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x07},
						0x08 : {'offset':1760,'bit':3,'bits':2,'parameter':'Tk9 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x08},
						0x09 : {'offset':1760,'bit':6,'bits':2,'parameter':'Tk9 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x09},
						0x0A : {'offset':1761,'bit':7,'bits':8,'parameter':'Tk9 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x0A},
						0x0B : {'offset':1739,'bit':7,'bits':8,'parameter':'Tk9 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x0B},
						0x0C : {'offset':1740,'bit':7,'bits':16,'parameter':'Tk9 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x0C},
						0x0D : {'offset':1738,'bit':7,'bits':8,'parameter':'Tk9 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x0D},
						0x0E : {'offset':1742,'bit':7,'bits':8,'parameter':'Tk9 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x0E},
						0x0F : {'offset':1744,'bit':3,'bits':4,'parameter':'Tk9 Delay Tempo Base','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x0F},
						0x10 : {'offset':1744,'bit':7,'bits':1,'parameter':'Tk9 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x10},
						0x11 : {'offset':1745,'bit':7,'bits':8,'parameter':'Tk9 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x11},
						0x12 : {'offset':1759,'bit':5,'bits':1,'parameter':'Tk9 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x12},
						0x13 : {'offset':1757,'bit':0,'bits':1,'parameter':'Tk9 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x13},
						0x14 : {'offset':1757,'bit':1,'bits':1,'parameter':'Tk9 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x14},
						0x15 : {'offset':1757,'bit':2,'bits':1,'parameter':'Tk9 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x15},
						0x16 : {'offset':1757,'bit':3,'bits':1,'parameter':'Tk9 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x16},
						0x17 : {'offset':1757,'bit':4,'bits':1,'parameter':'Tk9 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x17},
						0x18 : {'offset':1757,'bit':5,'bits':1,'parameter':'Tk9 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x18},
						0x19 : {'offset':1757,'bit':6,'bits':1,'parameter':'Tk9 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x19},
						0x1A : {'offset':1757,'bit':7,'bits':1,'parameter':'Tk9 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x1A},
						0x1B : {'offset':1758,'bit':0,'bits':1,'parameter':'Tk9 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x1B},
						0x1C : {'offset':1758,'bit':1,'bits':1,'parameter':'Tk9 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x1C},
						0x1D : {'offset':1758,'bit':2,'bits':1,'parameter':'Tk9 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x1D},
						0x1E : {'offset':1758,'bit':3,'bits':1,'parameter':'Tk9 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x1E},
						0x1F : {'offset':1758,'bit':4,'bits':1,'parameter':'Tk9 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x1F},
						0x20 : {'offset':1758,'bit':5,'bits':1,'parameter':'Tk9 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x20},
						0x21 : {'offset':1758,'bit':6,'bits':1,'parameter':'Tk9 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x21},
						0x22 : {'offset':1758,'bit':7,'bits':1,'parameter':'Tk9 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x22},
						0x23 : {'offset':1759,'bit':0,'bits':1,'parameter':'Tk9 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x23},
						0x24 : {'offset':1759,'bit':1,'bits':1,'parameter':'Tk9 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x24},
						0x25 : {'offset':1759,'bit':2,'bits':1,'parameter':'Tk9 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x25},
						0x26 : {'offset':1759,'bit':3,'bits':1,'parameter':'Tk9 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x26},
						0x27 : {'offset':1759,'bit':4,'bits':1,'parameter':'Tk9 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x27},
						0x28 : {'offset':1759,'bit':7,'bits':1,'parameter':'Tk9 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x28},
# 0x29
						0x29 : {'offset':-1,'bit':7,'bits':8,'parameter':'Track 9 Solo','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x29},
						0x2A : {'offset':1759,'bit':6,'bits':1,'parameter':'Tk9 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x2A},
						0x2B : {'offset':1768,'bit':6,'bits':7,'parameter':'Tk9 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x2B},
						0x2C : {'offset':1768,'bit':7,'bits':1,'parameter':'Tk9 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x2C},
						0x2D : {'offset':1770,'bit':7,'bits':8,'parameter':'Tk9 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x2D},
						0x2E : {'offset':1771,'bit':7,'bits':8,'parameter':'Tk9 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x2E},
						0x2F : {'offset':1772,'bit':7,'bits':8,'parameter':'Tk9 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x2F},
						0x30 : {'offset':1773,'bit':7,'bits':8,'parameter':'Tk9 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x30},
						0x31 : {'offset':1762,'bit':7,'bits':8,'parameter':'Tk9 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x31},
						0x32 : {'offset':1764,'bit':3,'bits':4,'parameter':'Tk9 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x32},
						0x33 : {'offset':1764,'bit':7,'bits':4,'parameter':'Tk9 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x33},
						0x34 : {'offset':1763,'bit':7,'bits':8,'parameter':'Tk9 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x34},
						0x35 : {'offset':1765,'bit':7,'bits':8,'parameter':'Tk9 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x35},
						0x36 : {'offset':1767,'bit':3,'bits':4,'parameter':'Tk9 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x36},
						0x37 : {'offset':1767,'bit':7,'bits':4,'parameter':'Tk9 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x37},
						0x38 : {'offset':1766,'bit':7,'bits':8,'parameter':'Tk9 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x38},
						0x39 : {'offset':1754,'bit':4,'bits':5,'parameter':'Tk9 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x39},
						0x3A : {'offset':1754,'bit':6,'bits':2,'parameter':'Tk9 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x3A},
						0x3B : {'offset':1747,'bit':7,'bits':8,'parameter':'Tk9 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x3B},
						0x3C : {'offset':1748,'bit':7,'bits':8,'parameter':'Tk9 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x3C},
						0x3D : {'offset':1749,'bit':7,'bits':8,'parameter':'Tk9 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x3D},
						0x3E : {'offset':1750,'bit':7,'bits':8,'parameter':'Tk9 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x3E},
						0x3F : {'offset':1751,'bit':7,'bits':8,'parameter':'Tk9 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x3F},
						0x40 : {'offset':1752,'bit':7,'bits':8,'parameter':'Tk9 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x40},
						0x41 : {'offset':1753,'bit':7,'bits':8,'parameter':'Tk9 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x41},
						0x42 : {'offset':1760,'bit':7,'bits':1,'parameter':'Tk9 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x14,'subid':0x42},
					},
	0x15 :  {
						0x00 : {'offset':1844,'bit':7,'bits':16,'parameter':'Tk10 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x00},
						0x01 : {'offset':1858,'bit':7,'bits':8,'parameter':'Tk10 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x01},
						0x02 : {'offset':1849,'bit':7,'bits':8,'parameter':'Tk10 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x02},
						0x03 : {'offset':1846,'bit':7,'bits':3,'parameter':'Tk10 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x03},
						0x04 : {'offset':1846,'bit':4,'bits':5,'parameter':'Tk10 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x04},
						0x05 : {'offset':1847,'bit':7,'bits':8,'parameter':'Tk10 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x05},
						0x06 : {'offset':1848,'bit':7,'bits':8,'parameter':'Tk10 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x06},
						0x07 : {'offset':1872,'bit':1,'bits':2,'parameter':'Tk10 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x07},
						0x08 : {'offset':1872,'bit':3,'bits':2,'parameter':'Tk10 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x08},
						0x09 : {'offset':1872,'bit':6,'bits':2,'parameter':'Tk10 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x09},
						0x0A : {'offset':1873,'bit':7,'bits':8,'parameter':'Tk10 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x0A},
						0x0B : {'offset':1851,'bit':7,'bits':8,'parameter':'Tk10 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x0B},
						0x0C : {'offset':1852,'bit':7,'bits':16,'parameter':'Tk10 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x0C},
						0x0D : {'offset':1850,'bit':7,'bits':8,'parameter':'Tk10 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x0D},
						0x0E : {'offset':1854,'bit':7,'bits':8,'parameter':'Tk10 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x0E},
						0x0F : {'offset':1856,'bit':3,'bits':4,'parameter':'Tk10 Delay Tempo Base','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x0F},
						0x10 : {'offset':1856,'bit':7,'bits':1,'parameter':'Tk10 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x10},
						0x11 : {'offset':1857,'bit':7,'bits':8,'parameter':'Tk10 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x11},
						0x12 : {'offset':1871,'bit':5,'bits':1,'parameter':'Tk10 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x12},
						0x13 : {'offset':1869,'bit':0,'bits':1,'parameter':'Tk10 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x13},
						0x14 : {'offset':1869,'bit':1,'bits':1,'parameter':'Tk10 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x14},
						0x15 : {'offset':1869,'bit':2,'bits':1,'parameter':'Tk10 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x15},
						0x16 : {'offset':1869,'bit':3,'bits':1,'parameter':'Tk10 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x16},
						0x17 : {'offset':1869,'bit':4,'bits':1,'parameter':'Tk10 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x17},
						0x18 : {'offset':1869,'bit':5,'bits':1,'parameter':'Tk10 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x18},
						0x19 : {'offset':1869,'bit':6,'bits':1,'parameter':'Tk10 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x19},
						0x1A : {'offset':1869,'bit':7,'bits':1,'parameter':'Tk10 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x1A},
						0x1B : {'offset':1870,'bit':0,'bits':1,'parameter':'Tk10 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x1B},
						0x1C : {'offset':1870,'bit':1,'bits':1,'parameter':'Tk10 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x1C},
						0x1D : {'offset':1870,'bit':2,'bits':1,'parameter':'Tk10 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x1D},
						0x1E : {'offset':1870,'bit':3,'bits':1,'parameter':'Tk10 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x1E},
						0x1F : {'offset':1870,'bit':4,'bits':1,'parameter':'Tk10 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x1F},
						0x20 : {'offset':1870,'bit':5,'bits':1,'parameter':'Tk10 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x20},
						0x21 : {'offset':1870,'bit':6,'bits':1,'parameter':'Tk10 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x21},
						0x22 : {'offset':1870,'bit':7,'bits':1,'parameter':'Tk10 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x22},
						0x23 : {'offset':1871,'bit':0,'bits':1,'parameter':'Tk10 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x23},
						0x24 : {'offset':1871,'bit':1,'bits':1,'parameter':'Tk10 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x24},
						0x25 : {'offset':1871,'bit':2,'bits':1,'parameter':'Tk10 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x25},
						0x26 : {'offset':1871,'bit':3,'bits':1,'parameter':'Tk10 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x26},
						0x27 : {'offset':1871,'bit':4,'bits':1,'parameter':'Tk10 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x27},
						0x28 : {'offset':1871,'bit':7,'bits':1,'parameter':'Tk10 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x28},
# 0x29
						0x29 : {'offset':-1,'bit':7,'bits':8,'parameter':'Track 10 Solo','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x29},
						0x2A : {'offset':1871,'bit':6,'bits':1,'parameter':'Tk10 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x2A},
						0x2B : {'offset':1880,'bit':6,'bits':7,'parameter':'Tk10 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x2B},
						0x2C : {'offset':1880,'bit':7,'bits':1,'parameter':'Tk10 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x2C},
						0x2D : {'offset':1882,'bit':7,'bits':8,'parameter':'Tk10 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x2D},
						0x2E : {'offset':1883,'bit':7,'bits':8,'parameter':'Tk10 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x2E},
						0x2F : {'offset':1884,'bit':7,'bits':8,'parameter':'Tk10 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x2F},
						0x30 : {'offset':1885,'bit':7,'bits':8,'parameter':'Tk10 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x30},
						0x31 : {'offset':1874,'bit':7,'bits':8,'parameter':'Tk10 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x31},
						0x32 : {'offset':1876,'bit':3,'bits':4,'parameter':'Tk10 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x32},
						0x33 : {'offset':1876,'bit':7,'bits':4,'parameter':'Tk10 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x33},
						0x34 : {'offset':1875,'bit':7,'bits':8,'parameter':'Tk10 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x34},
						0x35 : {'offset':1877,'bit':7,'bits':8,'parameter':'Tk10 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x35},
						0x36 : {'offset':1879,'bit':3,'bits':4,'parameter':'Tk10 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x36},
						0x37 : {'offset':1879,'bit':7,'bits':4,'parameter':'Tk10 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x37},
						0x38 : {'offset':1878,'bit':7,'bits':8,'parameter':'Tk10 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x38},
						0x39 : {'offset':1866,'bit':4,'bits':5,'parameter':'Tk10 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x39},
						0x3A : {'offset':1866,'bit':6,'bits':2,'parameter':'Tk10 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x3A},
						0x3B : {'offset':1859,'bit':7,'bits':8,'parameter':'Tk10 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x3B},
						0x3C : {'offset':1860,'bit':7,'bits':8,'parameter':'Tk10 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x3C},
						0x3D : {'offset':1861,'bit':7,'bits':8,'parameter':'Tk10 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x3D},
						0x3E : {'offset':1862,'bit':7,'bits':8,'parameter':'Tk10 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x3E},
						0x3F : {'offset':1863,'bit':7,'bits':8,'parameter':'Tk10 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x3F},
						0x40 : {'offset':1864,'bit':7,'bits':8,'parameter':'Tk10 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x40},
						0x41 : {'offset':1865,'bit':7,'bits':8,'parameter':'Tk10 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x41},
						0x42 : {'offset':1872,'bit':7,'bits':1,'parameter':'Tk10 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x15,'subid':0x42},
					},
	0x16 :  {
						0x00 : {'offset':1956,'bit':7,'bits':16,'parameter':'Tk11 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x00},
						0x01 : {'offset':1970,'bit':7,'bits':8,'parameter':'Tk11 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x01},
						0x02 : {'offset':1961,'bit':7,'bits':8,'parameter':'Tk11 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x02},
						0x03 : {'offset':1958,'bit':7,'bits':3,'parameter':'Tk11 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x03},
						0x04 : {'offset':1958,'bit':4,'bits':5,'parameter':'Tk11 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x04},
						0x05 : {'offset':1959,'bit':7,'bits':8,'parameter':'Tk11 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x05},
						0x06 : {'offset':1960,'bit':7,'bits':8,'parameter':'Tk11 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x06},
						0x07 : {'offset':1984,'bit':1,'bits':2,'parameter':'Tk11 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x07},
						0x08 : {'offset':1984,'bit':3,'bits':2,'parameter':'Tk11 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x08},
						0x09 : {'offset':1984,'bit':6,'bits':2,'parameter':'Tk11 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x09},
						0x0A : {'offset':1985,'bit':7,'bits':8,'parameter':'Tk11 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x0A},
						0x0B : {'offset':1963,'bit':7,'bits':8,'parameter':'Tk11 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x0B},
						0x0C : {'offset':1964,'bit':7,'bits':16,'parameter':'Tk11 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x0C},
						0x0D : {'offset':1962,'bit':7,'bits':8,'parameter':'Tk11 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x0D},
						0x0E : {'offset':1966,'bit':7,'bits':8,'parameter':'Tk11 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x0E},
						0x0F : {'offset':1968,'bit':3,'bits':4,'parameter':'Tk11 Delay Tempo Base','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x0F},
						0x10 : {'offset':1968,'bit':7,'bits':1,'parameter':'Tk11 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x10},
						0x11 : {'offset':1969,'bit':7,'bits':8,'parameter':'Tk11 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x11},
						0x12 : {'offset':1983,'bit':5,'bits':1,'parameter':'Tk11 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x12},
						0x13 : {'offset':1981,'bit':0,'bits':1,'parameter':'Tk11 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x13},
						0x14 : {'offset':1981,'bit':1,'bits':1,'parameter':'Tk11 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x14},
						0x15 : {'offset':1981,'bit':2,'bits':1,'parameter':'Tk11 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x15},
						0x16 : {'offset':1981,'bit':3,'bits':1,'parameter':'Tk11 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x16},
						0x17 : {'offset':1981,'bit':4,'bits':1,'parameter':'Tk11 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x17},
						0x18 : {'offset':1981,'bit':5,'bits':1,'parameter':'Tk11 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x18},
						0x19 : {'offset':1981,'bit':6,'bits':1,'parameter':'Tk11 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x19},
						0x1A : {'offset':1981,'bit':7,'bits':1,'parameter':'Tk11 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x1A},
						0x1B : {'offset':1982,'bit':0,'bits':1,'parameter':'Tk11 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x1B},
						0x1C : {'offset':1982,'bit':1,'bits':1,'parameter':'Tk11 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x1C},
						0x1D : {'offset':1982,'bit':2,'bits':1,'parameter':'Tk11 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x1D},
						0x1E : {'offset':1982,'bit':3,'bits':1,'parameter':'Tk11 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x1E},
						0x1F : {'offset':1982,'bit':4,'bits':1,'parameter':'Tk11 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x1F},
						0x20 : {'offset':1982,'bit':5,'bits':1,'parameter':'Tk11 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x20},
						0x21 : {'offset':1982,'bit':6,'bits':1,'parameter':'Tk11 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x21},
						0x22 : {'offset':1982,'bit':7,'bits':1,'parameter':'Tk11 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x22},
						0x23 : {'offset':1983,'bit':0,'bits':1,'parameter':'Tk11 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x23},
						0x24 : {'offset':1983,'bit':1,'bits':1,'parameter':'Tk11 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x24},
						0x25 : {'offset':1983,'bit':2,'bits':1,'parameter':'Tk11 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x25},
						0x26 : {'offset':1983,'bit':3,'bits':1,'parameter':'Tk11 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x26},
						0x27 : {'offset':1983,'bit':4,'bits':1,'parameter':'Tk11 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x27},
						0x28 : {'offset':1983,'bit':7,'bits':1,'parameter':'Tk11 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x28},
# 0x29
						0x29 : {'offset':-1,'bit':7,'bits':8,'parameter':'Track 11 Solo','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x29},
						0x2A : {'offset':1983,'bit':6,'bits':1,'parameter':'Tk11 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x2A},
						0x2B : {'offset':1992,'bit':6,'bits':7,'parameter':'Tk11 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x2B},
						0x2C : {'offset':1992,'bit':7,'bits':1,'parameter':'Tk11 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x2C},
						0x2D : {'offset':1994,'bit':7,'bits':8,'parameter':'Tk11 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x2D},
						0x2E : {'offset':1995,'bit':7,'bits':8,'parameter':'Tk11 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x2E},
						0x2F : {'offset':1996,'bit':7,'bits':8,'parameter':'Tk11 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x2F},
						0x30 : {'offset':1997,'bit':7,'bits':8,'parameter':'Tk11 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x30},
						0x31 : {'offset':1986,'bit':7,'bits':8,'parameter':'Tk11 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x31},
						0x32 : {'offset':1988,'bit':3,'bits':4,'parameter':'Tk11 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x32},
						0x33 : {'offset':1988,'bit':7,'bits':4,'parameter':'Tk11 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x33},
						0x34 : {'offset':1987,'bit':7,'bits':8,'parameter':'Tk11 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x34},
						0x35 : {'offset':1989,'bit':7,'bits':8,'parameter':'Tk11 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x35},
						0x36 : {'offset':1991,'bit':3,'bits':4,'parameter':'Tk11 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x36},
						0x37 : {'offset':1991,'bit':7,'bits':4,'parameter':'Tk11 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x37},
						0x38 : {'offset':1990,'bit':7,'bits':8,'parameter':'Tk11 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x38},
						0x39 : {'offset':1978,'bit':4,'bits':5,'parameter':'Tk11 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x39},
						0x3A : {'offset':1978,'bit':6,'bits':2,'parameter':'Tk11 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x3A},
						0x3B : {'offset':1971,'bit':7,'bits':8,'parameter':'Tk11 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x3B},
						0x3C : {'offset':1972,'bit':7,'bits':8,'parameter':'Tk11 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x3C},
						0x3D : {'offset':1973,'bit':7,'bits':8,'parameter':'Tk11 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x3D},
						0x3E : {'offset':1974,'bit':7,'bits':8,'parameter':'Tk11 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x3E},
						0x3F : {'offset':1975,'bit':7,'bits':8,'parameter':'Tk11 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x3F},
						0x40 : {'offset':1976,'bit':7,'bits':8,'parameter':'Tk11 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x40},
						0x41 : {'offset':1977,'bit':7,'bits':8,'parameter':'Tk11 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x41},
						0x42 : {'offset':1984,'bit':7,'bits':1,'parameter':'Tk11 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x16,'subid':0x42},
					},
	0x17 :  {
						0x00 : {'offset':2068,'bit':7,'bits':16,'parameter':'Tk12 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x00},
						0x01 : {'offset':2082,'bit':7,'bits':8,'parameter':'Tk12 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x01},
						0x02 : {'offset':2073,'bit':7,'bits':8,'parameter':'Tk12 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x02},
						0x03 : {'offset':2070,'bit':7,'bits':3,'parameter':'Tk12 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x03},
						0x04 : {'offset':2070,'bit':4,'bits':5,'parameter':'Tk12 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x04},
						0x05 : {'offset':2071,'bit':7,'bits':8,'parameter':'Tk12 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x05},
						0x06 : {'offset':2072,'bit':7,'bits':8,'parameter':'Tk12 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x06},
						0x07 : {'offset':2096,'bit':1,'bits':2,'parameter':'Tk12 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x07},
						0x08 : {'offset':2096,'bit':3,'bits':2,'parameter':'Tk12 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x08},
						0x09 : {'offset':2096,'bit':6,'bits':2,'parameter':'Tk12 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x09},
						0x0A : {'offset':2097,'bit':7,'bits':8,'parameter':'Tk12 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x0A},
						0x0B : {'offset':2075,'bit':7,'bits':8,'parameter':'Tk12 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x0B},
						0x0C : {'offset':2076,'bit':7,'bits':16,'parameter':'Tk12 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x0C},
						0x0D : {'offset':2074,'bit':7,'bits':8,'parameter':'Tk12 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x0D},
						0x0E : {'offset':2078,'bit':7,'bits':8,'parameter':'Tk12 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x0E},
						0x0F : {'offset':2080,'bit':3,'bits':4,'parameter':'Tk12 Delay Tempo Base','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x0F},
						0x10 : {'offset':2080,'bit':7,'bits':1,'parameter':'Tk12 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x10},
						0x11 : {'offset':2081,'bit':7,'bits':8,'parameter':'Tk12 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x11},
						0x12 : {'offset':2095,'bit':5,'bits':1,'parameter':'Tk12 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x12},
						0x13 : {'offset':2093,'bit':0,'bits':1,'parameter':'Tk12 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x13},
						0x14 : {'offset':2093,'bit':1,'bits':1,'parameter':'Tk12 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x14},
						0x15 : {'offset':2093,'bit':2,'bits':1,'parameter':'Tk12 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x15},
						0x16 : {'offset':2093,'bit':3,'bits':1,'parameter':'Tk12 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x16},
						0x17 : {'offset':2093,'bit':4,'bits':1,'parameter':'Tk12 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x17},
						0x18 : {'offset':2093,'bit':5,'bits':1,'parameter':'Tk12 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x18},
						0x19 : {'offset':2093,'bit':6,'bits':1,'parameter':'Tk12 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x19},
						0x1A : {'offset':2093,'bit':7,'bits':1,'parameter':'Tk12 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x1A},
						0x1B : {'offset':2094,'bit':0,'bits':1,'parameter':'Tk12 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x1B},
						0x1C : {'offset':2094,'bit':1,'bits':1,'parameter':'Tk12 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x1C},
						0x1D : {'offset':2094,'bit':2,'bits':1,'parameter':'Tk12 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x1D},
						0x1E : {'offset':2094,'bit':3,'bits':1,'parameter':'Tk12 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x1E},
						0x1F : {'offset':2094,'bit':4,'bits':1,'parameter':'Tk12 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x1F},
						0x20 : {'offset':2094,'bit':5,'bits':1,'parameter':'Tk12 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x20},
						0x21 : {'offset':2094,'bit':6,'bits':1,'parameter':'Tk12 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x21},
						0x22 : {'offset':2094,'bit':7,'bits':1,'parameter':'Tk12 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x22},
						0x23 : {'offset':2095,'bit':0,'bits':1,'parameter':'Tk12 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x23},
						0x24 : {'offset':2095,'bit':1,'bits':1,'parameter':'Tk12 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x24},
						0x25 : {'offset':2095,'bit':2,'bits':1,'parameter':'Tk12 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x25},
						0x26 : {'offset':2095,'bit':3,'bits':1,'parameter':'Tk12 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x26},
						0x27 : {'offset':2095,'bit':4,'bits':1,'parameter':'Tk12 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x27},
						0x28 : {'offset':2095,'bit':7,'bits':1,'parameter':'Tk12 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x28},
# 0x29
						0x29 : {'offset':-1,'bit':7,'bits':8,'parameter':'Track 12 Solo','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x29},
						0x2A : {'offset':2095,'bit':6,'bits':1,'parameter':'Tk12 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x2A},
						0x2B : {'offset':2104,'bit':6,'bits':7,'parameter':'Tk12 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x2B},
						0x2C : {'offset':2104,'bit':7,'bits':1,'parameter':'Tk12 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x2C},
						0x2D : {'offset':2106,'bit':7,'bits':8,'parameter':'Tk12 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x2D},
						0x2E : {'offset':2107,'bit':7,'bits':8,'parameter':'Tk12 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x2E},
						0x2F : {'offset':2108,'bit':7,'bits':8,'parameter':'Tk12 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x2F},
						0x30 : {'offset':2109,'bit':7,'bits':8,'parameter':'Tk12 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x30},
						0x31 : {'offset':2098,'bit':7,'bits':8,'parameter':'Tk12 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x31},
						0x32 : {'offset':2100,'bit':3,'bits':4,'parameter':'Tk12 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x32},
						0x33 : {'offset':2100,'bit':7,'bits':4,'parameter':'Tk12 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x33},
						0x34 : {'offset':2099,'bit':7,'bits':8,'parameter':'Tk12 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x34},
						0x35 : {'offset':2101,'bit':7,'bits':8,'parameter':'Tk12 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x35},
						0x36 : {'offset':2103,'bit':3,'bits':4,'parameter':'Tk12 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x36},
						0x37 : {'offset':2103,'bit':7,'bits':4,'parameter':'Tk12 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x37},
						0x38 : {'offset':2102,'bit':7,'bits':8,'parameter':'Tk12 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x38},
						0x39 : {'offset':2090,'bit':4,'bits':5,'parameter':'Tk12 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x39},
						0x3A : {'offset':2090,'bit':6,'bits':2,'parameter':'Tk12 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x3A},
						0x3B : {'offset':2083,'bit':7,'bits':8,'parameter':'Tk12 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x3B},
						0x3C : {'offset':2084,'bit':7,'bits':8,'parameter':'Tk12 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x3C},
						0x3D : {'offset':2085,'bit':7,'bits':8,'parameter':'Tk12 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x3D},
						0x3E : {'offset':2086,'bit':7,'bits':8,'parameter':'Tk12 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x3E},
						0x3F : {'offset':2087,'bit':7,'bits':8,'parameter':'Tk12 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x3F},
						0x40 : {'offset':2088,'bit':7,'bits':8,'parameter':'Tk12 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x40},
						0x41 : {'offset':2089,'bit':7,'bits':8,'parameter':'Tk12 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x41},
						0x42 : {'offset':2096,'bit':7,'bits':1,'parameter':'Tk12 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x17,'subid':0x42},
					},
	0x18 :  {
						0x00 : {'offset':2180,'bit':7,'bits':16,'parameter':'Tk13 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x00},
						0x01 : {'offset':2194,'bit':7,'bits':8,'parameter':'Tk13 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x01},
						0x02 : {'offset':2185,'bit':7,'bits':8,'parameter':'Tk13 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x02},
						0x03 : {'offset':2182,'bit':7,'bits':3,'parameter':'Tk13 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x03},
						0x04 : {'offset':2182,'bit':4,'bits':5,'parameter':'Tk13 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x04},
						0x05 : {'offset':2183,'bit':7,'bits':8,'parameter':'Tk13 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x05},
						0x06 : {'offset':2184,'bit':7,'bits':8,'parameter':'Tk13 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x06},
						0x07 : {'offset':2208,'bit':1,'bits':2,'parameter':'Tk13 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x07},
						0x08 : {'offset':2208,'bit':3,'bits':2,'parameter':'Tk13 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x08},
						0x09 : {'offset':2208,'bit':6,'bits':2,'parameter':'Tk13 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x09},
						0x0A : {'offset':2209,'bit':7,'bits':8,'parameter':'Tk13 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x0A},
						0x0B : {'offset':2187,'bit':7,'bits':8,'parameter':'Tk13 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x0B},
						0x0C : {'offset':2188,'bit':7,'bits':16,'parameter':'Tk13 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x0C},
						0x0D : {'offset':2186,'bit':7,'bits':8,'parameter':'Tk13 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x0D},
						0x0E : {'offset':2190,'bit':7,'bits':8,'parameter':'Tk13 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x0E},
						0x0F : {'offset':2192,'bit':3,'bits':4,'parameter':'Tk13 Delay Tempo Base','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x0F},
						0x10 : {'offset':2192,'bit':7,'bits':1,'parameter':'Tk13 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x10},
						0x11 : {'offset':2193,'bit':7,'bits':8,'parameter':'Tk13 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x11},
						0x12 : {'offset':2207,'bit':5,'bits':1,'parameter':'Tk13 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x12},
						0x13 : {'offset':2205,'bit':0,'bits':1,'parameter':'Tk13 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x13},
						0x14 : {'offset':2205,'bit':1,'bits':1,'parameter':'Tk13 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x14},
						0x15 : {'offset':2205,'bit':2,'bits':1,'parameter':'Tk13 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x15},
						0x16 : {'offset':2205,'bit':3,'bits':1,'parameter':'Tk13 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x16},
						0x17 : {'offset':2205,'bit':4,'bits':1,'parameter':'Tk13 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x17},
						0x18 : {'offset':2205,'bit':5,'bits':1,'parameter':'Tk13 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x18},
						0x19 : {'offset':2205,'bit':6,'bits':1,'parameter':'Tk13 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x19},
						0x1A : {'offset':2205,'bit':7,'bits':1,'parameter':'Tk13 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x1A},
						0x1B : {'offset':2206,'bit':0,'bits':1,'parameter':'Tk13 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x1B},
						0x1C : {'offset':2206,'bit':1,'bits':1,'parameter':'Tk13 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x1C},
						0x1D : {'offset':2206,'bit':2,'bits':1,'parameter':'Tk13 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x1D},
						0x1E : {'offset':2206,'bit':3,'bits':1,'parameter':'Tk13 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x1E},
						0x1F : {'offset':2206,'bit':4,'bits':1,'parameter':'Tk13 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x1F},
						0x20 : {'offset':2206,'bit':5,'bits':1,'parameter':'Tk13 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x20},
						0x21 : {'offset':2206,'bit':6,'bits':1,'parameter':'Tk13 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x21},
						0x22 : {'offset':2206,'bit':7,'bits':1,'parameter':'Tk13 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x22},
						0x23 : {'offset':2207,'bit':0,'bits':1,'parameter':'Tk13 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x23},
						0x24 : {'offset':2207,'bit':1,'bits':1,'parameter':'Tk13 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x24},
						0x25 : {'offset':2207,'bit':2,'bits':1,'parameter':'Tk13 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x25},
						0x26 : {'offset':2207,'bit':3,'bits':1,'parameter':'Tk13 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x26},
						0x27 : {'offset':2207,'bit':4,'bits':1,'parameter':'Tk13 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x27},
						0x28 : {'offset':2207,'bit':7,'bits':1,'parameter':'Tk13 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x28},
# 0x29
						0x29 : {'offset':-1,'bit':7,'bits':8,'parameter':'Track 13 Solo','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x29},
						0x2A : {'offset':2207,'bit':6,'bits':1,'parameter':'Tk13 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x2A},
						0x2B : {'offset':2216,'bit':6,'bits':7,'parameter':'Tk13 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x2B},
						0x2C : {'offset':2216,'bit':7,'bits':1,'parameter':'Tk13 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x2C},
						0x2D : {'offset':2218,'bit':7,'bits':8,'parameter':'Tk13 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x2D},
						0x2E : {'offset':2219,'bit':7,'bits':8,'parameter':'Tk13 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x2E},
						0x2F : {'offset':2220,'bit':7,'bits':8,'parameter':'Tk13 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x2F},
						0x30 : {'offset':2221,'bit':7,'bits':8,'parameter':'Tk13 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x30},
						0x31 : {'offset':2210,'bit':7,'bits':8,'parameter':'Tk13 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x31},
						0x32 : {'offset':2212,'bit':3,'bits':4,'parameter':'Tk13 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x32},
						0x33 : {'offset':2212,'bit':7,'bits':4,'parameter':'Tk13 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x33},
						0x34 : {'offset':2211,'bit':7,'bits':8,'parameter':'Tk13 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x34},
						0x35 : {'offset':2213,'bit':7,'bits':8,'parameter':'Tk13 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x35},
						0x36 : {'offset':2215,'bit':3,'bits':4,'parameter':'Tk13 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x36},
						0x37 : {'offset':2215,'bit':7,'bits':4,'parameter':'Tk13 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x37},
						0x38 : {'offset':2214,'bit':7,'bits':8,'parameter':'Tk13 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x38},
						0x39 : {'offset':2202,'bit':4,'bits':5,'parameter':'Tk13 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x39},
						0x3A : {'offset':2202,'bit':6,'bits':2,'parameter':'Tk13 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x3A},
						0x3B : {'offset':2195,'bit':7,'bits':8,'parameter':'Tk13 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x3B},
						0x3C : {'offset':2196,'bit':7,'bits':8,'parameter':'Tk13 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x3C},
						0x3D : {'offset':2197,'bit':7,'bits':8,'parameter':'Tk13 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x3D},
						0x3E : {'offset':2198,'bit':7,'bits':8,'parameter':'Tk13 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x3E},
						0x3F : {'offset':2199,'bit':7,'bits':8,'parameter':'Tk13 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x3F},
						0x40 : {'offset':2200,'bit':7,'bits':8,'parameter':'Tk13 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x40},
						0x41 : {'offset':2201,'bit':7,'bits':8,'parameter':'Tk13 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x41},
						0x42 : {'offset':2208,'bit':7,'bits':1,'parameter':'Tk13 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x18,'subid':0x42},
					},
	0x19 :  {
						0x00 : {'offset':2292,'bit':7,'bits':16,'parameter':'Tk14 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x00},
						0x01 : {'offset':2306,'bit':7,'bits':8,'parameter':'Tk14 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x01},
						0x02 : {'offset':2297,'bit':7,'bits':8,'parameter':'Tk14 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x02},
						0x03 : {'offset':2294,'bit':7,'bits':3,'parameter':'Tk14 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x03},
						0x04 : {'offset':2294,'bit':4,'bits':5,'parameter':'Tk14 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x04},
						0x05 : {'offset':2295,'bit':7,'bits':8,'parameter':'Tk14 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x05},
						0x06 : {'offset':2296,'bit':7,'bits':8,'parameter':'Tk14 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x06},
						0x07 : {'offset':2320,'bit':1,'bits':2,'parameter':'Tk14 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x07},
						0x08 : {'offset':2320,'bit':3,'bits':2,'parameter':'Tk14 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x08},
						0x09 : {'offset':2320,'bit':6,'bits':2,'parameter':'Tk14 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x09},
						0x0A : {'offset':2321,'bit':7,'bits':8,'parameter':'Tk14 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x0A},
						0x0B : {'offset':2299,'bit':7,'bits':8,'parameter':'Tk14 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x0B},
						0x0C : {'offset':2300,'bit':7,'bits':16,'parameter':'Tk14 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x0C},
						0x0D : {'offset':2298,'bit':7,'bits':8,'parameter':'Tk14 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x0D},
						0x0E : {'offset':2302,'bit':7,'bits':8,'parameter':'Tk14 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x0E},
						0x0F : {'offset':2304,'bit':3,'bits':4,'parameter':'Tk14 Delay Tempo Base','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x0F},
						0x10 : {'offset':2304,'bit':7,'bits':1,'parameter':'Tk14 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x10},
						0x11 : {'offset':2305,'bit':7,'bits':8,'parameter':'Tk14 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x11},
						0x12 : {'offset':2319,'bit':5,'bits':1,'parameter':'Tk14 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x12},
						0x13 : {'offset':2317,'bit':0,'bits':1,'parameter':'Tk14 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x13},
						0x14 : {'offset':2317,'bit':1,'bits':1,'parameter':'Tk14 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x14},
						0x15 : {'offset':2317,'bit':2,'bits':1,'parameter':'Tk14 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x15},
						0x16 : {'offset':2317,'bit':3,'bits':1,'parameter':'Tk14 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x16},
						0x17 : {'offset':2317,'bit':4,'bits':1,'parameter':'Tk14 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x17},
						0x18 : {'offset':2317,'bit':5,'bits':1,'parameter':'Tk14 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x18},
						0x19 : {'offset':2317,'bit':6,'bits':1,'parameter':'Tk14 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x19},
						0x1A : {'offset':2317,'bit':7,'bits':1,'parameter':'Tk14 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x1A},
						0x1B : {'offset':2318,'bit':0,'bits':1,'parameter':'Tk14 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x1B},
						0x1C : {'offset':2318,'bit':1,'bits':1,'parameter':'Tk14 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x1C},
						0x1D : {'offset':2318,'bit':2,'bits':1,'parameter':'Tk14 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x1D},
						0x1E : {'offset':2318,'bit':3,'bits':1,'parameter':'Tk14 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x1E},
						0x1F : {'offset':2318,'bit':4,'bits':1,'parameter':'Tk14 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x1F},
						0x20 : {'offset':2318,'bit':5,'bits':1,'parameter':'Tk14 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x20},
						0x21 : {'offset':2318,'bit':6,'bits':1,'parameter':'Tk14 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x21},
						0x22 : {'offset':2318,'bit':7,'bits':1,'parameter':'Tk14 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x22},
						0x23 : {'offset':2319,'bit':0,'bits':1,'parameter':'Tk14 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x23},
						0x24 : {'offset':2319,'bit':1,'bits':1,'parameter':'Tk14 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x24},
						0x25 : {'offset':2319,'bit':2,'bits':1,'parameter':'Tk14 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x25},
						0x26 : {'offset':2319,'bit':3,'bits':1,'parameter':'Tk14 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x26},
						0x27 : {'offset':2319,'bit':4,'bits':1,'parameter':'Tk14 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x27},
						0x28 : {'offset':2319,'bit':7,'bits':1,'parameter':'Tk14 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x28},
# 0x29
						0x29 : {'offset':-1,'bit':7,'bits':8,'parameter':'Track 14 Solo','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x29},
						0x2A : {'offset':2319,'bit':6,'bits':1,'parameter':'Tk14 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x2A},
						0x2B : {'offset':2328,'bit':6,'bits':7,'parameter':'Tk14 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x2B},
						0x2C : {'offset':2328,'bit':7,'bits':1,'parameter':'Tk14 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x2C},
						0x2D : {'offset':2330,'bit':7,'bits':8,'parameter':'Tk14 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x2D},
						0x2E : {'offset':2331,'bit':7,'bits':8,'parameter':'Tk14 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x2E},
						0x2F : {'offset':2332,'bit':7,'bits':8,'parameter':'Tk14 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x2F},
						0x30 : {'offset':2333,'bit':7,'bits':8,'parameter':'Tk14 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x30},
						0x31 : {'offset':2322,'bit':7,'bits':8,'parameter':'Tk14 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x31},
						0x32 : {'offset':2324,'bit':3,'bits':4,'parameter':'Tk14 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x32},
						0x33 : {'offset':2324,'bit':7,'bits':4,'parameter':'Tk14 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x33},
						0x34 : {'offset':2323,'bit':7,'bits':8,'parameter':'Tk14 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x34},
						0x35 : {'offset':2325,'bit':7,'bits':8,'parameter':'Tk14 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x35},
						0x36 : {'offset':2327,'bit':3,'bits':4,'parameter':'Tk14 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x36},
						0x37 : {'offset':2327,'bit':7,'bits':4,'parameter':'Tk14 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x37},
						0x38 : {'offset':2326,'bit':7,'bits':8,'parameter':'Tk14 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x38},
						0x39 : {'offset':2314,'bit':4,'bits':5,'parameter':'Tk14 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x39},
						0x3A : {'offset':2314,'bit':6,'bits':2,'parameter':'Tk14 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x3A},
						0x3B : {'offset':2307,'bit':7,'bits':8,'parameter':'Tk14 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x3B},
						0x3C : {'offset':2308,'bit':7,'bits':8,'parameter':'Tk14 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x3C},
						0x3D : {'offset':2309,'bit':7,'bits':8,'parameter':'Tk14 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x3D},
						0x3E : {'offset':2310,'bit':7,'bits':8,'parameter':'Tk14 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x3E},
						0x3F : {'offset':2311,'bit':7,'bits':8,'parameter':'Tk14 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x3F},
						0x40 : {'offset':2312,'bit':7,'bits':8,'parameter':'Tk14 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x40},
						0x41 : {'offset':2313,'bit':7,'bits':8,'parameter':'Tk14 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x41},
						0x42 : {'offset':2320,'bit':7,'bits':1,'parameter':'Tk14 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x19,'subid':0x42},
					},
	0x1A :  {
						0x00 : {'offset':2404,'bit':7,'bits':16,'parameter':'Tk15 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x00},
						0x01 : {'offset':2418,'bit':7,'bits':8,'parameter':'Tk15 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x01},
						0x02 : {'offset':2409,'bit':7,'bits':8,'parameter':'Tk15 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x02},
						0x03 : {'offset':2406,'bit':7,'bits':3,'parameter':'Tk15 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x03},
						0x04 : {'offset':2406,'bit':4,'bits':5,'parameter':'Tk15 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x04},
						0x05 : {'offset':2407,'bit':7,'bits':8,'parameter':'Tk15 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x05},
						0x06 : {'offset':2408,'bit':7,'bits':8,'parameter':'Tk15 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x06},
						0x07 : {'offset':2432,'bit':1,'bits':2,'parameter':'Tk15 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x07},
						0x08 : {'offset':2432,'bit':3,'bits':2,'parameter':'Tk15 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x08},
						0x09 : {'offset':2432,'bit':6,'bits':2,'parameter':'Tk15 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x09},
						0x0A : {'offset':2433,'bit':7,'bits':8,'parameter':'Tk15 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x0A},
						0x0B : {'offset':2411,'bit':7,'bits':8,'parameter':'Tk15 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x0B},
						0x0C : {'offset':2412,'bit':7,'bits':16,'parameter':'Tk15 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x0C},
						0x0D : {'offset':2410,'bit':7,'bits':8,'parameter':'Tk15 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x0D},
						0x0E : {'offset':2414,'bit':7,'bits':8,'parameter':'Tk15 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x0E},
						0x0F : {'offset':2416,'bit':3,'bits':4,'parameter':'Tk15 Delay Tempo Base','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x0F},
						0x10 : {'offset':2416,'bit':7,'bits':1,'parameter':'Tk15 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x10},
						0x11 : {'offset':2417,'bit':7,'bits':8,'parameter':'Tk15 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x11},
						0x12 : {'offset':2431,'bit':5,'bits':1,'parameter':'Tk15 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x12},
						0x13 : {'offset':2429,'bit':0,'bits':1,'parameter':'Tk15 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x13},
						0x14 : {'offset':2429,'bit':1,'bits':1,'parameter':'Tk15 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x14},
						0x15 : {'offset':2429,'bit':2,'bits':1,'parameter':'Tk15 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x15},
						0x16 : {'offset':2429,'bit':3,'bits':1,'parameter':'Tk15 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x16},
						0x17 : {'offset':2429,'bit':4,'bits':1,'parameter':'Tk15 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x17},
						0x18 : {'offset':2429,'bit':5,'bits':1,'parameter':'Tk15 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x18},
						0x19 : {'offset':2429,'bit':6,'bits':1,'parameter':'Tk15 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x19},
						0x1A : {'offset':2429,'bit':7,'bits':1,'parameter':'Tk15 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x1A},
						0x1B : {'offset':2430,'bit':0,'bits':1,'parameter':'Tk15 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x1B},
						0x1C : {'offset':2430,'bit':1,'bits':1,'parameter':'Tk15 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x1C},
						0x1D : {'offset':2430,'bit':2,'bits':1,'parameter':'Tk15 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x1D},
						0x1E : {'offset':2430,'bit':3,'bits':1,'parameter':'Tk15 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x1E},
						0x1F : {'offset':2430,'bit':4,'bits':1,'parameter':'Tk15 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x1F},
						0x20 : {'offset':2430,'bit':5,'bits':1,'parameter':'Tk15 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x20},
						0x21 : {'offset':2430,'bit':6,'bits':1,'parameter':'Tk15 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x21},
						0x22 : {'offset':2430,'bit':7,'bits':1,'parameter':'Tk15 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x22},
						0x23 : {'offset':2431,'bit':0,'bits':1,'parameter':'Tk15 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x23},
						0x24 : {'offset':2431,'bit':1,'bits':1,'parameter':'Tk15 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x24},
						0x25 : {'offset':2431,'bit':2,'bits':1,'parameter':'Tk15 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x25},
						0x26 : {'offset':2431,'bit':3,'bits':1,'parameter':'Tk15 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x26},
						0x27 : {'offset':2431,'bit':4,'bits':1,'parameter':'Tk15 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x27},
						0x28 : {'offset':2431,'bit':7,'bits':1,'parameter':'Tk15 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x28},
# 0x29
						0x29 : {'offset':-1,'bit':7,'bits':8,'parameter':'Track 15 Solo','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x29},
						0x2A : {'offset':2431,'bit':6,'bits':1,'parameter':'Tk15 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x2A},
						0x2B : {'offset':2440,'bit':6,'bits':7,'parameter':'Tk15 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x2B},
						0x2C : {'offset':2440,'bit':7,'bits':1,'parameter':'Tk15 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x2C},
						0x2D : {'offset':2442,'bit':7,'bits':8,'parameter':'Tk15 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x2D},
						0x2E : {'offset':2443,'bit':7,'bits':8,'parameter':'Tk15 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x2E},
						0x2F : {'offset':2444,'bit':7,'bits':8,'parameter':'Tk15 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x2F},
						0x30 : {'offset':2445,'bit':7,'bits':8,'parameter':'Tk15 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x30},
						0x31 : {'offset':2434,'bit':7,'bits':8,'parameter':'Tk15 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x31},
						0x32 : {'offset':2436,'bit':3,'bits':4,'parameter':'Tk15 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x32},
						0x33 : {'offset':2436,'bit':7,'bits':4,'parameter':'Tk15 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x33},
						0x34 : {'offset':2435,'bit':7,'bits':8,'parameter':'Tk15 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x34},
						0x35 : {'offset':2437,'bit':7,'bits':8,'parameter':'Tk15 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x35},
						0x36 : {'offset':2439,'bit':3,'bits':4,'parameter':'Tk15 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x36},
						0x37 : {'offset':2439,'bit':7,'bits':4,'parameter':'Tk15 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x37},
						0x38 : {'offset':2438,'bit':7,'bits':8,'parameter':'Tk15 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x38},
						0x39 : {'offset':2426,'bit':4,'bits':5,'parameter':'Tk15 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x39},
						0x3A : {'offset':2426,'bit':6,'bits':2,'parameter':'Tk15 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x3A},
						0x3B : {'offset':2419,'bit':7,'bits':8,'parameter':'Tk15 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x3B},
						0x3C : {'offset':2420,'bit':7,'bits':8,'parameter':'Tk15 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x3C},
						0x3D : {'offset':2421,'bit':7,'bits':8,'parameter':'Tk15 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x3D},
						0x3E : {'offset':2422,'bit':7,'bits':8,'parameter':'Tk15 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x3E},
						0x3F : {'offset':2423,'bit':7,'bits':8,'parameter':'Tk15 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x3F},
						0x40 : {'offset':2424,'bit':7,'bits':8,'parameter':'Tk15 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x40},
						0x41 : {'offset':2425,'bit':7,'bits':8,'parameter':'Tk15 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x41},
						0x42 : {'offset':2432,'bit':7,'bits':1,'parameter':'Tk15 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1A,'subid':0x42},
					},
	0x1B :  {
						0x00 : {'offset':2516,'bit':7,'bits':16,'parameter':'Tk16 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x00},
						0x01 : {'offset':2530,'bit':7,'bits':8,'parameter':'Tk16 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x01},
						0x02 : {'offset':2521,'bit':7,'bits':8,'parameter':'Tk16 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x02},
						0x03 : {'offset':2518,'bit':7,'bits':3,'parameter':'Tk16 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x03},
						0x04 : {'offset':2518,'bit':4,'bits':5,'parameter':'Tk16 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x04},
						0x05 : {'offset':2519,'bit':7,'bits':8,'parameter':'Tk16 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x05},
						0x06 : {'offset':2520,'bit':7,'bits':8,'parameter':'Tk16 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x06},
						0x07 : {'offset':2544,'bit':1,'bits':2,'parameter':'Tk16 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x07},
						0x08 : {'offset':2544,'bit':3,'bits':2,'parameter':'Tk16 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x08},
						0x09 : {'offset':2544,'bit':6,'bits':2,'parameter':'Tk16 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x09},
						0x0A : {'offset':2545,'bit':7,'bits':8,'parameter':'Tk16 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x0A},
						0x0B : {'offset':2523,'bit':7,'bits':8,'parameter':'Tk16 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x0B},
						0x0C : {'offset':2524,'bit':7,'bits':16,'parameter':'Tk16 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x0C},
						0x0D : {'offset':2522,'bit':7,'bits':8,'parameter':'Tk16 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x0D},
						0x0E : {'offset':2526,'bit':7,'bits':8,'parameter':'Tk16 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x0E},
						0x0F : {'offset':2528,'bit':3,'bits':4,'parameter':'Tk16 Delay Tempo Base','range':{0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x0F},
						0x10 : {'offset':2528,'bit':7,'bits':1,'parameter':'Tk16 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x10},
						0x11 : {'offset':2529,'bit':7,'bits':8,'parameter':'Tk16 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x11},
						0x12 : {'offset':2543,'bit':5,'bits':1,'parameter':'Tk16 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x12},
						0x13 : {'offset':2541,'bit':0,'bits':1,'parameter':'Tk16 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x13},
						0x14 : {'offset':2541,'bit':1,'bits':1,'parameter':'Tk16 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x14},
						0x15 : {'offset':2541,'bit':2,'bits':1,'parameter':'Tk16 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x15},
						0x16 : {'offset':2541,'bit':3,'bits':1,'parameter':'Tk16 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x16},
						0x17 : {'offset':2541,'bit':4,'bits':1,'parameter':'Tk16 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x17},
						0x18 : {'offset':2541,'bit':5,'bits':1,'parameter':'Tk16 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x18},
						0x19 : {'offset':2541,'bit':6,'bits':1,'parameter':'Tk16 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x19},
						0x1A : {'offset':2541,'bit':7,'bits':1,'parameter':'Tk16 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x1A},
						0x1B : {'offset':2542,'bit':0,'bits':1,'parameter':'Tk16 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x1B},
						0x1C : {'offset':2542,'bit':1,'bits':1,'parameter':'Tk16 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x1C},
						0x1D : {'offset':2542,'bit':2,'bits':1,'parameter':'Tk16 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x1D},
						0x1E : {'offset':2542,'bit':3,'bits':1,'parameter':'Tk16 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x1E},
						0x1F : {'offset':2542,'bit':4,'bits':1,'parameter':'Tk16 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x1F},
						0x20 : {'offset':2542,'bit':5,'bits':1,'parameter':'Tk16 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x20},
						0x21 : {'offset':2542,'bit':6,'bits':1,'parameter':'Tk16 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x21},
						0x22 : {'offset':2542,'bit':7,'bits':1,'parameter':'Tk16 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x22},
						0x23 : {'offset':2543,'bit':0,'bits':1,'parameter':'Tk16 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x23},
						0x24 : {'offset':2543,'bit':1,'bits':1,'parameter':'Tk16 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x24},
						0x25 : {'offset':2543,'bit':2,'bits':1,'parameter':'Tk16 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x25},
						0x26 : {'offset':2543,'bit':3,'bits':1,'parameter':'Tk16 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x26},
						0x27 : {'offset':2543,'bit':4,'bits':1,'parameter':'Tk16 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x27},
						0x28 : {'offset':2543,'bit':7,'bits':1,'parameter':'Tk16 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x28},
# 0x29
						0x29 : {'offset':-1,'bit':7,'bits':8,'parameter':'Track 16 Solo','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x29},
						0x2A : {'offset':2543,'bit':6,'bits':1,'parameter':'Tk16 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x2A},
						0x2B : {'offset':2552,'bit':6,'bits':7,'parameter':'Tk16 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x2B},
						0x2C : {'offset':2552,'bit':7,'bits':1,'parameter':'Tk16 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x2C},
						0x2D : {'offset':2554,'bit':7,'bits':8,'parameter':'Tk16 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x2D},
						0x2E : {'offset':2555,'bit':7,'bits':8,'parameter':'Tk16 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x2E},
						0x2F : {'offset':2556,'bit':7,'bits':8,'parameter':'Tk16 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x2F},
						0x30 : {'offset':2557,'bit':7,'bits':8,'parameter':'Tk16 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x30},
						0x31 : {'offset':2546,'bit':7,'bits':8,'parameter':'Tk16 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x31},
						0x32 : {'offset':2548,'bit':3,'bits':4,'parameter':'Tk16 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x32},
						0x33 : {'offset':2548,'bit':7,'bits':4,'parameter':'Tk16 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x33},
						0x34 : {'offset':2547,'bit':7,'bits':8,'parameter':'Tk16 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x34},
						0x35 : {'offset':2549,'bit':7,'bits':8,'parameter':'Tk16 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x35},
						0x36 : {'offset':2551,'bit':3,'bits':4,'parameter':'Tk16 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x36},
						0x37 : {'offset':2551,'bit':7,'bits':4,'parameter':'Tk16 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x37},
						0x38 : {'offset':2550,'bit':7,'bits':8,'parameter':'Tk16 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x38},
						0x39 : {'offset':2538,'bit':4,'bits':5,'parameter':'Tk16 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x39},
						0x3A : {'offset':2538,'bit':6,'bits':2,'parameter':'Tk16 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x3A},
						0x3B : {'offset':2531,'bit':7,'bits':8,'parameter':'Tk16 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x3B},
						0x3C : {'offset':2532,'bit':7,'bits':8,'parameter':'Tk16 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x3C},
						0x3D : {'offset':2533,'bit':7,'bits':8,'parameter':'Tk16 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x3D},
						0x3E : {'offset':2534,'bit':7,'bits':8,'parameter':'Tk16 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x3E},
						0x3F : {'offset':2535,'bit':7,'bits':8,'parameter':'Tk16 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x3F},
						0x40 : {'offset':2536,'bit':7,'bits':8,'parameter':'Tk16 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x40},
						0x41 : {'offset':2537,'bit':7,'bits':8,'parameter':'Tk16 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x41},
						0x42 : {'offset':2544,'bit':7,'bits':1,'parameter':'Tk16 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1B,'subid':0x42},
					},
	0x1C :  {
						# Track 1 Tone Adjust
						0x00 : {'offset':916,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x00},
						0x01 : {'offset':917,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 1 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x01},
						0x02 : {'offset':918,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x02},
						0x03 : {'offset':920,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x03},
						0x04 : {'offset':921,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 2 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x04},
						0x05 : {'offset':922,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x05},
						0x06 : {'offset':924,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x06},
						0x07 : {'offset':925,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 3 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x07},
						0x08 : {'offset':926,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x08},
						0x09 : {'offset':928,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x09},
						0x0A : {'offset':929,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 4 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x0A},
						0x0B : {'offset':930,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x0B},
						0x0C : {'offset':932,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x0C},
						0x0D : {'offset':933,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 5 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x0D},
						0x0E : {'offset':934,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x0E},
						0x0F : {'offset':936,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x0F},
						0x10 : {'offset':937,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 6 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x10},
						0x11 : {'offset':938,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x11},
						0x12 : {'offset':940,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x12},
						0x13 : {'offset':941,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 7 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x13},
						0x14 : {'offset':942,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x14},
						0x15 : {'offset':944,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x15},
						0x16 : {'offset':945,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 8 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x16},
						0x17 : {'offset':946,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x17},
						0x18 : {'offset':884,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x18},
						0x19 : {'offset':886,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x19},
						0x1A : {'offset':888,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x1A},
						0x1B : {'offset':890,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x1B},
						0x1C : {'offset':892,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x1C},
						0x1D : {'offset':894,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x1D},
						0x1E : {'offset':896,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x1E},
						0x1F : {'offset':898,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x1F},
						0x20 : {'offset':900,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x20},
						0x21 : {'offset':902,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x21},
						0x22 : {'offset':904,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x22},
						0x23 : {'offset':906,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x23},
						0x24 : {'offset':908,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x24},
						0x25 : {'offset':910,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x25},
						0x26 : {'offset':912,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x26},
						0x27 : {'offset':914,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1C,'subid':0x27},
					},
	0x1D :  {
						# Track 2 Tone Adjust
						0x00 : {'offset':1028,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x00},
						0x01 : {'offset':1029,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x01},
						0x02 : {'offset':1030,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x02},
						0x03 : {'offset':1032,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x03},
						0x04 : {'offset':1033,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x04},
						0x05 : {'offset':1034,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x05},
						0x06 : {'offset':1036,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x06},
						0x07 : {'offset':1037,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x07},
						0x08 : {'offset':1038,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x08},
						0x09 : {'offset':1040,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x09},
						0x0A : {'offset':1041,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x0A},
						0x0B : {'offset':1042,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x0B},
						0x0C : {'offset':1044,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x0C},
						0x0D : {'offset':1045,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x0D},
						0x0E : {'offset':1046,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x0E},
						0x0F : {'offset':1048,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x0F},
						0x10 : {'offset':1049,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x10},
						0x11 : {'offset':1050,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x11},
						0x12 : {'offset':1052,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x12},
						0x13 : {'offset':1053,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x13},
						0x14 : {'offset':1054,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x14},
						0x15 : {'offset':1056,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x15},
						0x16 : {'offset':1057,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x16},
						0x17 : {'offset':1058,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x17},
						0x18 : {'offset':996,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x18},
						0x19 : {'offset':998,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x19},
						0x1A : {'offset':1000,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x1A},
						0x1B : {'offset':1002,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x1B},
						0x1C : {'offset':1004,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x1C},
						0x1D : {'offset':1006,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x1D},
						0x1E : {'offset':1008,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x1E},
						0x1F : {'offset':1010,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x1F},
						0x20 : {'offset':1012,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x20},
						0x21 : {'offset':1014,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x21},
						0x22 : {'offset':1016,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x22},
						0x23 : {'offset':1018,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x23},
						0x24 : {'offset':1020,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x24},
						0x25 : {'offset':1022,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x25},
						0x26 : {'offset':1024,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x26},
						0x27 : {'offset':1026,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1D,'subid':0x27},
					},
	0x1E :  {
						# Track 3 Tone Adjust
						0x00 : {'offset':1140,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x00},
						0x01 : {'offset':1141,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x01},
						0x02 : {'offset':1142,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x02},
						0x03 : {'offset':1144,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x03},
						0x04 : {'offset':1145,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x04},
						0x05 : {'offset':1146,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x05},
						0x06 : {'offset':1148,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x06},
						0x07 : {'offset':1149,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x07},
						0x08 : {'offset':1150,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x08},
						0x09 : {'offset':1152,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x09},
						0x0A : {'offset':1153,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x0A},
						0x0B : {'offset':1154,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x0B},
						0x0C : {'offset':1156,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x0C},
						0x0D : {'offset':1157,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x0D},
						0x0E : {'offset':1158,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x0E},
						0x0F : {'offset':1160,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x0F},
						0x10 : {'offset':1161,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x10},
						0x11 : {'offset':1162,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x11},
						0x12 : {'offset':1164,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x12},
						0x13 : {'offset':1165,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x13},
						0x14 : {'offset':1166,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x14},
						0x15 : {'offset':1168,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x15},
						0x16 : {'offset':1169,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x16},
						0x17 : {'offset':1170,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x17},
						0x18 : {'offset':1108,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x18},
						0x19 : {'offset':1110,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x19},
						0x1A : {'offset':1112,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x1A},
						0x1B : {'offset':1114,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x1B},
						0x1C : {'offset':1116,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x1C},
						0x1D : {'offset':1118,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x1D},
						0x1E : {'offset':1120,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x1E},
						0x1F : {'offset':1122,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x1F},
						0x20 : {'offset':1124,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x20},
						0x21 : {'offset':1126,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x21},
						0x22 : {'offset':1128,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x22},
						0x23 : {'offset':1130,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x23},
						0x24 : {'offset':1132,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x24},
						0x25 : {'offset':1134,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x25},
						0x26 : {'offset':1136,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x26},
						0x27 : {'offset':1138,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1E,'subid':0x27},
					},
	0x1F :  {
						# Track 4 Tone Adjust
						0x00 : {'offset':1252,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x00},
						0x01 : {'offset':1253,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x01},
						0x02 : {'offset':1254,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x02},
						0x03 : {'offset':1256,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x03},
						0x04 : {'offset':1257,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x04},
						0x05 : {'offset':1258,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x05},
						0x06 : {'offset':1260,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x06},
						0x07 : {'offset':1261,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x07},
						0x08 : {'offset':1262,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x08},
						0x09 : {'offset':1264,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x09},
						0x0A : {'offset':1265,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x0A},
						0x0B : {'offset':1266,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x0B},
						0x0C : {'offset':1268,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x0C},
						0x0D : {'offset':1269,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x0D},
						0x0E : {'offset':1270,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x0E},
						0x0F : {'offset':1272,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x0F},
						0x10 : {'offset':1273,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x10},
						0x11 : {'offset':1274,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x11},
						0x12 : {'offset':1276,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x12},
						0x13 : {'offset':1277,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x13},
						0x14 : {'offset':1278,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x14},
						0x15 : {'offset':1280,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x15},
						0x16 : {'offset':1281,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x16},
						0x17 : {'offset':1282,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x17},
						0x18 : {'offset':1220,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x18},
						0x19 : {'offset':1222,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x19},
						0x1A : {'offset':1224,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x1A},
						0x1B : {'offset':1226,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x1B},
						0x1C : {'offset':1228,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x1C},
						0x1D : {'offset':1230,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x1D},
						0x1E : {'offset':1232,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x1E},
						0x1F : {'offset':1234,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x1F},
						0x20 : {'offset':1236,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x20},
						0x21 : {'offset':1238,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x21},
						0x22 : {'offset':1240,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x22},
						0x23 : {'offset':1242,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x23},
						0x24 : {'offset':1244,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x24},
						0x25 : {'offset':1246,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x25},
						0x26 : {'offset':1248,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x26},
						0x27 : {'offset':1250,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x1F,'subid':0x27},
					},
	0x20 :  {
						# Track 5 Tone Adjust
						0x00 : {'offset':1364,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x00},
						0x01 : {'offset':1365,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x01},
						0x02 : {'offset':1366,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x02},
						0x03 : {'offset':1368,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x03},
						0x04 : {'offset':1369,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x04},
						0x05 : {'offset':1370,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x05},
						0x06 : {'offset':1372,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x06},
						0x07 : {'offset':1373,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x07},
						0x08 : {'offset':1374,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x08},
						0x09 : {'offset':1376,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x09},
						0x0A : {'offset':1377,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x0A},
						0x0B : {'offset':1378,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x0B},
						0x0C : {'offset':1380,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x0C},
						0x0D : {'offset':1381,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x0D},
						0x0E : {'offset':1382,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x0E},
						0x0F : {'offset':1384,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x0F},
						0x10 : {'offset':1385,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x10},
						0x11 : {'offset':1386,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x11},
						0x12 : {'offset':1388,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x12},
						0x13 : {'offset':1389,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x13},
						0x14 : {'offset':1390,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x14},
						0x15 : {'offset':1392,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x15},
						0x16 : {'offset':1393,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x16},
						0x17 : {'offset':1394,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x17},
						0x18 : {'offset':1332,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x18},
						0x19 : {'offset':1334,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x19},
						0x1A : {'offset':1336,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x1A},
						0x1B : {'offset':1338,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x1B},
						0x1C : {'offset':1340,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x1C},
						0x1D : {'offset':1342,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x1D},
						0x1E : {'offset':1344,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x1E},
						0x1F : {'offset':1346,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x1F},
						0x20 : {'offset':1348,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x20},
						0x21 : {'offset':1350,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x21},
						0x22 : {'offset':1352,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x22},
						0x23 : {'offset':1354,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x23},
						0x24 : {'offset':1356,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x24},
						0x25 : {'offset':1358,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x25},
						0x26 : {'offset':1360,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x26},
						0x27 : {'offset':1362,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x20,'subid':0x27},
					},
	0x21 :  {
						# Track 6 Tone Adjust
						0x00 : {'offset':1476,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x00},
						0x01 : {'offset':1477,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x01},
						0x02 : {'offset':1478,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x02},
						0x03 : {'offset':1480,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x03},
						0x04 : {'offset':1481,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x04},
						0x05 : {'offset':1482,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x05},
						0x06 : {'offset':1484,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x06},
						0x07 : {'offset':1485,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x07},
						0x08 : {'offset':1486,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x08},
						0x09 : {'offset':1488,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x09},
						0x0A : {'offset':1489,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x0A},
						0x0B : {'offset':1490,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x0B},
						0x0C : {'offset':1492,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x0C},
						0x0D : {'offset':1493,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x0D},
						0x0E : {'offset':1494,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x0E},
						0x0F : {'offset':1496,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x0F},
						0x10 : {'offset':1497,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x10},
						0x11 : {'offset':1498,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x11},
						0x12 : {'offset':1500,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x12},
						0x13 : {'offset':1501,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x13},
						0x14 : {'offset':1502,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x14},
						0x15 : {'offset':1504,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x15},
						0x16 : {'offset':1505,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x16},
						0x17 : {'offset':1506,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x17},
						0x18 : {'offset':1444,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x18},
						0x19 : {'offset':1446,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x19},
						0x1A : {'offset':1448,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x1A},
						0x1B : {'offset':1450,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x1B},
						0x1C : {'offset':1452,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x1C},
						0x1D : {'offset':1454,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x1D},
						0x1E : {'offset':1456,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x1E},
						0x1F : {'offset':1458,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x1F},
						0x20 : {'offset':1460,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x20},
						0x21 : {'offset':1462,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x21},
						0x22 : {'offset':1464,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x22},
						0x23 : {'offset':1466,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x23},
						0x24 : {'offset':1468,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x24},
						0x25 : {'offset':1470,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x25},
						0x26 : {'offset':1472,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x26},
						0x27 : {'offset':1474,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x21,'subid':0x27},
					},
	0x22 :  {
						# Track 7 Tone Adjust
						0x00 : {'offset':1588,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x00},
						0x01 : {'offset':1589,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x01},
						0x02 : {'offset':1590,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x02},
						0x03 : {'offset':1592,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x03},
						0x04 : {'offset':1593,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x04},
						0x05 : {'offset':1594,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x05},
						0x06 : {'offset':1596,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x06},
						0x07 : {'offset':1597,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x07},
						0x08 : {'offset':1598,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x08},
						0x09 : {'offset':1600,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x09},
						0x0A : {'offset':1601,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x0A},
						0x0B : {'offset':1602,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x0B},
						0x0C : {'offset':1604,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x0C},
						0x0D : {'offset':1605,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x0D},
						0x0E : {'offset':1606,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x0E},
						0x0F : {'offset':1608,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x0F},
						0x10 : {'offset':1609,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x10},
						0x11 : {'offset':1610,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x11},
						0x12 : {'offset':1612,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x12},
						0x13 : {'offset':1613,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x13},
						0x14 : {'offset':1614,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x14},
						0x15 : {'offset':1616,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x15},
						0x16 : {'offset':1617,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x16},
						0x17 : {'offset':1618,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x17},
						0x18 : {'offset':1556,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x18},
						0x19 : {'offset':1558,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x19},
						0x1A : {'offset':1560,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x1A},
						0x1B : {'offset':1562,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x1B},
						0x1C : {'offset':1564,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x1C},
						0x1D : {'offset':1566,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x1D},
						0x1E : {'offset':1568,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x1E},
						0x1F : {'offset':1570,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x1F},
						0x20 : {'offset':1572,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x20},
						0x21 : {'offset':1574,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x21},
						0x22 : {'offset':1576,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x22},
						0x23 : {'offset':1578,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x23},
						0x24 : {'offset':1580,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x24},
						0x25 : {'offset':1582,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x25},
						0x26 : {'offset':1584,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x26},
						0x27 : {'offset':1586,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x22,'subid':0x27},
					},
	0x23 :  {
						# Track 8 Tone Adjust
						0x00 : {'offset':1700,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x00},
						0x01 : {'offset':1701,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x01},
						0x02 : {'offset':1702,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x02},
						0x03 : {'offset':1704,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x03},
						0x04 : {'offset':1705,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x04},
						0x05 : {'offset':1706,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x05},
						0x06 : {'offset':1708,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x06},
						0x07 : {'offset':1709,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x07},
						0x08 : {'offset':1710,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x08},
						0x09 : {'offset':1712,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x09},
						0x0A : {'offset':1713,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x0A},
						0x0B : {'offset':1714,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x0B},
						0x0C : {'offset':1716,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x0C},
						0x0D : {'offset':1717,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x0D},
						0x0E : {'offset':1718,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x0E},
						0x0F : {'offset':1720,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x0F},
						0x10 : {'offset':1721,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x10},
						0x11 : {'offset':1722,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x11},
						0x12 : {'offset':1724,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x12},
						0x13 : {'offset':1725,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x13},
						0x14 : {'offset':1726,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x14},
						0x15 : {'offset':1728,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x15},
						0x16 : {'offset':1729,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x16},
						0x17 : {'offset':1730,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x17},
						0x18 : {'offset':1668,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x18},
						0x19 : {'offset':1670,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x19},
						0x1A : {'offset':1672,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x1A},
						0x1B : {'offset':1674,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x1B},
						0x1C : {'offset':1676,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x1C},
						0x1D : {'offset':1678,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x1D},
						0x1E : {'offset':1680,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x1E},
						0x1F : {'offset':1682,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x1F},
						0x20 : {'offset':1684,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x20},
						0x21 : {'offset':1686,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x21},
						0x22 : {'offset':1688,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x22},
						0x23 : {'offset':1690,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x23},
						0x24 : {'offset':1692,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x24},
						0x25 : {'offset':1694,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x25},
						0x26 : {'offset':1696,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x26},
						0x27 : {'offset':1698,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x23,'subid':0x27},
					},
	0x24 :  {
						# Track 9 Tone Adjust
						0x00 : {'offset':1812,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x00},
						0x01 : {'offset':1813,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x01},
						0x02 : {'offset':1814,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x02},
						0x03 : {'offset':1816,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x03},
						0x04 : {'offset':1817,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x04},
						0x05 : {'offset':1818,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x05},
						0x06 : {'offset':1820,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x06},
						0x07 : {'offset':1821,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x07},
						0x08 : {'offset':1822,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x08},
						0x09 : {'offset':1824,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x09},
						0x0A : {'offset':1825,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x0A},
						0x0B : {'offset':1826,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x0B},
						0x0C : {'offset':1828,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x0C},
						0x0D : {'offset':1829,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x0D},
						0x0E : {'offset':1830,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x0E},
						0x0F : {'offset':1832,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x0F},
						0x10 : {'offset':1833,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x10},
						0x11 : {'offset':1834,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x11},
						0x12 : {'offset':1836,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x12},
						0x13 : {'offset':1837,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x13},
						0x14 : {'offset':1838,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x14},
						0x15 : {'offset':1840,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x15},
						0x16 : {'offset':1841,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x16},
						0x17 : {'offset':1842,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x17},
						0x18 : {'offset':1780,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x18},
						0x19 : {'offset':1782,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x19},
						0x1A : {'offset':1784,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x1A},
						0x1B : {'offset':1786,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x1B},
						0x1C : {'offset':1788,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x1C},
						0x1D : {'offset':1790,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x1D},
						0x1E : {'offset':1792,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x1E},
						0x1F : {'offset':1794,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x1F},
						0x20 : {'offset':1796,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x20},
						0x21 : {'offset':1798,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x21},
						0x22 : {'offset':1800,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x22},
						0x23 : {'offset':1802,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x23},
						0x24 : {'offset':1804,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x24},
						0x25 : {'offset':1806,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x25},
						0x26 : {'offset':1808,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x26},
						0x27 : {'offset':1810,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x24,'subid':0x27},
					},
	0x25 :  {
						# Track 10 Tone Adjust
						0x00 : {'offset':1924,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x00},
						0x01 : {'offset':1925,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x01},
						0x02 : {'offset':1926,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x02},
						0x03 : {'offset':1928,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x03},
						0x04 : {'offset':1929,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x04},
						0x05 : {'offset':1930,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x05},
						0x06 : {'offset':1932,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x06},
						0x07 : {'offset':1933,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x07},
						0x08 : {'offset':1934,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x08},
						0x09 : {'offset':1936,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x09},
						0x0A : {'offset':1937,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x0A},
						0x0B : {'offset':1938,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x0B},
						0x0C : {'offset':1940,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x0C},
						0x0D : {'offset':1941,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x0D},
						0x0E : {'offset':1942,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x0E},
						0x0F : {'offset':1944,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x0F},
						0x10 : {'offset':1945,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x10},
						0x11 : {'offset':1946,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x11},
						0x12 : {'offset':1948,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x12},
						0x13 : {'offset':1949,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x13},
						0x14 : {'offset':1950,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x14},
						0x15 : {'offset':1952,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x15},
						0x16 : {'offset':1953,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x16},
						0x17 : {'offset':1954,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x17},
						0x18 : {'offset':1892,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x18},
						0x19 : {'offset':1894,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x19},
						0x1A : {'offset':1896,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x1A},
						0x1B : {'offset':1898,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x1B},
						0x1C : {'offset':1900,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x1C},
						0x1D : {'offset':1902,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x1D},
						0x1E : {'offset':1904,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x1E},
						0x1F : {'offset':1906,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x1F},
						0x20 : {'offset':1908,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x20},
						0x21 : {'offset':1910,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x21},
						0x22 : {'offset':1912,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x22},
						0x23 : {'offset':1914,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x23},
						0x24 : {'offset':1916,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x24},
						0x25 : {'offset':1918,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x25},
						0x26 : {'offset':1920,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x26},
						0x27 : {'offset':1922,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x25,'subid':0x27},
					},
	0x26 :  {
						# Track 11 Tone Adjust
						0x00 : {'offset':2036,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x00},
						0x01 : {'offset':2037,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x01},
						0x02 : {'offset':2038,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x02},
						0x03 : {'offset':2040,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x03},
						0x04 : {'offset':2041,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x04},
						0x05 : {'offset':2042,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x05},
						0x06 : {'offset':2044,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x06},
						0x07 : {'offset':2045,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x07},
						0x08 : {'offset':2046,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x08},
						0x09 : {'offset':2048,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x09},
						0x0A : {'offset':2049,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x0A},
						0x0B : {'offset':2050,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x0B},
						0x0C : {'offset':2052,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x0C},
						0x0D : {'offset':2053,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x0D},
						0x0E : {'offset':2054,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x0E},
						0x0F : {'offset':2056,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x0F},
						0x10 : {'offset':2057,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x10},
						0x11 : {'offset':2058,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x11},
						0x12 : {'offset':2060,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x12},
						0x13 : {'offset':2061,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x13},
						0x14 : {'offset':2062,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x14},
						0x15 : {'offset':2064,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x15},
						0x16 : {'offset':2065,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x16},
						0x17 : {'offset':2066,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x17},
						0x18 : {'offset':2004,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x18},
						0x19 : {'offset':2006,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x19},
						0x1A : {'offset':2008,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x1A},
						0x1B : {'offset':2010,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x1B},
						0x1C : {'offset':2012,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x1C},
						0x1D : {'offset':2014,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x1D},
						0x1E : {'offset':2016,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x1E},
						0x1F : {'offset':2018,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x1F},
						0x20 : {'offset':2020,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x20},
						0x21 : {'offset':2022,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x21},
						0x22 : {'offset':2024,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x22},
						0x23 : {'offset':2026,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x23},
						0x24 : {'offset':2028,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x24},
						0x25 : {'offset':2030,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x25},
						0x26 : {'offset':2032,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x26},
						0x27 : {'offset':2034,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x26,'subid':0x27},
					},
	0x27 :  {
						# Track 12 Tone Adjust
						0x00 : {'offset':2148,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x00},
						0x01 : {'offset':2149,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x01},
						0x02 : {'offset':2150,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x02},
						0x03 : {'offset':2152,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x03},
						0x04 : {'offset':2153,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x04},
						0x05 : {'offset':2154,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x05},
						0x06 : {'offset':2156,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x06},
						0x07 : {'offset':2157,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x07},
						0x08 : {'offset':2158,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x08},
						0x09 : {'offset':2160,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x09},
						0x0A : {'offset':2161,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x0A},
						0x0B : {'offset':2162,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x0B},
						0x0C : {'offset':2164,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x0C},
						0x0D : {'offset':2165,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x0D},
						0x0E : {'offset':2166,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x0E},
						0x0F : {'offset':2168,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x0F},
						0x10 : {'offset':2169,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x10},
						0x11 : {'offset':2170,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x11},
						0x12 : {'offset':2172,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x12},
						0x13 : {'offset':2173,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x13},
						0x14 : {'offset':2174,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x14},
						0x15 : {'offset':2176,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x15},
						0x16 : {'offset':2177,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x16},
						0x17 : {'offset':2178,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x17},
						0x18 : {'offset':2116,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x18},
						0x19 : {'offset':2118,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x19},
						0x1A : {'offset':2120,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x1A},
						0x1B : {'offset':2122,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x1B},
						0x1C : {'offset':2124,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x1C},
						0x1D : {'offset':2126,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x1D},
						0x1E : {'offset':2128,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x1E},
						0x1F : {'offset':2130,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x1F},
						0x20 : {'offset':2132,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x20},
						0x21 : {'offset':2134,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x21},
						0x22 : {'offset':2136,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x22},
						0x23 : {'offset':2138,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x23},
						0x24 : {'offset':2140,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x24},
						0x25 : {'offset':2142,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x25},
						0x26 : {'offset':2144,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x26},
						0x27 : {'offset':2146,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x27,'subid':0x27},
					},
	0x28 :  {
						# Track 13 Tone Adjust
						0x00 : {'offset':2260,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x00},
						0x01 : {'offset':2261,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x01},
						0x02 : {'offset':2262,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x02},
						0x03 : {'offset':2264,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x03},
						0x04 : {'offset':2265,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x04},
						0x05 : {'offset':2266,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x05},
						0x06 : {'offset':2268,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x06},
						0x07 : {'offset':2269,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x07},
						0x08 : {'offset':2270,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x08},
						0x09 : {'offset':2272,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x09},
						0x0A : {'offset':2273,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x0A},
						0x0B : {'offset':2274,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x0B},
						0x0C : {'offset':2276,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x0C},
						0x0D : {'offset':2277,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x0D},
						0x0E : {'offset':2278,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x0E},
						0x0F : {'offset':2280,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x0F},
						0x10 : {'offset':2281,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x10},
						0x11 : {'offset':2282,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x11},
						0x12 : {'offset':2284,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x12},
						0x13 : {'offset':2285,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x13},
						0x14 : {'offset':2286,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x14},
						0x15 : {'offset':2288,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x15},
						0x16 : {'offset':2289,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x16},
						0x17 : {'offset':2290,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x17},
						0x18 : {'offset':2228,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x18},
						0x19 : {'offset':2230,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x19},
						0x1A : {'offset':2232,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x1A},
						0x1B : {'offset':2234,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x1B},
						0x1C : {'offset':2236,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x1C},
						0x1D : {'offset':2238,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x1D},
						0x1E : {'offset':2240,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x1E},
						0x1F : {'offset':2242,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x1F},
						0x20 : {'offset':2244,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x20},
						0x21 : {'offset':2246,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x21},
						0x22 : {'offset':2248,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x22},
						0x23 : {'offset':2250,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x23},
						0x24 : {'offset':2252,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x24},
						0x25 : {'offset':2254,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x25},
						0x26 : {'offset':2256,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x26},
						0x27 : {'offset':2258,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x28,'subid':0x27},
					},
	0x29 :  {
						# Track 14 Tone Adjust
						0x00 : {'offset':2372,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x00},
						0x01 : {'offset':2373,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x01},
						0x02 : {'offset':2374,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x02},
						0x03 : {'offset':2376,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x03},
						0x04 : {'offset':2377,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x04},
						0x05 : {'offset':2378,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x05},
						0x06 : {'offset':2380,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x06},
						0x07 : {'offset':2381,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x07},
						0x08 : {'offset':2382,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x08},
						0x09 : {'offset':2384,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x09},
						0x0A : {'offset':2385,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x0A},
						0x0B : {'offset':2386,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x0B},
						0x0C : {'offset':2388,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x0C},
						0x0D : {'offset':2389,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x0D},
						0x0E : {'offset':2390,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x0E},
						0x0F : {'offset':2392,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x0F},
						0x10 : {'offset':2393,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x10},
						0x11 : {'offset':2394,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x11},
						0x12 : {'offset':2396,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x12},
						0x13 : {'offset':2397,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x13},
						0x14 : {'offset':2398,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x14},
						0x15 : {'offset':2400,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x15},
						0x16 : {'offset':2401,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x16},
						0x17 : {'offset':2402,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x17},
						0x18 : {'offset':2340,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x18},
						0x19 : {'offset':2342,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x19},
						0x1A : {'offset':2344,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x1A},
						0x1B : {'offset':2346,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x1B},
						0x1C : {'offset':2348,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x1C},
						0x1D : {'offset':2350,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x1D},
						0x1E : {'offset':2352,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x1E},
						0x1F : {'offset':2354,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x1F},
						0x20 : {'offset':2356,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x20},
						0x21 : {'offset':2358,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x21},
						0x22 : {'offset':2360,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x22},
						0x23 : {'offset':2362,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x23},
						0x24 : {'offset':2364,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x24},
						0x25 : {'offset':2366,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x25},
						0x26 : {'offset':2368,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x26},
						0x27 : {'offset':2370,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x29,'subid':0x27},
					},
	0x2A :  {
						# Track 15 Tone Adjust
						0x00 : {'offset':2484,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x00},
						0x01 : {'offset':2485,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x01},
						0x02 : {'offset':2486,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x02},
						0x03 : {'offset':2488,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x03},
						0x04 : {'offset':2489,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x04},
						0x05 : {'offset':2490,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x05},
						0x06 : {'offset':2492,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x06},
						0x07 : {'offset':2493,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x07},
						0x08 : {'offset':2494,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x08},
						0x09 : {'offset':2496,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x09},
						0x0A : {'offset':2497,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x0A},
						0x0B : {'offset':2498,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x0B},
						0x0C : {'offset':2500,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x0C},
						0x0D : {'offset':2501,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x0D},
						0x0E : {'offset':2502,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x0E},
						0x0F : {'offset':2504,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x0F},
						0x10 : {'offset':2505,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x10},
						0x11 : {'offset':2506,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x11},
						0x12 : {'offset':2508,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x12},
						0x13 : {'offset':2509,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x13},
						0x14 : {'offset':2510,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x14},
						0x15 : {'offset':2512,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x15},
						0x16 : {'offset':2513,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x16},
						0x17 : {'offset':2514,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x17},
						0x18 : {'offset':2452,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x18},
						0x19 : {'offset':2454,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x19},
						0x1A : {'offset':2456,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x1A},
						0x1B : {'offset':2458,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x1B},
						0x1C : {'offset':2460,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x1C},
						0x1D : {'offset':2462,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x1D},
						0x1E : {'offset':2464,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x1E},
						0x1F : {'offset':2466,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x1F},
						0x20 : {'offset':2468,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x20},
						0x21 : {'offset':2470,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x21},
						0x22 : {'offset':2472,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x22},
						0x23 : {'offset':2474,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x23},
						0x24 : {'offset':2476,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x24},
						0x25 : {'offset':2478,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x25},
						0x26 : {'offset':2480,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x26},
						0x27 : {'offset':2482,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2A,'subid':0x27},
					},
	0x2B :  {
						# Track 16 Tone Adjust
						0x00 : {'offset':2596,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x00},
						0x01 : {'offset':2597,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x01},
						0x02 : {'offset':2598,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x02},
						0x03 : {'offset':2600,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x03},
						0x04 : {'offset':2601,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x04},
						0x05 : {'offset':2602,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x05},
						0x06 : {'offset':2604,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x06},
						0x07 : {'offset':2605,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x07},
						0x08 : {'offset':2606,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x08},
						0x09 : {'offset':2608,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x09},
						0x0A : {'offset':2609,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x0A},
						0x0B : {'offset':2610,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x0B},
						0x0C : {'offset':2612,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x0C},
						0x0D : {'offset':2613,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x0D},
						0x0E : {'offset':2614,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x0E},
						0x0F : {'offset':2616,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x0F},
						0x10 : {'offset':2617,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x10},
						0x11 : {'offset':2618,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x11},
						0x12 : {'offset':2620,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x12},
						0x13 : {'offset':2621,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x13},
						0x14 : {'offset':2622,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x14},
						0x15 : {'offset':2624,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x15},
						0x16 : {'offset':2625,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x16},
						0x17 : {'offset':2626,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x17},
						0x18 : {'offset':2564,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x18},
						0x19 : {'offset':2566,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x19},
						0x1A : {'offset':2568,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x1A},
						0x1B : {'offset':2570,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x1B},
						0x1C : {'offset':2572,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x1C},
						0x1D : {'offset':2574,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x1D},
						0x1E : {'offset':2576,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x1E},
						0x1F : {'offset':2578,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x1F},
						0x20 : {'offset':2580,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x20},
						0x21 : {'offset':2582,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x21},
						0x22 : {'offset':2584,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x22},
						0x23 : {'offset':2586,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x23},
						0x24 : {'offset':2588,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x24},
						0x25 : {'offset':2590,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x25},
						0x26 : {'offset':2592,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x26},
						0x27 : {'offset':2594,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x00,'id':0x2B,'subid':0x27},
					},
	0x2C :  {
						# Insert Effect 1-5 Parameters
						0x00 : {'offset':88,'bit':7,'bits':8,'parameter':'IFX1 Effect Type','range':(0, 193),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x00},
						0x01 : {'offset':164,'bit':7,'bits':8,'parameter':'IFX2 Effect Type','range':(0, 193),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x01},
						0x02 : {'offset':240,'bit':7,'bits':8,'parameter':'IFX3 Effect Type','range':(0, 193),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x02},
						0x03 : {'offset':316,'bit':7,'bits':8,'parameter':'IFX4 Effect Type','range':(0, 193),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x03},
						0x04 : {'offset':392,'bit':7,'bits':8,'parameter':'IFX5 Effect Type','range':(0, 171),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x04},
						0x05 : {'offset':89,'bit':6,'bits':1,'parameter':'IFX1 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x05},
						0x06 : {'offset':165,'bit':6,'bits':1,'parameter':'IFX2 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x06},
						0x07 : {'offset':241,'bit':6,'bits':1,'parameter':'IFX3 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x07},
						0x08 : {'offset':317,'bit':6,'bits':1,'parameter':'IFX4 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x08},
						0x09 : {'offset':393,'bit':6,'bits':1,'parameter':'IFX5 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x09},
						0x0A : {'offset':92,'bit':7,'bits':8,'parameter':'IFX1 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x0A},
						0x0B : {'offset':168,'bit':7,'bits':8,'parameter':'IFX2 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x0B},
						0x0C : {'offset':244,'bit':7,'bits':8,'parameter':'IFX3 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x0C},
						0x0D : {'offset':320,'bit':7,'bits':8,'parameter':'IFX4 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x0D},
						0x0E : {'offset':396,'bit':7,'bits':8,'parameter':'IFX5 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x0E},
						0x0F : {'offset':93,'bit':3,'bits':4,'parameter':'IFX1 Bus Select','range':{00:'L/R', 07:'Off'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x0F},
						0x10 : {'offset':169,'bit':3,'bits':4,'parameter':'IFX2 Bus Select','range':{00:'L/R', 07:'Off'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x10},
						0x11 : {'offset':245,'bit':3,'bits':4,'parameter':'IFX3 Bus Select','range':{00:'L/R', 07:'Off'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x11},
						0x12 : {'offset':321,'bit':3,'bits':4,'parameter':'IFX4 Bus Select','range':{00:'L/R', 07:'Off'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x12},
						0x13 : {'offset':397,'bit':3,'bits':4,'parameter':'IFX5 Bus Select','range':{00:'L/R', 07:'Off'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x13},
						0x14 : {'offset':94,'bit':7,'bits':8,'parameter':'IFX1 Send 1 Level','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x14},
						0x15 : {'offset':170,'bit':7,'bits':8,'parameter':'IFX2 Send 1 Level','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x15},
						0x16 : {'offset':246,'bit':7,'bits':8,'parameter':'IFX3 Send 1 Level','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x16},
						0x17 : {'offset':322,'bit':7,'bits':8,'parameter':'IFX4 Send 1 Level','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x17},
						0x18 : {'offset':398,'bit':7,'bits':8,'parameter':'IFX5 Send 1 Level','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x18},
						0x19 : {'offset':95,'bit':7,'bits':8,'parameter':'IFX1 Send 2 Level','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x19},
						0x1A : {'offset':171,'bit':7,'bits':8,'parameter':'IFX2 Send 2 Level','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x1A},
						0x1B : {'offset':247,'bit':7,'bits':8,'parameter':'IFX3 Send 2 Level','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x1B},
						0x1C : {'offset':323,'bit':7,'bits':8,'parameter':'IFX4 Send 2 Level','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x1C},
						0x1D : {'offset':399,'bit':7,'bits':8,'parameter':'IFX5 Send 2 Level','range':(0, 127),'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x1D},
						0x1E : {'offset':93,'bit':5,'bits':2,'parameter':'IFX1 FX Control','range':{0:'Off',01:'FX Ctrl1',02:'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x1E},
						0x1F : {'offset':169,'bit':5,'bits':2,'parameter':'IFX2 FX Control','range':{0:'Off',01:'FX Ctrl1',02:'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x1F},
						0x20 : {'offset':245,'bit':5,'bits':2,'parameter':'IFX3 FX Control','range':{0:'Off',01:'FX Ctrl1',02:'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x20},
						0x21 : {'offset':321,'bit':5,'bits':2,'parameter':'IFX4 FX Control','range':{0:'Off',01:'FX Ctrl1',02:'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x21},
						0x22 : {'offset':397,'bit':5,'bits':2,'parameter':'IFX5 FX Control','range':{0:'Off',01:'FX Ctrl1',02:'FX Ctrl2'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x22},
						0x28 : {'offset':89,'bit':7,'bits':1,'parameter':'IFX1 Chain','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x28},
						0x29 : {'offset':165,'bit':7,'bits':1,'parameter':'IFX2 Chain','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x29},
						0x2A : {'offset':241,'bit':7,'bits':1,'parameter':'IFX3 Chain','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x2A},
						0x2B : {'offset':317,'bit':7,'bits':1,'parameter':'IFX4 Chain','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x2B},
						0x2C : {'offset': 90,'bit':7,'bits':8,'parameter':'IFX1 Chain To','range':{0:'IF2',1:'IFX3',2:'IFX4',3:'IFX5'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x2C},
						0x2D : {'offset':166,'bit':7,'bits':8,'parameter':'IFX2 Chain To','range':{0:'IF3',1:'IFX4',2:'IFX5'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x2D},
						0x2E : {'offset':242,'bit':7,'bits':8,'parameter':'IFX3 Chain To','range':{0:'IF4',1:'IFX5'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x2E},
						0x2F : {'offset':89,'bit':5,'bits':6,'parameter':'IFX1 Channel','range':{0:'Ch01',1:'Ch02',2:'Ch03',3:'Ch04',4:'Ch05',5:'Ch06',6:'Ch07',7:'Ch08',8:'Ch09',9:'Ch10',10:'Ch11',11:'Ch12',12:'Ch13',13:'Ch14',14:'Ch15',15:'Ch16',16:'G ch',17:'All-R'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x2F},
						0x30 : {'offset':165,'bit':5,'bits':6,'parameter':'IFX2 Channel','range':{0:'Ch01',1:'Ch02',2:'Ch03',3:'Ch04',4:'Ch05',5:'Ch06',6:'Ch07',7:'Ch08',8:'Ch09',9:'Ch10',10:'Ch11',11:'Ch12',12:'Ch13',13:'Ch14',14:'Ch15',15:'Ch16',16:'G ch',17:'All-R'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x30},
						0x31 : {'offset':241,'bit':5,'bits':6,'parameter':'IFX3 Channel','range':{0:'Ch01',1:'Ch02',2:'Ch03',3:'Ch04',4:'Ch05',5:'Ch06',6:'Ch07',7:'Ch08',8:'Ch09',9:'Ch10',10:'Ch11',11:'Ch12',12:'Ch13',13:'Ch14',14:'Ch15',15:'Ch16',16:'G ch',17:'All-R'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x31},
						0x32 : {'offset':317,'bit':5,'bits':6,'parameter':'IFX4 Channel','range':{0:'Ch01',1:'Ch02',2:'Ch03',3:'Ch04',4:'Ch05',5:'Ch06',6:'Ch07',7:'Ch08',8:'Ch09',9:'Ch10',10:'Ch11',11:'Ch12',12:'Ch13',13:'Ch14',14:'Ch15',15:'Ch16',16:'G ch',17:'All-R'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x32},
						0x33 : {'offset':393,'bit':5,'bits':6,'parameter':'IFX5 Channel','range':{0:'Ch01',1:'Ch02',2:'Ch03',3:'Ch04',4:'Ch05',5:'Ch06',6:'Ch07',7:'Ch08',8:'Ch09',9:'Ch10',10:'Ch11',11:'Ch12',12:'Ch13',13:'Ch14',14:'Ch15',15:'Ch16',16:'G ch',17:'All-R'},'bias':0,'step':None,'mode':0x00,'id':0x2C,'subid':0x33},
					},
	0x2D :  {
						# Insert Effect 1 Parameter Structure
						0x00 : {'offset':24,'bit':7,'bits':8*64,'parameter':'IFX1 Effect Parameter Structure','range':None,'bias':0,'step':None,'mode':0x00,'id':0x2D,'subid':0xFF},
					},
	0x2E :  {
						# Insert Effect 2 Parameter Structure
						0x00 : {'offset':100,'bit':7,'bits':8*64,'parameter':'IFX2 Effect Parameter Structure','range':None,'bias':0,'step':None,'mode':0x00,'id':0x2E,'subid':0xFF},
					},
	0x2F :  {
						# Insert Effect 3 Parameter Structure
						0x00 : {'offset':176,'bit':7,'bits':8*64,'parameter':'IFX3 Effect Parameter Structure','range':None,'bias':0,'step':None,'mode':0x00,'id':0x2F,'subid':0xFF},
					},
	0x30 :  {
						# Insert Effect 4 Parameter Structure
						0x00 : {'offset':252,'bit':7,'bits':8*64,'parameter':'IFX4 Effect Parameter Structure','range':None,'bias':0,'step':None,'mode':0x00,'id':0x30,'subid':0xFF},
					},
	0x31 :  {
						# Insert Effect 5 Parameter Structure
						0x00 : {'offset':328,'bit':7,'bits':8*64,'parameter':'IFX5 Effect Parameter Structure','range':None,'bias':0,'step':None,'mode':0x00,'id':0x31,'subid':0xFF},
					},
	0x32 :  {
						# Master Effect 1 and 2 Parameters
						0x00 : {'offset':468,'bit':7,'bits':8,'parameter':'MFX1 Effect Type','range':(0,0xC1),'bias':0,'step':None,'mode':0x00,'id':0x32,'subid':0x00},
						0x01 : {'offset':536,'bit':7,'bits':8,'parameter':'MFX2 Effect Type','range':(0,0xC1),'bias':0,'step':None,'mode':0x00,'id':0x32,'subid':0x01},
						0x02 : {'offset':469,'bit':6,'bits':1,'parameter':'MFX1 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x32,'subid':0x02},
						0x03 : {'offset':537,'bit':6,'bits':1,'parameter':'MFX2 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x32,'subid':0x03},
						0x04 : {'offset':540,'bit':7,'bits':8,'parameter':'MFX1 Return Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x00,'id':0x32,'subid':0x04},
						0x05 : {'offset':541,'bit':7,'bits':8,'parameter':'MFX2 Return Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x00,'id':0x32,'subid':0x05},
						0x06 : {'offset':542,'bit':1,'bits':1,'parameter':'MFX Chain On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x32,'subid':0x06},
						0x07 : {'offset':542,'bit':0,'bits':1,'parameter':'MFX Chain Direction','range':{0:'MFX1->MFX2', 1:'MFX2->MFX1'},'bias':0,'step':None,'mode':0x00,'id':0x32,'subid':0x07},
						0x08 : {'offset':543,'bit':7,'bits':8,'parameter':'MFX Chain Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x00,'id':0x32,'subid':0x08},
					},
	0x33 :  {
						# Master Effect 1 Parameter Structure
						0x00 : {'offset':404,'bit':7,'bits':8*64,'parameter':'MFX1 Effect Parameter Structure','range':None,'bias':0,'step':None,'mode':0x00,'id':0x33,'subid':0xFF},
					},
	0x34 :  {
						# Master Effect 2 Parameter Structure
						0x00 : {'offset':472,'bit':7,'bits':8*64,'parameter':'MFX2 Effect Parameter Structure','range':None,'bias':0,'step':None,'mode':0x00,'id':0x34,'subid':0xFF},
					},
	0x35 :  {
						# Total Effect Parameters
						0x00 : {'offset':608,'bit':7,'bits':8,'parameter':'TFX Effect Type','range':(0,0xAB),'bias':0,'step':None,'mode':0x00,'id':0x35,'subid':0x00},
						0x01 : {'offset':609,'bit':6,'bits':1,'parameter':'TFX On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x00,'id':0x35,'subid':0x01},
						0x02 : {'offset':612,'bit':7,'bits':8,'parameter':'TFX Master Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x00,'id':0x35,'subid':0x02},
					},
	0x36 :  {
						# Total Effect Parameter Structure
						0x00 : {'offset':544,'bit':7,'bits':8*64,'parameter':'TFX Effect Parameter Structure','range':None,'bias':0,'step':None,'mode':0x00,'id':0x36,'subid':0xFF},
					},
	0x37 :  {
					},
	0x38 :  {
					},
	0x39 :  {
					},
	0x3A :  {
					},
	0x3B :  {
					},
	0x3C :  {
					},
	0x3D :  {
					},
	0x3E :  {
					},
	0x3F :  {
					},
	0xFF :  {
						# No message for these
						0x00 : {'offset':0,'bit':7,'bits':8*24,'parameter':'Combination Name','range':None,'bias':0,'step':None,'mode':0x04,'id':0x7F,'subid':0x00},
					},
}

member_name_dict = {
		(0, 7):'song_name',
		(24, 7):'ifx1',
		(100, 7):'ifx2',
		(176, 7):'ifx3',
		(252, 7):'ifx4',
		(328, 7):'ifx5',
		(404, 7):'mfx1',
		(472, 7):'mfx2',
		(540, 7):'mfx1_return_level',
		(541, 7):'mfx2_return_level',
		(542, 0):'mfx_chain_direction',
		(542, 1):'mfx_chain_on_off',
		(543, 7):'mfx_chain_level',
		(544, 7):'tfx',
		(616, 7):'lfo1',
		(624, 7):'lfo2',
		(632, 7):'control_assign',
		(633, 7):'selected_track',
		(636, 7):'drum',
		(792, 7):'arp',
		(800, 7):'arpa',
		(812, 7):'arpb',
		(824, 7):'common',
		(836, 7):'trk1',
		(948, 7):'trk2',
		(1060, 7):'trk3',
		(1172, 7):'trk4',
		(1284, 7):'trk5',
		(1396, 7):'trk6',
		(1508, 7):'trk7',
		(1620, 7):'trk8',
		(1732, 7):'trk9',
		(1844, 7):'trk10',
		(1956, 7):'trk11',
		(2068, 7):'trk12',
		(2180, 7):'trk13',
		(2292, 7):'trk14',
		(2404, 7):'trk15',
		(2516, 7):'trk16',
#		(24, 7):'param_struct',
		(88, 7):'effect_type',
		(89, 5):'channel',
		(89, 6):'on_off',
		(89, 7):'chain',
		(90, 7):'chain_to',
		(92, 7):'pan',
		(93, 3):'bus_select',
		(93, 5):'fx_control',
		(94, 7):'send1level',
		(95, 7):'send2level',
#		(100, 7):'param_struct',
		(164, 7):'effect_type',
		(165, 5):'channel',
		(165, 6):'on_off',
		(165, 7):'chain',
		(166, 7):'chain_to',
		(168, 7):'pan',
		(169, 3):'bus_select',
		(169, 5):'fx_control',
		(170, 7):'send1level',
		(171, 7):'send2level',
#		(176, 7):'param_struct',
		(240, 7):'effect_type',
		(241, 5):'channel',
		(241, 6):'on_off',
		(241, 7):'chain',
		(242, 7):'chain_to',
		(244, 7):'pan',
		(245, 3):'bus_select',
		(245, 5):'fx_control',
		(246, 7):'send1level',
		(247, 7):'send2level',
#		(252, 7):'param_struct',
		(316, 7):'effect_type',
		(317, 5):'channel',
		(317, 6):'on_off',
		(317, 7):'chain',
		(320, 7):'pan',
		(321, 3):'bus_select',
		(321, 5):'fx_control',
		(322, 7):'send1level',
		(323, 7):'send2level',
#		(328, 7):'param_struct',
		(392, 7):'effect_type',
		(393, 5):'channel',
		(393, 6):'on_off',
		(396, 7):'pan',
		(397, 3):'bus_select',
		(397, 5):'fx_control',
		(398, 7):'send1level',
		(399, 7):'send2level',
#		(404, 7):'param_struct',
		(468, 7):'effect_type',
		(469, 6):'on_off',
#		(472, 7):'param_struct',
		(536, 7):'effect_type',
		(537, 6):'on_off',
#		(544, 7):'param_struct',
		(608, 7):'effect_type',
		(609, 6):'on_off',
		(612, 7):'master_volume',
		(616, 7):'frequency',
		(617, 7):'flag',
		(618, 7):'dmod_src',
		(619, 7):'midi_channel',
		(620, 7):'bpm',
		(622, 3):'midi_sync_base_note',
		(622, 7):'midi_sync_off_on',
		(623, 7):'midi_sync_time',
		(624, 7):'frequency',
		(625, 7):'flag',
		(626, 7):'dmod_src',
		(627, 7):'midi_channel',
		(628, 7):'bpm',
		(630, 3):'midi_sync_base_note',
		(630, 7):'midi_sync_off_on',
		(631, 7):'midi_sync_time',
		(636, 7):'pattern_number',
		(638, 7):'pattern_bank',
		(639, 0):'button_mode',
		(639, 2):'latch_mode',
		(639, 3):'trigger_sync',
		(639, 4):'drum_track_on',
		(640, 7):'trigger_bottom_key',
		(641, 7):'trigger_top_key',
		(642, 7):'velocity_bottom',
		(643, 7):'velocity_top',
		(644, 7):'shift',
		(645, 7):'output_channel',
		(646, 7):'input_channel',
		(792, 7):'tempo',
		(794, 0):'switch',
		(794, 1):'run_a',
		(794, 2):'run_b',
		(796, 7):'gate_control',
		(797, 7):'velocity_control',
		(798, 7):'swing_control',
		(799, 7):'step_control',
		(800, 7):'pattern_number',
		(802, 1):'octave',
		(802, 4):'resolution',
		(803, 0):'sort',
		(803, 1):'latch',
		(803, 2):'key_sync',
		(803, 3):'keyboard',
		(804, 7):'gate',
		(805, 7):'velocity',
		(806, 7):'swing',
		(807, 7):'top_key',
		(808, 7):'bottom_key',
		(809, 7):'top_velocity',
		(810, 7):'bottom_velocity',
		(812, 7):'pattern_number',
		(814, 1):'octave',
		(814, 4):'resolution',
		(815, 0):'sort',
		(815, 1):'latch',
		(815, 2):'key_sync',
		(815, 3):'keyboard',
		(816, 7):'gate',
		(817, 7):'velocity',
		(818, 7):'swing',
		(819, 7):'top_key',
		(820, 7):'bottom_key',
		(821, 7):'top_velocity',
		(822, 7):'bottom_velocity',
		(824, 4):'category',
		(824, 7):'sub_category',
		(825, 7):'favorite',
		(826, 0):'auto_load_tone_adjust',
		(827, 7):'scale_type',
		(828, 7):'scale_key',
		(829, 7):'scale_random',
		(830, 5):'sw1_assignable_sw',
		(830, 6):'sw1_mode',
		(830, 7):'sw1_off_on',
		(831, 5):'sw2_assignable_sw',
		(831, 6):'sw2_mode',
		(831, 7):'sw2_off_on',
		(832, 7):'rt_knob_1',
		(833, 7):'rt_knob_2',
		(834, 7):'rt_knob_3',
		(835, 7):'rt_knob_4',
		(836, 7):'program_bank_number',
		(838, 4):'midi_channel',
		(838, 7):'midi_status',
		(839, 7):'ext_bank_msb',
		(840, 7):'ext_bank_lsb',
		(841, 7):'volume',
		(842, 7):'bend_range',
		(843, 7):'transpose',
		(844, 7):'detune',
		(846, 7):'delay_time',
		(848, 3):'delay_tempo_base',
		(848, 7):'delay_mode',
		(849, 7):'delay_tempo_times',
		(850, 7):'pan',
		(851, 7):'send1',
		(852, 7):'send2',
		(853, 7):'dkit_patch_ifx_1',
		(854, 7):'dkit_patch_ifx_2',
		(855, 7):'dkit_patch_ifx_3',
		(856, 7):'dkit_patch_ifx_4',
		(857, 7):'dkit_patch_ifx_5',
		(858, 4):'bus_select',
		(858, 6):'fx_bus_select',
		(861, 0):'enable_program_change',
		(861, 1):'enable_after_touch',
		(861, 2):'enable_damper',
		(861, 3):'enable_portamento',
		(861, 4):'enable_joystick_x',
		(861, 5):'enable_joystick_plus',
		(861, 6):'enable_joystick_minus',
		(861, 7):'enable_ribbon',
		(862, 0):'enable_rt_knob_cutoff',
		(862, 1):'enable_rt_knob_resonance',
		(862, 2):'enable_rt_knob_eg_int',
		(862, 3):'enable_rt_knob_release',
		(862, 4):'enable_rt_knob_user1',
		(862, 5):'enable_rt_knob_user2',
		(862, 6):'enable_rt_knob_user3',
		(862, 7):'enable_rt_knob_user4',
		(863, 0):'enable_sw1',
		(863, 1):'enable_sw2',
		(863, 2):'enable_foot_switch',
		(863, 3):'enable_foot_pedal',
		(863, 4):'enable_other_control_change',
		(863, 5):'enable_use_prg_scales',
		(863, 6):'enable_auto_load_prg_eq',
		(863, 7):'enable_timbre_mute',
		(864, 1):'force_osc_mode',
		(864, 3):'osc_select',
		(864, 6):'arpeggiator_assign',
		(864, 7):'enable_waveform_sysex',
		(865, 7):'portamento_time',
		(866, 7):'top_key',
		(867, 7):'bottom_key',
		(868, 3):'top_slope',
		(868, 7):'bottom_slope',
		(869, 7):'top_velocity',
		(870, 7):'bottom_velocity',
		(871, 3):'top_velocity_slope',
		(871, 7):'bottom_velocity_slope',
		(872, 6):'trim_value',
		(872, 7):'trim_bypass',
		(874, 7):'mid_freq',
		(875, 7):'low_gain',
		(876, 7):'mid_gain',
		(877, 7):'high_gain',
		(884, 7):'tone_adj_slider1_assign',
		(886, 7):'tone_adj_slider1_value',
		(888, 7):'tone_adj_slider2_assign',
		(890, 7):'tone_adj_slider2_value',
		(892, 7):'tone_adj_slider3_assign',
		(894, 7):'tone_adj_slider3_value',
		(896, 7):'tone_adj_slider4_assign',
		(898, 7):'tone_adj_slider4_value',
		(900, 7):'tone_adj_slider5_assign',
		(902, 7):'tone_adj_slider5_value',
		(904, 7):'tone_adj_slider6_assign',
		(906, 7):'tone_adj_slider6_value',
		(908, 7):'tone_adj_slider7_assign',
		(910, 7):'tone_adj_slider7_value',
		(912, 7):'tone_adj_slider8_assign',
		(914, 7):'tone_adj_slider8_value',
		(916, 7):'tone_adj_switch1_assign',
		(917, 7):'tone_adj_switch1_off_on',
		(918, 7):'tone_adj_switch1_value',
		(920, 7):'tone_adj_switch2_assign',
		(921, 7):'tone_adj_switch2_off_on',
		(922, 7):'tone_adj_switch2_value',
		(924, 7):'tone_adj_switch3_assign',
		(925, 7):'tone_adj_switch3_off_on',
		(926, 7):'tone_adj_switch3_value',
		(928, 7):'tone_adj_switch4_assign',
		(929, 7):'tone_adj_switch4_off_on',
		(930, 7):'tone_adj_switch4_value',
		(932, 7):'tone_adj_switch5_assign',
		(933, 7):'tone_adj_switch5_off_on',
		(934, 7):'tone_adj_switch5_value',
		(936, 7):'tone_adj_switch6_assign',
		(937, 7):'tone_adj_switch6_off_on',
		(938, 7):'tone_adj_switch6_value',
		(940, 7):'tone_adj_switch7_assign',
		(941, 7):'tone_adj_switch7_off_on',
		(942, 7):'tone_adj_switch7_value',
		(944, 7):'tone_adj_switch8_assign',
		(945, 7):'tone_adj_switch8_off_on',
		(946, 7):'tone_adj_switch8_value',
		(948, 7):'program_bank_number',
		(950, 4):'midi_channel',
		(950, 7):'midi_status',
		(951, 7):'ext_bank_msb',
		(952, 7):'ext_bank_lsb',
		(953, 7):'volume',
		(954, 7):'bend_range',
		(955, 7):'transpose',
		(956, 7):'detune',
		(958, 7):'delay_time',
		(960, 3):'delay_tempo_base',
		(960, 7):'delay_mode',
		(961, 7):'delay_tempo_times',
		(962, 7):'pan',
		(963, 7):'send1',
		(964, 7):'send2',
		(965, 7):'dkit_patch_ifx_1',
		(966, 7):'dkit_patch_ifx_2',
		(967, 7):'dkit_patch_ifx_3',
		(968, 7):'dkit_patch_ifx_4',
		(969, 7):'dkit_patch_ifx_5',
		(970, 4):'bus_select',
		(970, 6):'fx_bus_select',
		(973, 0):'enable_program_change',
		(973, 1):'enable_after_touch',
		(973, 2):'enable_damper',
		(973, 3):'enable_portamento',
		(973, 4):'enable_joystick_x',
		(973, 5):'enable_joystick_plus',
		(973, 6):'enable_joystick_minus',
		(973, 7):'enable_ribbon',
		(974, 0):'enable_rt_knob_cutoff',
		(974, 1):'enable_rt_knob_resonance',
		(974, 2):'enable_rt_knob_eg_int',
		(974, 3):'enable_rt_knob_release',
		(974, 4):'enable_rt_knob_user1',
		(974, 5):'enable_rt_knob_user2',
		(974, 6):'enable_rt_knob_user3',
		(974, 7):'enable_rt_knob_user4',
		(975, 0):'enable_sw1',
		(975, 1):'enable_sw2',
		(975, 2):'enable_foot_switch',
		(975, 3):'enable_foot_pedal',
		(975, 4):'enable_other_control_change',
		(975, 5):'enable_use_prg_scales',
		(975, 6):'enable_auto_load_prg_eq',
		(975, 7):'enable_timbre_mute',
		(976, 1):'force_osc_mode',
		(976, 3):'osc_select',
		(976, 6):'arpeggiator_assign',
		(976, 7):'enable_waveform_sysex',
		(977, 7):'portamento_time',
		(978, 7):'top_key',
		(979, 7):'bottom_key',
		(980, 3):'top_slope',
		(980, 7):'bottom_slope',
		(981, 7):'top_velocity',
		(982, 7):'bottom_velocity',
		(983, 3):'top_velocity_slope',
		(983, 7):'bottom_velocity_slope',
		(984, 6):'trim_value',
		(984, 7):'trim_bypass',
		(986, 7):'mid_freq',
		(987, 7):'low_gain',
		(988, 7):'mid_gain',
		(989, 7):'high_gain',
		(996, 7):'tone_adj_slider1_assign',
		(998, 7):'tone_adj_slider1_value',
		(1000, 7):'tone_adj_slider2_assign',
		(1002, 7):'tone_adj_slider2_value',
		(1004, 7):'tone_adj_slider3_assign',
		(1006, 7):'tone_adj_slider3_value',
		(1008, 7):'tone_adj_slider4_assign',
		(1010, 7):'tone_adj_slider4_value',
		(1012, 7):'tone_adj_slider5_assign',
		(1014, 7):'tone_adj_slider5_value',
		(1016, 7):'tone_adj_slider6_assign',
		(1018, 7):'tone_adj_slider6_value',
		(1020, 7):'tone_adj_slider7_assign',
		(1022, 7):'tone_adj_slider7_value',
		(1024, 7):'tone_adj_slider8_assign',
		(1026, 7):'tone_adj_slider8_value',
		(1028, 7):'tone_adj_switch1_assign',
		(1029, 7):'tone_adj_switch1_off_on',
		(1030, 7):'tone_adj_switch1_value',
		(1032, 7):'tone_adj_switch2_assign',
		(1033, 7):'tone_adj_switch2_off_on',
		(1034, 7):'tone_adj_switch2_value',
		(1036, 7):'tone_adj_switch3_assign',
		(1037, 7):'tone_adj_switch3_off_on',
		(1038, 7):'tone_adj_switch3_value',
		(1040, 7):'tone_adj_switch4_assign',
		(1041, 7):'tone_adj_switch4_off_on',
		(1042, 7):'tone_adj_switch4_value',
		(1044, 7):'tone_adj_switch5_assign',
		(1045, 7):'tone_adj_switch5_off_on',
		(1046, 7):'tone_adj_switch5_value',
		(1048, 7):'tone_adj_switch6_assign',
		(1049, 7):'tone_adj_switch6_off_on',
		(1050, 7):'tone_adj_switch6_value',
		(1052, 7):'tone_adj_switch7_assign',
		(1053, 7):'tone_adj_switch7_off_on',
		(1054, 7):'tone_adj_switch7_value',
		(1056, 7):'tone_adj_switch8_assign',
		(1057, 7):'tone_adj_switch8_off_on',
		(1058, 7):'tone_adj_switch8_value',
		(1060, 7):'program_bank_number',
		(1062, 4):'midi_channel',
		(1062, 7):'midi_status',
		(1063, 7):'ext_bank_msb',
		(1064, 7):'ext_bank_lsb',
		(1065, 7):'volume',
		(1066, 7):'bend_range',
		(1067, 7):'transpose',
		(1068, 7):'detune',
		(1070, 7):'delay_time',
		(1072, 3):'delay_tempo_base',
		(1072, 7):'delay_mode',
		(1073, 7):'delay_tempo_times',
		(1074, 7):'pan',
		(1075, 7):'send1',
		(1076, 7):'send2',
		(1077, 7):'dkit_patch_ifx_1',
		(1078, 7):'dkit_patch_ifx_2',
		(1079, 7):'dkit_patch_ifx_3',
		(1080, 7):'dkit_patch_ifx_4',
		(1081, 7):'dkit_patch_ifx_5',
		(1082, 4):'bus_select',
		(1082, 6):'fx_bus_select',
		(1085, 0):'enable_program_change',
		(1085, 1):'enable_after_touch',
		(1085, 2):'enable_damper',
		(1085, 3):'enable_portamento',
		(1085, 4):'enable_joystick_x',
		(1085, 5):'enable_joystick_plus',
		(1085, 6):'enable_joystick_minus',
		(1085, 7):'enable_ribbon',
		(1086, 0):'enable_rt_knob_cutoff',
		(1086, 1):'enable_rt_knob_resonance',
		(1086, 2):'enable_rt_knob_eg_int',
		(1086, 3):'enable_rt_knob_release',
		(1086, 4):'enable_rt_knob_user1',
		(1086, 5):'enable_rt_knob_user2',
		(1086, 6):'enable_rt_knob_user3',
		(1086, 7):'enable_rt_knob_user4',
		(1087, 0):'enable_sw1',
		(1087, 1):'enable_sw2',
		(1087, 2):'enable_foot_switch',
		(1087, 3):'enable_foot_pedal',
		(1087, 4):'enable_other_control_change',
		(1087, 5):'enable_use_prg_scales',
		(1087, 6):'enable_auto_load_prg_eq',
		(1087, 7):'enable_timbre_mute',
		(1088, 1):'force_osc_mode',
		(1088, 3):'osc_select',
		(1088, 6):'arpeggiator_assign',
		(1088, 7):'enable_waveform_sysex',
		(1089, 7):'portamento_time',
		(1090, 7):'top_key',
		(1091, 7):'bottom_key',
		(1092, 3):'top_slope',
		(1092, 7):'bottom_slope',
		(1093, 7):'top_velocity',
		(1094, 7):'bottom_velocity',
		(1095, 3):'top_velocity_slope',
		(1095, 7):'bottom_velocity_slope',
		(1096, 6):'trim_value',
		(1096, 7):'trim_bypass',
		(1098, 7):'mid_freq',
		(1099, 7):'low_gain',
		(1100, 7):'mid_gain',
		(1101, 7):'high_gain',
		(1108, 7):'tone_adj_slider1_assign',
		(1110, 7):'tone_adj_slider1_value',
		(1112, 7):'tone_adj_slider2_assign',
		(1114, 7):'tone_adj_slider2_value',
		(1116, 7):'tone_adj_slider3_assign',
		(1118, 7):'tone_adj_slider3_value',
		(1120, 7):'tone_adj_slider4_assign',
		(1122, 7):'tone_adj_slider4_value',
		(1124, 7):'tone_adj_slider5_assign',
		(1126, 7):'tone_adj_slider5_value',
		(1128, 7):'tone_adj_slider6_assign',
		(1130, 7):'tone_adj_slider6_value',
		(1132, 7):'tone_adj_slider7_assign',
		(1134, 7):'tone_adj_slider7_value',
		(1136, 7):'tone_adj_slider8_assign',
		(1138, 7):'tone_adj_slider8_value',
		(1140, 7):'tone_adj_switch1_assign',
		(1141, 7):'tone_adj_switch1_off_on',
		(1142, 7):'tone_adj_switch1_value',
		(1144, 7):'tone_adj_switch2_assign',
		(1145, 7):'tone_adj_switch2_off_on',
		(1146, 7):'tone_adj_switch2_value',
		(1148, 7):'tone_adj_switch3_assign',
		(1149, 7):'tone_adj_switch3_off_on',
		(1150, 7):'tone_adj_switch3_value',
		(1152, 7):'tone_adj_switch4_assign',
		(1153, 7):'tone_adj_switch4_off_on',
		(1154, 7):'tone_adj_switch4_value',
		(1156, 7):'tone_adj_switch5_assign',
		(1157, 7):'tone_adj_switch5_off_on',
		(1158, 7):'tone_adj_switch5_value',
		(1160, 7):'tone_adj_switch6_assign',
		(1161, 7):'tone_adj_switch6_off_on',
		(1162, 7):'tone_adj_switch6_value',
		(1164, 7):'tone_adj_switch7_assign',
		(1165, 7):'tone_adj_switch7_off_on',
		(1166, 7):'tone_adj_switch7_value',
		(1168, 7):'tone_adj_switch8_assign',
		(1169, 7):'tone_adj_switch8_off_on',
		(1170, 7):'tone_adj_switch8_value',
		(1172, 7):'program_bank_number',
		(1174, 4):'midi_channel',
		(1174, 7):'midi_status',
		(1175, 7):'ext_bank_msb',
		(1176, 7):'ext_bank_lsb',
		(1177, 7):'volume',
		(1178, 7):'bend_range',
		(1179, 7):'transpose',
		(1180, 7):'detune',
		(1182, 7):'delay_time',
		(1184, 3):'delay_tempo_base',
		(1184, 7):'delay_mode',
		(1185, 7):'delay_tempo_times',
		(1186, 7):'pan',
		(1187, 7):'send1',
		(1188, 7):'send2',
		(1189, 7):'dkit_patch_ifx_1',
		(1190, 7):'dkit_patch_ifx_2',
		(1191, 7):'dkit_patch_ifx_3',
		(1192, 7):'dkit_patch_ifx_4',
		(1193, 7):'dkit_patch_ifx_5',
		(1194, 4):'bus_select',
		(1194, 6):'fx_bus_select',
		(1197, 0):'enable_program_change',
		(1197, 1):'enable_after_touch',
		(1197, 2):'enable_damper',
		(1197, 3):'enable_portamento',
		(1197, 4):'enable_joystick_x',
		(1197, 5):'enable_joystick_plus',
		(1197, 6):'enable_joystick_minus',
		(1197, 7):'enable_ribbon',
		(1198, 0):'enable_rt_knob_cutoff',
		(1198, 1):'enable_rt_knob_resonance',
		(1198, 2):'enable_rt_knob_eg_int',
		(1198, 3):'enable_rt_knob_release',
		(1198, 4):'enable_rt_knob_user1',
		(1198, 5):'enable_rt_knob_user2',
		(1198, 6):'enable_rt_knob_user3',
		(1198, 7):'enable_rt_knob_user4',
		(1199, 0):'enable_sw1',
		(1199, 1):'enable_sw2',
		(1199, 2):'enable_foot_switch',
		(1199, 3):'enable_foot_pedal',
		(1199, 4):'enable_other_control_change',
		(1199, 5):'enable_use_prg_scales',
		(1199, 6):'enable_auto_load_prg_eq',
		(1199, 7):'enable_timbre_mute',
		(1200, 1):'force_osc_mode',
		(1200, 3):'osc_select',
		(1200, 6):'arpeggiator_assign',
		(1200, 7):'enable_waveform_sysex',
		(1201, 7):'portamento_time',
		(1202, 7):'top_key',
		(1203, 7):'bottom_key',
		(1204, 3):'top_slope',
		(1204, 7):'bottom_slope',
		(1205, 7):'top_velocity',
		(1206, 7):'bottom_velocity',
		(1207, 3):'top_velocity_slope',
		(1207, 7):'bottom_velocity_slope',
		(1208, 6):'trim_value',
		(1208, 7):'trim_bypass',
		(1210, 7):'mid_freq',
		(1211, 7):'low_gain',
		(1212, 7):'mid_gain',
		(1213, 7):'high_gain',
		(1220, 7):'tone_adj_slider1_assign',
		(1222, 7):'tone_adj_slider1_value',
		(1224, 7):'tone_adj_slider2_assign',
		(1226, 7):'tone_adj_slider2_value',
		(1228, 7):'tone_adj_slider3_assign',
		(1230, 7):'tone_adj_slider3_value',
		(1232, 7):'tone_adj_slider4_assign',
		(1234, 7):'tone_adj_slider4_value',
		(1236, 7):'tone_adj_slider5_assign',
		(1238, 7):'tone_adj_slider5_value',
		(1240, 7):'tone_adj_slider6_assign',
		(1242, 7):'tone_adj_slider6_value',
		(1244, 7):'tone_adj_slider7_assign',
		(1246, 7):'tone_adj_slider7_value',
		(1248, 7):'tone_adj_slider8_assign',
		(1250, 7):'tone_adj_slider8_value',
		(1252, 7):'tone_adj_switch1_assign',
		(1253, 7):'tone_adj_switch1_off_on',
		(1254, 7):'tone_adj_switch1_value',
		(1256, 7):'tone_adj_switch2_assign',
		(1257, 7):'tone_adj_switch2_off_on',
		(1258, 7):'tone_adj_switch2_value',
		(1260, 7):'tone_adj_switch3_assign',
		(1261, 7):'tone_adj_switch3_off_on',
		(1262, 7):'tone_adj_switch3_value',
		(1264, 7):'tone_adj_switch4_assign',
		(1265, 7):'tone_adj_switch4_off_on',
		(1266, 7):'tone_adj_switch4_value',
		(1268, 7):'tone_adj_switch5_assign',
		(1269, 7):'tone_adj_switch5_off_on',
		(1270, 7):'tone_adj_switch5_value',
		(1272, 7):'tone_adj_switch6_assign',
		(1273, 7):'tone_adj_switch6_off_on',
		(1274, 7):'tone_adj_switch6_value',
		(1276, 7):'tone_adj_switch7_assign',
		(1277, 7):'tone_adj_switch7_off_on',
		(1278, 7):'tone_adj_switch7_value',
		(1280, 7):'tone_adj_switch8_assign',
		(1281, 7):'tone_adj_switch8_off_on',
		(1282, 7):'tone_adj_switch8_value',
		(1284, 7):'program_bank_number',
		(1286, 4):'midi_channel',
		(1286, 7):'midi_status',
		(1287, 7):'ext_bank_msb',
		(1288, 7):'ext_bank_lsb',
		(1289, 7):'volume',
		(1290, 7):'bend_range',
		(1291, 7):'transpose',
		(1292, 7):'detune',
		(1294, 7):'delay_time',
		(1296, 3):'delay_tempo_base',
		(1296, 7):'delay_mode',
		(1297, 7):'delay_tempo_times',
		(1298, 7):'pan',
		(1299, 7):'send1',
		(1300, 7):'send2',
		(1301, 7):'dkit_patch_ifx_1',
		(1302, 7):'dkit_patch_ifx_2',
		(1303, 7):'dkit_patch_ifx_3',
		(1304, 7):'dkit_patch_ifx_4',
		(1305, 7):'dkit_patch_ifx_5',
		(1306, 4):'bus_select',
		(1306, 6):'fx_bus_select',
		(1309, 0):'enable_program_change',
		(1309, 1):'enable_after_touch',
		(1309, 2):'enable_damper',
		(1309, 3):'enable_portamento',
		(1309, 4):'enable_joystick_x',
		(1309, 5):'enable_joystick_plus',
		(1309, 6):'enable_joystick_minus',
		(1309, 7):'enable_ribbon',
		(1310, 0):'enable_rt_knob_cutoff',
		(1310, 1):'enable_rt_knob_resonance',
		(1310, 2):'enable_rt_knob_eg_int',
		(1310, 3):'enable_rt_knob_release',
		(1310, 4):'enable_rt_knob_user1',
		(1310, 5):'enable_rt_knob_user2',
		(1310, 6):'enable_rt_knob_user3',
		(1310, 7):'enable_rt_knob_user4',
		(1311, 0):'enable_sw1',
		(1311, 1):'enable_sw2',
		(1311, 2):'enable_foot_switch',
		(1311, 3):'enable_foot_pedal',
		(1311, 4):'enable_other_control_change',
		(1311, 5):'enable_use_prg_scales',
		(1311, 6):'enable_auto_load_prg_eq',
		(1311, 7):'enable_timbre_mute',
		(1312, 1):'force_osc_mode',
		(1312, 3):'osc_select',
		(1312, 6):'arpeggiator_assign',
		(1312, 7):'enable_waveform_sysex',
		(1313, 7):'portamento_time',
		(1314, 7):'top_key',
		(1315, 7):'bottom_key',
		(1316, 3):'top_slope',
		(1316, 7):'bottom_slope',
		(1317, 7):'top_velocity',
		(1318, 7):'bottom_velocity',
		(1319, 3):'top_velocity_slope',
		(1319, 7):'bottom_velocity_slope',
		(1320, 6):'trim_value',
		(1320, 7):'trim_bypass',
		(1322, 7):'mid_freq',
		(1323, 7):'low_gain',
		(1324, 7):'mid_gain',
		(1325, 7):'high_gain',
		(1332, 7):'tone_adj_slider1_assign',
		(1334, 7):'tone_adj_slider1_value',
		(1336, 7):'tone_adj_slider2_assign',
		(1338, 7):'tone_adj_slider2_value',
		(1340, 7):'tone_adj_slider3_assign',
		(1342, 7):'tone_adj_slider3_value',
		(1344, 7):'tone_adj_slider4_assign',
		(1346, 7):'tone_adj_slider4_value',
		(1348, 7):'tone_adj_slider5_assign',
		(1350, 7):'tone_adj_slider5_value',
		(1352, 7):'tone_adj_slider6_assign',
		(1354, 7):'tone_adj_slider6_value',
		(1356, 7):'tone_adj_slider7_assign',
		(1358, 7):'tone_adj_slider7_value',
		(1360, 7):'tone_adj_slider8_assign',
		(1362, 7):'tone_adj_slider8_value',
		(1364, 7):'tone_adj_switch1_assign',
		(1365, 7):'tone_adj_switch1_off_on',
		(1366, 7):'tone_adj_switch1_value',
		(1368, 7):'tone_adj_switch2_assign',
		(1369, 7):'tone_adj_switch2_off_on',
		(1370, 7):'tone_adj_switch2_value',
		(1372, 7):'tone_adj_switch3_assign',
		(1373, 7):'tone_adj_switch3_off_on',
		(1374, 7):'tone_adj_switch3_value',
		(1376, 7):'tone_adj_switch4_assign',
		(1377, 7):'tone_adj_switch4_off_on',
		(1378, 7):'tone_adj_switch4_value',
		(1380, 7):'tone_adj_switch5_assign',
		(1381, 7):'tone_adj_switch5_off_on',
		(1382, 7):'tone_adj_switch5_value',
		(1384, 7):'tone_adj_switch6_assign',
		(1385, 7):'tone_adj_switch6_off_on',
		(1386, 7):'tone_adj_switch6_value',
		(1388, 7):'tone_adj_switch7_assign',
		(1389, 7):'tone_adj_switch7_off_on',
		(1390, 7):'tone_adj_switch7_value',
		(1392, 7):'tone_adj_switch8_assign',
		(1393, 7):'tone_adj_switch8_off_on',
		(1394, 7):'tone_adj_switch8_value',
		(1396, 7):'program_bank_number',
		(1398, 4):'midi_channel',
		(1398, 7):'midi_status',
		(1399, 7):'ext_bank_msb',
		(1400, 7):'ext_bank_lsb',
		(1401, 7):'volume',
		(1402, 7):'bend_range',
		(1403, 7):'transpose',
		(1404, 7):'detune',
		(1406, 7):'delay_time',
		(1408, 3):'delay_tempo_base',
		(1408, 7):'delay_mode',
		(1409, 7):'delay_tempo_times',
		(1410, 7):'pan',
		(1411, 7):'send1',
		(1412, 7):'send2',
		(1413, 7):'dkit_patch_ifx_1',
		(1414, 7):'dkit_patch_ifx_2',
		(1415, 7):'dkit_patch_ifx_3',
		(1416, 7):'dkit_patch_ifx_4',
		(1417, 7):'dkit_patch_ifx_5',
		(1418, 4):'bus_select',
		(1418, 6):'fx_bus_select',
		(1421, 0):'enable_program_change',
		(1421, 1):'enable_after_touch',
		(1421, 2):'enable_damper',
		(1421, 3):'enable_portamento',
		(1421, 4):'enable_joystick_x',
		(1421, 5):'enable_joystick_plus',
		(1421, 6):'enable_joystick_minus',
		(1421, 7):'enable_ribbon',
		(1422, 0):'enable_rt_knob_cutoff',
		(1422, 1):'enable_rt_knob_resonance',
		(1422, 2):'enable_rt_knob_eg_int',
		(1422, 3):'enable_rt_knob_release',
		(1422, 4):'enable_rt_knob_user1',
		(1422, 5):'enable_rt_knob_user2',
		(1422, 6):'enable_rt_knob_user3',
		(1422, 7):'enable_rt_knob_user4',
		(1423, 0):'enable_sw1',
		(1423, 1):'enable_sw2',
		(1423, 2):'enable_foot_switch',
		(1423, 3):'enable_foot_pedal',
		(1423, 4):'enable_other_control_change',
		(1423, 5):'enable_use_prg_scales',
		(1423, 6):'enable_auto_load_prg_eq',
		(1423, 7):'enable_timbre_mute',
		(1424, 1):'force_osc_mode',
		(1424, 3):'osc_select',
		(1424, 6):'arpeggiator_assign',
		(1424, 7):'enable_waveform_sysex',
		(1425, 7):'portamento_time',
		(1426, 7):'top_key',
		(1427, 7):'bottom_key',
		(1428, 3):'top_slope',
		(1428, 7):'bottom_slope',
		(1429, 7):'top_velocity',
		(1430, 7):'bottom_velocity',
		(1431, 3):'top_velocity_slope',
		(1431, 7):'bottom_velocity_slope',
		(1432, 6):'trim_value',
		(1432, 7):'trim_bypass',
		(1434, 7):'mid_freq',
		(1435, 7):'low_gain',
		(1436, 7):'mid_gain',
		(1437, 7):'high_gain',
		(1444, 7):'tone_adj_slider1_assign',
		(1446, 7):'tone_adj_slider1_value',
		(1448, 7):'tone_adj_slider2_assign',
		(1450, 7):'tone_adj_slider2_value',
		(1452, 7):'tone_adj_slider3_assign',
		(1454, 7):'tone_adj_slider3_value',
		(1456, 7):'tone_adj_slider4_assign',
		(1458, 7):'tone_adj_slider4_value',
		(1460, 7):'tone_adj_slider5_assign',
		(1462, 7):'tone_adj_slider5_value',
		(1464, 7):'tone_adj_slider6_assign',
		(1466, 7):'tone_adj_slider6_value',
		(1468, 7):'tone_adj_slider7_assign',
		(1470, 7):'tone_adj_slider7_value',
		(1472, 7):'tone_adj_slider8_assign',
		(1474, 7):'tone_adj_slider8_value',
		(1476, 7):'tone_adj_switch1_assign',
		(1477, 7):'tone_adj_switch1_off_on',
		(1478, 7):'tone_adj_switch1_value',
		(1480, 7):'tone_adj_switch2_assign',
		(1481, 7):'tone_adj_switch2_off_on',
		(1482, 7):'tone_adj_switch2_value',
		(1484, 7):'tone_adj_switch3_assign',
		(1485, 7):'tone_adj_switch3_off_on',
		(1486, 7):'tone_adj_switch3_value',
		(1488, 7):'tone_adj_switch4_assign',
		(1489, 7):'tone_adj_switch4_off_on',
		(1490, 7):'tone_adj_switch4_value',
		(1492, 7):'tone_adj_switch5_assign',
		(1493, 7):'tone_adj_switch5_off_on',
		(1494, 7):'tone_adj_switch5_value',
		(1496, 7):'tone_adj_switch6_assign',
		(1497, 7):'tone_adj_switch6_off_on',
		(1498, 7):'tone_adj_switch6_value',
		(1500, 7):'tone_adj_switch7_assign',
		(1501, 7):'tone_adj_switch7_off_on',
		(1502, 7):'tone_adj_switch7_value',
		(1504, 7):'tone_adj_switch8_assign',
		(1505, 7):'tone_adj_switch8_off_on',
		(1506, 7):'tone_adj_switch8_value',
		(1508, 7):'program_bank_number',
		(1510, 4):'midi_channel',
		(1510, 7):'midi_status',
		(1511, 7):'ext_bank_msb',
		(1512, 7):'ext_bank_lsb',
		(1513, 7):'volume',
		(1514, 7):'bend_range',
		(1515, 7):'transpose',
		(1516, 7):'detune',
		(1518, 7):'delay_time',
		(1520, 3):'delay_tempo_base',
		(1520, 7):'delay_mode',
		(1521, 7):'delay_tempo_times',
		(1522, 7):'pan',
		(1523, 7):'send1',
		(1524, 7):'send2',
		(1525, 7):'dkit_patch_ifx_1',
		(1526, 7):'dkit_patch_ifx_2',
		(1527, 7):'dkit_patch_ifx_3',
		(1528, 7):'dkit_patch_ifx_4',
		(1529, 7):'dkit_patch_ifx_5',
		(1530, 4):'bus_select',
		(1530, 6):'fx_bus_select',
		(1533, 0):'enable_program_change',
		(1533, 1):'enable_after_touch',
		(1533, 2):'enable_damper',
		(1533, 3):'enable_portamento',
		(1533, 4):'enable_joystick_x',
		(1533, 5):'enable_joystick_plus',
		(1533, 6):'enable_joystick_minus',
		(1533, 7):'enable_ribbon',
		(1534, 0):'enable_rt_knob_cutoff',
		(1534, 1):'enable_rt_knob_resonance',
		(1534, 2):'enable_rt_knob_eg_int',
		(1534, 3):'enable_rt_knob_release',
		(1534, 4):'enable_rt_knob_user1',
		(1534, 5):'enable_rt_knob_user2',
		(1534, 6):'enable_rt_knob_user3',
		(1534, 7):'enable_rt_knob_user4',
		(1535, 0):'enable_sw1',
		(1535, 1):'enable_sw2',
		(1535, 2):'enable_foot_switch',
		(1535, 3):'enable_foot_pedal',
		(1535, 4):'enable_other_control_change',
		(1535, 5):'enable_use_prg_scales',
		(1535, 6):'enable_auto_load_prg_eq',
		(1535, 7):'enable_timbre_mute',
		(1536, 1):'force_osc_mode',
		(1536, 3):'osc_select',
		(1536, 6):'arpeggiator_assign',
		(1536, 7):'enable_waveform_sysex',
		(1537, 7):'portamento_time',
		(1538, 7):'top_key',
		(1539, 7):'bottom_key',
		(1540, 3):'top_slope',
		(1540, 7):'bottom_slope',
		(1541, 7):'top_velocity',
		(1542, 7):'bottom_velocity',
		(1543, 3):'top_velocity_slope',
		(1543, 7):'bottom_velocity_slope',
		(1544, 6):'trim_value',
		(1544, 7):'trim_bypass',
		(1546, 7):'mid_freq',
		(1547, 7):'low_gain',
		(1548, 7):'mid_gain',
		(1549, 7):'high_gain',
		(1556, 7):'tone_adj_slider1_assign',
		(1558, 7):'tone_adj_slider1_value',
		(1560, 7):'tone_adj_slider2_assign',
		(1562, 7):'tone_adj_slider2_value',
		(1564, 7):'tone_adj_slider3_assign',
		(1566, 7):'tone_adj_slider3_value',
		(1568, 7):'tone_adj_slider4_assign',
		(1570, 7):'tone_adj_slider4_value',
		(1572, 7):'tone_adj_slider5_assign',
		(1574, 7):'tone_adj_slider5_value',
		(1576, 7):'tone_adj_slider6_assign',
		(1578, 7):'tone_adj_slider6_value',
		(1580, 7):'tone_adj_slider7_assign',
		(1582, 7):'tone_adj_slider7_value',
		(1584, 7):'tone_adj_slider8_assign',
		(1586, 7):'tone_adj_slider8_value',
		(1588, 7):'tone_adj_switch1_assign',
		(1589, 7):'tone_adj_switch1_off_on',
		(1590, 7):'tone_adj_switch1_value',
		(1592, 7):'tone_adj_switch2_assign',
		(1593, 7):'tone_adj_switch2_off_on',
		(1594, 7):'tone_adj_switch2_value',
		(1596, 7):'tone_adj_switch3_assign',
		(1597, 7):'tone_adj_switch3_off_on',
		(1598, 7):'tone_adj_switch3_value',
		(1600, 7):'tone_adj_switch4_assign',
		(1601, 7):'tone_adj_switch4_off_on',
		(1602, 7):'tone_adj_switch4_value',
		(1604, 7):'tone_adj_switch5_assign',
		(1605, 7):'tone_adj_switch5_off_on',
		(1606, 7):'tone_adj_switch5_value',
		(1608, 7):'tone_adj_switch6_assign',
		(1609, 7):'tone_adj_switch6_off_on',
		(1610, 7):'tone_adj_switch6_value',
		(1612, 7):'tone_adj_switch7_assign',
		(1613, 7):'tone_adj_switch7_off_on',
		(1614, 7):'tone_adj_switch7_value',
		(1616, 7):'tone_adj_switch8_assign',
		(1617, 7):'tone_adj_switch8_off_on',
		(1618, 7):'tone_adj_switch8_value',
		(1620, 7):'program_bank_number',
		(1622, 4):'midi_channel',
		(1622, 7):'midi_status',
		(1623, 7):'ext_bank_msb',
		(1624, 7):'ext_bank_lsb',
		(1625, 7):'volume',
		(1626, 7):'bend_range',
		(1627, 7):'transpose',
		(1628, 7):'detune',
		(1630, 7):'delay_time',
		(1632, 3):'delay_tempo_base',
		(1632, 7):'delay_mode',
		(1633, 7):'delay_tempo_times',
		(1634, 7):'pan',
		(1635, 7):'send1',
		(1636, 7):'send2',
		(1637, 7):'dkit_patch_ifx_1',
		(1638, 7):'dkit_patch_ifx_2',
		(1639, 7):'dkit_patch_ifx_3',
		(1640, 7):'dkit_patch_ifx_4',
		(1641, 7):'dkit_patch_ifx_5',
		(1642, 4):'bus_select',
		(1642, 6):'fx_bus_select',
		(1645, 0):'enable_program_change',
		(1645, 1):'enable_after_touch',
		(1645, 2):'enable_damper',
		(1645, 3):'enable_portamento',
		(1645, 4):'enable_joystick_x',
		(1645, 5):'enable_joystick_plus',
		(1645, 6):'enable_joystick_minus',
		(1645, 7):'enable_ribbon',
		(1646, 0):'enable_rt_knob_cutoff',
		(1646, 1):'enable_rt_knob_resonance',
		(1646, 2):'enable_rt_knob_eg_int',
		(1646, 3):'enable_rt_knob_release',
		(1646, 4):'enable_rt_knob_user1',
		(1646, 5):'enable_rt_knob_user2',
		(1646, 6):'enable_rt_knob_user3',
		(1646, 7):'enable_rt_knob_user4',
		(1647, 0):'enable_sw1',
		(1647, 1):'enable_sw2',
		(1647, 2):'enable_foot_switch',
		(1647, 3):'enable_foot_pedal',
		(1647, 4):'enable_other_control_change',
		(1647, 5):'enable_use_prg_scales',
		(1647, 6):'enable_auto_load_prg_eq',
		(1647, 7):'enable_timbre_mute',
		(1648, 1):'force_osc_mode',
		(1648, 3):'osc_select',
		(1648, 6):'arpeggiator_assign',
		(1648, 7):'enable_waveform_sysex',
		(1649, 7):'portamento_time',
		(1650, 7):'top_key',
		(1651, 7):'bottom_key',
		(1652, 3):'top_slope',
		(1652, 7):'bottom_slope',
		(1653, 7):'top_velocity',
		(1654, 7):'bottom_velocity',
		(1655, 3):'top_velocity_slope',
		(1655, 7):'bottom_velocity_slope',
		(1656, 6):'trim_value',
		(1656, 7):'trim_bypass',
		(1658, 7):'mid_freq',
		(1659, 7):'low_gain',
		(1660, 7):'mid_gain',
		(1661, 7):'high_gain',
		(1668, 7):'tone_adj_slider1_assign',
		(1670, 7):'tone_adj_slider1_value',
		(1672, 7):'tone_adj_slider2_assign',
		(1674, 7):'tone_adj_slider2_value',
		(1676, 7):'tone_adj_slider3_assign',
		(1678, 7):'tone_adj_slider3_value',
		(1680, 7):'tone_adj_slider4_assign',
		(1682, 7):'tone_adj_slider4_value',
		(1684, 7):'tone_adj_slider5_assign',
		(1686, 7):'tone_adj_slider5_value',
		(1688, 7):'tone_adj_slider6_assign',
		(1690, 7):'tone_adj_slider6_value',
		(1692, 7):'tone_adj_slider7_assign',
		(1694, 7):'tone_adj_slider7_value',
		(1696, 7):'tone_adj_slider8_assign',
		(1698, 7):'tone_adj_slider8_value',
		(1700, 7):'tone_adj_switch1_assign',
		(1701, 7):'tone_adj_switch1_off_on',
		(1702, 7):'tone_adj_switch1_value',
		(1704, 7):'tone_adj_switch2_assign',
		(1705, 7):'tone_adj_switch2_off_on',
		(1706, 7):'tone_adj_switch2_value',
		(1708, 7):'tone_adj_switch3_assign',
		(1709, 7):'tone_adj_switch3_off_on',
		(1710, 7):'tone_adj_switch3_value',
		(1712, 7):'tone_adj_switch4_assign',
		(1713, 7):'tone_adj_switch4_off_on',
		(1714, 7):'tone_adj_switch4_value',
		(1716, 7):'tone_adj_switch5_assign',
		(1717, 7):'tone_adj_switch5_off_on',
		(1718, 7):'tone_adj_switch5_value',
		(1720, 7):'tone_adj_switch6_assign',
		(1721, 7):'tone_adj_switch6_off_on',
		(1722, 7):'tone_adj_switch6_value',
		(1724, 7):'tone_adj_switch7_assign',
		(1725, 7):'tone_adj_switch7_off_on',
		(1726, 7):'tone_adj_switch7_value',
		(1728, 7):'tone_adj_switch8_assign',
		(1729, 7):'tone_adj_switch8_off_on',
		(1730, 7):'tone_adj_switch8_value',
		(1732, 7):'program_bank_number',
		(1734, 4):'midi_channel',
		(1734, 7):'midi_status',
		(1735, 7):'ext_bank_msb',
		(1736, 7):'ext_bank_lsb',
		(1737, 7):'volume',
		(1738, 7):'bend_range',
		(1739, 7):'transpose',
		(1740, 7):'detune',
		(1742, 7):'delay_time',
		(1744, 3):'delay_tempo_base',
		(1744, 7):'delay_mode',
		(1745, 7):'delay_tempo_times',
		(1746, 7):'pan',
		(1747, 7):'send1',
		(1748, 7):'send2',
		(1749, 7):'dkit_patch_ifx_1',
		(1750, 7):'dkit_patch_ifx_2',
		(1751, 7):'dkit_patch_ifx_3',
		(1752, 7):'dkit_patch_ifx_4',
		(1753, 7):'dkit_patch_ifx_5',
		(1754, 4):'bus_select',
		(1754, 6):'fx_bus_select',
		(1757, 0):'enable_program_change',
		(1757, 1):'enable_after_touch',
		(1757, 2):'enable_damper',
		(1757, 3):'enable_portamento',
		(1757, 4):'enable_joystick_x',
		(1757, 5):'enable_joystick_plus',
		(1757, 6):'enable_joystick_minus',
		(1757, 7):'enable_ribbon',
		(1758, 0):'enable_rt_knob_cutoff',
		(1758, 1):'enable_rt_knob_resonance',
		(1758, 2):'enable_rt_knob_eg_int',
		(1758, 3):'enable_rt_knob_release',
		(1758, 4):'enable_rt_knob_user1',
		(1758, 5):'enable_rt_knob_user2',
		(1758, 6):'enable_rt_knob_user3',
		(1758, 7):'enable_rt_knob_user4',
		(1759, 0):'enable_sw1',
		(1759, 1):'enable_sw2',
		(1759, 2):'enable_foot_switch',
		(1759, 3):'enable_foot_pedal',
		(1759, 4):'enable_other_control_change',
		(1759, 5):'enable_use_prg_scales',
		(1759, 6):'enable_auto_load_prg_eq',
		(1759, 7):'enable_timbre_mute',
		(1760, 1):'force_osc_mode',
		(1760, 3):'osc_select',
		(1760, 6):'arpeggiator_assign',
		(1760, 7):'enable_waveform_sysex',
		(1761, 7):'portamento_time',
		(1762, 7):'top_key',
		(1763, 7):'bottom_key',
		(1764, 3):'top_slope',
		(1764, 7):'bottom_slope',
		(1765, 7):'top_velocity',
		(1766, 7):'bottom_velocity',
		(1767, 3):'top_velocity_slope',
		(1767, 7):'bottom_velocity_slope',
		(1768, 6):'trim_value',
		(1768, 7):'trim_bypass',
		(1770, 7):'mid_freq',
		(1771, 7):'low_gain',
		(1772, 7):'mid_gain',
		(1773, 7):'high_gain',
		(1780, 7):'tone_adj_slider1_assign',
		(1782, 7):'tone_adj_slider1_value',
		(1784, 7):'tone_adj_slider2_assign',
		(1786, 7):'tone_adj_slider2_value',
		(1788, 7):'tone_adj_slider3_assign',
		(1790, 7):'tone_adj_slider3_value',
		(1792, 7):'tone_adj_slider4_assign',
		(1794, 7):'tone_adj_slider4_value',
		(1796, 7):'tone_adj_slider5_assign',
		(1798, 7):'tone_adj_slider5_value',
		(1800, 7):'tone_adj_slider6_assign',
		(1802, 7):'tone_adj_slider6_value',
		(1804, 7):'tone_adj_slider7_assign',
		(1806, 7):'tone_adj_slider7_value',
		(1808, 7):'tone_adj_slider8_assign',
		(1810, 7):'tone_adj_slider8_value',
		(1812, 7):'tone_adj_switch1_assign',
		(1813, 7):'tone_adj_switch1_off_on',
		(1814, 7):'tone_adj_switch1_value',
		(1816, 7):'tone_adj_switch2_assign',
		(1817, 7):'tone_adj_switch2_off_on',
		(1818, 7):'tone_adj_switch2_value',
		(1820, 7):'tone_adj_switch3_assign',
		(1821, 7):'tone_adj_switch3_off_on',
		(1822, 7):'tone_adj_switch3_value',
		(1824, 7):'tone_adj_switch4_assign',
		(1825, 7):'tone_adj_switch4_off_on',
		(1826, 7):'tone_adj_switch4_value',
		(1828, 7):'tone_adj_switch5_assign',
		(1829, 7):'tone_adj_switch5_off_on',
		(1830, 7):'tone_adj_switch5_value',
		(1832, 7):'tone_adj_switch6_assign',
		(1833, 7):'tone_adj_switch6_off_on',
		(1834, 7):'tone_adj_switch6_value',
		(1836, 7):'tone_adj_switch7_assign',
		(1837, 7):'tone_adj_switch7_off_on',
		(1838, 7):'tone_adj_switch7_value',
		(1840, 7):'tone_adj_switch8_assign',
		(1841, 7):'tone_adj_switch8_off_on',
		(1842, 7):'tone_adj_switch8_value',
		(1844, 7):'program_bank_number',
		(1846, 4):'midi_channel',
		(1846, 7):'midi_status',
		(1847, 7):'ext_bank_msb',
		(1848, 7):'ext_bank_lsb',
		(1849, 7):'volume',
		(1850, 7):'bend_range',
		(1851, 7):'transpose',
		(1852, 7):'detune',
		(1854, 7):'delay_time',
		(1856, 3):'delay_tempo_base',
		(1856, 7):'delay_mode',
		(1857, 7):'delay_tempo_times',
		(1858, 7):'pan',
		(1859, 7):'send1',
		(1860, 7):'send2',
		(1861, 7):'dkit_patch_ifx_1',
		(1862, 7):'dkit_patch_ifx_2',
		(1863, 7):'dkit_patch_ifx_3',
		(1864, 7):'dkit_patch_ifx_4',
		(1865, 7):'dkit_patch_ifx_5',
		(1866, 4):'bus_select',
		(1866, 6):'fx_bus_select',
		(1869, 0):'enable_program_change',
		(1869, 1):'enable_after_touch',
		(1869, 2):'enable_damper',
		(1869, 3):'enable_portamento',
		(1869, 4):'enable_joystick_x',
		(1869, 5):'enable_joystick_plus',
		(1869, 6):'enable_joystick_minus',
		(1869, 7):'enable_ribbon',
		(1870, 0):'enable_rt_knob_cutoff',
		(1870, 1):'enable_rt_knob_resonance',
		(1870, 2):'enable_rt_knob_eg_int',
		(1870, 3):'enable_rt_knob_release',
		(1870, 4):'enable_rt_knob_user1',
		(1870, 5):'enable_rt_knob_user2',
		(1870, 6):'enable_rt_knob_user3',
		(1870, 7):'enable_rt_knob_user4',
		(1871, 0):'enable_sw1',
		(1871, 1):'enable_sw2',
		(1871, 2):'enable_foot_switch',
		(1871, 3):'enable_foot_pedal',
		(1871, 4):'enable_other_control_change',
		(1871, 5):'enable_use_prg_scales',
		(1871, 6):'enable_auto_load_prg_eq',
		(1871, 7):'enable_timbre_mute',
		(1872, 1):'force_osc_mode',
		(1872, 3):'osc_select',
		(1872, 6):'arpeggiator_assign',
		(1872, 7):'enable_waveform_sysex',
		(1873, 7):'portamento_time',
		(1874, 7):'top_key',
		(1875, 7):'bottom_key',
		(1876, 3):'top_slope',
		(1876, 7):'bottom_slope',
		(1877, 7):'top_velocity',
		(1878, 7):'bottom_velocity',
		(1879, 3):'top_velocity_slope',
		(1879, 7):'bottom_velocity_slope',
		(1880, 6):'trim_value',
		(1880, 7):'trim_bypass',
		(1882, 7):'mid_freq',
		(1883, 7):'low_gain',
		(1884, 7):'mid_gain',
		(1885, 7):'high_gain',
		(1892, 7):'tone_adj_slider1_assign',
		(1894, 7):'tone_adj_slider1_value',
		(1896, 7):'tone_adj_slider2_assign',
		(1898, 7):'tone_adj_slider2_value',
		(1900, 7):'tone_adj_slider3_assign',
		(1902, 7):'tone_adj_slider3_value',
		(1904, 7):'tone_adj_slider4_assign',
		(1906, 7):'tone_adj_slider4_value',
		(1908, 7):'tone_adj_slider5_assign',
		(1910, 7):'tone_adj_slider5_value',
		(1912, 7):'tone_adj_slider6_assign',
		(1914, 7):'tone_adj_slider6_value',
		(1916, 7):'tone_adj_slider7_assign',
		(1918, 7):'tone_adj_slider7_value',
		(1920, 7):'tone_adj_slider8_assign',
		(1922, 7):'tone_adj_slider8_value',
		(1924, 7):'tone_adj_switch1_assign',
		(1925, 7):'tone_adj_switch1_off_on',
		(1926, 7):'tone_adj_switch1_value',
		(1928, 7):'tone_adj_switch2_assign',
		(1929, 7):'tone_adj_switch2_off_on',
		(1930, 7):'tone_adj_switch2_value',
		(1932, 7):'tone_adj_switch3_assign',
		(1933, 7):'tone_adj_switch3_off_on',
		(1934, 7):'tone_adj_switch3_value',
		(1936, 7):'tone_adj_switch4_assign',
		(1937, 7):'tone_adj_switch4_off_on',
		(1938, 7):'tone_adj_switch4_value',
		(1940, 7):'tone_adj_switch5_assign',
		(1941, 7):'tone_adj_switch5_off_on',
		(1942, 7):'tone_adj_switch5_value',
		(1944, 7):'tone_adj_switch6_assign',
		(1945, 7):'tone_adj_switch6_off_on',
		(1946, 7):'tone_adj_switch6_value',
		(1948, 7):'tone_adj_switch7_assign',
		(1949, 7):'tone_adj_switch7_off_on',
		(1950, 7):'tone_adj_switch7_value',
		(1952, 7):'tone_adj_switch8_assign',
		(1953, 7):'tone_adj_switch8_off_on',
		(1954, 7):'tone_adj_switch8_value',
		(1956, 7):'program_bank_number',
		(1958, 4):'midi_channel',
		(1958, 7):'midi_status',
		(1959, 7):'ext_bank_msb',
		(1960, 7):'ext_bank_lsb',
		(1961, 7):'volume',
		(1962, 7):'bend_range',
		(1963, 7):'transpose',
		(1964, 7):'detune',
		(1966, 7):'delay_time',
		(1968, 3):'delay_tempo_base',
		(1968, 7):'delay_mode',
		(1969, 7):'delay_tempo_times',
		(1970, 7):'pan',
		(1971, 7):'send1',
		(1972, 7):'send2',
		(1973, 7):'dkit_patch_ifx_1',
		(1974, 7):'dkit_patch_ifx_2',
		(1975, 7):'dkit_patch_ifx_3',
		(1976, 7):'dkit_patch_ifx_4',
		(1977, 7):'dkit_patch_ifx_5',
		(1978, 4):'bus_select',
		(1978, 6):'fx_bus_select',
		(1981, 0):'enable_program_change',
		(1981, 1):'enable_after_touch',
		(1981, 2):'enable_damper',
		(1981, 3):'enable_portamento',
		(1981, 4):'enable_joystick_x',
		(1981, 5):'enable_joystick_plus',
		(1981, 6):'enable_joystick_minus',
		(1981, 7):'enable_ribbon',
		(1982, 0):'enable_rt_knob_cutoff',
		(1982, 1):'enable_rt_knob_resonance',
		(1982, 2):'enable_rt_knob_eg_int',
		(1982, 3):'enable_rt_knob_release',
		(1982, 4):'enable_rt_knob_user1',
		(1982, 5):'enable_rt_knob_user2',
		(1982, 6):'enable_rt_knob_user3',
		(1982, 7):'enable_rt_knob_user4',
		(1983, 0):'enable_sw1',
		(1983, 1):'enable_sw2',
		(1983, 2):'enable_foot_switch',
		(1983, 3):'enable_foot_pedal',
		(1983, 4):'enable_other_control_change',
		(1983, 5):'enable_use_prg_scales',
		(1983, 6):'enable_auto_load_prg_eq',
		(1983, 7):'enable_timbre_mute',
		(1984, 1):'force_osc_mode',
		(1984, 3):'osc_select',
		(1984, 6):'arpeggiator_assign',
		(1984, 7):'enable_waveform_sysex',
		(1985, 7):'portamento_time',
		(1986, 7):'top_key',
		(1987, 7):'bottom_key',
		(1988, 3):'top_slope',
		(1988, 7):'bottom_slope',
		(1989, 7):'top_velocity',
		(1990, 7):'bottom_velocity',
		(1991, 3):'top_velocity_slope',
		(1991, 7):'bottom_velocity_slope',
		(1992, 6):'trim_value',
		(1992, 7):'trim_bypass',
		(1994, 7):'mid_freq',
		(1995, 7):'low_gain',
		(1996, 7):'mid_gain',
		(1997, 7):'high_gain',
		(2004, 7):'tone_adj_slider1_assign',
		(2006, 7):'tone_adj_slider1_value',
		(2008, 7):'tone_adj_slider2_assign',
		(2010, 7):'tone_adj_slider2_value',
		(2012, 7):'tone_adj_slider3_assign',
		(2014, 7):'tone_adj_slider3_value',
		(2016, 7):'tone_adj_slider4_assign',
		(2018, 7):'tone_adj_slider4_value',
		(2020, 7):'tone_adj_slider5_assign',
		(2022, 7):'tone_adj_slider5_value',
		(2024, 7):'tone_adj_slider6_assign',
		(2026, 7):'tone_adj_slider6_value',
		(2028, 7):'tone_adj_slider7_assign',
		(2030, 7):'tone_adj_slider7_value',
		(2032, 7):'tone_adj_slider8_assign',
		(2034, 7):'tone_adj_slider8_value',
		(2036, 7):'tone_adj_switch1_assign',
		(2037, 7):'tone_adj_switch1_off_on',
		(2038, 7):'tone_adj_switch1_value',
		(2040, 7):'tone_adj_switch2_assign',
		(2041, 7):'tone_adj_switch2_off_on',
		(2042, 7):'tone_adj_switch2_value',
		(2044, 7):'tone_adj_switch3_assign',
		(2045, 7):'tone_adj_switch3_off_on',
		(2046, 7):'tone_adj_switch3_value',
		(2048, 7):'tone_adj_switch4_assign',
		(2049, 7):'tone_adj_switch4_off_on',
		(2050, 7):'tone_adj_switch4_value',
		(2052, 7):'tone_adj_switch5_assign',
		(2053, 7):'tone_adj_switch5_off_on',
		(2054, 7):'tone_adj_switch5_value',
		(2056, 7):'tone_adj_switch6_assign',
		(2057, 7):'tone_adj_switch6_off_on',
		(2058, 7):'tone_adj_switch6_value',
		(2060, 7):'tone_adj_switch7_assign',
		(2061, 7):'tone_adj_switch7_off_on',
		(2062, 7):'tone_adj_switch7_value',
		(2064, 7):'tone_adj_switch8_assign',
		(2065, 7):'tone_adj_switch8_off_on',
		(2066, 7):'tone_adj_switch8_value',
		(2068, 7):'program_bank_number',
		(2070, 4):'midi_channel',
		(2070, 7):'midi_status',
		(2071, 7):'ext_bank_msb',
		(2072, 7):'ext_bank_lsb',
		(2073, 7):'volume',
		(2074, 7):'bend_range',
		(2075, 7):'transpose',
		(2076, 7):'detune',
		(2078, 7):'delay_time',
		(2080, 3):'delay_tempo_base',
		(2080, 7):'delay_mode',
		(2081, 7):'delay_tempo_times',
		(2082, 7):'pan',
		(2083, 7):'send1',
		(2084, 7):'send2',
		(2085, 7):'dkit_patch_ifx_1',
		(2086, 7):'dkit_patch_ifx_2',
		(2087, 7):'dkit_patch_ifx_3',
		(2088, 7):'dkit_patch_ifx_4',
		(2089, 7):'dkit_patch_ifx_5',
		(2090, 4):'bus_select',
		(2090, 6):'fx_bus_select',
		(2093, 0):'enable_program_change',
		(2093, 1):'enable_after_touch',
		(2093, 2):'enable_damper',
		(2093, 3):'enable_portamento',
		(2093, 4):'enable_joystick_x',
		(2093, 5):'enable_joystick_plus',
		(2093, 6):'enable_joystick_minus',
		(2093, 7):'enable_ribbon',
		(2094, 0):'enable_rt_knob_cutoff',
		(2094, 1):'enable_rt_knob_resonance',
		(2094, 2):'enable_rt_knob_eg_int',
		(2094, 3):'enable_rt_knob_release',
		(2094, 4):'enable_rt_knob_user1',
		(2094, 5):'enable_rt_knob_user2',
		(2094, 6):'enable_rt_knob_user3',
		(2094, 7):'enable_rt_knob_user4',
		(2095, 0):'enable_sw1',
		(2095, 1):'enable_sw2',
		(2095, 2):'enable_foot_switch',
		(2095, 3):'enable_foot_pedal',
		(2095, 4):'enable_other_control_change',
		(2095, 5):'enable_use_prg_scales',
		(2095, 6):'enable_auto_load_prg_eq',
		(2095, 7):'enable_timbre_mute',
		(2096, 1):'force_osc_mode',
		(2096, 3):'osc_select',
		(2096, 6):'arpeggiator_assign',
		(2096, 7):'enable_waveform_sysex',
		(2097, 7):'portamento_time',
		(2098, 7):'top_key',
		(2099, 7):'bottom_key',
		(2100, 3):'top_slope',
		(2100, 7):'bottom_slope',
		(2101, 7):'top_velocity',
		(2102, 7):'bottom_velocity',
		(2103, 3):'top_velocity_slope',
		(2103, 7):'bottom_velocity_slope',
		(2104, 6):'trim_value',
		(2104, 7):'trim_bypass',
		(2106, 7):'mid_freq',
		(2107, 7):'low_gain',
		(2108, 7):'mid_gain',
		(2109, 7):'high_gain',
		(2116, 7):'tone_adj_slider1_assign',
		(2118, 7):'tone_adj_slider1_value',
		(2120, 7):'tone_adj_slider2_assign',
		(2122, 7):'tone_adj_slider2_value',
		(2124, 7):'tone_adj_slider3_assign',
		(2126, 7):'tone_adj_slider3_value',
		(2128, 7):'tone_adj_slider4_assign',
		(2130, 7):'tone_adj_slider4_value',
		(2132, 7):'tone_adj_slider5_assign',
		(2134, 7):'tone_adj_slider5_value',
		(2136, 7):'tone_adj_slider6_assign',
		(2138, 7):'tone_adj_slider6_value',
		(2140, 7):'tone_adj_slider7_assign',
		(2142, 7):'tone_adj_slider7_value',
		(2144, 7):'tone_adj_slider8_assign',
		(2146, 7):'tone_adj_slider8_value',
		(2148, 7):'tone_adj_switch1_assign',
		(2149, 7):'tone_adj_switch1_off_on',
		(2150, 7):'tone_adj_switch1_value',
		(2152, 7):'tone_adj_switch2_assign',
		(2153, 7):'tone_adj_switch2_off_on',
		(2154, 7):'tone_adj_switch2_value',
		(2156, 7):'tone_adj_switch3_assign',
		(2157, 7):'tone_adj_switch3_off_on',
		(2158, 7):'tone_adj_switch3_value',
		(2160, 7):'tone_adj_switch4_assign',
		(2161, 7):'tone_adj_switch4_off_on',
		(2162, 7):'tone_adj_switch4_value',
		(2164, 7):'tone_adj_switch5_assign',
		(2165, 7):'tone_adj_switch5_off_on',
		(2166, 7):'tone_adj_switch5_value',
		(2168, 7):'tone_adj_switch6_assign',
		(2169, 7):'tone_adj_switch6_off_on',
		(2170, 7):'tone_adj_switch6_value',
		(2172, 7):'tone_adj_switch7_assign',
		(2173, 7):'tone_adj_switch7_off_on',
		(2174, 7):'tone_adj_switch7_value',
		(2176, 7):'tone_adj_switch8_assign',
		(2177, 7):'tone_adj_switch8_off_on',
		(2178, 7):'tone_adj_switch8_value',
		(2180, 7):'program_bank_number',
		(2182, 4):'midi_channel',
		(2182, 7):'midi_status',
		(2183, 7):'ext_bank_msb',
		(2184, 7):'ext_bank_lsb',
		(2185, 7):'volume',
		(2186, 7):'bend_range',
		(2187, 7):'transpose',
		(2188, 7):'detune',
		(2190, 7):'delay_time',
		(2192, 3):'delay_tempo_base',
		(2192, 7):'delay_mode',
		(2193, 7):'delay_tempo_times',
		(2194, 7):'pan',
		(2195, 7):'send1',
		(2196, 7):'send2',
		(2197, 7):'dkit_patch_ifx_1',
		(2198, 7):'dkit_patch_ifx_2',
		(2199, 7):'dkit_patch_ifx_3',
		(2200, 7):'dkit_patch_ifx_4',
		(2201, 7):'dkit_patch_ifx_5',
		(2202, 4):'bus_select',
		(2202, 6):'fx_bus_select',
		(2205, 0):'enable_program_change',
		(2205, 1):'enable_after_touch',
		(2205, 2):'enable_damper',
		(2205, 3):'enable_portamento',
		(2205, 4):'enable_joystick_x',
		(2205, 5):'enable_joystick_plus',
		(2205, 6):'enable_joystick_minus',
		(2205, 7):'enable_ribbon',
		(2206, 0):'enable_rt_knob_cutoff',
		(2206, 1):'enable_rt_knob_resonance',
		(2206, 2):'enable_rt_knob_eg_int',
		(2206, 3):'enable_rt_knob_release',
		(2206, 4):'enable_rt_knob_user1',
		(2206, 5):'enable_rt_knob_user2',
		(2206, 6):'enable_rt_knob_user3',
		(2206, 7):'enable_rt_knob_user4',
		(2207, 0):'enable_sw1',
		(2207, 1):'enable_sw2',
		(2207, 2):'enable_foot_switch',
		(2207, 3):'enable_foot_pedal',
		(2207, 4):'enable_other_control_change',
		(2207, 5):'enable_use_prg_scales',
		(2207, 6):'enable_auto_load_prg_eq',
		(2207, 7):'enable_timbre_mute',
		(2208, 1):'force_osc_mode',
		(2208, 3):'osc_select',
		(2208, 6):'arpeggiator_assign',
		(2208, 7):'enable_waveform_sysex',
		(2209, 7):'portamento_time',
		(2210, 7):'top_key',
		(2211, 7):'bottom_key',
		(2212, 3):'top_slope',
		(2212, 7):'bottom_slope',
		(2213, 7):'top_velocity',
		(2214, 7):'bottom_velocity',
		(2215, 3):'top_velocity_slope',
		(2215, 7):'bottom_velocity_slope',
		(2216, 6):'trim_value',
		(2216, 7):'trim_bypass',
		(2218, 7):'mid_freq',
		(2219, 7):'low_gain',
		(2220, 7):'mid_gain',
		(2221, 7):'high_gain',
		(2228, 7):'tone_adj_slider1_assign',
		(2230, 7):'tone_adj_slider1_value',
		(2232, 7):'tone_adj_slider2_assign',
		(2234, 7):'tone_adj_slider2_value',
		(2236, 7):'tone_adj_slider3_assign',
		(2238, 7):'tone_adj_slider3_value',
		(2240, 7):'tone_adj_slider4_assign',
		(2242, 7):'tone_adj_slider4_value',
		(2244, 7):'tone_adj_slider5_assign',
		(2246, 7):'tone_adj_slider5_value',
		(2248, 7):'tone_adj_slider6_assign',
		(2250, 7):'tone_adj_slider6_value',
		(2252, 7):'tone_adj_slider7_assign',
		(2254, 7):'tone_adj_slider7_value',
		(2256, 7):'tone_adj_slider8_assign',
		(2258, 7):'tone_adj_slider8_value',
		(2260, 7):'tone_adj_switch1_assign',
		(2261, 7):'tone_adj_switch1_off_on',
		(2262, 7):'tone_adj_switch1_value',
		(2264, 7):'tone_adj_switch2_assign',
		(2265, 7):'tone_adj_switch2_off_on',
		(2266, 7):'tone_adj_switch2_value',
		(2268, 7):'tone_adj_switch3_assign',
		(2269, 7):'tone_adj_switch3_off_on',
		(2270, 7):'tone_adj_switch3_value',
		(2272, 7):'tone_adj_switch4_assign',
		(2273, 7):'tone_adj_switch4_off_on',
		(2274, 7):'tone_adj_switch4_value',
		(2276, 7):'tone_adj_switch5_assign',
		(2277, 7):'tone_adj_switch5_off_on',
		(2278, 7):'tone_adj_switch5_value',
		(2280, 7):'tone_adj_switch6_assign',
		(2281, 7):'tone_adj_switch6_off_on',
		(2282, 7):'tone_adj_switch6_value',
		(2284, 7):'tone_adj_switch7_assign',
		(2285, 7):'tone_adj_switch7_off_on',
		(2286, 7):'tone_adj_switch7_value',
		(2288, 7):'tone_adj_switch8_assign',
		(2289, 7):'tone_adj_switch8_off_on',
		(2290, 7):'tone_adj_switch8_value',
		(2292, 7):'program_bank_number',
		(2294, 4):'midi_channel',
		(2294, 7):'midi_status',
		(2295, 7):'ext_bank_msb',
		(2296, 7):'ext_bank_lsb',
		(2297, 7):'volume',
		(2298, 7):'bend_range',
		(2299, 7):'transpose',
		(2300, 7):'detune',
		(2302, 7):'delay_time',
		(2304, 3):'delay_tempo_base',
		(2304, 7):'delay_mode',
		(2305, 7):'delay_tempo_times',
		(2306, 7):'pan',
		(2307, 7):'send1',
		(2308, 7):'send2',
		(2309, 7):'dkit_patch_ifx_1',
		(2310, 7):'dkit_patch_ifx_2',
		(2311, 7):'dkit_patch_ifx_3',
		(2312, 7):'dkit_patch_ifx_4',
		(2313, 7):'dkit_patch_ifx_5',
		(2314, 4):'bus_select',
		(2314, 6):'fx_bus_select',
		(2317, 0):'enable_program_change',
		(2317, 1):'enable_after_touch',
		(2317, 2):'enable_damper',
		(2317, 3):'enable_portamento',
		(2317, 4):'enable_joystick_x',
		(2317, 5):'enable_joystick_plus',
		(2317, 6):'enable_joystick_minus',
		(2317, 7):'enable_ribbon',
		(2318, 0):'enable_rt_knob_cutoff',
		(2318, 1):'enable_rt_knob_resonance',
		(2318, 2):'enable_rt_knob_eg_int',
		(2318, 3):'enable_rt_knob_release',
		(2318, 4):'enable_rt_knob_user1',
		(2318, 5):'enable_rt_knob_user2',
		(2318, 6):'enable_rt_knob_user3',
		(2318, 7):'enable_rt_knob_user4',
		(2319, 0):'enable_sw1',
		(2319, 1):'enable_sw2',
		(2319, 2):'enable_foot_switch',
		(2319, 3):'enable_foot_pedal',
		(2319, 4):'enable_other_control_change',
		(2319, 5):'enable_use_prg_scales',
		(2319, 6):'enable_auto_load_prg_eq',
		(2319, 7):'enable_timbre_mute',
		(2320, 1):'force_osc_mode',
		(2320, 3):'osc_select',
		(2320, 6):'arpeggiator_assign',
		(2320, 7):'enable_waveform_sysex',
		(2321, 7):'portamento_time',
		(2322, 7):'top_key',
		(2323, 7):'bottom_key',
		(2324, 3):'top_slope',
		(2324, 7):'bottom_slope',
		(2325, 7):'top_velocity',
		(2326, 7):'bottom_velocity',
		(2327, 3):'top_velocity_slope',
		(2327, 7):'bottom_velocity_slope',
		(2328, 6):'trim_value',
		(2328, 7):'trim_bypass',
		(2330, 7):'mid_freq',
		(2331, 7):'low_gain',
		(2332, 7):'mid_gain',
		(2333, 7):'high_gain',
		(2340, 7):'tone_adj_slider1_assign',
		(2342, 7):'tone_adj_slider1_value',
		(2344, 7):'tone_adj_slider2_assign',
		(2346, 7):'tone_adj_slider2_value',
		(2348, 7):'tone_adj_slider3_assign',
		(2350, 7):'tone_adj_slider3_value',
		(2352, 7):'tone_adj_slider4_assign',
		(2354, 7):'tone_adj_slider4_value',
		(2356, 7):'tone_adj_slider5_assign',
		(2358, 7):'tone_adj_slider5_value',
		(2360, 7):'tone_adj_slider6_assign',
		(2362, 7):'tone_adj_slider6_value',
		(2364, 7):'tone_adj_slider7_assign',
		(2366, 7):'tone_adj_slider7_value',
		(2368, 7):'tone_adj_slider8_assign',
		(2370, 7):'tone_adj_slider8_value',
		(2372, 7):'tone_adj_switch1_assign',
		(2373, 7):'tone_adj_switch1_off_on',
		(2374, 7):'tone_adj_switch1_value',
		(2376, 7):'tone_adj_switch2_assign',
		(2377, 7):'tone_adj_switch2_off_on',
		(2378, 7):'tone_adj_switch2_value',
		(2380, 7):'tone_adj_switch3_assign',
		(2381, 7):'tone_adj_switch3_off_on',
		(2382, 7):'tone_adj_switch3_value',
		(2384, 7):'tone_adj_switch4_assign',
		(2385, 7):'tone_adj_switch4_off_on',
		(2386, 7):'tone_adj_switch4_value',
		(2388, 7):'tone_adj_switch5_assign',
		(2389, 7):'tone_adj_switch5_off_on',
		(2390, 7):'tone_adj_switch5_value',
		(2392, 7):'tone_adj_switch6_assign',
		(2393, 7):'tone_adj_switch6_off_on',
		(2394, 7):'tone_adj_switch6_value',
		(2396, 7):'tone_adj_switch7_assign',
		(2397, 7):'tone_adj_switch7_off_on',
		(2398, 7):'tone_adj_switch7_value',
		(2400, 7):'tone_adj_switch8_assign',
		(2401, 7):'tone_adj_switch8_off_on',
		(2402, 7):'tone_adj_switch8_value',
		(2404, 7):'program_bank_number',
		(2406, 4):'midi_channel',
		(2406, 7):'midi_status',
		(2407, 7):'ext_bank_msb',
		(2408, 7):'ext_bank_lsb',
		(2409, 7):'volume',
		(2410, 7):'bend_range',
		(2411, 7):'transpose',
		(2412, 7):'detune',
		(2414, 7):'delay_time',
		(2416, 3):'delay_tempo_base',
		(2416, 7):'delay_mode',
		(2417, 7):'delay_tempo_times',
		(2418, 7):'pan',
		(2419, 7):'send1',
		(2420, 7):'send2',
		(2421, 7):'dkit_patch_ifx_1',
		(2422, 7):'dkit_patch_ifx_2',
		(2423, 7):'dkit_patch_ifx_3',
		(2424, 7):'dkit_patch_ifx_4',
		(2425, 7):'dkit_patch_ifx_5',
		(2426, 4):'bus_select',
		(2426, 6):'fx_bus_select',
		(2429, 0):'enable_program_change',
		(2429, 1):'enable_after_touch',
		(2429, 2):'enable_damper',
		(2429, 3):'enable_portamento',
		(2429, 4):'enable_joystick_x',
		(2429, 5):'enable_joystick_plus',
		(2429, 6):'enable_joystick_minus',
		(2429, 7):'enable_ribbon',
		(2430, 0):'enable_rt_knob_cutoff',
		(2430, 1):'enable_rt_knob_resonance',
		(2430, 2):'enable_rt_knob_eg_int',
		(2430, 3):'enable_rt_knob_release',
		(2430, 4):'enable_rt_knob_user1',
		(2430, 5):'enable_rt_knob_user2',
		(2430, 6):'enable_rt_knob_user3',
		(2430, 7):'enable_rt_knob_user4',
		(2431, 0):'enable_sw1',
		(2431, 1):'enable_sw2',
		(2431, 2):'enable_foot_switch',
		(2431, 3):'enable_foot_pedal',
		(2431, 4):'enable_other_control_change',
		(2431, 5):'enable_use_prg_scales',
		(2431, 6):'enable_auto_load_prg_eq',
		(2431, 7):'enable_timbre_mute',
		(2432, 1):'force_osc_mode',
		(2432, 3):'osc_select',
		(2432, 6):'arpeggiator_assign',
		(2432, 7):'enable_waveform_sysex',
		(2433, 7):'portamento_time',
		(2434, 7):'top_key',
		(2435, 7):'bottom_key',
		(2436, 3):'top_slope',
		(2436, 7):'bottom_slope',
		(2437, 7):'top_velocity',
		(2438, 7):'bottom_velocity',
		(2439, 3):'top_velocity_slope',
		(2439, 7):'bottom_velocity_slope',
		(2440, 6):'trim_value',
		(2440, 7):'trim_bypass',
		(2442, 7):'mid_freq',
		(2443, 7):'low_gain',
		(2444, 7):'mid_gain',
		(2445, 7):'high_gain',
		(2452, 7):'tone_adj_slider1_assign',
		(2454, 7):'tone_adj_slider1_value',
		(2456, 7):'tone_adj_slider2_assign',
		(2458, 7):'tone_adj_slider2_value',
		(2460, 7):'tone_adj_slider3_assign',
		(2462, 7):'tone_adj_slider3_value',
		(2464, 7):'tone_adj_slider4_assign',
		(2466, 7):'tone_adj_slider4_value',
		(2468, 7):'tone_adj_slider5_assign',
		(2470, 7):'tone_adj_slider5_value',
		(2472, 7):'tone_adj_slider6_assign',
		(2474, 7):'tone_adj_slider6_value',
		(2476, 7):'tone_adj_slider7_assign',
		(2478, 7):'tone_adj_slider7_value',
		(2480, 7):'tone_adj_slider8_assign',
		(2482, 7):'tone_adj_slider8_value',
		(2484, 7):'tone_adj_switch1_assign',
		(2485, 7):'tone_adj_switch1_off_on',
		(2486, 7):'tone_adj_switch1_value',
		(2488, 7):'tone_adj_switch2_assign',
		(2489, 7):'tone_adj_switch2_off_on',
		(2490, 7):'tone_adj_switch2_value',
		(2492, 7):'tone_adj_switch3_assign',
		(2493, 7):'tone_adj_switch3_off_on',
		(2494, 7):'tone_adj_switch3_value',
		(2496, 7):'tone_adj_switch4_assign',
		(2497, 7):'tone_adj_switch4_off_on',
		(2498, 7):'tone_adj_switch4_value',
		(2500, 7):'tone_adj_switch5_assign',
		(2501, 7):'tone_adj_switch5_off_on',
		(2502, 7):'tone_adj_switch5_value',
		(2504, 7):'tone_adj_switch6_assign',
		(2505, 7):'tone_adj_switch6_off_on',
		(2506, 7):'tone_adj_switch6_value',
		(2508, 7):'tone_adj_switch7_assign',
		(2509, 7):'tone_adj_switch7_off_on',
		(2510, 7):'tone_adj_switch7_value',
		(2512, 7):'tone_adj_switch8_assign',
		(2513, 7):'tone_adj_switch8_off_on',
		(2514, 7):'tone_adj_switch8_value',
		(2516, 7):'program_bank_number',
		(2518, 4):'midi_channel',
		(2518, 7):'midi_status',
		(2519, 7):'ext_bank_msb',
		(2520, 7):'ext_bank_lsb',
		(2521, 7):'volume',
		(2522, 7):'bend_range',
		(2523, 7):'transpose',
		(2524, 7):'detune',
		(2526, 7):'delay_time',
		(2528, 3):'delay_tempo_base',
		(2528, 7):'delay_mode',
		(2529, 7):'delay_tempo_times',
		(2530, 7):'pan',
		(2531, 7):'send1',
		(2532, 7):'send2',
		(2533, 7):'dkit_patch_ifx_1',
		(2534, 7):'dkit_patch_ifx_2',
		(2535, 7):'dkit_patch_ifx_3',
		(2536, 7):'dkit_patch_ifx_4',
		(2537, 7):'dkit_patch_ifx_5',
		(2538, 4):'bus_select',
		(2538, 6):'fx_bus_select',
		(2541, 0):'enable_program_change',
		(2541, 1):'enable_after_touch',
		(2541, 2):'enable_damper',
		(2541, 3):'enable_portamento',
		(2541, 4):'enable_joystick_x',
		(2541, 5):'enable_joystick_plus',
		(2541, 6):'enable_joystick_minus',
		(2541, 7):'enable_ribbon',
		(2542, 0):'enable_rt_knob_cutoff',
		(2542, 1):'enable_rt_knob_resonance',
		(2542, 2):'enable_rt_knob_eg_int',
		(2542, 3):'enable_rt_knob_release',
		(2542, 4):'enable_rt_knob_user1',
		(2542, 5):'enable_rt_knob_user2',
		(2542, 6):'enable_rt_knob_user3',
		(2542, 7):'enable_rt_knob_user4',
		(2543, 0):'enable_sw1',
		(2543, 1):'enable_sw2',
		(2543, 2):'enable_foot_switch',
		(2543, 3):'enable_foot_pedal',
		(2543, 4):'enable_other_control_change',
		(2543, 5):'enable_use_prg_scales',
		(2543, 6):'enable_auto_load_prg_eq',
		(2543, 7):'enable_timbre_mute',
		(2544, 1):'force_osc_mode',
		(2544, 3):'osc_select',
		(2544, 6):'arpeggiator_assign',
		(2544, 7):'enable_waveform_sysex',
		(2545, 7):'portamento_time',
		(2546, 7):'top_key',
		(2547, 7):'bottom_key',
		(2548, 3):'top_slope',
		(2548, 7):'bottom_slope',
		(2549, 7):'top_velocity',
		(2550, 7):'bottom_velocity',
		(2551, 3):'top_velocity_slope',
		(2551, 7):'bottom_velocity_slope',
		(2552, 6):'trim_value',
		(2552, 7):'trim_bypass',
		(2554, 7):'mid_freq',
		(2555, 7):'low_gain',
		(2556, 7):'mid_gain',
		(2557, 7):'high_gain',
		(2564, 7):'tone_adj_slider1_assign',
		(2566, 7):'tone_adj_slider1_value',
		(2568, 7):'tone_adj_slider2_assign',
		(2570, 7):'tone_adj_slider2_value',
		(2572, 7):'tone_adj_slider3_assign',
		(2574, 7):'tone_adj_slider3_value',
		(2576, 7):'tone_adj_slider4_assign',
		(2578, 7):'tone_adj_slider4_value',
		(2580, 7):'tone_adj_slider5_assign',
		(2582, 7):'tone_adj_slider5_value',
		(2584, 7):'tone_adj_slider6_assign',
		(2586, 7):'tone_adj_slider6_value',
		(2588, 7):'tone_adj_slider7_assign',
		(2590, 7):'tone_adj_slider7_value',
		(2592, 7):'tone_adj_slider8_assign',
		(2594, 7):'tone_adj_slider8_value',
		(2596, 7):'tone_adj_switch1_assign',
		(2597, 7):'tone_adj_switch1_off_on',
		(2598, 7):'tone_adj_switch1_value',
		(2600, 7):'tone_adj_switch2_assign',
		(2601, 7):'tone_adj_switch2_off_on',
		(2602, 7):'tone_adj_switch2_value',
		(2604, 7):'tone_adj_switch3_assign',
		(2605, 7):'tone_adj_switch3_off_on',
		(2606, 7):'tone_adj_switch3_value',
		(2608, 7):'tone_adj_switch4_assign',
		(2609, 7):'tone_adj_switch4_off_on',
		(2610, 7):'tone_adj_switch4_value',
		(2612, 7):'tone_adj_switch5_assign',
		(2613, 7):'tone_adj_switch5_off_on',
		(2614, 7):'tone_adj_switch5_value',
		(2616, 7):'tone_adj_switch6_assign',
		(2617, 7):'tone_adj_switch6_off_on',
		(2618, 7):'tone_adj_switch6_value',
		(2620, 7):'tone_adj_switch7_assign',
		(2621, 7):'tone_adj_switch7_off_on',
		(2622, 7):'tone_adj_switch7_value',
		(2624, 7):'tone_adj_switch8_assign',
		(2625, 7):'tone_adj_switch8_off_on',
		(2626, 7):'tone_adj_switch8_value',
}

bits7_range = (0x00,0x7F)
effect_type_range = (0x00,0xC1)
last_effect_type_range = (0x00,0xAB)
lfo_freq_range = (0x00,0xE6)
lfo_dmod_src_range = (0x00,0x25)
lfo_midi_channel_range = (0x00,0x10)
lfo_bpm_range = (0x0F9F,0x5DC0)
bank_program_range = (0x000,0x87F)
portamento_time_range = (-0x01,0x7F)
transpose_range = (-0x3C,0x3C)
detune_range = (-0x4B0,0x4B0)
gain_range = (-0x24,0x24)
bend_range = (-0x19,0x18)
delay_time_range = (0x00,0x61)
delay_tempo_times_range = (0x00,0x20)
slope_range = (0x00,0x0F)
mid_frequency_range = (0x00,0xA5)
tempo_range = (0x0FA0,0x7530)
swing_range = (-0x064,0x44C)
arp_pattern_range = (0x000,0x408)
arp_value_range = (-0x40,0x3F)
input_trim_range = (0x00,0x63)
rt_knob_assign_range = (0,0x8E)
tone_adjust_assign_range = (0x00,0x4D)
tone_adjust_value_range = (-0x3FFF,0x3FFE)

base_note_dict = {0:'1/32',1:'1/24',2:'1/16',3:'1/12',4:'1/8',5:'1/6',6:'1/4',7:'1/3',8:'1/2',9:'1/1'}
off_on_dict = {0:'Off',1:'On'}
ifx_channel_dict = {0:'Ch01',1:'Ch02',2:'Ch03',3:'Ch04',4:'Ch05',5:'Ch06',6:'Ch07',7:'Ch08',8:'Ch09',9:'Ch10',10:'Ch11',11:'Ch12',12:'Ch13',13:'Ch14',14:'Ch15',15:'Ch16',16:'G ch',17:'All-R'}
bus_select_dict = {0:'L/R',7:'Off'}
fx_control_dict = {0:'Off',1:'FX Ctrl1',2:'FX Ctrl2'}
dkit_patch_ifx_dict = {0:'L/R',1:'IFX1',2:'IFX2',3:'IFX3',4:'IFX4',5:'IFX5',12:'Off'}
mfx_chain_direction_dict = {0:'MFX1->MFX2',1:'MFX2->MFX1'}
control_assign_dict = {0:'Tone Control',1:'User Control',2:'ARP'}
chain1_to_dict = {0:'IF2',1:'IFX3',2:'IFX4',3:'IFX5'}
chain2_to_dict = {0:'IF3',1:'IFX4',2:'IFX5'}
chain3_to_dict = {0:'IF4',1:'IFX5'}
pattern_bank_dict = {0:'Preset',1:'User'}
button_mode_dict = {0:'Start Immediately',1:'Wait KBD Trigger'}
trigger_sync_dict = {0:'Off',1:'SEQ'}
midi_status_dict = {0:'Off',1:'Int',2:'Ext',3:'Ext2'}
delay_mode_dict = {0:'Time',1:'Tempo'}
tbus_select_dict = {0:'DKit',1:'L/R',2:'IFX1',3:'IFX2',4:'IFX3',5:'IFX4',6:'IFX5',13:'Off'}
force_osc_mode_dict = {0:'Prog',1:'Poly',2:'Mono',3:'Mono Legato'}
osc_select_dict = {0:'Both',1:'OSC1',2:'OSC2'}
arpeggiator_assign_dict = {0:'Off',1:'A',2:'B'}
sw_assignable_sw_dict = {0:'Off',1:'SW1 Mod. (CC#80)',2:'Porta.SW (CC#65)',3:'Octave Down',4:'Octave Up',5:'JS X Lock',6:'JS Y Lock',7:'JS+Y Lock',8:'JS-Y Lock'}
sw_mode_dict = {0:'Toggle',1:'Momentary'}

def list_table2_members():
	current = 0
	table2keys = mode0param_dict.keys()
#	l1 = [mode4param_dict[k1][k2] for k1 in table10keys for k2 in mode4param_dict[k1].keys]
	l = [(p['offset'],p['bit'],p) for p in [mode0param_dict[k1][k2] for k1 in table2keys for k2 in mode0param_dict[k1].keys()]]
	l.sort()
	for offset,bit,p in l:
		if offset < 0:
			continue
		bits = p['bits']
		start = offset*8+1+bit-min(bits,8)
		start_bit = start % 8
		if start<current:
			print 'Error:',current,start,offset,p['parameter']
#			return
		while start > current:
			reserved = start - current
			current_bit = current % 8
			roffset = current >> 3
#			print current,start,roffset,current_bit,start_bit
			if current_bit == 0:
				if reserved >= 8:
					reserved_bits = 8
					print "\t\tMember('_reserved%04d',(%d,%d),%d,None,'Reserved',None)," % (roffset,roffset,7,reserved_bits)
					current += reserved_bits
				else:
					reserved_bits = start_bit
					print "\t\tMember('_reserved%04d_%d',(%d,%d),%d,None,'Reserved',None)," % (roffset,start_bit-1,roffset,start_bit-1,reserved_bits)
					current += reserved_bits
			elif start_bit == 0 or reserved >= 8:
				reserved_bits = 8 - current_bit
				print "\t\tMember('_reserved%04d_%d',(%d,%d),%d,None,'Reserved',None)," % (roffset,7,roffset,7,reserved_bits)
				current += reserved_bits
			else:
				reserved_bits = start_bit - current_bit
				print "\t\tMember('_reserved%04d_%d',(%d,%d),%d,None,'Reserved',None)," % (roffset,start_bit-1,roffset,start_bit-1,reserved_bits)
				current += reserved_bits
				
					
		rng = p['range']
		rngstr = '???'
		if isinstance(rng,tuple):
			if rng == bits7_range:
				rngstr = 'bits7_range'
			elif rng == effect_type_range:
				rngstr = 'effect_type_range'
			elif rng == last_effect_type_range:
				rngstr = 'last_effect_type_range'
			elif rng == lfo_freq_range:
				rngstr = 'lfo_freq_range'
			elif rng == lfo_dmod_src_range:
				rngstr = 'lfo_dmod_src_range'
			elif rng == lfo_midi_channel_range:
				rngstr = 'lfo_midi_channel_range'
			elif rng == lfo_bpm_range:
				rngstr = 'lfo_bpm_range'
			elif rng == bank_program_range:
				rngstr = 'bank_program_range'
			elif rng == portamento_time_range:
				rngstr = 'portamento_time_range'
			elif rng == transpose_range:
				rngstr = 'transpose_range'
			elif rng == detune_range:
				rngstr = 'detune_range'
			elif rng == gain_range:
				rngstr = 'gain_range'
			elif rng == bend_range:
				rngstr = 'bend_range'
			elif rng == delay_time_range:
				rngstr = 'delay_time_range'
			elif rng == delay_tempo_times_range:
				rngstr = 'delay_tempo_times_range'
			elif rng == mid_frequency_range:
				rngstr = 'mid_frequency_range'
			elif rng == tempo_range:
				rngstr = 'tempo_range'
			elif rng == swing_range:
				rngstr = 'swing_range'
			elif rng == arp_pattern_range:
				rngstr = 'arp_pattern_range'
			elif rng == arp_value_range:
				rngstr = 'arp_value_range'
			elif rng == input_trim_range:
				rngstr = 'input_trim_range'
			elif rng == slope_range and offset >= 868:
				rngstr = 'slope_range'
			elif rng == rt_knob_assign_range:
				rngstr = 'rt_knob_assign_range'
			elif rng == tone_adjust_assign_range:
				rngstr = 'tone_adjust_assign_range'
			elif rng == tone_adjust_value_range:
				rngstr = 'tone_adjust_value_range'
			else:
				if rng[0] >= 0:
					if rng[1] < 256:
						rngstr = '(0x%02X,0x%02X)' % rng
					elif rng[1] < 4096:
						rngstr = '(0x%03X,0x%03X)' % rng
					else:
						rngstr = '(0x%04X,0x%04X)' % rng
				else:
					if rng[1] < 256:
						rngstr = '(-0x%02X,0x%02X)' % (-rng[0],rng[1])
					elif rng[1] < 4096:
						rngstr = '(-0x%03X,0x%03X)' % (-rng[0],rng[1])
					else:
						rngstr = '(-0x%04X,0x%04X)' % (-rng[0],rng[1])
#				print offset,rngstr
		elif isinstance(rng,dict):
			if rng == off_on_dict:
				rngstr = 'off_on_dict'
			elif rng == ifx_channel_dict:
				rngstr = 'ifx_channel_dict'
			elif rng == bus_select_dict:
				rngstr = 'bus_select_dict'
			elif rng == fx_control_dict:
				rngstr = 'fx_control_dict'
			elif rng == dkit_patch_ifx_dict:
				rngstr = 'dkit_patch_ifx_dict'
			elif rng == mfx_chain_direction_dict:
				rngstr = 'mfx_chain_direction_dict'
			elif rng == control_assign_dict:
				rngstr = 'control_assign_dict'
			elif rng == chain1_to_dict:
				rngstr = 'chain1_to_dict'
			elif rng == chain2_to_dict:
				rngstr = 'chain2_to_dict'
			elif rng == chain3_to_dict:
				rngstr = 'chain3_to_dict'
			elif rng == pattern_bank_dict:
				rngstr = 'pattern_bank_dict'
			elif rng == button_mode_dict:
				rngstr = 'button_mode_dict'
			elif rng == trigger_sync_dict:
				rngstr = 'trigger_sync_dict'
			elif rng == midi_status_dict:
				rngstr = 'midi_status_dict'
			elif rng == delay_mode_dict:
				rngstr = 'delay_mode_dict'
			elif rng == tbus_select_dict:
				rngstr = 'tbus_select_dict'
			elif rng == force_osc_mode_dict:
				rngstr = 'force_osc_mode_dict'
			elif rng == osc_select_dict:
				rngstr = 'osc_select_dict'
			elif rng == arpeggiator_assign_dict:
				rngstr = 'arpeggiator_assign_dict'
			elif rng == sw_assignable_sw_dict:
				rngstr = 'sw_assignable_sw_dict'
			elif rng == sw_mode_dict:
				rngstr = 'sw_mode_dict'
			elif rng == base_note_dict:
				rngstr = 'base_note_dict'
			else:
				keys = rng.keys()
				keys.sort()
				rngstr = '{%s}' % (','.join(['%d:%s' % (k,repr(rng[k])) for k in keys]))
#				print offset,rngstr
		else:
			rngstr = 'None'
		key = (offset,bit)
		if key in member_name_dict:
			print "\t\tMember('%s',(%d,%d),%d,%s,'%s',(0,0x%02X,0x%02X),None)," % (member_name_dict[key],offset,bit,bits,rngstr,p['parameter'],p['id'],p['subid'])
		else:
			if bits % 8:
				print "\t\tMember('o%04d_%d',(%d,%d),%d,%s,'%s',(0,0x%02X,0x%02X),None)," % (offset,bit,offset,bit,bits,rngstr,p['parameter'],p['id'],p['subid'])
			else:
				print "\t\tMember('o%04d',(%d,%d),%d,%s,'%s',(0,0x%02X,0x%02X),None)," % (offset,offset,bit,bits,rngstr,p['parameter'],p['id'],p['subid'])
		current += bits
	
if __name__ == '__main__':
	list_table2_members()			
