#!@PYTHON@
# -*- coding: utf-8 -*-
#
# fx001.py -- classes for Korg Krome Music Workstation
#
# (c) 2014  Brian M. Ames <bmames@apk.net>

__all__ = ['mode4param_dict']

#===============================================================================
mode4param_dict = {
	0x00 :  {
						0x00 : {'offset':827,'bit':7,'bits':8,'parameter':'Scale Type','range':(0, 26),'bias':0,'step':None,'mode':0x04,'id':0x00,'subid':0x00},# DIFF
						0x01 : {'offset':828,'bit':7,'bits':8,'parameter':'Scale Key','range':(0, 11),'bias':0,'step':None,'mode':0x04,'id':0x00,'subid':0x01},# DIFF
						0x02 : {'offset':829,'bit':7,'bits':8,'parameter':'Scale Random','range':(0, 7),'bias':0,'step':None,'mode':0x04,'id':0x00,'subid':0x02},# DIFF
						0x03 : {'offset':830,'bit':5,'bits':6,'parameter':'Switch 1 Assign','range':{0:'Off',1:'SW1 Mod. (CC#80)',2:'Porta.SW (CC#65)',3:'Octave Down',4:'Octave Up',5:'JS X Lock',6:'JS Y Lock',7:'JS+Y Lock',8:'JS-Y Lock',},'bias':0,'step':None,'mode':0x04,'id':0x00,'subid':0x03},# DIFF
						0x04 : {'offset':831,'bit':5,'bits':6,'parameter':'Switch 2 Assign','range':{0:'Off',1:'SW1 Mod. (CC#80)',2:'Porta.SW (CC#65)',3:'Octave Down',4:'Octave Up',5:'JS X Lock',6:'JS Y Lock',7:'JS+Y Lock',8:'JS-Y Lock',},'bias':0,'step':None,'mode':0x04,'id':0x00,'subid':0x04},# DIFF
						0x05 : {'offset':830,'bit':7,'bits':1,'parameter':'Switch 1 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x00,'subid':0x05},# DIFF
						0x06 : {'offset':831,'bit':7,'bits':1,'parameter':'Switch 2 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x00,'subid':0x06},# DIFF
						0x07 : {'offset':830,'bit':6,'bits':1,'parameter':'Switch 1 Mode','range':{0:'Toggle', 1:'Momentary'},'bias':0,'step':None,'mode':0x04,'id':0x00,'subid':0x07},# DIFF
						0x08 : {'offset':831,'bit':6,'bits':1,'parameter':'Switch 2 Mode','range':{0:'Toggle', 1:'Momentary'},'bias':0,'step':None,'mode':0x04,'id':0x00,'subid':0x08},# DIFF
						0x09 : {'offset':832,'bit':7,'bits':8,'parameter':'RT Knob-1 Assign','range':(0,0x8E),'bias':0,'step':None,'mode':0x04,'id':0x00,'subid':0x09},# DIFF
						0x0A : {'offset':833,'bit':7,'bits':8,'parameter':'RT Knob-2 Assign','range':(0,0x8E),'bias':0,'step':None,'mode':0x04,'id':0x00,'subid':0x0A},# DIFF
						0x0B : {'offset':834,'bit':7,'bits':8,'parameter':'RT Knob-3 Assign','range':(0,0x8E),'bias':0,'step':None,'mode':0x04,'id':0x00,'subid':0x0B},# DIFF
						0x0C : {'offset':835,'bit':7,'bits':8,'parameter':'RT Knob-4 Assign','range':(0,0x8E),'bias':0,'step':None,'mode':0x04,'id':0x00,'subid':0x0C},# DIFF
						0x0D : {'offset':632,'bit':7,'bits':8,'parameter':'Control Assign','range':{0:'Tone Control', 1:'User Control', 2:'ARP'},'bias':0,'step':None,'mode':0x04,'id':0x00,'subid':0x0D},# DIFF
						0x0E : {'offset':633,'bit':7,'bits':8,'parameter':'Selected Track','range':(0, 0x0F),'bias':0,'step':None,'mode':0x04,'id':0x00,'subid':0x0E},# 0x01
						0x0F : {'offset':826,'bit':0,'bits':1,'parameter':'Auto Load Tone Adjust','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x00,'subid':0x0F},# DIFF
					},
	0x05 :  {
						0x00 : {'offset':616,'bit':7,'bits':8,'parameter':'LFO1 Frequency','range':(0, 230),'bias':0,'step':None,'mode':0x04,'id':0x05,'subid':0x00},
						0x01 : {'offset':617,'bit':7,'bits':8,'parameter':'LFO1 Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x05,'subid':0x01},
						0x02 : {'offset':618,'bit':7,'bits':8,'parameter':'LFO1 DMod Src','range':(0, 37),'bias':0,'step':None,'mode':0x04,'id':0x05,'subid':0x02},
						0x03 : {'offset':619,'bit':7,'bits':8,'parameter':'LFO1 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x05,'subid':0x03},
						0x04 : {'offset':620,'bit':7,'bits':16,'parameter':'LFO1 BPM','range':(3999, 24000),'bias':0,'step':None,'mode':0x04,'id':0x05,'subid':0x04},
						0x05 : {'offset':622,'bit':3,'bits':4,'parameter':'LFO1 MIDI Sync Base Note','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x05,'subid':0x05},
						0x06 : {'offset':622,'bit':7,'bits':1,'parameter':'LFO1 MIDI Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x05,'subid':0x06},
						0x07 : {'offset':623,'bit':7,'bits':8,'parameter':'LFO1 MIDI Sync Time','range':(1, 32),'bias':0,'step':None,'mode':0x04,'id':0x05,'subid':0x07},
					},
	0x06 :  {
						0x00 : {'offset':624,'bit':7,'bits':8,'parameter':'LFO2 Frequency','range':(0, 230),'bias':0,'step':None,'mode':0x04,'id':0x06,'subid':0x00},
						0x01 : {'offset':625,'bit':7,'bits':8,'parameter':'LFO2 Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x06,'subid':0x01},
						0x02 : {'offset':626,'bit':7,'bits':8,'parameter':'LFO2 DMod Src','range':(0, 37),'bias':0,'step':None,'mode':0x04,'id':0x06,'subid':0x02},
						0x03 : {'offset':627,'bit':7,'bits':8,'parameter':'LFO2 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x06,'subid':0x03},
						0x04 : {'offset':628,'bit':7,'bits':16,'parameter':'LFO2 BPM','range':(3999, 24000),'bias':0,'step':None,'mode':0x04,'id':0x06,'subid':0x04},
						0x05 : {'offset':630,'bit':3,'bits':4,'parameter':'LFO2 MIDI Sync Base Note','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x06,'subid':0x05},
						0x06 : {'offset':630,'bit':7,'bits':1,'parameter':'LFO2 MIDI Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x06,'subid':0x06},
						0x07 : {'offset':631,'bit':7,'bits':8,'parameter':'LFO2 MIDI Sync Time','range':(1, 32),'bias':0,'step':None,'mode':0x04,'id':0x06,'subid':0x07},
					},
	0x07 :  {
						0x00 : {'offset':792,'bit':7,'bits':16,'parameter':'Arpeggiator Tempo','range':(0xFA0,0x7530),'bias':0,'step':None,'mode':0x04,'id':0x07,'subid':0x00},
						0x01 : {'offset':794,'bit':0,'bits':1,'parameter':'Arpeggiator Switch','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x07,'subid':0x01},
						0x02 : {'offset':794,'bit':1,'bits':1,'parameter':'Arpeggiator Run A','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x07,'subid':0x02},
						0x03 : {'offset':794,'bit':2,'bits':1,'parameter':'Arpeggiator Run B','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x07,'subid':0x03},
						0x04 : {'offset':796,'bit':7,'bits':8,'parameter':'Arpeggiator Gate','range':(-64, 63),'bias':0,'step':None,'mode':0x04,'id':0x07,'subid':0x04},
						0x05 : {'offset':797,'bit':7,'bits':8,'parameter':'Arpeggiator Velocity','range':(-64, 63),'bias':0,'step':None,'mode':0x04,'id':0x07,'subid':0x05},
						0x06 : {'offset':798,'bit':7,'bits':8,'parameter':'Arpeggiator Swing','range':(-64, 63),'bias':0,'step':None,'mode':0x04,'id':0x07,'subid':0x06},
						0x07 : {'offset':799,'bit':7,'bits':8,'parameter':'Arpeggiator Step','range':(-64, 63),'bias':0,'step':None,'mode':0x04,'id':0x07,'subid':0x07},
					},
	0x08 :  {
						0x00 : {'offset':800,'bit':7,'bits':16,'parameter':'Arpeggiator A Pattern','range':(0, 1032),'bias':0,'step':None,'mode':0x04,'id':0x08,'subid':0x00},
						0x01 : {'offset':802,'bit':4,'bits':3,'parameter':'Arpeggiator A Resolution','range':(0, 7),'bias':0,'step':None,'mode':0x04,'id':0x08,'subid':0x01},
						0x02 : {'offset':802,'bit':1,'bits':2,'parameter':'Arpeggiator A Octave','range':(0, 4),'bias':0,'step':None,'mode':0x04,'id':0x08,'subid':0x02},
						0x03 : {'offset':804,'bit':7,'bits':8,'parameter':'Arpeggiator A Gate','range':(0, 100),'bias':0,'step':None,'mode':0x04,'id':0x08,'subid':0x03},
						0x04 : {'offset':805,'bit':7,'bits':8,'parameter':'Arpeggiator A Velocity','range':(1, 129),'bias':0,'step':None,'mode':0x04,'id':0x08,'subid':0x04},
						0x05 : {'offset':806,'bit':7,'bits':8,'parameter':'Arpeggiator A Swing','range':(-100, 1100),'bias':0,'step':None,'mode':0x04,'id':0x08,'subid':0x05},
						0x06 : {'offset':803,'bit':0,'bits':1,'parameter':'Arpeggiator A Sort','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x08,'subid':0x06},
						0x07 : {'offset':803,'bit':1,'bits':1,'parameter':'Arpeggiator A Latch','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x08,'subid':0x07},
						0x08 : {'offset':803,'bit':2,'bits':1,'parameter':'Arpeggiator A Key Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x08,'subid':0x08},
						0x09 : {'offset':803,'bit':3,'bits':1,'parameter':'Arpeggiator A Keyboard','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x08,'subid':0x09},
						0x0A : {'offset':807,'bit':7,'bits':8,'parameter':'Arpeggiator A Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x08,'subid':0x0A},
						0x0B : {'offset':808,'bit':7,'bits':8,'parameter':'Arpeggiator A Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x08,'subid':0x0B},
						0x0C : {'offset':809,'bit':7,'bits':8,'parameter':'Arpeggiator A Top Velocity','range':(1, 127),'bias':0,'step':None,'mode':0x04,'id':0x08,'subid':0x0C},
						0x0D : {'offset':810,'bit':7,'bits':8,'parameter':'Arpeggiator A Bottom Velocity','range':(1, 127),'bias':0,'step':None,'mode':0x04,'id':0x08,'subid':0x0D},
					},
	0x09 :  {
						0x00 : {'offset':812,'bit':7,'bits':16,'parameter':'Arpeggiator B Pattern','range':(0, 1032),'bias':0,'step':None,'mode':0x04,'id':0x09,'subid':0x00},
						0x01 : {'offset':814,'bit':4,'bits':3,'parameter':'Arpeggiator B Resolution','range':(0, 7),'bias':0,'step':None,'mode':0x04,'id':0x09,'subid':0x01},
						0x02 : {'offset':814,'bit':1,'bits':2,'parameter':'Arpeggiator B Octave','range':(0, 4),'bias':0,'step':None,'mode':0x04,'id':0x09,'subid':0x02},
						0x03 : {'offset':816,'bit':7,'bits':8,'parameter':'Arpeggiator B Gate','range':(0, 100),'bias':0,'step':None,'mode':0x04,'id':0x09,'subid':0x03},
						0x04 : {'offset':817,'bit':7,'bits':8,'parameter':'Arpeggiator B Velocity','range':(1, 129),'bias':0,'step':None,'mode':0x04,'id':0x09,'subid':0x04},
						0x05 : {'offset':818,'bit':7,'bits':8,'parameter':'Arpeggiator B Swing','range':(-100, 1100),'bias':0,'step':None,'mode':0x04,'id':0x09,'subid':0x05},
						0x06 : {'offset':815,'bit':0,'bits':1,'parameter':'Arpeggiator B Sort','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x09,'subid':0x06},
						0x07 : {'offset':815,'bit':1,'bits':1,'parameter':'Arpeggiator B Latch','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x09,'subid':0x07},
						0x08 : {'offset':815,'bit':2,'bits':1,'parameter':'Arpeggiator B Key Sync','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x09,'subid':0x08},
						0x09 : {'offset':815,'bit':3,'bits':1,'parameter':'Arpeggiator B Keyboard','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x09,'subid':0x09},
						0x0A : {'offset':819,'bit':7,'bits':8,'parameter':'Arpeggiator B Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x09,'subid':0x0A},
						0x0B : {'offset':820,'bit':7,'bits':8,'parameter':'Arpeggiator B Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x09,'subid':0x0B},
						0x0C : {'offset':821,'bit':7,'bits':8,'parameter':'Arpeggiator B Top Velocity','range':(1, 127),'bias':0,'step':None,'mode':0x04,'id':0x09,'subid':0x0C},
						0x0D : {'offset':822,'bit':7,'bits':8,'parameter':'Arpeggiator B Bottom Velocity','range':(1, 127),'bias':0,'step':None,'mode':0x04,'id':0x09,'subid':0x0D},
					},
	0x0A :  {
						0x00 : {'offset':638,'bit':7,'bits':8,'parameter':'Pattern Bank','range':{0:'Preset', 1:'User'},'bias':0,'step':None,'mode':0x04,'id':0x0A,'subid':0x00},
						0x01 : {'offset':636,'bit':7,'bits':16,'parameter':'Drum Track Pattern','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0A,'subid':0x01},
						0x02 : {'offset':639,'bit':0,'bits':1,'parameter':'Trigger Mode','range':{0:'Start Immediately', 1:'Wait KBD Trigger'},'bias':0,'step':None,'mode':0x04,'id':0x0A,'subid':0x02},
						0x03 : {'offset':639,'bit':2,'bits':2,'parameter':'Trigger Latch','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x0A,'subid':0x03},
						0x04 : {'offset':639,'bit':3,'bits':1,'parameter':'Trigger Sync','range':{0:'Off',1:'SEQ'},'bias':0,'step':None,'mode':0x04,'id':0x0A,'subid':0x04},
						0x05 : {'offset':640,'bit':7,'bits':8,'parameter':'Zone Keyboard Bottom','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0A,'subid':0x05},
						0x06 : {'offset':641,'bit':7,'bits':8,'parameter':'Zone Keyboard Top','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0A,'subid':0x06},
						0x07 : {'offset':642,'bit':7,'bits':8,'parameter':'Zone Velocity Bottom','range':(1, 127),'bias':0,'step':None,'mode':0x04,'id':0x0A,'subid':0x07},
						0x08 : {'offset':643,'bit':7,'bits':8,'parameter':'Zone Velocity Top','range':(1, 127),'bias':0,'step':None,'mode':0x04,'id':0x0A,'subid':0x08},
						0x09 : {'offset':644,'bit':7,'bits':8,'parameter':'Shift','range':(-24, 24),'bias':0,'step':None,'mode':0x04,'id':0x0A,'subid':0x09},
						0x0A : {'offset':639,'bit':4,'bits':1,'parameter':'Drum Track On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x0A,'subid':0x04},
						0x0B : {'offset':645,'bit':7,'bits':8,'parameter':'Output Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x0A,'subid':0x0B},
						0x0C : {'offset':646,'bit':7,'bits':8,'parameter':'Input Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x0A,'subid':0x0C},
					},
	0x0B :  {
						0x00 : {'offset':836,'bit':7,'bits':16,'parameter':'Tk1 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x00},
						0x01 : {'offset':850,'bit':7,'bits':8,'parameter':'Tk1 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x01},
						0x02 : {'offset':841,'bit':7,'bits':8,'parameter':'Tk1 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x02},
						0x03 : {'offset':838,'bit':7,'bits':3,'parameter':'Tk1 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x03},
						0x04 : {'offset':838,'bit':4,'bits':5,'parameter':'Tk1 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x04},
						0x05 : {'offset':839,'bit':7,'bits':8,'parameter':'Tk1 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x05},
						0x06 : {'offset':840,'bit':7,'bits':8,'parameter':'Tk1 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x06},
						0x07 : {'offset':864,'bit':1,'bits':2,'parameter':'Tk1 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x07},
						0x08 : {'offset':864,'bit':3,'bits':2,'parameter':'Tk1 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x08},
						0x09 : {'offset':864,'bit':6,'bits':2,'parameter':'Tk1 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x09},
						0x0A : {'offset':865,'bit':7,'bits':8,'parameter':'Tk1 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x0A},
						0x0B : {'offset':843,'bit':7,'bits':8,'parameter':'Tk1 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x0B},
						0x0C : {'offset':844,'bit':7,'bits':16,'parameter':'Tk1 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x0C},
						0x0D : {'offset':842,'bit':7,'bits':8,'parameter':'Tk1 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x0D},
						0x0E : {'offset':846,'bit':7,'bits':8,'parameter':'Tk1 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x0E},
						0x0F : {'offset':848,'bit':3,'bits':4,'parameter':'Tk1 Delay Tempo Base','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x0F},
						0x10 : {'offset':848,'bit':7,'bits':1,'parameter':'Tk1 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x10},
						0x11 : {'offset':849,'bit':7,'bits':8,'parameter':'Tk1 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x11},
						0x12 : {'offset':863,'bit':5,'bits':1,'parameter':'Tk1 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x12},
						0x13 : {'offset':861,'bit':0,'bits':1,'parameter':'Tk1 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x13},
						0x14 : {'offset':861,'bit':1,'bits':1,'parameter':'Tk1 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x14},
						0x15 : {'offset':861,'bit':2,'bits':1,'parameter':'Tk1 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x15},
						0x16 : {'offset':861,'bit':3,'bits':1,'parameter':'Tk1 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x16},
						0x17 : {'offset':861,'bit':4,'bits':1,'parameter':'Tk1 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x17},
						0x18 : {'offset':861,'bit':5,'bits':1,'parameter':'Tk1 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x18},
						0x19 : {'offset':861,'bit':6,'bits':1,'parameter':'Tk1 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x19},
						0x1A : {'offset':861,'bit':7,'bits':1,'parameter':'Tk1 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x1A},
						0x1B : {'offset':862,'bit':0,'bits':1,'parameter':'Tk1 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x1B},
						0x1C : {'offset':862,'bit':1,'bits':1,'parameter':'Tk1 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x1C},
						0x1D : {'offset':862,'bit':2,'bits':1,'parameter':'Tk1 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x1D},
						0x1E : {'offset':862,'bit':3,'bits':1,'parameter':'Tk1 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x1E},
						0x1F : {'offset':862,'bit':4,'bits':1,'parameter':'Tk1 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x1F},
						0x20 : {'offset':862,'bit':5,'bits':1,'parameter':'Tk1 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x20},
						0x21 : {'offset':862,'bit':6,'bits':1,'parameter':'Tk1 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x21},
						0x22 : {'offset':862,'bit':7,'bits':1,'parameter':'Tk1 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x22},
						0x23 : {'offset':863,'bit':0,'bits':1,'parameter':'Tk1 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x23},
						0x24 : {'offset':863,'bit':1,'bits':1,'parameter':'Tk1 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x24},
						0x25 : {'offset':863,'bit':2,'bits':1,'parameter':'Tk1 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x25},
						0x26 : {'offset':863,'bit':3,'bits':1,'parameter':'Tk1 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x26},
						0x27 : {'offset':863,'bit':4,'bits':1,'parameter':'Tk1 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x27},
						0x28 : {'offset':863,'bit':7,'bits':1,'parameter':'Tk1 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x28},
# 0x29
						0x2A : {'offset':863,'bit':6,'bits':1,'parameter':'Tk1 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x2A},
						0x2B : {'offset':872,'bit':6,'bits':7,'parameter':'Tk1 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x2B},
						0x2C : {'offset':872,'bit':7,'bits':1,'parameter':'Tk1 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x2C},
						0x2D : {'offset':874,'bit':7,'bits':8,'parameter':'Tk1 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x2D},
						0x2E : {'offset':875,'bit':7,'bits':8,'parameter':'Tk1 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x2E},
						0x2F : {'offset':876,'bit':7,'bits':8,'parameter':'Tk1 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x2F},
						0x30 : {'offset':877,'bit':7,'bits':8,'parameter':'Tk1 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x30},
						0x31 : {'offset':866,'bit':7,'bits':8,'parameter':'Tk1 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x31},
						0x32 : {'offset':868,'bit':3,'bits':4,'parameter':'Tk1 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x32},
						0x33 : {'offset':868,'bit':7,'bits':4,'parameter':'Tk1 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x33},
						0x34 : {'offset':867,'bit':7,'bits':8,'parameter':'Tk1 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x34},
						0x35 : {'offset':869,'bit':7,'bits':8,'parameter':'Tk1 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x35},
						0x36 : {'offset':871,'bit':3,'bits':4,'parameter':'Tk1 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x36},
						0x37 : {'offset':871,'bit':7,'bits':4,'parameter':'Tk1 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x37},
						0x38 : {'offset':870,'bit':7,'bits':8,'parameter':'Tk1 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x38},
						0x39 : {'offset':858,'bit':4,'bits':5,'parameter':'Tk1 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x39},
						0x3A : {'offset':858,'bit':6,'bits':2,'parameter':'Tk1 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x3A},
						0x3B : {'offset':851,'bit':7,'bits':8,'parameter':'Tk1 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x3B},
						0x3C : {'offset':852,'bit':7,'bits':8,'parameter':'Tk1 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x3C},
						0x3D : {'offset':853,'bit':7,'bits':8,'parameter':'Tk1 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x3D},
						0x3E : {'offset':854,'bit':7,'bits':8,'parameter':'Tk1 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x3E},
						0x3F : {'offset':855,'bit':7,'bits':8,'parameter':'Tk1 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x3F},
						0x40 : {'offset':856,'bit':7,'bits':8,'parameter':'Tk1 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x40},
						0x41 : {'offset':857,'bit':7,'bits':8,'parameter':'Tk1 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x41},
						0x42 : {'offset':864,'bit':7,'bits':1,'parameter':'Tk1 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0B,'subid':0x42},
					},
	0x0C :  {
						0x00 : {'offset':948,'bit':7,'bits':16,'parameter':'Tk2 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x00},# 0x00
						0x01 : {'offset':962,'bit':7,'bits':8,'parameter':'Tk2 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x01},# 0x00
						0x02 : {'offset':953,'bit':7,'bits':8,'parameter':'Tk2 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x02},# 0x00
						0x03 : {'offset':950,'bit':7,'bits':3,'parameter':'Tk2 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x03},# 0x00
						0x04 : {'offset':950,'bit':4,'bits':5,'parameter':'Tk2 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x04},# 0x00
						0x05 : {'offset':951,'bit':7,'bits':8,'parameter':'Tk2 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x05},# 0x00
						0x06 : {'offset':952,'bit':7,'bits':8,'parameter':'Tk2 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x06},# 0x00
						0x07 : {'offset':976,'bit':1,'bits':2,'parameter':'Tk2 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x07},# 0x00
						0x08 : {'offset':976,'bit':3,'bits':2,'parameter':'Tk2 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x08},# 0x00
						0x09 : {'offset':976,'bit':6,'bits':2,'parameter':'Tk2 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x09},# 0x00
						0x0A : {'offset':977,'bit':7,'bits':8,'parameter':'Tk2 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x0A},# 0x00
						0x0B : {'offset':955,'bit':7,'bits':8,'parameter':'Tk2 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x0B},# 0x00
						0x0C : {'offset':956,'bit':7,'bits':16,'parameter':'Tk2 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x0C},# 0x00
						0x0D : {'offset':954,'bit':7,'bits':8,'parameter':'Tk2 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x0D},# 0x00
						0x0E : {'offset':958,'bit':7,'bits':8,'parameter':'Tk2 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x0E},# 0x00
						0x0F : {'offset':960,'bit':3,'bits':4,'parameter':'Tk2 Delay Tempo Base','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x0F},# 0x00
						0x10 : {'offset':960,'bit':7,'bits':1,'parameter':'Tk2 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x10},# 0x00
						0x11 : {'offset':961,'bit':7,'bits':8,'parameter':'Tk2 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x11},# 0x00
						0x12 : {'offset':975,'bit':5,'bits':1,'parameter':'Tk2 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x12},# 0x00
						0x13 : {'offset':973,'bit':0,'bits':1,'parameter':'Tk2 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x13},# 0x00
						0x14 : {'offset':973,'bit':1,'bits':1,'parameter':'Tk2 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x14},# 0x00
						0x15 : {'offset':973,'bit':2,'bits':1,'parameter':'Tk2 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x15},# 0x00
						0x16 : {'offset':973,'bit':3,'bits':1,'parameter':'Tk2 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x16},# 0x00
						0x17 : {'offset':973,'bit':4,'bits':1,'parameter':'Tk2 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x17},# 0x00
						0x18 : {'offset':973,'bit':5,'bits':1,'parameter':'Tk2 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x18},# 0x00
						0x19 : {'offset':973,'bit':6,'bits':1,'parameter':'Tk2 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x19},# 0x00
						0x1A : {'offset':973,'bit':7,'bits':1,'parameter':'Tk2 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x1A},# 0x00
						0x1B : {'offset':974,'bit':0,'bits':1,'parameter':'Tk2 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x1B},# 0x00
						0x1C : {'offset':974,'bit':1,'bits':1,'parameter':'Tk2 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x1C},# 0x00
						0x1D : {'offset':974,'bit':2,'bits':1,'parameter':'Tk2 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x1D},# 0x00
						0x1E : {'offset':974,'bit':3,'bits':1,'parameter':'Tk2 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x1E},# 0x00
						0x1F : {'offset':974,'bit':4,'bits':1,'parameter':'Tk2 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x1F},# 0x00
						0x20 : {'offset':974,'bit':5,'bits':1,'parameter':'Tk2 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x20},# 0x00
						0x21 : {'offset':974,'bit':6,'bits':1,'parameter':'Tk2 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x21},# 0x00
						0x22 : {'offset':974,'bit':7,'bits':1,'parameter':'Tk2 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x22},# 0x00
						0x23 : {'offset':975,'bit':0,'bits':1,'parameter':'Tk2 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x23},# 0x00
						0x24 : {'offset':975,'bit':1,'bits':1,'parameter':'Tk2 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x24},# 0x00
						0x25 : {'offset':975,'bit':2,'bits':1,'parameter':'Tk2 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x25},# 0x00
						0x26 : {'offset':975,'bit':3,'bits':1,'parameter':'Tk2 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x26},# 0x00
						0x27 : {'offset':975,'bit':4,'bits':1,'parameter':'Tk2 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x27},# 0x00
						0x28 : {'offset':975,'bit':7,'bits':1,'parameter':'Tk2 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x28},# 0x00
# 0x29
						0x2A : {'offset':975,'bit':6,'bits':1,'parameter':'Tk2 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x2A},# 0x00
						0x2B : {'offset':984,'bit':6,'bits':7,'parameter':'Tk2 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x2B},# 0x00
						0x2C : {'offset':984,'bit':7,'bits':1,'parameter':'Tk2 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x2C},# 0x00
						0x2D : {'offset':986,'bit':7,'bits':8,'parameter':'Tk2 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x2D},# 0x00
						0x2E : {'offset':987,'bit':7,'bits':8,'parameter':'Tk2 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x2E},# 0x00
						0x2F : {'offset':988,'bit':7,'bits':8,'parameter':'Tk2 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x2F},# 0x00
						0x30 : {'offset':989,'bit':7,'bits':8,'parameter':'Tk2 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x30},# 0x00
						0x31 : {'offset':978,'bit':7,'bits':8,'parameter':'Tk2 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x31},# 0x00
						0x32 : {'offset':980,'bit':3,'bits':4,'parameter':'Tk2 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x32},# 0x00
						0x33 : {'offset':980,'bit':7,'bits':4,'parameter':'Tk2 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x33},# 0x00
						0x34 : {'offset':979,'bit':7,'bits':8,'parameter':'Tk2 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x34},# 0x00
						0x35 : {'offset':981,'bit':7,'bits':8,'parameter':'Tk2 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x35},# 0x00
						0x36 : {'offset':983,'bit':3,'bits':4,'parameter':'Tk2 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x36},# 0x00
						0x37 : {'offset':983,'bit':7,'bits':4,'parameter':'Tk2 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x37},# 0x00
						0x38 : {'offset':982,'bit':7,'bits':8,'parameter':'Tk2 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x38},# 0x00
						0x39 : {'offset':970,'bit':4,'bits':5,'parameter':'Tk2 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x39},# 0x00
						0x3A : {'offset':970,'bit':6,'bits':2,'parameter':'Tk2 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x3A},# 0x00
						0x3B : {'offset':963,'bit':7,'bits':8,'parameter':'Tk2 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x3B},# 0x00
						0x3C : {'offset':964,'bit':7,'bits':8,'parameter':'Tk2 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x3C},# 0x00
						0x3D : {'offset':965,'bit':7,'bits':8,'parameter':'Tk2 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x3D},# 0x00
						0x3E : {'offset':966,'bit':7,'bits':8,'parameter':'Tk2 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x3E},# 0x00
						0x3F : {'offset':967,'bit':7,'bits':8,'parameter':'Tk2 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x3F},# 0x00
						0x40 : {'offset':968,'bit':7,'bits':8,'parameter':'Tk2 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x40},# 0x00
						0x41 : {'offset':969,'bit':7,'bits':8,'parameter':'Tk2 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x41},# 0x00
						0x42 : {'offset':976,'bit':7,'bits':1,'parameter':'Tk2 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0C,'subid':0x42},# 0x00
					},
	0x0D :  {
						0x00 : {'offset':1060,'bit':7,'bits':16,'parameter':'Tk3 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x00},# 0x00
						0x01 : {'offset':1074,'bit':7,'bits':8,'parameter':'Tk3 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x01},# 0x00
						0x02 : {'offset':1065,'bit':7,'bits':8,'parameter':'Tk3 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x02},# 0x00
						0x03 : {'offset':1062,'bit':7,'bits':3,'parameter':'Tk3 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x03},# 0x00
						0x04 : {'offset':1062,'bit':4,'bits':5,'parameter':'Tk3 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x04},# 0x00
						0x05 : {'offset':1063,'bit':7,'bits':8,'parameter':'Tk3 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x05},# 0x00
						0x06 : {'offset':1064,'bit':7,'bits':8,'parameter':'Tk3 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x06},# 0x00
						0x07 : {'offset':1088,'bit':1,'bits':2,'parameter':'Tk3 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x07},# 0x00
						0x08 : {'offset':1088,'bit':3,'bits':2,'parameter':'Tk3 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x08},# 0x00
						0x09 : {'offset':1088,'bit':6,'bits':2,'parameter':'Tk3 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x09},# 0x00
						0x0A : {'offset':1089,'bit':7,'bits':8,'parameter':'Tk3 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x0A},# 0x00
						0x0B : {'offset':1067,'bit':7,'bits':8,'parameter':'Tk3 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x0B},# 0x00
						0x0C : {'offset':1068,'bit':7,'bits':16,'parameter':'Tk3 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x0C},# 0x00
						0x0D : {'offset':1066,'bit':7,'bits':8,'parameter':'Tk3 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x0D},# 0x00
						0x0E : {'offset':1070,'bit':7,'bits':8,'parameter':'Tk3 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x0E},# 0x00
						0x0F : {'offset':1072,'bit':3,'bits':4,'parameter':'Tk3 Delay Tempo Base','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x0F},# 0x00
						0x10 : {'offset':1072,'bit':7,'bits':1,'parameter':'Tk3 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x10},# 0x00
						0x11 : {'offset':1073,'bit':7,'bits':8,'parameter':'Tk3 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x11},# 0x00
						0x12 : {'offset':1087,'bit':5,'bits':1,'parameter':'Tk3 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x12},# 0x00
						0x13 : {'offset':1085,'bit':0,'bits':1,'parameter':'Tk3 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x13},# 0x00
						0x14 : {'offset':1085,'bit':1,'bits':1,'parameter':'Tk3 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x14},# 0x00
						0x15 : {'offset':1085,'bit':2,'bits':1,'parameter':'Tk3 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x15},# 0x00
						0x16 : {'offset':1085,'bit':3,'bits':1,'parameter':'Tk3 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x16},# 0x00
						0x17 : {'offset':1085,'bit':4,'bits':1,'parameter':'Tk3 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x17},# 0x00
						0x18 : {'offset':1085,'bit':5,'bits':1,'parameter':'Tk3 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x18},# 0x00
						0x19 : {'offset':1085,'bit':6,'bits':1,'parameter':'Tk3 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x19},# 0x00
						0x1A : {'offset':1085,'bit':7,'bits':1,'parameter':'Tk3 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x1A},# 0x00
						0x1B : {'offset':1086,'bit':0,'bits':1,'parameter':'Tk3 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x1B},# 0x00
						0x1C : {'offset':1086,'bit':1,'bits':1,'parameter':'Tk3 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x1C},# 0x00
						0x1D : {'offset':1086,'bit':2,'bits':1,'parameter':'Tk3 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x1D},# 0x00
						0x1E : {'offset':1086,'bit':3,'bits':1,'parameter':'Tk3 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x1E},# 0x00
						0x1F : {'offset':1086,'bit':4,'bits':1,'parameter':'Tk3 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x1F},# 0x00
						0x20 : {'offset':1086,'bit':5,'bits':1,'parameter':'Tk3 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x20},# 0x00
						0x21 : {'offset':1086,'bit':6,'bits':1,'parameter':'Tk3 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x21},# 0x00
						0x22 : {'offset':1086,'bit':7,'bits':1,'parameter':'Tk3 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x22},# 0x00
						0x23 : {'offset':1087,'bit':0,'bits':1,'parameter':'Tk3 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x23},# 0x00
						0x24 : {'offset':1087,'bit':1,'bits':1,'parameter':'Tk3 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x24},# 0x00
						0x25 : {'offset':1087,'bit':2,'bits':1,'parameter':'Tk3 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x25},# 0x00
						0x26 : {'offset':1087,'bit':3,'bits':1,'parameter':'Tk3 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x26},# 0x00
						0x27 : {'offset':1087,'bit':4,'bits':1,'parameter':'Tk3 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x27},# 0x00
						0x28 : {'offset':1087,'bit':7,'bits':1,'parameter':'Tk3 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x28},# 0x00
# 0x29
						0x2A : {'offset':1087,'bit':6,'bits':1,'parameter':'Tk3 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x2A},# 0x00
						0x2B : {'offset':1096,'bit':6,'bits':7,'parameter':'Tk3 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x2B},# 0x00
						0x2C : {'offset':1096,'bit':7,'bits':1,'parameter':'Tk3 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x2C},# 0x00
						0x2D : {'offset':1098,'bit':7,'bits':8,'parameter':'Tk3 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x2D},# 0x00
						0x2E : {'offset':1099,'bit':7,'bits':8,'parameter':'Tk3 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x2E},# 0x00
						0x2F : {'offset':1100,'bit':7,'bits':8,'parameter':'Tk3 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x2F},# 0x00
						0x30 : {'offset':1101,'bit':7,'bits':8,'parameter':'Tk3 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x30},# 0x00
						0x31 : {'offset':1090,'bit':7,'bits':8,'parameter':'Tk3 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x31},# 0x00
						0x32 : {'offset':1092,'bit':3,'bits':4,'parameter':'Tk3 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x32},# 0x00
						0x33 : {'offset':1092,'bit':7,'bits':4,'parameter':'Tk3 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x33},# 0x00
						0x34 : {'offset':1091,'bit':7,'bits':8,'parameter':'Tk3 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x34},# 0x00
						0x35 : {'offset':1093,'bit':7,'bits':8,'parameter':'Tk3 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x35},# 0x00
						0x36 : {'offset':1095,'bit':3,'bits':4,'parameter':'Tk3 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x36},# 0x00
						0x37 : {'offset':1095,'bit':7,'bits':4,'parameter':'Tk3 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x37},# 0x00
						0x38 : {'offset':1094,'bit':7,'bits':8,'parameter':'Tk3 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x38},# 0x00
						0x39 : {'offset':1082,'bit':4,'bits':5,'parameter':'Tk3 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x39},# 0x00
						0x3A : {'offset':1082,'bit':6,'bits':2,'parameter':'Tk3 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x3A},# 0x00
						0x3B : {'offset':1075,'bit':7,'bits':8,'parameter':'Tk3 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x3B},# 0x00
						0x3C : {'offset':1076,'bit':7,'bits':8,'parameter':'Tk3 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x3C},# 0x00
						0x3D : {'offset':1077,'bit':7,'bits':8,'parameter':'Tk3 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x3D},# 0x00
						0x3E : {'offset':1078,'bit':7,'bits':8,'parameter':'Tk3 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x3E},# 0x00
						0x3F : {'offset':1079,'bit':7,'bits':8,'parameter':'Tk3 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x3F},# 0x00
						0x40 : {'offset':1080,'bit':7,'bits':8,'parameter':'Tk3 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x40},# 0x00
						0x41 : {'offset':1081,'bit':7,'bits':8,'parameter':'Tk3 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x41},# 0x00
						0x42 : {'offset':1088,'bit':7,'bits':1,'parameter':'Tk3 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0D,'subid':0x42},# 0x00
					},
	0x0E :  {
						0x00 : {'offset':1172,'bit':7,'bits':16,'parameter':'Tk4 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x00},# 0x00
						0x01 : {'offset':1186,'bit':7,'bits':8,'parameter':'Tk4 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x01},# 0x00
						0x02 : {'offset':1177,'bit':7,'bits':8,'parameter':'Tk4 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x02},# 0x00
						0x03 : {'offset':1174,'bit':7,'bits':3,'parameter':'Tk4 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x03},# 0x00
						0x04 : {'offset':1174,'bit':4,'bits':5,'parameter':'Tk4 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x04},# 0x00
						0x05 : {'offset':1175,'bit':7,'bits':8,'parameter':'Tk4 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x05},# 0x00
						0x06 : {'offset':1176,'bit':7,'bits':8,'parameter':'Tk4 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x06},# 0x00
						0x07 : {'offset':1200,'bit':1,'bits':2,'parameter':'Tk4 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x07},# 0x00
						0x08 : {'offset':1200,'bit':3,'bits':2,'parameter':'Tk4 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x08},# 0x00
						0x09 : {'offset':1200,'bit':6,'bits':2,'parameter':'Tk4 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x09},# 0x00
						0x0A : {'offset':1201,'bit':7,'bits':8,'parameter':'Tk4 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x0A},# 0x00
						0x0B : {'offset':1179,'bit':7,'bits':8,'parameter':'Tk4 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x0B},# 0x00
						0x0C : {'offset':1180,'bit':7,'bits':16,'parameter':'Tk4 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x0C},# 0x00
						0x0D : {'offset':1178,'bit':7,'bits':8,'parameter':'Tk4 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x0D},# 0x00
						0x0E : {'offset':1182,'bit':7,'bits':8,'parameter':'Tk4 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x0E},# 0x00
						0x0F : {'offset':1184,'bit':3,'bits':4,'parameter':'Tk4 Delay Tempo Base','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x0F},# 0x00
						0x10 : {'offset':1184,'bit':7,'bits':1,'parameter':'Tk4 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x10},# 0x00
						0x11 : {'offset':1185,'bit':7,'bits':8,'parameter':'Tk4 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x11},# 0x00
						0x12 : {'offset':1199,'bit':5,'bits':1,'parameter':'Tk4 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x12},# 0x00
						0x13 : {'offset':1197,'bit':0,'bits':1,'parameter':'Tk4 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x13},# 0x00
						0x14 : {'offset':1197,'bit':1,'bits':1,'parameter':'Tk4 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x14},# 0x00
						0x15 : {'offset':1197,'bit':2,'bits':1,'parameter':'Tk4 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x15},# 0x00
						0x16 : {'offset':1197,'bit':3,'bits':1,'parameter':'Tk4 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x16},# 0x00
						0x17 : {'offset':1197,'bit':4,'bits':1,'parameter':'Tk4 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x17},# 0x00
						0x18 : {'offset':1197,'bit':5,'bits':1,'parameter':'Tk4 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x18},# 0x00
						0x19 : {'offset':1197,'bit':6,'bits':1,'parameter':'Tk4 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x19},# 0x00
						0x1A : {'offset':1197,'bit':7,'bits':1,'parameter':'Tk4 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x1A},# 0x00
						0x1B : {'offset':1198,'bit':0,'bits':1,'parameter':'Tk4 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x1B},# 0x00
						0x1C : {'offset':1198,'bit':1,'bits':1,'parameter':'Tk4 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x1C},# 0x00
						0x1D : {'offset':1198,'bit':2,'bits':1,'parameter':'Tk4 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x1D},# 0x00
						0x1E : {'offset':1198,'bit':3,'bits':1,'parameter':'Tk4 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x1E},# 0x00
						0x1F : {'offset':1198,'bit':4,'bits':1,'parameter':'Tk4 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x1F},# 0x00
						0x20 : {'offset':1198,'bit':5,'bits':1,'parameter':'Tk4 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x20},# 0x00
						0x21 : {'offset':1198,'bit':6,'bits':1,'parameter':'Tk4 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x21},# 0x00
						0x22 : {'offset':1198,'bit':7,'bits':1,'parameter':'Tk4 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x22},# 0x00
						0x23 : {'offset':1199,'bit':0,'bits':1,'parameter':'Tk4 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x23},# 0x00
						0x24 : {'offset':1199,'bit':1,'bits':1,'parameter':'Tk4 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x24},# 0x00
						0x25 : {'offset':1199,'bit':2,'bits':1,'parameter':'Tk4 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x25},# 0x00
						0x26 : {'offset':1199,'bit':3,'bits':1,'parameter':'Tk4 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x26},# 0x00
						0x27 : {'offset':1199,'bit':4,'bits':1,'parameter':'Tk4 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x27},# 0x00
						0x28 : {'offset':1199,'bit':7,'bits':1,'parameter':'Tk4 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x28},# 0x00
# 0x29
						0x2A : {'offset':1199,'bit':6,'bits':1,'parameter':'Tk4 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x2A},# 0x00
						0x2B : {'offset':1208,'bit':6,'bits':7,'parameter':'Tk4 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x2B},# 0x00
						0x2C : {'offset':1208,'bit':7,'bits':1,'parameter':'Tk4 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x2C},# 0x00
						0x2D : {'offset':1210,'bit':7,'bits':8,'parameter':'Tk4 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x2D},# 0x00
						0x2E : {'offset':1211,'bit':7,'bits':8,'parameter':'Tk4 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x2E},# 0x00
						0x2F : {'offset':1212,'bit':7,'bits':8,'parameter':'Tk4 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x2F},# 0x00
						0x30 : {'offset':1213,'bit':7,'bits':8,'parameter':'Tk4 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x30},# 0x00
						0x31 : {'offset':1202,'bit':7,'bits':8,'parameter':'Tk4 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x31},# 0x00
						0x32 : {'offset':1204,'bit':3,'bits':4,'parameter':'Tk4 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x32},# 0x00
						0x33 : {'offset':1204,'bit':7,'bits':4,'parameter':'Tk4 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x33},# 0x00
						0x34 : {'offset':1203,'bit':7,'bits':8,'parameter':'Tk4 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x34},# 0x00
						0x35 : {'offset':1205,'bit':7,'bits':8,'parameter':'Tk4 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x35},# 0x00
						0x36 : {'offset':1207,'bit':3,'bits':4,'parameter':'Tk4 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x36},# 0x00
						0x37 : {'offset':1207,'bit':7,'bits':4,'parameter':'Tk4 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x37},# 0x00
						0x38 : {'offset':1206,'bit':7,'bits':8,'parameter':'Tk4 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x38},# 0x00
						0x39 : {'offset':1194,'bit':4,'bits':5,'parameter':'Tk4 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x39},# 0x00
						0x3A : {'offset':1194,'bit':6,'bits':2,'parameter':'Tk4 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x3A},# 0x00
						0x3B : {'offset':1187,'bit':7,'bits':8,'parameter':'Tk4 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x3B},# 0x00
						0x3C : {'offset':1188,'bit':7,'bits':8,'parameter':'Tk4 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x3C},# 0x00
						0x3D : {'offset':1189,'bit':7,'bits':8,'parameter':'Tk4 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x3D},# 0x00
						0x3E : {'offset':1190,'bit':7,'bits':8,'parameter':'Tk4 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x3E},# 0x00
						0x3F : {'offset':1191,'bit':7,'bits':8,'parameter':'Tk4 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x3F},# 0x00
						0x40 : {'offset':1192,'bit':7,'bits':8,'parameter':'Tk4 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x40},# 0x00
						0x41 : {'offset':1193,'bit':7,'bits':8,'parameter':'Tk4 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x41},# 0x00
						0x42 : {'offset':1200,'bit':7,'bits':1,'parameter':'Tk4 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0E,'subid':0x42},# 0x00
					},
	0x0F :  {
						0x00 : {'offset':1284,'bit':7,'bits':16,'parameter':'Tk5 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x00},# 0x00
						0x01 : {'offset':1298,'bit':7,'bits':8,'parameter':'Tk5 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x01},# 0x00
						0x02 : {'offset':1289,'bit':7,'bits':8,'parameter':'Tk5 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x02},# 0x00
						0x03 : {'offset':1286,'bit':7,'bits':3,'parameter':'Tk5 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x03},# 0x00
						0x04 : {'offset':1286,'bit':4,'bits':5,'parameter':'Tk5 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x04},# 0x00
						0x05 : {'offset':1287,'bit':7,'bits':8,'parameter':'Tk5 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x05},# 0x00
						0x06 : {'offset':1288,'bit':7,'bits':8,'parameter':'Tk5 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x06},# 0x00
						0x07 : {'offset':1312,'bit':1,'bits':2,'parameter':'Tk5 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x07},# 0x00
						0x08 : {'offset':1312,'bit':3,'bits':2,'parameter':'Tk5 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x08},# 0x00
						0x09 : {'offset':1312,'bit':6,'bits':2,'parameter':'Tk5 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x09},# 0x00
						0x0A : {'offset':1313,'bit':7,'bits':8,'parameter':'Tk5 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x0A},# 0x00
						0x0B : {'offset':1291,'bit':7,'bits':8,'parameter':'Tk5 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x0B},# 0x00
						0x0C : {'offset':1292,'bit':7,'bits':16,'parameter':'Tk5 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x0C},# 0x00
						0x0D : {'offset':1290,'bit':7,'bits':8,'parameter':'Tk5 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x0D},# 0x00
						0x0E : {'offset':1294,'bit':7,'bits':8,'parameter':'Tk5 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x0E},# 0x00
						0x0F : {'offset':1296,'bit':3,'bits':4,'parameter':'Tk5 Delay Tempo Base','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x0F},# 0x00
						0x10 : {'offset':1296,'bit':7,'bits':1,'parameter':'Tk5 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x10},# 0x00
						0x11 : {'offset':1297,'bit':7,'bits':8,'parameter':'Tk5 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x11},# 0x00
						0x12 : {'offset':1311,'bit':5,'bits':1,'parameter':'Tk5 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x12},# 0x00
						0x13 : {'offset':1309,'bit':0,'bits':1,'parameter':'Tk5 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x13},# 0x00
						0x14 : {'offset':1309,'bit':1,'bits':1,'parameter':'Tk5 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x14},# 0x00
						0x15 : {'offset':1309,'bit':2,'bits':1,'parameter':'Tk5 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x15},# 0x00
						0x16 : {'offset':1309,'bit':3,'bits':1,'parameter':'Tk5 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x16},# 0x00
						0x17 : {'offset':1309,'bit':4,'bits':1,'parameter':'Tk5 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x17},# 0x00
						0x18 : {'offset':1309,'bit':5,'bits':1,'parameter':'Tk5 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x18},# 0x00
						0x19 : {'offset':1309,'bit':6,'bits':1,'parameter':'Tk5 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x19},# 0x00
						0x1A : {'offset':1309,'bit':7,'bits':1,'parameter':'Tk5 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x1A},# 0x00
						0x1B : {'offset':1310,'bit':0,'bits':1,'parameter':'Tk5 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x1B},# 0x00
						0x1C : {'offset':1310,'bit':1,'bits':1,'parameter':'Tk5 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x1C},# 0x00
						0x1D : {'offset':1310,'bit':2,'bits':1,'parameter':'Tk5 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x1D},# 0x00
						0x1E : {'offset':1310,'bit':3,'bits':1,'parameter':'Tk5 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x1E},# 0x00
						0x1F : {'offset':1310,'bit':4,'bits':1,'parameter':'Tk5 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x1F},# 0x00
						0x20 : {'offset':1310,'bit':5,'bits':1,'parameter':'Tk5 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x20},# 0x00
						0x21 : {'offset':1310,'bit':6,'bits':1,'parameter':'Tk5 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x21},# 0x00
						0x22 : {'offset':1310,'bit':7,'bits':1,'parameter':'Tk5 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x22},# 0x00
						0x23 : {'offset':1311,'bit':0,'bits':1,'parameter':'Tk5 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x23},# 0x00
						0x24 : {'offset':1311,'bit':1,'bits':1,'parameter':'Tk5 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x24},# 0x00
						0x25 : {'offset':1311,'bit':2,'bits':1,'parameter':'Tk5 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x25},# 0x00
						0x26 : {'offset':1311,'bit':3,'bits':1,'parameter':'Tk5 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x26},# 0x00
						0x27 : {'offset':1311,'bit':4,'bits':1,'parameter':'Tk5 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x27},# 0x00
						0x28 : {'offset':1311,'bit':7,'bits':1,'parameter':'Tk5 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x28},# 0x00
# 0x29
						0x2A : {'offset':1311,'bit':6,'bits':1,'parameter':'Tk5 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x2A},# 0x00
						0x2B : {'offset':1320,'bit':6,'bits':7,'parameter':'Tk5 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x2B},# 0x00
						0x2C : {'offset':1320,'bit':7,'bits':1,'parameter':'Tk5 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x2C},# 0x00
						0x2D : {'offset':1322,'bit':7,'bits':8,'parameter':'Tk5 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x2D},# 0x00
						0x2E : {'offset':1323,'bit':7,'bits':8,'parameter':'Tk5 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x2E},# 0x00
						0x2F : {'offset':1324,'bit':7,'bits':8,'parameter':'Tk5 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x2F},# 0x00
						0x30 : {'offset':1325,'bit':7,'bits':8,'parameter':'Tk5 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x30},# 0x00
						0x31 : {'offset':1314,'bit':7,'bits':8,'parameter':'Tk5 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x31},# 0x00
						0x32 : {'offset':1316,'bit':3,'bits':4,'parameter':'Tk5 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x32},# 0x00
						0x33 : {'offset':1316,'bit':7,'bits':4,'parameter':'Tk5 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x33},# 0x00
						0x34 : {'offset':1315,'bit':7,'bits':8,'parameter':'Tk5 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x34},# 0x00
						0x35 : {'offset':1317,'bit':7,'bits':8,'parameter':'Tk5 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x35},# 0x00
						0x36 : {'offset':1319,'bit':3,'bits':4,'parameter':'Tk5 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x36},# 0x00
						0x37 : {'offset':1319,'bit':7,'bits':4,'parameter':'Tk5 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x37},# 0x00
						0x38 : {'offset':1318,'bit':7,'bits':8,'parameter':'Tk5 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x38},# 0x00
						0x39 : {'offset':1306,'bit':4,'bits':5,'parameter':'Tk5 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x39},# 0x00
						0x3A : {'offset':1306,'bit':6,'bits':2,'parameter':'Tk5 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x3A},# 0x00
						0x3B : {'offset':1299,'bit':7,'bits':8,'parameter':'Tk5 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x3B},# 0x00
						0x3C : {'offset':1300,'bit':7,'bits':8,'parameter':'Tk5 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x3C},# 0x00
						0x3D : {'offset':1301,'bit':7,'bits':8,'parameter':'Tk5 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x3D},# 0x00
						0x3E : {'offset':1302,'bit':7,'bits':8,'parameter':'Tk5 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x3E},# 0x00
						0x3F : {'offset':1303,'bit':7,'bits':8,'parameter':'Tk5 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x3F},# 0x00
						0x40 : {'offset':1304,'bit':7,'bits':8,'parameter':'Tk5 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x40},# 0x00
						0x41 : {'offset':1305,'bit':7,'bits':8,'parameter':'Tk5 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x41},# 0x00
						0x42 : {'offset':1312,'bit':7,'bits':1,'parameter':'Tk5 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x0F,'subid':0x42},# 0x00
					},
	0x10 :  {
						0x00 : {'offset':1396,'bit':7,'bits':16,'parameter':'Tk6 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x00},# 0x00
						0x01 : {'offset':1410,'bit':7,'bits':8,'parameter':'Tk6 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x01},# 0x00
						0x02 : {'offset':1401,'bit':7,'bits':8,'parameter':'Tk6 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x02},# 0x00
						0x03 : {'offset':1398,'bit':7,'bits':3,'parameter':'Tk6 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x03},# 0x00
						0x04 : {'offset':1398,'bit':4,'bits':5,'parameter':'Tk6 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x04},# 0x00
						0x05 : {'offset':1399,'bit':7,'bits':8,'parameter':'Tk6 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x05},# 0x00
						0x06 : {'offset':1400,'bit':7,'bits':8,'parameter':'Tk6 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x06},# 0x00
						0x07 : {'offset':1424,'bit':1,'bits':2,'parameter':'Tk6 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x07},# 0x00
						0x08 : {'offset':1424,'bit':3,'bits':2,'parameter':'Tk6 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x08},# 0x00
						0x09 : {'offset':1424,'bit':6,'bits':2,'parameter':'Tk6 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x09},# 0x00
						0x0A : {'offset':1425,'bit':7,'bits':8,'parameter':'Tk6 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x0A},# 0x00
						0x0B : {'offset':1403,'bit':7,'bits':8,'parameter':'Tk6 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x0B},# 0x00
						0x0C : {'offset':1404,'bit':7,'bits':16,'parameter':'Tk6 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x0C},# 0x00
						0x0D : {'offset':1402,'bit':7,'bits':8,'parameter':'Tk6 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x0D},# 0x00
						0x0E : {'offset':1406,'bit':7,'bits':8,'parameter':'Tk6 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x0E},# 0x00
						0x0F : {'offset':1408,'bit':3,'bits':4,'parameter':'Tk6 Delay Tempo Base','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x0F},# 0x00
						0x10 : {'offset':1408,'bit':7,'bits':1,'parameter':'Tk6 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x10},# 0x00
						0x11 : {'offset':1409,'bit':7,'bits':8,'parameter':'Tk6 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x11},# 0x00
						0x12 : {'offset':1423,'bit':5,'bits':1,'parameter':'Tk6 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x12},# 0x00
						0x13 : {'offset':1421,'bit':0,'bits':1,'parameter':'Tk6 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x13},# 0x00
						0x14 : {'offset':1421,'bit':1,'bits':1,'parameter':'Tk6 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x14},# 0x00
						0x15 : {'offset':1421,'bit':2,'bits':1,'parameter':'Tk6 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x15},# 0x00
						0x16 : {'offset':1421,'bit':3,'bits':1,'parameter':'Tk6 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x16},# 0x00
						0x17 : {'offset':1421,'bit':4,'bits':1,'parameter':'Tk6 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x17},# 0x00
						0x18 : {'offset':1421,'bit':5,'bits':1,'parameter':'Tk6 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x18},# 0x00
						0x19 : {'offset':1421,'bit':6,'bits':1,'parameter':'Tk6 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x19},# 0x00
						0x1A : {'offset':1421,'bit':7,'bits':1,'parameter':'Tk6 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x1A},# 0x00
						0x1B : {'offset':1422,'bit':0,'bits':1,'parameter':'Tk6 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x1B},# 0x00
						0x1C : {'offset':1422,'bit':1,'bits':1,'parameter':'Tk6 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x1C},# 0x00
						0x1D : {'offset':1422,'bit':2,'bits':1,'parameter':'Tk6 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x1D},# 0x00
						0x1E : {'offset':1422,'bit':3,'bits':1,'parameter':'Tk6 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x1E},# 0x00
						0x1F : {'offset':1422,'bit':4,'bits':1,'parameter':'Tk6 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x1F},# 0x00
						0x20 : {'offset':1422,'bit':5,'bits':1,'parameter':'Tk6 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x20},# 0x00
						0x21 : {'offset':1422,'bit':6,'bits':1,'parameter':'Tk6 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x21},# 0x00
						0x22 : {'offset':1422,'bit':7,'bits':1,'parameter':'Tk6 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x22},# 0x00
						0x23 : {'offset':1423,'bit':0,'bits':1,'parameter':'Tk6 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x23},# 0x00
						0x24 : {'offset':1423,'bit':1,'bits':1,'parameter':'Tk6 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x24},# 0x00
						0x25 : {'offset':1423,'bit':2,'bits':1,'parameter':'Tk6 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x25},# 0x00
						0x26 : {'offset':1423,'bit':3,'bits':1,'parameter':'Tk6 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x26},# 0x00
						0x27 : {'offset':1423,'bit':4,'bits':1,'parameter':'Tk6 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x27},# 0x00
						0x28 : {'offset':1423,'bit':7,'bits':1,'parameter':'Tk6 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x28},# 0x00
# 0x29
						0x2A : {'offset':1423,'bit':6,'bits':1,'parameter':'Tk6 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x2A},# 0x00
						0x2B : {'offset':1432,'bit':6,'bits':7,'parameter':'Tk6 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x2B},# 0x00
						0x2C : {'offset':1432,'bit':7,'bits':1,'parameter':'Tk6 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x2C},# 0x00
						0x2D : {'offset':1434,'bit':7,'bits':8,'parameter':'Tk6 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x2D},# 0x00
						0x2E : {'offset':1435,'bit':7,'bits':8,'parameter':'Tk6 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x2E},# 0x00
						0x2F : {'offset':1436,'bit':7,'bits':8,'parameter':'Tk6 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x2F},# 0x00
						0x30 : {'offset':1437,'bit':7,'bits':8,'parameter':'Tk6 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x30},# 0x00
						0x31 : {'offset':1426,'bit':7,'bits':8,'parameter':'Tk6 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x31},# 0x00
						0x32 : {'offset':1428,'bit':3,'bits':4,'parameter':'Tk6 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x32},# 0x00
						0x33 : {'offset':1428,'bit':7,'bits':4,'parameter':'Tk6 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x33},# 0x00
						0x34 : {'offset':1427,'bit':7,'bits':8,'parameter':'Tk6 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x34},# 0x00
						0x35 : {'offset':1429,'bit':7,'bits':8,'parameter':'Tk6 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x35},# 0x00
						0x36 : {'offset':1431,'bit':3,'bits':4,'parameter':'Tk6 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x36},# 0x00
						0x37 : {'offset':1431,'bit':7,'bits':4,'parameter':'Tk6 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x37},# 0x00
						0x38 : {'offset':1430,'bit':7,'bits':8,'parameter':'Tk6 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x38},# 0x00
						0x39 : {'offset':1418,'bit':4,'bits':5,'parameter':'Tk6 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x39},# 0x00
						0x3A : {'offset':1418,'bit':6,'bits':2,'parameter':'Tk6 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x3A},# 0x00
						0x3B : {'offset':1411,'bit':7,'bits':8,'parameter':'Tk6 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x3B},# 0x00
						0x3C : {'offset':1412,'bit':7,'bits':8,'parameter':'Tk6 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x3C},# 0x00
						0x3D : {'offset':1413,'bit':7,'bits':8,'parameter':'Tk6 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x3D},# 0x00
						0x3E : {'offset':1414,'bit':7,'bits':8,'parameter':'Tk6 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x3E},# 0x00
						0x3F : {'offset':1415,'bit':7,'bits':8,'parameter':'Tk6 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x3F},# 0x00
						0x40 : {'offset':1416,'bit':7,'bits':8,'parameter':'Tk6 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x40},# 0x00
						0x41 : {'offset':1417,'bit':7,'bits':8,'parameter':'Tk6 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x41},# 0x00
						0x42 : {'offset':1424,'bit':7,'bits':1,'parameter':'Tk6 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x10,'subid':0x42},# 0x00
					},
	0x11 :  {
						0x00 : {'offset':1508,'bit':7,'bits':16,'parameter':'Tk7 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x00},# 0x00
						0x01 : {'offset':1522,'bit':7,'bits':8,'parameter':'Tk7 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x01},# 0x00
						0x02 : {'offset':1513,'bit':7,'bits':8,'parameter':'Tk7 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x02},# 0x00
						0x03 : {'offset':1510,'bit':7,'bits':3,'parameter':'Tk7 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x03},# 0x00
						0x04 : {'offset':1510,'bit':4,'bits':5,'parameter':'Tk7 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x04},# 0x00
						0x05 : {'offset':1511,'bit':7,'bits':8,'parameter':'Tk7 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x05},# 0x00
						0x06 : {'offset':1512,'bit':7,'bits':8,'parameter':'Tk7 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x06},# 0x00
						0x07 : {'offset':1536,'bit':1,'bits':2,'parameter':'Tk7 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x07},# 0x00
						0x08 : {'offset':1536,'bit':3,'bits':2,'parameter':'Tk7 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x08},# 0x00
						0x09 : {'offset':1536,'bit':6,'bits':2,'parameter':'Tk7 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x09},# 0x00
						0x0A : {'offset':1537,'bit':7,'bits':8,'parameter':'Tk7 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x0A},# 0x00
						0x0B : {'offset':1515,'bit':7,'bits':8,'parameter':'Tk7 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x0B},# 0x00
						0x0C : {'offset':1516,'bit':7,'bits':16,'parameter':'Tk7 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x0C},# 0x00
						0x0D : {'offset':1514,'bit':7,'bits':8,'parameter':'Tk7 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x0D},# 0x00
						0x0E : {'offset':1518,'bit':7,'bits':8,'parameter':'Tk7 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x0E},# 0x00
						0x0F : {'offset':1520,'bit':3,'bits':4,'parameter':'Tk7 Delay Tempo Base','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x0F},# 0x00
						0x10 : {'offset':1520,'bit':7,'bits':1,'parameter':'Tk7 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x10},# 0x00
						0x11 : {'offset':1521,'bit':7,'bits':8,'parameter':'Tk7 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x11},# 0x00
						0x12 : {'offset':1535,'bit':5,'bits':1,'parameter':'Tk7 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x12},# 0x00
						0x13 : {'offset':1533,'bit':0,'bits':1,'parameter':'Tk7 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x13},# 0x00
						0x14 : {'offset':1533,'bit':1,'bits':1,'parameter':'Tk7 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x14},# 0x00
						0x15 : {'offset':1533,'bit':2,'bits':1,'parameter':'Tk7 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x15},# 0x00
						0x16 : {'offset':1533,'bit':3,'bits':1,'parameter':'Tk7 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x16},# 0x00
						0x17 : {'offset':1533,'bit':4,'bits':1,'parameter':'Tk7 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x17},# 0x00
						0x18 : {'offset':1533,'bit':5,'bits':1,'parameter':'Tk7 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x18},# 0x00
						0x19 : {'offset':1533,'bit':6,'bits':1,'parameter':'Tk7 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x19},# 0x00
						0x1A : {'offset':1533,'bit':7,'bits':1,'parameter':'Tk7 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x1A},# 0x00
						0x1B : {'offset':1534,'bit':0,'bits':1,'parameter':'Tk7 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x1B},# 0x00
						0x1C : {'offset':1534,'bit':1,'bits':1,'parameter':'Tk7 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x1C},# 0x00
						0x1D : {'offset':1534,'bit':2,'bits':1,'parameter':'Tk7 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x1D},# 0x00
						0x1E : {'offset':1534,'bit':3,'bits':1,'parameter':'Tk7 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x1E},# 0x00
						0x1F : {'offset':1534,'bit':4,'bits':1,'parameter':'Tk7 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x1F},# 0x00
						0x20 : {'offset':1534,'bit':5,'bits':1,'parameter':'Tk7 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x20},# 0x00
						0x21 : {'offset':1534,'bit':6,'bits':1,'parameter':'Tk7 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x21},# 0x00
						0x22 : {'offset':1534,'bit':7,'bits':1,'parameter':'Tk7 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x22},# 0x00
						0x23 : {'offset':1535,'bit':0,'bits':1,'parameter':'Tk7 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x23},# 0x00
						0x24 : {'offset':1535,'bit':1,'bits':1,'parameter':'Tk7 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x24},# 0x00
						0x25 : {'offset':1535,'bit':2,'bits':1,'parameter':'Tk7 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x25},# 0x00
						0x26 : {'offset':1535,'bit':3,'bits':1,'parameter':'Tk7 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x26},# 0x00
						0x27 : {'offset':1535,'bit':4,'bits':1,'parameter':'Tk7 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x27},# 0x00
						0x28 : {'offset':1535,'bit':7,'bits':1,'parameter':'Tk7 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x28},# 0x00
# 0x29
						0x2A : {'offset':1535,'bit':6,'bits':1,'parameter':'Tk7 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x2A},# 0x00
						0x2B : {'offset':1544,'bit':6,'bits':7,'parameter':'Tk7 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x2B},# 0x00
						0x2C : {'offset':1544,'bit':7,'bits':1,'parameter':'Tk7 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x2C},# 0x00
						0x2D : {'offset':1546,'bit':7,'bits':8,'parameter':'Tk7 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x2D},# 0x00
						0x2E : {'offset':1547,'bit':7,'bits':8,'parameter':'Tk7 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x2E},# 0x00
						0x2F : {'offset':1548,'bit':7,'bits':8,'parameter':'Tk7 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x2F},# 0x00
						0x30 : {'offset':1549,'bit':7,'bits':8,'parameter':'Tk7 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x30},# 0x00
						0x31 : {'offset':1538,'bit':7,'bits':8,'parameter':'Tk7 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x31},# 0x00
						0x32 : {'offset':1540,'bit':3,'bits':4,'parameter':'Tk7 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x32},# 0x00
						0x33 : {'offset':1540,'bit':7,'bits':4,'parameter':'Tk7 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x33},# 0x00
						0x34 : {'offset':1539,'bit':7,'bits':8,'parameter':'Tk7 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x34},# 0x00
						0x35 : {'offset':1541,'bit':7,'bits':8,'parameter':'Tk7 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x35},# 0x00
						0x36 : {'offset':1543,'bit':3,'bits':4,'parameter':'Tk7 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x36},# 0x00
						0x37 : {'offset':1543,'bit':7,'bits':4,'parameter':'Tk7 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x37},# 0x00
						0x38 : {'offset':1542,'bit':7,'bits':8,'parameter':'Tk7 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x38},# 0x00
						0x39 : {'offset':1530,'bit':4,'bits':5,'parameter':'Tk7 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x39},# 0x00
						0x3A : {'offset':1530,'bit':6,'bits':2,'parameter':'Tk7 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x3A},# 0x00
						0x3B : {'offset':1523,'bit':7,'bits':8,'parameter':'Tk7 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x3B},# 0x00
						0x3C : {'offset':1524,'bit':7,'bits':8,'parameter':'Tk7 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x3C},# 0x00
						0x3D : {'offset':1525,'bit':7,'bits':8,'parameter':'Tk7 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x3D},# 0x00
						0x3E : {'offset':1526,'bit':7,'bits':8,'parameter':'Tk7 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x3E},# 0x00
						0x3F : {'offset':1527,'bit':7,'bits':8,'parameter':'Tk7 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x3F},# 0x00
						0x40 : {'offset':1528,'bit':7,'bits':8,'parameter':'Tk7 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x40},# 0x00
						0x41 : {'offset':1529,'bit':7,'bits':8,'parameter':'Tk7 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x41},# 0x00
						0x42 : {'offset':1536,'bit':7,'bits':1,'parameter':'Tk7 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x11,'subid':0x42},# 0x00
					},
	0x12 :  {
						0x00 : {'offset':1620,'bit':7,'bits':16,'parameter':'Tk8 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x00},# 0x00
						0x01 : {'offset':1634,'bit':7,'bits':8,'parameter':'Tk8 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x01},# 0x00
						0x02 : {'offset':1625,'bit':7,'bits':8,'parameter':'Tk8 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x02},# 0x00
						0x03 : {'offset':1622,'bit':7,'bits':3,'parameter':'Tk8 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x03},# 0x00
						0x04 : {'offset':1622,'bit':4,'bits':5,'parameter':'Tk8 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x04},# 0x00
						0x05 : {'offset':1623,'bit':7,'bits':8,'parameter':'Tk8 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x05},# 0x00
						0x06 : {'offset':1624,'bit':7,'bits':8,'parameter':'Tk8 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x06},# 0x00
						0x07 : {'offset':1648,'bit':1,'bits':2,'parameter':'Tk8 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x07},# 0x00
						0x08 : {'offset':1648,'bit':3,'bits':2,'parameter':'Tk8 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x08},# 0x00
						0x09 : {'offset':1648,'bit':6,'bits':2,'parameter':'Tk8 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x09},# 0x00
						0x0A : {'offset':1649,'bit':7,'bits':8,'parameter':'Tk8 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x0A},# 0x00
						0x0B : {'offset':1627,'bit':7,'bits':8,'parameter':'Tk8 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x0B},# 0x00
						0x0C : {'offset':1628,'bit':7,'bits':16,'parameter':'Tk8 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x0C},# 0x00
						0x0D : {'offset':1626,'bit':7,'bits':8,'parameter':'Tk8 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x0D},# 0x00
						0x0E : {'offset':1630,'bit':7,'bits':8,'parameter':'Tk8 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x0E},# 0x00
						0x0F : {'offset':1632,'bit':3,'bits':4,'parameter':'Tk8 Delay Tempo Base','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x0F},# 0x00
						0x10 : {'offset':1632,'bit':7,'bits':1,'parameter':'Tk8 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x10},# 0x00
						0x11 : {'offset':1633,'bit':7,'bits':8,'parameter':'Tk8 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x11},# 0x00
						0x12 : {'offset':1647,'bit':5,'bits':1,'parameter':'Tk8 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x12},# 0x00
						0x13 : {'offset':1645,'bit':0,'bits':1,'parameter':'Tk8 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x13},# 0x00
						0x14 : {'offset':1645,'bit':1,'bits':1,'parameter':'Tk8 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x14},# 0x00
						0x15 : {'offset':1645,'bit':2,'bits':1,'parameter':'Tk8 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x15},# 0x00
						0x16 : {'offset':1645,'bit':3,'bits':1,'parameter':'Tk8 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x16},# 0x00
						0x17 : {'offset':1645,'bit':4,'bits':1,'parameter':'Tk8 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x17},# 0x00
						0x18 : {'offset':1645,'bit':5,'bits':1,'parameter':'Tk8 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x18},# 0x00
						0x19 : {'offset':1645,'bit':6,'bits':1,'parameter':'Tk8 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x19},# 0x00
						0x1A : {'offset':1645,'bit':7,'bits':1,'parameter':'Tk8 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x1A},# 0x00
						0x1B : {'offset':1646,'bit':0,'bits':1,'parameter':'Tk8 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x1B},# 0x00
						0x1C : {'offset':1646,'bit':1,'bits':1,'parameter':'Tk8 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x1C},# 0x00
						0x1D : {'offset':1646,'bit':2,'bits':1,'parameter':'Tk8 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x1D},# 0x00
						0x1E : {'offset':1646,'bit':3,'bits':1,'parameter':'Tk8 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x1E},# 0x00
						0x1F : {'offset':1646,'bit':4,'bits':1,'parameter':'Tk8 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x1F},# 0x00
						0x20 : {'offset':1646,'bit':5,'bits':1,'parameter':'Tk8 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x20},# 0x00
						0x21 : {'offset':1646,'bit':6,'bits':1,'parameter':'Tk8 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x21},# 0x00
						0x22 : {'offset':1646,'bit':7,'bits':1,'parameter':'Tk8 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x22},# 0x00
						0x23 : {'offset':1647,'bit':0,'bits':1,'parameter':'Tk8 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x23},# 0x00
						0x24 : {'offset':1647,'bit':1,'bits':1,'parameter':'Tk8 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x24},# 0x00
						0x25 : {'offset':1647,'bit':2,'bits':1,'parameter':'Tk8 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x25},# 0x00
						0x26 : {'offset':1647,'bit':3,'bits':1,'parameter':'Tk8 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x26},# 0x00
						0x27 : {'offset':1647,'bit':4,'bits':1,'parameter':'Tk8 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x27},# 0x00
						0x28 : {'offset':1647,'bit':7,'bits':1,'parameter':'Tk8 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x28},# 0x00
# 0x29
						0x2A : {'offset':1647,'bit':6,'bits':1,'parameter':'Tk8 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x2A},# 0x00
						0x2B : {'offset':1656,'bit':6,'bits':7,'parameter':'Tk8 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x2B},# 0x00
						0x2C : {'offset':1656,'bit':7,'bits':1,'parameter':'Tk8 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x2C},# 0x00
						0x2D : {'offset':1658,'bit':7,'bits':8,'parameter':'Tk8 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x2D},# 0x00
						0x2E : {'offset':1659,'bit':7,'bits':8,'parameter':'Tk8 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x2E},# 0x00
						0x2F : {'offset':1660,'bit':7,'bits':8,'parameter':'Tk8 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x2F},# 0x00
						0x30 : {'offset':1661,'bit':7,'bits':8,'parameter':'Tk8 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x30},# 0x00
						0x31 : {'offset':1650,'bit':7,'bits':8,'parameter':'Tk8 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x31},# 0x00
						0x32 : {'offset':1652,'bit':3,'bits':4,'parameter':'Tk8 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x32},# 0x00
						0x33 : {'offset':1652,'bit':7,'bits':4,'parameter':'Tk8 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x33},# 0x00
						0x34 : {'offset':1651,'bit':7,'bits':8,'parameter':'Tk8 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x34},# 0x00
						0x35 : {'offset':1653,'bit':7,'bits':8,'parameter':'Tk8 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x35},# 0x00
						0x36 : {'offset':1655,'bit':3,'bits':4,'parameter':'Tk8 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x36},# 0x00
						0x37 : {'offset':1655,'bit':7,'bits':4,'parameter':'Tk8 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x37},# 0x00
						0x38 : {'offset':1654,'bit':7,'bits':8,'parameter':'Tk8 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x38},# 0x00
						0x39 : {'offset':1642,'bit':4,'bits':5,'parameter':'Tk8 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x39},# 0x00
						0x3A : {'offset':1642,'bit':6,'bits':2,'parameter':'Tk8 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x3A},# 0x00
						0x3B : {'offset':1635,'bit':7,'bits':8,'parameter':'Tk8 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x3B},# 0x00
						0x3C : {'offset':1636,'bit':7,'bits':8,'parameter':'Tk8 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x3C},# 0x00
						0x3D : {'offset':1637,'bit':7,'bits':8,'parameter':'Tk8 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x3D},# 0x00
						0x3E : {'offset':1638,'bit':7,'bits':8,'parameter':'Tk8 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x3E},# 0x00
						0x3F : {'offset':1639,'bit':7,'bits':8,'parameter':'Tk8 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x3F},# 0x00
						0x40 : {'offset':1640,'bit':7,'bits':8,'parameter':'Tk8 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x40},# 0x00
						0x41 : {'offset':1641,'bit':7,'bits':8,'parameter':'Tk8 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x41},# 0x00
						0x42 : {'offset':1648,'bit':7,'bits':1,'parameter':'Tk8 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x12,'subid':0x42},# 0x00
					},
	0x13 :  {
						0x00 : {'offset':1732,'bit':7,'bits':16,'parameter':'Tk9 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x00},# 0x00
						0x01 : {'offset':1746,'bit':7,'bits':8,'parameter':'Tk9 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x01},# 0x00
						0x02 : {'offset':1737,'bit':7,'bits':8,'parameter':'Tk9 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x02},# 0x00
						0x03 : {'offset':1734,'bit':7,'bits':3,'parameter':'Tk9 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x03},# 0x00
						0x04 : {'offset':1734,'bit':4,'bits':5,'parameter':'Tk9 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x04},# 0x00
						0x05 : {'offset':1735,'bit':7,'bits':8,'parameter':'Tk9 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x05},# 0x00
						0x06 : {'offset':1736,'bit':7,'bits':8,'parameter':'Tk9 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x06},# 0x00
						0x07 : {'offset':1760,'bit':1,'bits':2,'parameter':'Tk9 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x07},# 0x00
						0x08 : {'offset':1760,'bit':3,'bits':2,'parameter':'Tk9 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x08},# 0x00
						0x09 : {'offset':1760,'bit':6,'bits':2,'parameter':'Tk9 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x09},# 0x00
						0x0A : {'offset':1761,'bit':7,'bits':8,'parameter':'Tk9 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x0A},# 0x00
						0x0B : {'offset':1739,'bit':7,'bits':8,'parameter':'Tk9 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x0B},# 0x00
						0x0C : {'offset':1740,'bit':7,'bits':16,'parameter':'Tk9 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x0C},# 0x00
						0x0D : {'offset':1738,'bit':7,'bits':8,'parameter':'Tk9 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x0D},# 0x00
						0x0E : {'offset':1742,'bit':7,'bits':8,'parameter':'Tk9 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x0E},# 0x00
						0x0F : {'offset':1744,'bit':3,'bits':4,'parameter':'Tk9 Delay Tempo Base','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x0F},# 0x00
						0x10 : {'offset':1744,'bit':7,'bits':1,'parameter':'Tk9 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x10},# 0x00
						0x11 : {'offset':1745,'bit':7,'bits':8,'parameter':'Tk9 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x11},# 0x00
						0x12 : {'offset':1759,'bit':5,'bits':1,'parameter':'Tk9 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x12},# 0x00
						0x13 : {'offset':1757,'bit':0,'bits':1,'parameter':'Tk9 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x13},# 0x00
						0x14 : {'offset':1757,'bit':1,'bits':1,'parameter':'Tk9 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x14},# 0x00
						0x15 : {'offset':1757,'bit':2,'bits':1,'parameter':'Tk9 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x15},# 0x00
						0x16 : {'offset':1757,'bit':3,'bits':1,'parameter':'Tk9 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x16},# 0x00
						0x17 : {'offset':1757,'bit':4,'bits':1,'parameter':'Tk9 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x17},# 0x00
						0x18 : {'offset':1757,'bit':5,'bits':1,'parameter':'Tk9 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x18},# 0x00
						0x19 : {'offset':1757,'bit':6,'bits':1,'parameter':'Tk9 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x19},# 0x00
						0x1A : {'offset':1757,'bit':7,'bits':1,'parameter':'Tk9 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x1A},# 0x00
						0x1B : {'offset':1758,'bit':0,'bits':1,'parameter':'Tk9 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x1B},# 0x00
						0x1C : {'offset':1758,'bit':1,'bits':1,'parameter':'Tk9 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x1C},# 0x00
						0x1D : {'offset':1758,'bit':2,'bits':1,'parameter':'Tk9 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x1D},# 0x00
						0x1E : {'offset':1758,'bit':3,'bits':1,'parameter':'Tk9 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x1E},# 0x00
						0x1F : {'offset':1758,'bit':4,'bits':1,'parameter':'Tk9 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x1F},# 0x00
						0x20 : {'offset':1758,'bit':5,'bits':1,'parameter':'Tk9 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x20},# 0x00
						0x21 : {'offset':1758,'bit':6,'bits':1,'parameter':'Tk9 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x21},# 0x00
						0x22 : {'offset':1758,'bit':7,'bits':1,'parameter':'Tk9 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x22},# 0x00
						0x23 : {'offset':1759,'bit':0,'bits':1,'parameter':'Tk9 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x23},# 0x00
						0x24 : {'offset':1759,'bit':1,'bits':1,'parameter':'Tk9 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x24},# 0x00
						0x25 : {'offset':1759,'bit':2,'bits':1,'parameter':'Tk9 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x25},# 0x00
						0x26 : {'offset':1759,'bit':3,'bits':1,'parameter':'Tk9 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x26},# 0x00
						0x27 : {'offset':1759,'bit':4,'bits':1,'parameter':'Tk9 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x27},# 0x00
						0x28 : {'offset':1759,'bit':7,'bits':1,'parameter':'Tk9 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x28},# 0x00
# 0x29
						0x2A : {'offset':1759,'bit':6,'bits':1,'parameter':'Tk9 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x2A},# 0x00
						0x2B : {'offset':1768,'bit':6,'bits':7,'parameter':'Tk9 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x2B},# 0x00
						0x2C : {'offset':1768,'bit':7,'bits':1,'parameter':'Tk9 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x2C},# 0x00
						0x2D : {'offset':1770,'bit':7,'bits':8,'parameter':'Tk9 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x2D},# 0x00
						0x2E : {'offset':1771,'bit':7,'bits':8,'parameter':'Tk9 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x2E},# 0x00
						0x2F : {'offset':1772,'bit':7,'bits':8,'parameter':'Tk9 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x2F},# 0x00
						0x30 : {'offset':1773,'bit':7,'bits':8,'parameter':'Tk9 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x30},# 0x00
						0x31 : {'offset':1762,'bit':7,'bits':8,'parameter':'Tk9 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x31},# 0x00
						0x32 : {'offset':1764,'bit':3,'bits':4,'parameter':'Tk9 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x32},# 0x00
						0x33 : {'offset':1764,'bit':7,'bits':4,'parameter':'Tk9 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x33},# 0x00
						0x34 : {'offset':1763,'bit':7,'bits':8,'parameter':'Tk9 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x34},# 0x00
						0x35 : {'offset':1765,'bit':7,'bits':8,'parameter':'Tk9 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x35},# 0x00
						0x36 : {'offset':1767,'bit':3,'bits':4,'parameter':'Tk9 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x36},# 0x00
						0x37 : {'offset':1767,'bit':7,'bits':4,'parameter':'Tk9 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x37},# 0x00
						0x38 : {'offset':1766,'bit':7,'bits':8,'parameter':'Tk9 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x38},# 0x00
						0x39 : {'offset':1754,'bit':4,'bits':5,'parameter':'Tk9 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x39},# 0x00
						0x3A : {'offset':1754,'bit':6,'bits':2,'parameter':'Tk9 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x3A},# 0x00
						0x3B : {'offset':1747,'bit':7,'bits':8,'parameter':'Tk9 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x3B},# 0x00
						0x3C : {'offset':1748,'bit':7,'bits':8,'parameter':'Tk9 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x3C},# 0x00
						0x3D : {'offset':1749,'bit':7,'bits':8,'parameter':'Tk9 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x3D},# 0x00
						0x3E : {'offset':1750,'bit':7,'bits':8,'parameter':'Tk9 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x3E},# 0x00
						0x3F : {'offset':1751,'bit':7,'bits':8,'parameter':'Tk9 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x3F},# 0x00
						0x40 : {'offset':1752,'bit':7,'bits':8,'parameter':'Tk9 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x40},# 0x00
						0x41 : {'offset':1753,'bit':7,'bits':8,'parameter':'Tk9 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x41},# 0x00
						0x42 : {'offset':1760,'bit':7,'bits':1,'parameter':'Tk9 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x13,'subid':0x42},# 0x00
					},
	0x14 :  {
						0x00 : {'offset':1844,'bit':7,'bits':16,'parameter':'Tk10 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x00},# 0x00
						0x01 : {'offset':1858,'bit':7,'bits':8,'parameter':'Tk10 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x01},# 0x00
						0x02 : {'offset':1849,'bit':7,'bits':8,'parameter':'Tk10 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x02},# 0x00
						0x03 : {'offset':1846,'bit':7,'bits':3,'parameter':'Tk10 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x03},# 0x00
						0x04 : {'offset':1846,'bit':4,'bits':5,'parameter':'Tk10 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x04},# 0x00
						0x05 : {'offset':1847,'bit':7,'bits':8,'parameter':'Tk10 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x05},# 0x00
						0x06 : {'offset':1848,'bit':7,'bits':8,'parameter':'Tk10 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x06},# 0x00
						0x07 : {'offset':1872,'bit':1,'bits':2,'parameter':'Tk10 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x07},# 0x00
						0x08 : {'offset':1872,'bit':3,'bits':2,'parameter':'Tk10 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x08},# 0x00
						0x09 : {'offset':1872,'bit':6,'bits':2,'parameter':'Tk10 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x09},# 0x00
						0x0A : {'offset':1873,'bit':7,'bits':8,'parameter':'Tk10 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x0A},# 0x00
						0x0B : {'offset':1851,'bit':7,'bits':8,'parameter':'Tk10 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x0B},# 0x00
						0x0C : {'offset':1852,'bit':7,'bits':16,'parameter':'Tk10 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x0C},# 0x00
						0x0D : {'offset':1850,'bit':7,'bits':8,'parameter':'Tk10 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x0D},# 0x00
						0x0E : {'offset':1854,'bit':7,'bits':8,'parameter':'Tk10 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x0E},# 0x00
						0x0F : {'offset':1856,'bit':3,'bits':4,'parameter':'Tk10 Delay Tempo Base','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x0F},# 0x00
						0x10 : {'offset':1856,'bit':7,'bits':1,'parameter':'Tk10 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x10},# 0x00
						0x11 : {'offset':1857,'bit':7,'bits':8,'parameter':'Tk10 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x11},# 0x00
						0x12 : {'offset':1871,'bit':5,'bits':1,'parameter':'Tk10 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x12},# 0x00
						0x13 : {'offset':1869,'bit':0,'bits':1,'parameter':'Tk10 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x13},# 0x00
						0x14 : {'offset':1869,'bit':1,'bits':1,'parameter':'Tk10 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x14},# 0x00
						0x15 : {'offset':1869,'bit':2,'bits':1,'parameter':'Tk10 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x15},# 0x00
						0x16 : {'offset':1869,'bit':3,'bits':1,'parameter':'Tk10 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x16},# 0x00
						0x17 : {'offset':1869,'bit':4,'bits':1,'parameter':'Tk10 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x17},# 0x00
						0x18 : {'offset':1869,'bit':5,'bits':1,'parameter':'Tk10 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x18},# 0x00
						0x19 : {'offset':1869,'bit':6,'bits':1,'parameter':'Tk10 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x19},# 0x00
						0x1A : {'offset':1869,'bit':7,'bits':1,'parameter':'Tk10 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x1A},# 0x00
						0x1B : {'offset':1870,'bit':0,'bits':1,'parameter':'Tk10 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x1B},# 0x00
						0x1C : {'offset':1870,'bit':1,'bits':1,'parameter':'Tk10 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x1C},# 0x00
						0x1D : {'offset':1870,'bit':2,'bits':1,'parameter':'Tk10 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x1D},# 0x00
						0x1E : {'offset':1870,'bit':3,'bits':1,'parameter':'Tk10 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x1E},# 0x00
						0x1F : {'offset':1870,'bit':4,'bits':1,'parameter':'Tk10 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x1F},# 0x00
						0x20 : {'offset':1870,'bit':5,'bits':1,'parameter':'Tk10 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x20},# 0x00
						0x21 : {'offset':1870,'bit':6,'bits':1,'parameter':'Tk10 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x21},# 0x00
						0x22 : {'offset':1870,'bit':7,'bits':1,'parameter':'Tk10 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x22},# 0x00
						0x23 : {'offset':1871,'bit':0,'bits':1,'parameter':'Tk10 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x23},# 0x00
						0x24 : {'offset':1871,'bit':1,'bits':1,'parameter':'Tk10 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x24},# 0x00
						0x25 : {'offset':1871,'bit':2,'bits':1,'parameter':'Tk10 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x25},# 0x00
						0x26 : {'offset':1871,'bit':3,'bits':1,'parameter':'Tk10 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x26},# 0x00
						0x27 : {'offset':1871,'bit':4,'bits':1,'parameter':'Tk10 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x27},# 0x00
						0x28 : {'offset':1871,'bit':7,'bits':1,'parameter':'Tk10 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x28},# 0x00
# 0x29
						0x2A : {'offset':1871,'bit':6,'bits':1,'parameter':'Tk10 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x2A},# 0x00
						0x2B : {'offset':1880,'bit':6,'bits':7,'parameter':'Tk10 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x2B},# 0x00
						0x2C : {'offset':1880,'bit':7,'bits':1,'parameter':'Tk10 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x2C},# 0x00
						0x2D : {'offset':1882,'bit':7,'bits':8,'parameter':'Tk10 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x2D},# 0x00
						0x2E : {'offset':1883,'bit':7,'bits':8,'parameter':'Tk10 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x2E},# 0x00
						0x2F : {'offset':1884,'bit':7,'bits':8,'parameter':'Tk10 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x2F},# 0x00
						0x30 : {'offset':1885,'bit':7,'bits':8,'parameter':'Tk10 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x30},# 0x00
						0x31 : {'offset':1874,'bit':7,'bits':8,'parameter':'Tk10 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x31},# 0x00
						0x32 : {'offset':1876,'bit':3,'bits':4,'parameter':'Tk10 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x32},# 0x00
						0x33 : {'offset':1876,'bit':7,'bits':4,'parameter':'Tk10 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x33},# 0x00
						0x34 : {'offset':1875,'bit':7,'bits':8,'parameter':'Tk10 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x34},# 0x00
						0x35 : {'offset':1877,'bit':7,'bits':8,'parameter':'Tk10 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x35},# 0x00
						0x36 : {'offset':1879,'bit':3,'bits':4,'parameter':'Tk10 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x36},# 0x00
						0x37 : {'offset':1879,'bit':7,'bits':4,'parameter':'Tk10 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x37},# 0x00
						0x38 : {'offset':1878,'bit':7,'bits':8,'parameter':'Tk10 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x38},# 0x00
						0x39 : {'offset':1866,'bit':4,'bits':5,'parameter':'Tk10 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x39},# 0x00
						0x3A : {'offset':1866,'bit':6,'bits':2,'parameter':'Tk10 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x3A},# 0x00
						0x3B : {'offset':1859,'bit':7,'bits':8,'parameter':'Tk10 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x3B},# 0x00
						0x3C : {'offset':1860,'bit':7,'bits':8,'parameter':'Tk10 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x3C},# 0x00
						0x3D : {'offset':1861,'bit':7,'bits':8,'parameter':'Tk10 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x3D},# 0x00
						0x3E : {'offset':1862,'bit':7,'bits':8,'parameter':'Tk10 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x3E},# 0x00
						0x3F : {'offset':1863,'bit':7,'bits':8,'parameter':'Tk10 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x3F},# 0x00
						0x40 : {'offset':1864,'bit':7,'bits':8,'parameter':'Tk10 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x40},# 0x00
						0x41 : {'offset':1865,'bit':7,'bits':8,'parameter':'Tk10 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x41},# 0x00
						0x42 : {'offset':1872,'bit':7,'bits':1,'parameter':'Tk10 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x14,'subid':0x42},# 0x00
					},
	0x15 :  {
						0x00 : {'offset':1956,'bit':7,'bits':16,'parameter':'Tk11 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x00},# 0x00
						0x01 : {'offset':1970,'bit':7,'bits':8,'parameter':'Tk11 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x01},# 0x00
						0x02 : {'offset':1961,'bit':7,'bits':8,'parameter':'Tk11 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x02},# 0x00
						0x03 : {'offset':1958,'bit':7,'bits':3,'parameter':'Tk11 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x03},# 0x00
						0x04 : {'offset':1958,'bit':4,'bits':5,'parameter':'Tk11 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x04},# 0x00
						0x05 : {'offset':1959,'bit':7,'bits':8,'parameter':'Tk11 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x05},# 0x00
						0x06 : {'offset':1960,'bit':7,'bits':8,'parameter':'Tk11 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x06},# 0x00
						0x07 : {'offset':1984,'bit':1,'bits':2,'parameter':'Tk11 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x07},# 0x00
						0x08 : {'offset':1984,'bit':3,'bits':2,'parameter':'Tk11 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x08},# 0x00
						0x09 : {'offset':1984,'bit':6,'bits':2,'parameter':'Tk11 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x09},# 0x00
						0x0A : {'offset':1985,'bit':7,'bits':8,'parameter':'Tk11 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x0A},# 0x00
						0x0B : {'offset':1963,'bit':7,'bits':8,'parameter':'Tk11 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x0B},# 0x00
						0x0C : {'offset':1964,'bit':7,'bits':16,'parameter':'Tk11 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x0C},# 0x00
						0x0D : {'offset':1962,'bit':7,'bits':8,'parameter':'Tk11 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x0D},# 0x00
						0x0E : {'offset':1966,'bit':7,'bits':8,'parameter':'Tk11 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x0E},# 0x00
						0x0F : {'offset':1968,'bit':3,'bits':4,'parameter':'Tk11 Delay Tempo Base','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x0F},# 0x00
						0x10 : {'offset':1968,'bit':7,'bits':1,'parameter':'Tk11 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x10},# 0x00
						0x11 : {'offset':1969,'bit':7,'bits':8,'parameter':'Tk11 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x11},# 0x00
						0x12 : {'offset':1983,'bit':5,'bits':1,'parameter':'Tk11 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x12},# 0x00
						0x13 : {'offset':1981,'bit':0,'bits':1,'parameter':'Tk11 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x13},# 0x00
						0x14 : {'offset':1981,'bit':1,'bits':1,'parameter':'Tk11 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x14},# 0x00
						0x15 : {'offset':1981,'bit':2,'bits':1,'parameter':'Tk11 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x15},# 0x00
						0x16 : {'offset':1981,'bit':3,'bits':1,'parameter':'Tk11 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x16},# 0x00
						0x17 : {'offset':1981,'bit':4,'bits':1,'parameter':'Tk11 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x17},# 0x00
						0x18 : {'offset':1981,'bit':5,'bits':1,'parameter':'Tk11 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x18},# 0x00
						0x19 : {'offset':1981,'bit':6,'bits':1,'parameter':'Tk11 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x19},# 0x00
						0x1A : {'offset':1981,'bit':7,'bits':1,'parameter':'Tk11 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x1A},# 0x00
						0x1B : {'offset':1982,'bit':0,'bits':1,'parameter':'Tk11 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x1B},# 0x00
						0x1C : {'offset':1982,'bit':1,'bits':1,'parameter':'Tk11 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x1C},# 0x00
						0x1D : {'offset':1982,'bit':2,'bits':1,'parameter':'Tk11 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x1D},# 0x00
						0x1E : {'offset':1982,'bit':3,'bits':1,'parameter':'Tk11 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x1E},# 0x00
						0x1F : {'offset':1982,'bit':4,'bits':1,'parameter':'Tk11 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x1F},# 0x00
						0x20 : {'offset':1982,'bit':5,'bits':1,'parameter':'Tk11 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x20},# 0x00
						0x21 : {'offset':1982,'bit':6,'bits':1,'parameter':'Tk11 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x21},# 0x00
						0x22 : {'offset':1982,'bit':7,'bits':1,'parameter':'Tk11 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x22},# 0x00
						0x23 : {'offset':1983,'bit':0,'bits':1,'parameter':'Tk11 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x23},# 0x00
						0x24 : {'offset':1983,'bit':1,'bits':1,'parameter':'Tk11 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x24},# 0x00
						0x25 : {'offset':1983,'bit':2,'bits':1,'parameter':'Tk11 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x25},# 0x00
						0x26 : {'offset':1983,'bit':3,'bits':1,'parameter':'Tk11 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x26},# 0x00
						0x27 : {'offset':1983,'bit':4,'bits':1,'parameter':'Tk11 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x27},# 0x00
						0x28 : {'offset':1983,'bit':7,'bits':1,'parameter':'Tk11 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x28},# 0x00
# 0x29
						0x2A : {'offset':1983,'bit':6,'bits':1,'parameter':'Tk11 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x2A},# 0x00
						0x2B : {'offset':1992,'bit':6,'bits':7,'parameter':'Tk11 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x2B},# 0x00
						0x2C : {'offset':1992,'bit':7,'bits':1,'parameter':'Tk11 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x2C},# 0x00
						0x2D : {'offset':1994,'bit':7,'bits':8,'parameter':'Tk11 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x2D},# 0x00
						0x2E : {'offset':1995,'bit':7,'bits':8,'parameter':'Tk11 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x2E},# 0x00
						0x2F : {'offset':1996,'bit':7,'bits':8,'parameter':'Tk11 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x2F},# 0x00
						0x30 : {'offset':1997,'bit':7,'bits':8,'parameter':'Tk11 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x30},# 0x00
						0x31 : {'offset':1986,'bit':7,'bits':8,'parameter':'Tk11 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x31},# 0x00
						0x32 : {'offset':1988,'bit':3,'bits':4,'parameter':'Tk11 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x32},# 0x00
						0x33 : {'offset':1988,'bit':7,'bits':4,'parameter':'Tk11 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x33},# 0x00
						0x34 : {'offset':1987,'bit':7,'bits':8,'parameter':'Tk11 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x34},# 0x00
						0x35 : {'offset':1989,'bit':7,'bits':8,'parameter':'Tk11 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x35},# 0x00
						0x36 : {'offset':1991,'bit':3,'bits':4,'parameter':'Tk11 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x36},# 0x00
						0x37 : {'offset':1991,'bit':7,'bits':4,'parameter':'Tk11 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x37},# 0x00
						0x38 : {'offset':1990,'bit':7,'bits':8,'parameter':'Tk11 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x38},# 0x00
						0x39 : {'offset':1978,'bit':4,'bits':5,'parameter':'Tk11 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x39},# 0x00
						0x3A : {'offset':1978,'bit':6,'bits':2,'parameter':'Tk11 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x3A},# 0x00
						0x3B : {'offset':1971,'bit':7,'bits':8,'parameter':'Tk11 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x3B},# 0x00
						0x3C : {'offset':1972,'bit':7,'bits':8,'parameter':'Tk11 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x3C},# 0x00
						0x3D : {'offset':1973,'bit':7,'bits':8,'parameter':'Tk11 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x3D},# 0x00
						0x3E : {'offset':1974,'bit':7,'bits':8,'parameter':'Tk11 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x3E},# 0x00
						0x3F : {'offset':1975,'bit':7,'bits':8,'parameter':'Tk11 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x3F},# 0x00
						0x40 : {'offset':1976,'bit':7,'bits':8,'parameter':'Tk11 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x40},# 0x00
						0x41 : {'offset':1977,'bit':7,'bits':8,'parameter':'Tk11 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x41},# 0x00
						0x42 : {'offset':1984,'bit':7,'bits':1,'parameter':'Tk11 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x15,'subid':0x42},# 0x00
					},
	0x16 :  {
						0x00 : {'offset':2068,'bit':7,'bits':16,'parameter':'Tk12 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x00},# 0x00
						0x01 : {'offset':2082,'bit':7,'bits':8,'parameter':'Tk12 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x01},# 0x00
						0x02 : {'offset':2073,'bit':7,'bits':8,'parameter':'Tk12 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x02},# 0x00
						0x03 : {'offset':2070,'bit':7,'bits':3,'parameter':'Tk12 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x03},# 0x00
						0x04 : {'offset':2070,'bit':4,'bits':5,'parameter':'Tk12 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x04},# 0x00
						0x05 : {'offset':2071,'bit':7,'bits':8,'parameter':'Tk12 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x05},# 0x00
						0x06 : {'offset':2072,'bit':7,'bits':8,'parameter':'Tk12 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x06},# 0x00
						0x07 : {'offset':2096,'bit':1,'bits':2,'parameter':'Tk12 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x07},# 0x00
						0x08 : {'offset':2096,'bit':3,'bits':2,'parameter':'Tk12 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x08},# 0x00
						0x09 : {'offset':2096,'bit':6,'bits':2,'parameter':'Tk12 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x09},# 0x00
						0x0A : {'offset':2097,'bit':7,'bits':8,'parameter':'Tk12 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x0A},# 0x00
						0x0B : {'offset':2075,'bit':7,'bits':8,'parameter':'Tk12 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x0B},# 0x00
						0x0C : {'offset':2076,'bit':7,'bits':16,'parameter':'Tk12 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x0C},# 0x00
						0x0D : {'offset':2074,'bit':7,'bits':8,'parameter':'Tk12 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x0D},# 0x00
						0x0E : {'offset':2078,'bit':7,'bits':8,'parameter':'Tk12 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x0E},# 0x00
						0x0F : {'offset':2080,'bit':3,'bits':4,'parameter':'Tk12 Delay Tempo Base','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x0F},# 0x00
						0x10 : {'offset':2080,'bit':7,'bits':1,'parameter':'Tk12 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x10},# 0x00
						0x11 : {'offset':2081,'bit':7,'bits':8,'parameter':'Tk12 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x11},# 0x00
						0x12 : {'offset':2095,'bit':5,'bits':1,'parameter':'Tk12 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x12},# 0x00
						0x13 : {'offset':2093,'bit':0,'bits':1,'parameter':'Tk12 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x13},# 0x00
						0x14 : {'offset':2093,'bit':1,'bits':1,'parameter':'Tk12 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x14},# 0x00
						0x15 : {'offset':2093,'bit':2,'bits':1,'parameter':'Tk12 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x15},# 0x00
						0x16 : {'offset':2093,'bit':3,'bits':1,'parameter':'Tk12 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x16},# 0x00
						0x17 : {'offset':2093,'bit':4,'bits':1,'parameter':'Tk12 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x17},# 0x00
						0x18 : {'offset':2093,'bit':5,'bits':1,'parameter':'Tk12 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x18},# 0x00
						0x19 : {'offset':2093,'bit':6,'bits':1,'parameter':'Tk12 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x19},# 0x00
						0x1A : {'offset':2093,'bit':7,'bits':1,'parameter':'Tk12 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x1A},# 0x00
						0x1B : {'offset':2094,'bit':0,'bits':1,'parameter':'Tk12 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x1B},# 0x00
						0x1C : {'offset':2094,'bit':1,'bits':1,'parameter':'Tk12 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x1C},# 0x00
						0x1D : {'offset':2094,'bit':2,'bits':1,'parameter':'Tk12 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x1D},# 0x00
						0x1E : {'offset':2094,'bit':3,'bits':1,'parameter':'Tk12 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x1E},# 0x00
						0x1F : {'offset':2094,'bit':4,'bits':1,'parameter':'Tk12 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x1F},# 0x00
						0x20 : {'offset':2094,'bit':5,'bits':1,'parameter':'Tk12 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x20},# 0x00
						0x21 : {'offset':2094,'bit':6,'bits':1,'parameter':'Tk12 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x21},# 0x00
						0x22 : {'offset':2094,'bit':7,'bits':1,'parameter':'Tk12 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x22},# 0x00
						0x23 : {'offset':2095,'bit':0,'bits':1,'parameter':'Tk12 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x23},# 0x00
						0x24 : {'offset':2095,'bit':1,'bits':1,'parameter':'Tk12 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x24},# 0x00
						0x25 : {'offset':2095,'bit':2,'bits':1,'parameter':'Tk12 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x25},# 0x00
						0x26 : {'offset':2095,'bit':3,'bits':1,'parameter':'Tk12 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x26},# 0x00
						0x27 : {'offset':2095,'bit':4,'bits':1,'parameter':'Tk12 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x27},# 0x00
						0x28 : {'offset':2095,'bit':7,'bits':1,'parameter':'Tk12 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x28},# 0x00
# 0x29
						0x2A : {'offset':2095,'bit':6,'bits':1,'parameter':'Tk12 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x2A},# 0x00
						0x2B : {'offset':2104,'bit':6,'bits':7,'parameter':'Tk12 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x2B},# 0x00
						0x2C : {'offset':2104,'bit':7,'bits':1,'parameter':'Tk12 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x2C},# 0x00
						0x2D : {'offset':2106,'bit':7,'bits':8,'parameter':'Tk12 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x2D},# 0x00
						0x2E : {'offset':2107,'bit':7,'bits':8,'parameter':'Tk12 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x2E},# 0x00
						0x2F : {'offset':2108,'bit':7,'bits':8,'parameter':'Tk12 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x2F},# 0x00
						0x30 : {'offset':2109,'bit':7,'bits':8,'parameter':'Tk12 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x30},# 0x00
						0x31 : {'offset':2098,'bit':7,'bits':8,'parameter':'Tk12 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x31},# 0x00
						0x32 : {'offset':2100,'bit':3,'bits':4,'parameter':'Tk12 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x32},# 0x00
						0x33 : {'offset':2100,'bit':7,'bits':4,'parameter':'Tk12 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x33},# 0x00
						0x34 : {'offset':2099,'bit':7,'bits':8,'parameter':'Tk12 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x34},# 0x00
						0x35 : {'offset':2101,'bit':7,'bits':8,'parameter':'Tk12 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x35},# 0x00
						0x36 : {'offset':2103,'bit':3,'bits':4,'parameter':'Tk12 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x36},# 0x00
						0x37 : {'offset':2103,'bit':7,'bits':4,'parameter':'Tk12 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x37},# 0x00
						0x38 : {'offset':2102,'bit':7,'bits':8,'parameter':'Tk12 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x38},# 0x00
						0x39 : {'offset':2090,'bit':4,'bits':5,'parameter':'Tk12 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x39},# 0x00
						0x3A : {'offset':2090,'bit':6,'bits':2,'parameter':'Tk12 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x3A},# 0x00
						0x3B : {'offset':2083,'bit':7,'bits':8,'parameter':'Tk12 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x3B},# 0x00
						0x3C : {'offset':2084,'bit':7,'bits':8,'parameter':'Tk12 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x3C},# 0x00
						0x3D : {'offset':2085,'bit':7,'bits':8,'parameter':'Tk12 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x3D},# 0x00
						0x3E : {'offset':2086,'bit':7,'bits':8,'parameter':'Tk12 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x3E},# 0x00
						0x3F : {'offset':2087,'bit':7,'bits':8,'parameter':'Tk12 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x3F},# 0x00
						0x40 : {'offset':2088,'bit':7,'bits':8,'parameter':'Tk12 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x40},# 0x00
						0x41 : {'offset':2089,'bit':7,'bits':8,'parameter':'Tk12 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x41},# 0x00
						0x42 : {'offset':2096,'bit':7,'bits':1,'parameter':'Tk12 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x16,'subid':0x42},# 0x00
					},
	0x17 :  {
						0x00 : {'offset':2180,'bit':7,'bits':16,'parameter':'Tk13 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x00},# 0x00
						0x01 : {'offset':2194,'bit':7,'bits':8,'parameter':'Tk13 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x01},# 0x00
						0x02 : {'offset':2185,'bit':7,'bits':8,'parameter':'Tk13 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x02},# 0x00
						0x03 : {'offset':2182,'bit':7,'bits':3,'parameter':'Tk13 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x03},# 0x00
						0x04 : {'offset':2182,'bit':4,'bits':5,'parameter':'Tk13 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x04},# 0x00
						0x05 : {'offset':2183,'bit':7,'bits':8,'parameter':'Tk13 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x05},# 0x00
						0x06 : {'offset':2184,'bit':7,'bits':8,'parameter':'Tk13 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x06},# 0x00
						0x07 : {'offset':2208,'bit':1,'bits':2,'parameter':'Tk13 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x07},# 0x00
						0x08 : {'offset':2208,'bit':3,'bits':2,'parameter':'Tk13 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x08},# 0x00
						0x09 : {'offset':2208,'bit':6,'bits':2,'parameter':'Tk13 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x09},# 0x00
						0x0A : {'offset':2209,'bit':7,'bits':8,'parameter':'Tk13 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x0A},# 0x00
						0x0B : {'offset':2187,'bit':7,'bits':8,'parameter':'Tk13 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x0B},# 0x00
						0x0C : {'offset':2188,'bit':7,'bits':16,'parameter':'Tk13 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x0C},# 0x00
						0x0D : {'offset':2186,'bit':7,'bits':8,'parameter':'Tk13 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x0D},# 0x00
						0x0E : {'offset':2190,'bit':7,'bits':8,'parameter':'Tk13 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x0E},# 0x00
						0x0F : {'offset':2192,'bit':3,'bits':4,'parameter':'Tk13 Delay Tempo Base','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x0F},# 0x00
						0x10 : {'offset':2192,'bit':7,'bits':1,'parameter':'Tk13 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x10},# 0x00
						0x11 : {'offset':2193,'bit':7,'bits':8,'parameter':'Tk13 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x11},# 0x00
						0x12 : {'offset':2207,'bit':5,'bits':1,'parameter':'Tk13 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x12},# 0x00
						0x13 : {'offset':2205,'bit':0,'bits':1,'parameter':'Tk13 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x13},# 0x00
						0x14 : {'offset':2205,'bit':1,'bits':1,'parameter':'Tk13 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x14},# 0x00
						0x15 : {'offset':2205,'bit':2,'bits':1,'parameter':'Tk13 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x15},# 0x00
						0x16 : {'offset':2205,'bit':3,'bits':1,'parameter':'Tk13 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x16},# 0x00
						0x17 : {'offset':2205,'bit':4,'bits':1,'parameter':'Tk13 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x17},# 0x00
						0x18 : {'offset':2205,'bit':5,'bits':1,'parameter':'Tk13 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x18},# 0x00
						0x19 : {'offset':2205,'bit':6,'bits':1,'parameter':'Tk13 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x19},# 0x00
						0x1A : {'offset':2205,'bit':7,'bits':1,'parameter':'Tk13 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x1A},# 0x00
						0x1B : {'offset':2206,'bit':0,'bits':1,'parameter':'Tk13 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x1B},# 0x00
						0x1C : {'offset':2206,'bit':1,'bits':1,'parameter':'Tk13 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x1C},# 0x00
						0x1D : {'offset':2206,'bit':2,'bits':1,'parameter':'Tk13 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x1D},# 0x00
						0x1E : {'offset':2206,'bit':3,'bits':1,'parameter':'Tk13 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x1E},# 0x00
						0x1F : {'offset':2206,'bit':4,'bits':1,'parameter':'Tk13 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x1F},# 0x00
						0x20 : {'offset':2206,'bit':5,'bits':1,'parameter':'Tk13 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x20},# 0x00
						0x21 : {'offset':2206,'bit':6,'bits':1,'parameter':'Tk13 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x21},# 0x00
						0x22 : {'offset':2206,'bit':7,'bits':1,'parameter':'Tk13 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x22},# 0x00
						0x23 : {'offset':2207,'bit':0,'bits':1,'parameter':'Tk13 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x23},# 0x00
						0x24 : {'offset':2207,'bit':1,'bits':1,'parameter':'Tk13 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x24},# 0x00
						0x25 : {'offset':2207,'bit':2,'bits':1,'parameter':'Tk13 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x25},# 0x00
						0x26 : {'offset':2207,'bit':3,'bits':1,'parameter':'Tk13 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x26},# 0x00
						0x27 : {'offset':2207,'bit':4,'bits':1,'parameter':'Tk13 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x27},# 0x00
						0x28 : {'offset':2207,'bit':7,'bits':1,'parameter':'Tk13 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x28},# 0x00
# 0x29
						0x2A : {'offset':2207,'bit':6,'bits':1,'parameter':'Tk13 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x2A},# 0x00
						0x2B : {'offset':2216,'bit':6,'bits':7,'parameter':'Tk13 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x2B},# 0x00
						0x2C : {'offset':2216,'bit':7,'bits':1,'parameter':'Tk13 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x2C},# 0x00
						0x2D : {'offset':2218,'bit':7,'bits':8,'parameter':'Tk13 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x2D},# 0x00
						0x2E : {'offset':2219,'bit':7,'bits':8,'parameter':'Tk13 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x2E},# 0x00
						0x2F : {'offset':2220,'bit':7,'bits':8,'parameter':'Tk13 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x2F},# 0x00
						0x30 : {'offset':2221,'bit':7,'bits':8,'parameter':'Tk13 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x30},# 0x00
						0x31 : {'offset':2210,'bit':7,'bits':8,'parameter':'Tk13 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x31},# 0x00
						0x32 : {'offset':2212,'bit':3,'bits':4,'parameter':'Tk13 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x32},# 0x00
						0x33 : {'offset':2212,'bit':7,'bits':4,'parameter':'Tk13 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x33},# 0x00
						0x34 : {'offset':2211,'bit':7,'bits':8,'parameter':'Tk13 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x34},# 0x00
						0x35 : {'offset':2213,'bit':7,'bits':8,'parameter':'Tk13 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x35},# 0x00
						0x36 : {'offset':2215,'bit':3,'bits':4,'parameter':'Tk13 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x36},# 0x00
						0x37 : {'offset':2215,'bit':7,'bits':4,'parameter':'Tk13 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x37},# 0x00
						0x38 : {'offset':2214,'bit':7,'bits':8,'parameter':'Tk13 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x38},# 0x00
						0x39 : {'offset':2202,'bit':4,'bits':5,'parameter':'Tk13 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x39},# 0x00
						0x3A : {'offset':2202,'bit':6,'bits':2,'parameter':'Tk13 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x3A},# 0x00
						0x3B : {'offset':2195,'bit':7,'bits':8,'parameter':'Tk13 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x3B},# 0x00
						0x3C : {'offset':2196,'bit':7,'bits':8,'parameter':'Tk13 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x3C},# 0x00
						0x3D : {'offset':2197,'bit':7,'bits':8,'parameter':'Tk13 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x3D},# 0x00
						0x3E : {'offset':2198,'bit':7,'bits':8,'parameter':'Tk13 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x3E},# 0x00
						0x3F : {'offset':2199,'bit':7,'bits':8,'parameter':'Tk13 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x3F},# 0x00
						0x40 : {'offset':2200,'bit':7,'bits':8,'parameter':'Tk13 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x40},# 0x00
						0x41 : {'offset':2201,'bit':7,'bits':8,'parameter':'Tk13 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x41},# 0x00
						0x42 : {'offset':2208,'bit':7,'bits':1,'parameter':'Tk13 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x17,'subid':0x42},# 0x00
					},
	0x18 :  {
						0x00 : {'offset':2292,'bit':7,'bits':16,'parameter':'Tk14 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x00},# 0x00
						0x01 : {'offset':2306,'bit':7,'bits':8,'parameter':'Tk14 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x01},# 0x00
						0x02 : {'offset':2297,'bit':7,'bits':8,'parameter':'Tk14 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x02},# 0x00
						0x03 : {'offset':2294,'bit':7,'bits':3,'parameter':'Tk14 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x03},# 0x00
						0x04 : {'offset':2294,'bit':4,'bits':5,'parameter':'Tk14 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x04},# 0x00
						0x05 : {'offset':2295,'bit':7,'bits':8,'parameter':'Tk14 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x05},# 0x00
						0x06 : {'offset':2296,'bit':7,'bits':8,'parameter':'Tk14 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x06},# 0x00
						0x07 : {'offset':2320,'bit':1,'bits':2,'parameter':'Tk14 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x07},# 0x00
						0x08 : {'offset':2320,'bit':3,'bits':2,'parameter':'Tk14 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x08},# 0x00
						0x09 : {'offset':2320,'bit':6,'bits':2,'parameter':'Tk14 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x09},# 0x00
						0x0A : {'offset':2321,'bit':7,'bits':8,'parameter':'Tk14 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x0A},# 0x00
						0x0B : {'offset':2299,'bit':7,'bits':8,'parameter':'Tk14 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x0B},# 0x00
						0x0C : {'offset':2300,'bit':7,'bits':16,'parameter':'Tk14 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x0C},# 0x00
						0x0D : {'offset':2298,'bit':7,'bits':8,'parameter':'Tk14 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x0D},# 0x00
						0x0E : {'offset':2302,'bit':7,'bits':8,'parameter':'Tk14 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x0E},# 0x00
						0x0F : {'offset':2304,'bit':3,'bits':4,'parameter':'Tk14 Delay Tempo Base','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x0F},# 0x00
						0x10 : {'offset':2304,'bit':7,'bits':1,'parameter':'Tk14 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x10},# 0x00
						0x11 : {'offset':2305,'bit':7,'bits':8,'parameter':'Tk14 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x11},# 0x00
						0x12 : {'offset':2319,'bit':5,'bits':1,'parameter':'Tk14 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x12},# 0x00
						0x13 : {'offset':2317,'bit':0,'bits':1,'parameter':'Tk14 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x13},# 0x00
						0x14 : {'offset':2317,'bit':1,'bits':1,'parameter':'Tk14 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x14},# 0x00
						0x15 : {'offset':2317,'bit':2,'bits':1,'parameter':'Tk14 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x15},# 0x00
						0x16 : {'offset':2317,'bit':3,'bits':1,'parameter':'Tk14 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x16},# 0x00
						0x17 : {'offset':2317,'bit':4,'bits':1,'parameter':'Tk14 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x17},# 0x00
						0x18 : {'offset':2317,'bit':5,'bits':1,'parameter':'Tk14 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x18},# 0x00
						0x19 : {'offset':2317,'bit':6,'bits':1,'parameter':'Tk14 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x19},# 0x00
						0x1A : {'offset':2317,'bit':7,'bits':1,'parameter':'Tk14 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x1A},# 0x00
						0x1B : {'offset':2318,'bit':0,'bits':1,'parameter':'Tk14 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x1B},# 0x00
						0x1C : {'offset':2318,'bit':1,'bits':1,'parameter':'Tk14 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x1C},# 0x00
						0x1D : {'offset':2318,'bit':2,'bits':1,'parameter':'Tk14 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x1D},# 0x00
						0x1E : {'offset':2318,'bit':3,'bits':1,'parameter':'Tk14 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x1E},# 0x00
						0x1F : {'offset':2318,'bit':4,'bits':1,'parameter':'Tk14 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x1F},# 0x00
						0x20 : {'offset':2318,'bit':5,'bits':1,'parameter':'Tk14 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x20},# 0x00
						0x21 : {'offset':2318,'bit':6,'bits':1,'parameter':'Tk14 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x21},# 0x00
						0x22 : {'offset':2318,'bit':7,'bits':1,'parameter':'Tk14 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x22},# 0x00
						0x23 : {'offset':2319,'bit':0,'bits':1,'parameter':'Tk14 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x23},# 0x00
						0x24 : {'offset':2319,'bit':1,'bits':1,'parameter':'Tk14 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x24},# 0x00
						0x25 : {'offset':2319,'bit':2,'bits':1,'parameter':'Tk14 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x25},# 0x00
						0x26 : {'offset':2319,'bit':3,'bits':1,'parameter':'Tk14 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x26},# 0x00
						0x27 : {'offset':2319,'bit':4,'bits':1,'parameter':'Tk14 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x27},# 0x00
						0x28 : {'offset':2319,'bit':7,'bits':1,'parameter':'Tk14 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x28},# 0x00
# 0x29
						0x2A : {'offset':2319,'bit':6,'bits':1,'parameter':'Tk14 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x2A},# 0x00
						0x2B : {'offset':2328,'bit':6,'bits':7,'parameter':'Tk14 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x2B},# 0x00
						0x2C : {'offset':2328,'bit':7,'bits':1,'parameter':'Tk14 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x2C},# 0x00
						0x2D : {'offset':2330,'bit':7,'bits':8,'parameter':'Tk14 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x2D},# 0x00
						0x2E : {'offset':2331,'bit':7,'bits':8,'parameter':'Tk14 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x2E},# 0x00
						0x2F : {'offset':2332,'bit':7,'bits':8,'parameter':'Tk14 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x2F},# 0x00
						0x30 : {'offset':2333,'bit':7,'bits':8,'parameter':'Tk14 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x30},# 0x00
						0x31 : {'offset':2322,'bit':7,'bits':8,'parameter':'Tk14 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x31},# 0x00
						0x32 : {'offset':2324,'bit':3,'bits':4,'parameter':'Tk14 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x32},# 0x00
						0x33 : {'offset':2324,'bit':7,'bits':4,'parameter':'Tk14 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x33},# 0x00
						0x34 : {'offset':2323,'bit':7,'bits':8,'parameter':'Tk14 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x34},# 0x00
						0x35 : {'offset':2325,'bit':7,'bits':8,'parameter':'Tk14 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x35},# 0x00
						0x36 : {'offset':2327,'bit':3,'bits':4,'parameter':'Tk14 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x36},# 0x00
						0x37 : {'offset':2327,'bit':7,'bits':4,'parameter':'Tk14 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x37},# 0x00
						0x38 : {'offset':2326,'bit':7,'bits':8,'parameter':'Tk14 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x38},# 0x00
						0x39 : {'offset':2314,'bit':4,'bits':5,'parameter':'Tk14 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x39},# 0x00
						0x3A : {'offset':2314,'bit':6,'bits':2,'parameter':'Tk14 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x3A},# 0x00
						0x3B : {'offset':2307,'bit':7,'bits':8,'parameter':'Tk14 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x3B},# 0x00
						0x3C : {'offset':2308,'bit':7,'bits':8,'parameter':'Tk14 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x3C},# 0x00
						0x3D : {'offset':2309,'bit':7,'bits':8,'parameter':'Tk14 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x3D},# 0x00
						0x3E : {'offset':2310,'bit':7,'bits':8,'parameter':'Tk14 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x3E},# 0x00
						0x3F : {'offset':2311,'bit':7,'bits':8,'parameter':'Tk14 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x3F},# 0x00
						0x40 : {'offset':2312,'bit':7,'bits':8,'parameter':'Tk14 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x40},# 0x00
						0x41 : {'offset':2313,'bit':7,'bits':8,'parameter':'Tk14 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x41},# 0x00
						0x42 : {'offset':2320,'bit':7,'bits':1,'parameter':'Tk14 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x18,'subid':0x42},# 0x00
					},
	0x19 :  {
						0x00 : {'offset':2404,'bit':7,'bits':16,'parameter':'Tk15 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x00},# 0x00
						0x01 : {'offset':2418,'bit':7,'bits':8,'parameter':'Tk15 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x01},# 0x00
						0x02 : {'offset':2409,'bit':7,'bits':8,'parameter':'Tk15 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x02},# 0x00
						0x03 : {'offset':2406,'bit':7,'bits':3,'parameter':'Tk15 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x03},# 0x00
						0x04 : {'offset':2406,'bit':4,'bits':5,'parameter':'Tk15 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x04},# 0x00
						0x05 : {'offset':2407,'bit':7,'bits':8,'parameter':'Tk15 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x05},# 0x00
						0x06 : {'offset':2408,'bit':7,'bits':8,'parameter':'Tk15 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x06},# 0x00
						0x07 : {'offset':2432,'bit':1,'bits':2,'parameter':'Tk15 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x07},# 0x00
						0x08 : {'offset':2432,'bit':3,'bits':2,'parameter':'Tk15 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x08},# 0x00
						0x09 : {'offset':2432,'bit':6,'bits':2,'parameter':'Tk15 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x09},# 0x00
						0x0A : {'offset':2433,'bit':7,'bits':8,'parameter':'Tk15 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x0A},# 0x00
						0x0B : {'offset':2411,'bit':7,'bits':8,'parameter':'Tk15 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x0B},# 0x00
						0x0C : {'offset':2412,'bit':7,'bits':16,'parameter':'Tk15 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x0C},# 0x00
						0x0D : {'offset':2410,'bit':7,'bits':8,'parameter':'Tk15 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x0D},# 0x00
						0x0E : {'offset':2414,'bit':7,'bits':8,'parameter':'Tk15 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x0E},# 0x00
						0x0F : {'offset':2416,'bit':3,'bits':4,'parameter':'Tk15 Delay Tempo Base','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x0F},# 0x00
						0x10 : {'offset':2416,'bit':7,'bits':1,'parameter':'Tk15 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x10},# 0x00
						0x11 : {'offset':2417,'bit':7,'bits':8,'parameter':'Tk15 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x11},# 0x00
						0x12 : {'offset':2431,'bit':5,'bits':1,'parameter':'Tk15 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x12},# 0x00
						0x13 : {'offset':2429,'bit':0,'bits':1,'parameter':'Tk15 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x13},# 0x00
						0x14 : {'offset':2429,'bit':1,'bits':1,'parameter':'Tk15 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x14},# 0x00
						0x15 : {'offset':2429,'bit':2,'bits':1,'parameter':'Tk15 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x15},# 0x00
						0x16 : {'offset':2429,'bit':3,'bits':1,'parameter':'Tk15 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x16},# 0x00
						0x17 : {'offset':2429,'bit':4,'bits':1,'parameter':'Tk15 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x17},# 0x00
						0x18 : {'offset':2429,'bit':5,'bits':1,'parameter':'Tk15 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x18},# 0x00
						0x19 : {'offset':2429,'bit':6,'bits':1,'parameter':'Tk15 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x19},# 0x00
						0x1A : {'offset':2429,'bit':7,'bits':1,'parameter':'Tk15 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x1A},# 0x00
						0x1B : {'offset':2430,'bit':0,'bits':1,'parameter':'Tk15 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x1B},# 0x00
						0x1C : {'offset':2430,'bit':1,'bits':1,'parameter':'Tk15 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x1C},# 0x00
						0x1D : {'offset':2430,'bit':2,'bits':1,'parameter':'Tk15 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x1D},# 0x00
						0x1E : {'offset':2430,'bit':3,'bits':1,'parameter':'Tk15 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x1E},# 0x00
						0x1F : {'offset':2430,'bit':4,'bits':1,'parameter':'Tk15 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x1F},# 0x00
						0x20 : {'offset':2430,'bit':5,'bits':1,'parameter':'Tk15 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x20},# 0x00
						0x21 : {'offset':2430,'bit':6,'bits':1,'parameter':'Tk15 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x21},# 0x00
						0x22 : {'offset':2430,'bit':7,'bits':1,'parameter':'Tk15 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x22},# 0x00
						0x23 : {'offset':2431,'bit':0,'bits':1,'parameter':'Tk15 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x23},# 0x00
						0x24 : {'offset':2431,'bit':1,'bits':1,'parameter':'Tk15 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x24},# 0x00
						0x25 : {'offset':2431,'bit':2,'bits':1,'parameter':'Tk15 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x25},# 0x00
						0x26 : {'offset':2431,'bit':3,'bits':1,'parameter':'Tk15 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x26},# 0x00
						0x27 : {'offset':2431,'bit':4,'bits':1,'parameter':'Tk15 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x27},# 0x00
						0x28 : {'offset':2431,'bit':7,'bits':1,'parameter':'Tk15 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x28},# 0x00
# 0x29
						0x2A : {'offset':2431,'bit':6,'bits':1,'parameter':'Tk15 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x2A},# 0x00
						0x2B : {'offset':2440,'bit':6,'bits':7,'parameter':'Tk15 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x2B},# 0x00
						0x2C : {'offset':2440,'bit':7,'bits':1,'parameter':'Tk15 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x2C},# 0x00
						0x2D : {'offset':2442,'bit':7,'bits':8,'parameter':'Tk15 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x2D},# 0x00
						0x2E : {'offset':2443,'bit':7,'bits':8,'parameter':'Tk15 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x2E},# 0x00
						0x2F : {'offset':2444,'bit':7,'bits':8,'parameter':'Tk15 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x2F},# 0x00
						0x30 : {'offset':2445,'bit':7,'bits':8,'parameter':'Tk15 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x30},# 0x00
						0x31 : {'offset':2434,'bit':7,'bits':8,'parameter':'Tk15 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x31},# 0x00
						0x32 : {'offset':2436,'bit':3,'bits':4,'parameter':'Tk15 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x32},# 0x00
						0x33 : {'offset':2436,'bit':7,'bits':4,'parameter':'Tk15 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x33},# 0x00
						0x34 : {'offset':2435,'bit':7,'bits':8,'parameter':'Tk15 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x34},# 0x00
						0x35 : {'offset':2437,'bit':7,'bits':8,'parameter':'Tk15 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x35},# 0x00
						0x36 : {'offset':2439,'bit':3,'bits':4,'parameter':'Tk15 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x36},# 0x00
						0x37 : {'offset':2439,'bit':7,'bits':4,'parameter':'Tk15 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x37},# 0x00
						0x38 : {'offset':2438,'bit':7,'bits':8,'parameter':'Tk15 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x38},# 0x00
						0x39 : {'offset':2426,'bit':4,'bits':5,'parameter':'Tk15 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x39},# 0x00
						0x3A : {'offset':2426,'bit':6,'bits':2,'parameter':'Tk15 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x3A},# 0x00
						0x3B : {'offset':2419,'bit':7,'bits':8,'parameter':'Tk15 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x3B},# 0x00
						0x3C : {'offset':2420,'bit':7,'bits':8,'parameter':'Tk15 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x3C},# 0x00
						0x3D : {'offset':2421,'bit':7,'bits':8,'parameter':'Tk15 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x3D},# 0x00
						0x3E : {'offset':2422,'bit':7,'bits':8,'parameter':'Tk15 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x3E},# 0x00
						0x3F : {'offset':2423,'bit':7,'bits':8,'parameter':'Tk15 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x3F},# 0x00
						0x40 : {'offset':2424,'bit':7,'bits':8,'parameter':'Tk15 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x40},# 0x00
						0x41 : {'offset':2425,'bit':7,'bits':8,'parameter':'Tk15 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x41},# 0x00
						0x42 : {'offset':2432,'bit':7,'bits':1,'parameter':'Tk15 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x19,'subid':0x42},# 0x00
					},
	0x1A :  {
						0x00 : {'offset':2516,'bit':7,'bits':16,'parameter':'Tk16 Bank No & Program No','range':(0, 2175),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x00},# 0x00
						0x01 : {'offset':2530,'bit':7,'bits':8,'parameter':'Tk16 Pan','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x01},# 0x00
						0x02 : {'offset':2521,'bit':7,'bits':8,'parameter':'Tk16 Volume','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x02},# 0x00
						0x03 : {'offset':2518,'bit':7,'bits':3,'parameter':'Tk16 Status','range':{0: 'Off', 1: 'Int', 2: 'Ext', 3: 'Ext2'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x03},# 0x00
						0x04 : {'offset':2518,'bit':4,'bits':5,'parameter':'Tk16 MIDI Channel','range':(0, 16),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x04},# 0x00
						0x05 : {'offset':2519,'bit':7,'bits':8,'parameter':'Tk16 Ext Bank MSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x05},# 0x00
						0x06 : {'offset':2520,'bit':7,'bits':8,'parameter':'Tk16 Ext Bank LSB','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x06},# 0x00
						0x07 : {'offset':2544,'bit':1,'bits':2,'parameter':'Tk16 Force OSC Mode','range':{0: 'Prog', 1: 'Poly', 2: 'Mono', 3: 'Mono Legato'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x07},# 0x00
						0x08 : {'offset':2544,'bit':3,'bits':2,'parameter':'Tk16 OSC Select','range':{0: 'Both', 1: 'OSC1', 2: 'OSC2'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x08},# 0x00
						0x09 : {'offset':2544,'bit':6,'bits':2,'parameter':'Tk16 Arpeggiator Assign','range':{0: 'Off', 1: 'A', 2: 'B'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x09},# 0x00
						0x0A : {'offset':2545,'bit':7,'bits':8,'parameter':'Tk16 Portamento Time','range':(-1, 127),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x0A},# 0x00
						0x0B : {'offset':2523,'bit':7,'bits':8,'parameter':'Tk16 Transpose','range':(-60, 60),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x0B},# 0x00
						0x0C : {'offset':2524,'bit':7,'bits':16,'parameter':'Tk16 Detune','range':(-1200, 1200),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x0C},# 0x00
						0x0D : {'offset':2522,'bit':7,'bits':8,'parameter':'Tk16 Bend Range','range':(-25, 24),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x0D},# 0x00
						0x0E : {'offset':2526,'bit':7,'bits':8,'parameter':'Tk16 Delay Time','range':(0, 97),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x0E},# 0x00
						0x0F : {'offset':2528,'bit':3,'bits':4,'parameter':'Tk16 Delay Tempo Base','range':(0, 9),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x0F},# 0x00
						0x10 : {'offset':2528,'bit':7,'bits':1,'parameter':'Tk16 Delay Mode','range':{0: 'Time', 1: 'Tempo'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x10},# 0x00
						0x11 : {'offset':2529,'bit':7,'bits':8,'parameter':'Tk16 Delay Tempo Times','range':(0, 32),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x11},# 0x00
						0x12 : {'offset':2543,'bit':5,'bits':1,'parameter':'Tk16 Use Program\'s Scale','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x12},# 0x00
						0x13 : {'offset':2541,'bit':0,'bits':1,'parameter':'Tk16 Enable Program Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x13},# 0x00
						0x14 : {'offset':2541,'bit':1,'bits':1,'parameter':'Tk16 Enable After Touch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x14},# 0x00
						0x15 : {'offset':2541,'bit':2,'bits':1,'parameter':'Tk16 Enable Damper','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x15},# 0x00
						0x16 : {'offset':2541,'bit':3,'bits':1,'parameter':'Tk16 Enable Portamento SW','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x16},# 0x00
						0x17 : {'offset':2541,'bit':4,'bits':1,'parameter':'Tk16 Enable JS X as AMS','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x17},# 0x00
						0x18 : {'offset':2541,'bit':5,'bits':1,'parameter':'Tk16 Enable JS+y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x18},# 0x00
						0x19 : {'offset':2541,'bit':6,'bits':1,'parameter':'Tk16 Enable JS-y','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x19},# 0x00
						0x1A : {'offset':2541,'bit':7,'bits':1,'parameter':'Tk16 Enable Ribbon CC#16','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x1A},# 0x00
						0x1B : {'offset':2542,'bit':0,'bits':1,'parameter':'Tk16 Enable Realtime Control-CUTOFF','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x1B},# 0x00
						0x1C : {'offset':2542,'bit':1,'bits':1,'parameter':'Tk16 Enable Realtime Control-RESONANCE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x1C},# 0x00
						0x1D : {'offset':2542,'bit':2,'bits':1,'parameter':'Tk16 Enable Realtime Control-EG INT','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x1D},# 0x00
						0x1E : {'offset':2542,'bit':3,'bits':1,'parameter':'Tk16 Enable Realtime Control-RELEASE','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x1E},# 0x00
						0x1F : {'offset':2542,'bit':4,'bits':1,'parameter':'Tk16 Enable Realtime Control-USER[1]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x1F},# 0x00
						0x20 : {'offset':2542,'bit':5,'bits':1,'parameter':'Tk16 Enable Realtime Control-USER[2]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x20},# 0x00
						0x21 : {'offset':2542,'bit':6,'bits':1,'parameter':'Tk16 Enable Realtime Control-USER[3]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x21},# 0x00
						0x22 : {'offset':2542,'bit':7,'bits':1,'parameter':'Tk16 Enable Realtime Control-USER[4]','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x22},# 0x00
						0x23 : {'offset':2543,'bit':0,'bits':1,'parameter':'Tk16 Enable SW1','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x23},# 0x00
						0x24 : {'offset':2543,'bit':1,'bits':1,'parameter':'Tk16 Enable SW2','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x24},# 0x00
						0x25 : {'offset':2543,'bit':2,'bits':1,'parameter':'Tk16 Enable Foot Switch','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x25},# 0x00
						0x26 : {'offset':2543,'bit':3,'bits':1,'parameter':'Tk16 Enable Foot Pedal','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x26},# 0x00
						0x27 : {'offset':2543,'bit':4,'bits':1,'parameter':'Tk16 Enable Other Control Change','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x27},# 0x00
						0x28 : {'offset':2543,'bit':7,'bits':1,'parameter':'Tk16 Enable Timbre Mute','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x28},# 0x00
# 0x29
						0x2A : {'offset':2543,'bit':6,'bits':1,'parameter':'Tk16 Auto Load Program EQ','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x2A},# 0x00
						0x2B : {'offset':2552,'bit':6,'bits':7,'parameter':'Tk16 Input Trim','range':(0, 99),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x2B},# 0x00
						0x2C : {'offset':2552,'bit':7,'bits':1,'parameter':'Tk16 Trim Bypass','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x2C},# 0x00
						0x2D : {'offset':2554,'bit':7,'bits':8,'parameter':'Tk16 Mid Frequency','range':(0, 165),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x2D},# 0x00
						0x2E : {'offset':2555,'bit':7,'bits':8,'parameter':'Tk16 Low Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x2E},# 0x00
						0x2F : {'offset':2556,'bit':7,'bits':8,'parameter':'Tk16 Mid Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x2F},# 0x00
						0x30 : {'offset':2557,'bit':7,'bits':8,'parameter':'Tk16 High Gain','range':(-36, 36),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x30},# 0x00
						0x31 : {'offset':2546,'bit':7,'bits':8,'parameter':'Tk16 Top Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x31},# 0x00
						0x32 : {'offset':2548,'bit':3,'bits':4,'parameter':'Tk16 Top Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x32},# 0x00
						0x33 : {'offset':2548,'bit':7,'bits':4,'parameter':'Tk16 Bottom Slope','range':(0, 15),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x33},# 0x00
						0x34 : {'offset':2547,'bit':7,'bits':8,'parameter':'Tk16 Bottom Key','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x34},# 0x00
						0x35 : {'offset':2549,'bit':7,'bits':8,'parameter':'Tk16 Top Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x35},# 0x00
						0x36 : {'offset':2551,'bit':3,'bits':4,'parameter':'Tk16 Top Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x36},# 0x00
						0x37 : {'offset':2551,'bit':7,'bits':4,'parameter':'Tk16 Bottom Velocity Slope','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x37},# 0x00
						0x38 : {'offset':2550,'bit':7,'bits':8,'parameter':'Tk16 Bottom Velocity','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x38},# 0x00
						0x39 : {'offset':2538,'bit':4,'bits':5,'parameter':'Tk16 Bus Select','range':{0: 'DKit', 1: 'L/R', 2: 'IFX1', 3: 'IFX2', 4: 'IFX3', 5: 'IFX4', 6: 'IFX5', 13: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x39},# 0x00
						0x3A : {'offset':2538,'bit':6,'bits':2,'parameter':'Tk16 FX Control Bus','range':{0: 'Off', 1: 'FX Ctrl1', 2: 'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x3A},# 0x00
						0x3B : {'offset':2531,'bit':7,'bits':8,'parameter':'Tk16 Send1','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x3B},# 0x00
						0x3C : {'offset':2532,'bit':7,'bits':8,'parameter':'Tk16 Send2','range':(0, 127),'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x3C},# 0x00
						0x3D : {'offset':2533,'bit':7,'bits':8,'parameter':'Tk16 DKit Patch IFX 1','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x3D},# 0x00
						0x3E : {'offset':2534,'bit':7,'bits':8,'parameter':'Tk16 DKit Patch IFX 2','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x3E},# 0x00
						0x3F : {'offset':2535,'bit':7,'bits':8,'parameter':'Tk16 DKit Patch IFX 3','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x3F},# 0x00
						0x40 : {'offset':2536,'bit':7,'bits':8,'parameter':'Tk16 DKit Patch IFX 4','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x40},# 0x00
						0x41 : {'offset':2537,'bit':7,'bits':8,'parameter':'Tk16 DKit Patch IFX 5','range':{0: 'L/R', 1: 'IFX1', 2: 'IFX2', 3: 'IFX3', 4: 'IFX4', 5: 'IFX5', 12: 'Off'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x41},# 0x00
						0x42 : {'offset':2544,'bit':7,'bits':1,'parameter':'Tk16 Enable Waveform SysEx','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x1A,'subid':0x42},# 0x00
					},
	0x1B :  {
						# Table 11
						0x00 : {'offset':124,'bit':5,'bits':1,'parameter':'Track 1 Mute','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x00},# 0x00
						0x01 : {'offset':124,'bit':4,'bits':1,'parameter':'Track 1 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x01},# 0x01
					},
	0x1C :  {
						# Table 11
						0x00 : {'offset':160,'bit':5,'bits':1,'parameter':'Track 2 Mute','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x00},# 0x00
						0x01 : {'offset':160,'bit':4,'bits':1,'parameter':'Track 2 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x01},# 0x01
					},
	0x1D :  {
						# Table 11
						0x00 : {'offset':196,'bit':5,'bits':1,'parameter':'Track 3 Mute','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x00},# 0x00
						0x01 : {'offset':196,'bit':4,'bits':1,'parameter':'Track 3 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x01},# 0x01
					},
	0x1E :  {
						# Table 11
						0x00 : {'offset':232,'bit':5,'bits':1,'parameter':'Track 4 Mute','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x00},# 0x00
						0x01 : {'offset':232,'bit':4,'bits':1,'parameter':'Track 4 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x01},# 0x01
					},
	0x1F :  {
						# Table 11
						0x00 : {'offset':268,'bit':5,'bits':1,'parameter':'Track 5 Mute','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x00},# 0x00
						0x01 : {'offset':268,'bit':4,'bits':1,'parameter':'Track 5 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x01},# 0x01
					},
	0x20 :  {
						# Table 11
						0x00 : {'offset':304,'bit':5,'bits':1,'parameter':'Track 6 Mute','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x00},# 0x00
						0x01 : {'offset':304,'bit':4,'bits':1,'parameter':'Track 6 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x01},# 0x01
					},
	0x21 :  {
						# Table 11
						0x00 : {'offset':340,'bit':5,'bits':1,'parameter':'Track 7 Mute','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x00},# 0x00
						0x01 : {'offset':340,'bit':4,'bits':1,'parameter':'Track 7 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x01},# 0x01
					},
	0x22 :  {
						# Table 11
						0x00 : {'offset':376,'bit':5,'bits':1,'parameter':'Track 8 Mute','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x00},# 0x00
						0x01 : {'offset':376,'bit':4,'bits':1,'parameter':'Track 8 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x01},# 0x01
					},
	0x23 :  {
						# Table 11
						0x00 : {'offset':412,'bit':5,'bits':1,'parameter':'Track 9 Mute','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x00},# 0x00
						0x01 : {'offset':412,'bit':4,'bits':1,'parameter':'Track 9 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x01},# 0x01
					},
	0x24 :  {
						# Table 11
						0x00 : {'offset':448,'bit':5,'bits':1,'parameter':'Track 10 Mute','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x00},# 0x00
						0x01 : {'offset':448,'bit':4,'bits':1,'parameter':'Track 10 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x01},# 0x01
					},
	0x25 :  {
						# Table 11
						0x00 : {'offset':484,'bit':5,'bits':1,'parameter':'Track 11 Mute','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x00},# 0x00
						0x01 : {'offset':484,'bit':4,'bits':1,'parameter':'Track 11 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x01},# 0x01
					},
	0x26 :  {
						# Table 11
						0x00 : {'offset':520,'bit':5,'bits':1,'parameter':'Track 12 Mute','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x00},# 0x00
						0x01 : {'offset':520,'bit':4,'bits':1,'parameter':'Track 12 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x01},# 0x01
					},
	0x27 :  {
						# Table 11
						0x00 : {'offset':556,'bit':5,'bits':1,'parameter':'Track 13 Mute','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x00},# 0x00
						0x01 : {'offset':556,'bit':4,'bits':1,'parameter':'Track 13 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x01},# 0x01
					},
	0x28 :  {
						# Table 11
						0x00 : {'offset':592,'bit':5,'bits':1,'parameter':'Track 14 Mute','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x00},# 0x00
						0x01 : {'offset':592,'bit':4,'bits':1,'parameter':'Track 14 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x01},# 0x01
					},
	0x29 :  {
						# Table 11
						0x00 : {'offset':628,'bit':5,'bits':1,'parameter':'Track 15 Mute','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x00},# 0x00
						0x01 : {'offset':628,'bit':4,'bits':1,'parameter':'Track 15 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x01},# 0x01
					},
	0x2A :  {
						# Table 11
						0x00 : {'offset':664,'bit':5,'bits':1,'parameter':'Track 16 Mute','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x00},# 0x00
						0x01 : {'offset':664,'bit':4,'bits':1,'parameter':'Track 16 Solo','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x1B,'subid':0x01},# 0x01
					},
	0x2B :  {
						# Track 1 Tone Adjust
						0x00 : {'offset':916,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x00},# 0x01
						0x01 : {'offset':917,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 1 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x01},# 0x01
						0x02 : {'offset':918,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x02},# 0x01
						0x03 : {'offset':920,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x03},# 0x02
						0x04 : {'offset':921,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 2 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x04},# 0x01
						0x05 : {'offset':922,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x05},# 0x01
						0x06 : {'offset':924,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x06},# 0x03
						0x07 : {'offset':925,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 3 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x07},# 0x01
						0x08 : {'offset':926,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x08},# 0x09
						0x09 : {'offset':928,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x09},# 0x04
						0x0A : {'offset':929,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 4 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x0A},# 0x01
						0x0B : {'offset':930,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x0B},# 0x01
						0x0C : {'offset':932,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x0C},# 0x05
						0x0D : {'offset':933,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 5 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x0D},# 0x01
						0x0E : {'offset':934,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x0E},# 0x01
						0x0F : {'offset':936,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x0F},# 0x06
						0x10 : {'offset':937,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 6 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x10},# 0x01
						0x11 : {'offset':938,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x11},# 0x01
						0x12 : {'offset':940,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x12},# 0x07
						0x13 : {'offset':941,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 7 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x13},# 0x01
						0x14 : {'offset':942,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x14},# 0x01
						0x15 : {'offset':944,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x15},# 0x08
						0x16 : {'offset':945,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Switch 8 Off/On','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x16},# 0x01
						0x17 : {'offset':946,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x17},# 0x01
						0x18 : {'offset':884,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x18},# 0x09
						0x19 : {'offset':886,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x19},# 0x01
						0x1A : {'offset':888,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x1A},# 0x0A
						0x1B : {'offset':890,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x1B},# 0x01
						0x1C : {'offset':892,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x1C},# 0x0A
						0x1D : {'offset':894,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x1D},# 0x01
						0x1E : {'offset':896,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x1E},# 0x0C
						0x1F : {'offset':898,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x1F},# 0x01
						0x20 : {'offset':900,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x20},# 0x0D
						0x21 : {'offset':902,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x21},# 0x01
						0x22 : {'offset':904,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x22},# 0x0E
						0x23 : {'offset':906,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x23},# 0x01
						0x24 : {'offset':908,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x24},# 0x0F
						0x25 : {'offset':910,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x25},# 0x01
						0x26 : {'offset':912,'bit':7,'bits':8,'parameter':'Tk1 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x26},# 0x10
						0x27 : {'offset':914,'bit':7,'bits':16,'parameter':'Tk1 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2B,'subid':0x27},# 0x01
					},
	0x2C :  {
						# Track 2 Tone Adjust
						0x00 : {'offset':1028,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x00},# 0x00
						0x01 : {'offset':1029,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x01},# 0x00
						0x02 : {'offset':1030,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x02},# 0x00
						0x03 : {'offset':1032,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x03},# 0x00
						0x04 : {'offset':1033,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x04},# 0x00
						0x05 : {'offset':1034,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x05},# 0x00
						0x06 : {'offset':1036,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x06},# 0x00
						0x07 : {'offset':1037,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x07},# 0x00
						0x08 : {'offset':1038,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x08},# 0x00
						0x09 : {'offset':1040,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x09},# 0x00
						0x0A : {'offset':1041,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x0A},# 0x00
						0x0B : {'offset':1042,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x0B},# 0x00
						0x0C : {'offset':1044,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x0C},# 0x00
						0x0D : {'offset':1045,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x0D},# 0x00
						0x0E : {'offset':1046,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x0E},# 0x00
						0x0F : {'offset':1048,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x0F},# 0x00
						0x10 : {'offset':1049,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x10},# 0x00
						0x11 : {'offset':1050,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x11},# 0x00
						0x12 : {'offset':1052,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x12},# 0x00
						0x13 : {'offset':1053,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x13},# 0x00
						0x14 : {'offset':1054,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x14},# 0x00
						0x15 : {'offset':1056,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x15},# 0x00
						0x16 : {'offset':1057,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x16},# 0x00
						0x17 : {'offset':1058,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x17},# 0x00
						0x18 : {'offset':996,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x18},# 0x00
						0x19 : {'offset':998,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x19},# 0x00
						0x1A : {'offset':1000,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x1A},# 0x00
						0x1B : {'offset':1002,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x1B},# 0x00
						0x1C : {'offset':1004,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x1C},# 0x00
						0x1D : {'offset':1006,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x1D},# 0x00
						0x1E : {'offset':1008,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x1E},# 0x00
						0x1F : {'offset':1010,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x1F},# 0x00
						0x20 : {'offset':1012,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x20},# 0x00
						0x21 : {'offset':1014,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x21},# 0x00
						0x22 : {'offset':1016,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x22},# 0x00
						0x23 : {'offset':1018,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x23},# 0x00
						0x24 : {'offset':1020,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x24},# 0x00
						0x25 : {'offset':1022,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x25},# 0x00
						0x26 : {'offset':1024,'bit':7,'bits':8,'parameter':'Tk2 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x26},# 0x00
						0x27 : {'offset':1026,'bit':7,'bits':16,'parameter':'Tk2 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2C,'subid':0x27},# 0x00
					},
	0x2D :  {
						# Track 3 Tone Adjust
						0x00 : {'offset':1140,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x00},# 0x00
						0x01 : {'offset':1141,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x01},# 0x00
						0x02 : {'offset':1142,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x02},# 0x00
						0x03 : {'offset':1144,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x03},# 0x00
						0x04 : {'offset':1145,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x04},# 0x00
						0x05 : {'offset':1146,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x05},# 0x00
						0x06 : {'offset':1148,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x06},# 0x00
						0x07 : {'offset':1149,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x07},# 0x00
						0x08 : {'offset':1150,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x08},# 0x00
						0x09 : {'offset':1152,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x09},# 0x00
						0x0A : {'offset':1153,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x0A},# 0x00
						0x0B : {'offset':1154,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x0B},# 0x00
						0x0C : {'offset':1156,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x0C},# 0x00
						0x0D : {'offset':1157,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x0D},# 0x00
						0x0E : {'offset':1158,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x0E},# 0x00
						0x0F : {'offset':1160,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x0F},# 0x00
						0x10 : {'offset':1161,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x10},# 0x00
						0x11 : {'offset':1162,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x11},# 0x00
						0x12 : {'offset':1164,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x12},# 0x00
						0x13 : {'offset':1165,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x13},# 0x00
						0x14 : {'offset':1166,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x14},# 0x00
						0x15 : {'offset':1168,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x15},# 0x00
						0x16 : {'offset':1169,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x16},# 0x00
						0x17 : {'offset':1170,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x17},# 0x00
						0x18 : {'offset':1108,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x18},# 0x00
						0x19 : {'offset':1110,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x19},# 0x00
						0x1A : {'offset':1112,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x1A},# 0x00
						0x1B : {'offset':1114,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x1B},# 0x00
						0x1C : {'offset':1116,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x1C},# 0x00
						0x1D : {'offset':1118,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x1D},# 0x00
						0x1E : {'offset':1120,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x1E},# 0x00
						0x1F : {'offset':1122,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x1F},# 0x00
						0x20 : {'offset':1124,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x20},# 0x00
						0x21 : {'offset':1126,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x21},# 0x00
						0x22 : {'offset':1128,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x22},# 0x00
						0x23 : {'offset':1130,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x23},# 0x00
						0x24 : {'offset':1132,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x24},# 0x00
						0x25 : {'offset':1134,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x25},# 0x00
						0x26 : {'offset':1136,'bit':7,'bits':8,'parameter':'Tk3 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x26},# 0x00
						0x27 : {'offset':1138,'bit':7,'bits':16,'parameter':'Tk3 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2D,'subid':0x27},# 0x00
					},
	0x2E :  {
						# Track 4 Tone Adjust
						0x00 : {'offset':1252,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x00},# 0x00
						0x01 : {'offset':1253,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x01},# 0x00
						0x02 : {'offset':1254,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x02},# 0x00
						0x03 : {'offset':1256,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x03},# 0x00
						0x04 : {'offset':1257,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x04},# 0x00
						0x05 : {'offset':1258,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x05},# 0x00
						0x06 : {'offset':1260,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x06},# 0x00
						0x07 : {'offset':1261,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x07},# 0x00
						0x08 : {'offset':1262,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x08},# 0x00
						0x09 : {'offset':1264,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x09},# 0x00
						0x0A : {'offset':1265,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x0A},# 0x00
						0x0B : {'offset':1266,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x0B},# 0x00
						0x0C : {'offset':1268,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x0C},# 0x00
						0x0D : {'offset':1269,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x0D},# 0x00
						0x0E : {'offset':1270,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x0E},# 0x00
						0x0F : {'offset':1272,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x0F},# 0x00
						0x10 : {'offset':1273,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x10},# 0x00
						0x11 : {'offset':1274,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x11},# 0x00
						0x12 : {'offset':1276,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x12},# 0x00
						0x13 : {'offset':1277,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x13},# 0x00
						0x14 : {'offset':1278,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x14},# 0x00
						0x15 : {'offset':1280,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x15},# 0x00
						0x16 : {'offset':1281,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x16},# 0x00
						0x17 : {'offset':1282,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x17},# 0x00
						0x18 : {'offset':1220,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x18},# 0x00
						0x19 : {'offset':1222,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x19},# 0x00
						0x1A : {'offset':1224,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x1A},# 0x00
						0x1B : {'offset':1226,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x1B},# 0x00
						0x1C : {'offset':1228,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x1C},# 0x00
						0x1D : {'offset':1230,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x1D},# 0x00
						0x1E : {'offset':1232,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x1E},# 0x00
						0x1F : {'offset':1234,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x1F},# 0x00
						0x20 : {'offset':1236,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x20},# 0x00
						0x21 : {'offset':1238,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x21},# 0x00
						0x22 : {'offset':1240,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x22},# 0x00
						0x23 : {'offset':1242,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x23},# 0x00
						0x24 : {'offset':1244,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x24},# 0x00
						0x25 : {'offset':1246,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x25},# 0x00
						0x26 : {'offset':1248,'bit':7,'bits':8,'parameter':'Tk4 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x26},# 0x00
						0x27 : {'offset':1250,'bit':7,'bits':16,'parameter':'Tk4 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2E,'subid':0x27},# 0x00
					},
	0x2F :  {
						# Track 5 Tone Adjust
						0x00 : {'offset':1364,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x00},# 0x00
						0x01 : {'offset':1365,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x01},# 0x00
						0x02 : {'offset':1366,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x02},# 0x00
						0x03 : {'offset':1368,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x03},# 0x00
						0x04 : {'offset':1369,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x04},# 0x00
						0x05 : {'offset':1370,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x05},# 0x00
						0x06 : {'offset':1372,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x06},# 0x00
						0x07 : {'offset':1373,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x07},# 0x00
						0x08 : {'offset':1374,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x08},# 0x00
						0x09 : {'offset':1376,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x09},# 0x00
						0x0A : {'offset':1377,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x0A},# 0x00
						0x0B : {'offset':1378,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x0B},# 0x00
						0x0C : {'offset':1380,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x0C},# 0x00
						0x0D : {'offset':1381,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x0D},# 0x00
						0x0E : {'offset':1382,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x0E},# 0x00
						0x0F : {'offset':1384,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x0F},# 0x00
						0x10 : {'offset':1385,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x10},# 0x00
						0x11 : {'offset':1386,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x11},# 0x00
						0x12 : {'offset':1388,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x12},# 0x00
						0x13 : {'offset':1389,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x13},# 0x00
						0x14 : {'offset':1390,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x14},# 0x00
						0x15 : {'offset':1392,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x15},# 0x00
						0x16 : {'offset':1393,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x16},# 0x00
						0x17 : {'offset':1394,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x17},# 0x00
						0x18 : {'offset':1332,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x18},# 0x00
						0x19 : {'offset':1334,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x19},# 0x00
						0x1A : {'offset':1336,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x1A},# 0x00
						0x1B : {'offset':1338,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x1B},# 0x00
						0x1C : {'offset':1340,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x1C},# 0x00
						0x1D : {'offset':1342,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x1D},# 0x00
						0x1E : {'offset':1344,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x1E},# 0x00
						0x1F : {'offset':1346,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x1F},# 0x00
						0x20 : {'offset':1348,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x20},# 0x00
						0x21 : {'offset':1350,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x21},# 0x00
						0x22 : {'offset':1352,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x22},# 0x00
						0x23 : {'offset':1354,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x23},# 0x00
						0x24 : {'offset':1356,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x24},# 0x00
						0x25 : {'offset':1358,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x25},# 0x00
						0x26 : {'offset':1360,'bit':7,'bits':8,'parameter':'Tk5 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x26},# 0x00
						0x27 : {'offset':1362,'bit':7,'bits':16,'parameter':'Tk5 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x2F,'subid':0x27},# 0x00
					},
	0x30 :  {
						# Track 6 Tone Adjust
						0x00 : {'offset':1476,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x00},# 0x00
						0x01 : {'offset':1477,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x01},# 0x00
						0x02 : {'offset':1478,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x02},# 0x00
						0x03 : {'offset':1480,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x03},# 0x00
						0x04 : {'offset':1481,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x04},# 0x00
						0x05 : {'offset':1482,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x05},# 0x00
						0x06 : {'offset':1484,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x06},# 0x00
						0x07 : {'offset':1485,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x07},# 0x00
						0x08 : {'offset':1486,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x08},# 0x00
						0x09 : {'offset':1488,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x09},# 0x00
						0x0A : {'offset':1489,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x0A},# 0x00
						0x0B : {'offset':1490,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x0B},# 0x00
						0x0C : {'offset':1492,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x0C},# 0x00
						0x0D : {'offset':1493,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x0D},# 0x00
						0x0E : {'offset':1494,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x0E},# 0x00
						0x0F : {'offset':1496,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x0F},# 0x00
						0x10 : {'offset':1497,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x10},# 0x00
						0x11 : {'offset':1498,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x11},# 0x00
						0x12 : {'offset':1500,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x12},# 0x00
						0x13 : {'offset':1501,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x13},# 0x00
						0x14 : {'offset':1502,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x14},# 0x00
						0x15 : {'offset':1504,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x15},# 0x00
						0x16 : {'offset':1505,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x16},# 0x00
						0x17 : {'offset':1506,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x17},# 0x00
						0x18 : {'offset':1444,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x18},# 0x00
						0x19 : {'offset':1446,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x19},# 0x00
						0x1A : {'offset':1448,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x1A},# 0x00
						0x1B : {'offset':1450,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x1B},# 0x00
						0x1C : {'offset':1452,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x1C},# 0x00
						0x1D : {'offset':1454,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x1D},# 0x00
						0x1E : {'offset':1456,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x1E},# 0x00
						0x1F : {'offset':1458,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x1F},# 0x00
						0x20 : {'offset':1460,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x20},# 0x00
						0x21 : {'offset':1462,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x21},# 0x00
						0x22 : {'offset':1464,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x22},# 0x00
						0x23 : {'offset':1466,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x23},# 0x00
						0x24 : {'offset':1468,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x24},# 0x00
						0x25 : {'offset':1470,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x25},# 0x00
						0x26 : {'offset':1472,'bit':7,'bits':8,'parameter':'Tk6 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x26},# 0x00
						0x27 : {'offset':1474,'bit':7,'bits':16,'parameter':'Tk6 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x30,'subid':0x27},# 0x00
					},
	0x31 :  {
						# Track 7 Tone Adjust
						0x00 : {'offset':1588,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x00},# 0x00
						0x01 : {'offset':1589,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x01},# 0x00
						0x02 : {'offset':1590,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x02},# 0x00
						0x03 : {'offset':1592,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x03},# 0x00
						0x04 : {'offset':1593,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x04},# 0x00
						0x05 : {'offset':1594,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x05},# 0x00
						0x06 : {'offset':1596,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x06},# 0x00
						0x07 : {'offset':1597,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x07},# 0x00
						0x08 : {'offset':1598,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x08},# 0x00
						0x09 : {'offset':1600,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x09},# 0x00
						0x0A : {'offset':1601,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x0A},# 0x00
						0x0B : {'offset':1602,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x0B},# 0x00
						0x0C : {'offset':1604,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x0C},# 0x00
						0x0D : {'offset':1605,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x0D},# 0x00
						0x0E : {'offset':1606,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x0E},# 0x00
						0x0F : {'offset':1608,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x0F},# 0x00
						0x10 : {'offset':1609,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x10},# 0x00
						0x11 : {'offset':1610,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x11},# 0x00
						0x12 : {'offset':1612,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x12},# 0x00
						0x13 : {'offset':1613,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x13},# 0x00
						0x14 : {'offset':1614,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x14},# 0x00
						0x15 : {'offset':1616,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x15},# 0x00
						0x16 : {'offset':1617,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x16},# 0x00
						0x17 : {'offset':1618,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x17},# 0x00
						0x18 : {'offset':1556,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x18},# 0x00
						0x19 : {'offset':1558,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x19},# 0x00
						0x1A : {'offset':1560,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x1A},# 0x00
						0x1B : {'offset':1562,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x1B},# 0x00
						0x1C : {'offset':1564,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x1C},# 0x00
						0x1D : {'offset':1566,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x1D},# 0x00
						0x1E : {'offset':1568,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x1E},# 0x00
						0x1F : {'offset':1570,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x1F},# 0x00
						0x20 : {'offset':1572,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x20},# 0x00
						0x21 : {'offset':1574,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x21},# 0x00
						0x22 : {'offset':1576,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x22},# 0x00
						0x23 : {'offset':1578,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x23},# 0x00
						0x24 : {'offset':1580,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x24},# 0x00
						0x25 : {'offset':1582,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x25},# 0x00
						0x26 : {'offset':1584,'bit':7,'bits':8,'parameter':'Tk7 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x26},# 0x00
						0x27 : {'offset':1586,'bit':7,'bits':16,'parameter':'Tk7 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x31,'subid':0x27},# 0x00
					},
	0x32 :  {
						# Track 8 Tone Adjust
						0x00 : {'offset':1700,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x00},# 0x00
						0x01 : {'offset':1701,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x01},# 0x00
						0x02 : {'offset':1702,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x02},# 0x00
						0x03 : {'offset':1704,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x03},# 0x00
						0x04 : {'offset':1705,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x04},# 0x00
						0x05 : {'offset':1706,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x05},# 0x00
						0x06 : {'offset':1708,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x06},# 0x00
						0x07 : {'offset':1709,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x07},# 0x00
						0x08 : {'offset':1710,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x08},# 0x00
						0x09 : {'offset':1712,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x09},# 0x00
						0x0A : {'offset':1713,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x0A},# 0x00
						0x0B : {'offset':1714,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x0B},# 0x00
						0x0C : {'offset':1716,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x0C},# 0x00
						0x0D : {'offset':1717,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x0D},# 0x00
						0x0E : {'offset':1718,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x0E},# 0x00
						0x0F : {'offset':1720,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x0F},# 0x00
						0x10 : {'offset':1721,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x10},# 0x00
						0x11 : {'offset':1722,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x11},# 0x00
						0x12 : {'offset':1724,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x12},# 0x00
						0x13 : {'offset':1725,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x13},# 0x00
						0x14 : {'offset':1726,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x14},# 0x00
						0x15 : {'offset':1728,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x15},# 0x00
						0x16 : {'offset':1729,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x16},# 0x00
						0x17 : {'offset':1730,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x17},# 0x00
						0x18 : {'offset':1668,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x18},# 0x00
						0x19 : {'offset':1670,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x19},# 0x00
						0x1A : {'offset':1672,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x1A},# 0x00
						0x1B : {'offset':1674,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x1B},# 0x00
						0x1C : {'offset':1676,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x1C},# 0x00
						0x1D : {'offset':1678,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x1D},# 0x00
						0x1E : {'offset':1680,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x1E},# 0x00
						0x1F : {'offset':1682,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x1F},# 0x00
						0x20 : {'offset':1684,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x20},# 0x00
						0x21 : {'offset':1686,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x21},# 0x00
						0x22 : {'offset':1688,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x22},# 0x00
						0x23 : {'offset':1690,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x23},# 0x00
						0x24 : {'offset':1692,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x24},# 0x00
						0x25 : {'offset':1694,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x25},# 0x00
						0x26 : {'offset':1696,'bit':7,'bits':8,'parameter':'Tk8 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x26},# 0x00
						0x27 : {'offset':1698,'bit':7,'bits':16,'parameter':'Tk8 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x32,'subid':0x27},# 0x00
					},
	0x33 :  {
						# Track 9 Tone Adjust
						0x00 : {'offset':1812,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x00},# 0x00
						0x01 : {'offset':1813,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x01},# 0x00
						0x02 : {'offset':1814,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x02},# 0x00
						0x03 : {'offset':1816,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x03},# 0x00
						0x04 : {'offset':1817,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x04},# 0x00
						0x05 : {'offset':1818,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x05},# 0x00
						0x06 : {'offset':1820,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x06},# 0x00
						0x07 : {'offset':1821,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x07},# 0x00
						0x08 : {'offset':1822,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x08},# 0x00
						0x09 : {'offset':1824,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x09},# 0x00
						0x0A : {'offset':1825,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x0A},# 0x00
						0x0B : {'offset':1826,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x0B},# 0x00
						0x0C : {'offset':1828,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x0C},# 0x00
						0x0D : {'offset':1829,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x0D},# 0x00
						0x0E : {'offset':1830,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x0E},# 0x00
						0x0F : {'offset':1832,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x0F},# 0x00
						0x10 : {'offset':1833,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x10},# 0x00
						0x11 : {'offset':1834,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x11},# 0x00
						0x12 : {'offset':1836,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x12},# 0x00
						0x13 : {'offset':1837,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x13},# 0x00
						0x14 : {'offset':1838,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x14},# 0x00
						0x15 : {'offset':1840,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x15},# 0x00
						0x16 : {'offset':1841,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x16},# 0x00
						0x17 : {'offset':1842,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x17},# 0x00
						0x18 : {'offset':1780,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x18},# 0x00
						0x19 : {'offset':1782,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x19},# 0x00
						0x1A : {'offset':1784,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x1A},# 0x00
						0x1B : {'offset':1786,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x1B},# 0x00
						0x1C : {'offset':1788,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x1C},# 0x00
						0x1D : {'offset':1790,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x1D},# 0x00
						0x1E : {'offset':1792,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x1E},# 0x00
						0x1F : {'offset':1794,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x1F},# 0x00
						0x20 : {'offset':1796,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x20},# 0x00
						0x21 : {'offset':1798,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x21},# 0x00
						0x22 : {'offset':1800,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x22},# 0x00
						0x23 : {'offset':1802,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x23},# 0x00
						0x24 : {'offset':1804,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x24},# 0x00
						0x25 : {'offset':1806,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x25},# 0x00
						0x26 : {'offset':1808,'bit':7,'bits':8,'parameter':'Tk9 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x26},# 0x00
						0x27 : {'offset':1810,'bit':7,'bits':16,'parameter':'Tk9 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x33,'subid':0x27},# 0x00
					},
	0x34 :  {
						# Track 10 Tone Adjust
						0x00 : {'offset':1924,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x00},# 0x00
						0x01 : {'offset':1925,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x01},# 0x00
						0x02 : {'offset':1926,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x02},# 0x00
						0x03 : {'offset':1928,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x03},# 0x00
						0x04 : {'offset':1929,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x04},# 0x00
						0x05 : {'offset':1930,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x05},# 0x00
						0x06 : {'offset':1932,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x06},# 0x00
						0x07 : {'offset':1933,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x07},# 0x00
						0x08 : {'offset':1934,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x08},# 0x00
						0x09 : {'offset':1936,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x09},# 0x00
						0x0A : {'offset':1937,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x0A},# 0x00
						0x0B : {'offset':1938,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x0B},# 0x00
						0x0C : {'offset':1940,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x0C},# 0x00
						0x0D : {'offset':1941,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x0D},# 0x00
						0x0E : {'offset':1942,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x0E},# 0x00
						0x0F : {'offset':1944,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x0F},# 0x00
						0x10 : {'offset':1945,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x10},# 0x00
						0x11 : {'offset':1946,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x11},# 0x00
						0x12 : {'offset':1948,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x12},# 0x00
						0x13 : {'offset':1949,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x13},# 0x00
						0x14 : {'offset':1950,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x14},# 0x00
						0x15 : {'offset':1952,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x15},# 0x00
						0x16 : {'offset':1953,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x16},# 0x00
						0x17 : {'offset':1954,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x17},# 0x00
						0x18 : {'offset':1892,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x18},# 0x00
						0x19 : {'offset':1894,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x19},# 0x00
						0x1A : {'offset':1896,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x1A},# 0x00
						0x1B : {'offset':1898,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x1B},# 0x00
						0x1C : {'offset':1900,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x1C},# 0x00
						0x1D : {'offset':1902,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x1D},# 0x00
						0x1E : {'offset':1904,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x1E},# 0x00
						0x1F : {'offset':1906,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x1F},# 0x00
						0x20 : {'offset':1908,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x20},# 0x00
						0x21 : {'offset':1910,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x21},# 0x00
						0x22 : {'offset':1912,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x22},# 0x00
						0x23 : {'offset':1914,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x23},# 0x00
						0x24 : {'offset':1916,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x24},# 0x00
						0x25 : {'offset':1918,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x25},# 0x00
						0x26 : {'offset':1920,'bit':7,'bits':8,'parameter':'Tk10 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x26},# 0x00
						0x27 : {'offset':1922,'bit':7,'bits':16,'parameter':'Tk10 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x34,'subid':0x27},# 0x00
					},
	0x35 :  {
						# Track 11 Tone Adjust
						0x00 : {'offset':2036,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x00},# 0x00
						0x01 : {'offset':2037,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x01},# 0x00
						0x02 : {'offset':2038,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x02},# 0x00
						0x03 : {'offset':2040,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x03},# 0x00
						0x04 : {'offset':2041,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x04},# 0x00
						0x05 : {'offset':2042,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x05},# 0x00
						0x06 : {'offset':2044,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x06},# 0x00
						0x07 : {'offset':2045,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x07},# 0x00
						0x08 : {'offset':2046,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x08},# 0x00
						0x09 : {'offset':2048,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x09},# 0x00
						0x0A : {'offset':2049,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x0A},# 0x00
						0x0B : {'offset':2050,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x0B},# 0x00
						0x0C : {'offset':2052,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x0C},# 0x00
						0x0D : {'offset':2053,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x0D},# 0x00
						0x0E : {'offset':2054,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x0E},# 0x00
						0x0F : {'offset':2056,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x0F},# 0x00
						0x10 : {'offset':2057,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x10},# 0x00
						0x11 : {'offset':2058,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x11},# 0x00
						0x12 : {'offset':2060,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x12},# 0x00
						0x13 : {'offset':2061,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x13},# 0x00
						0x14 : {'offset':2062,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x14},# 0x00
						0x15 : {'offset':2064,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x15},# 0x00
						0x16 : {'offset':2065,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x16},# 0x00
						0x17 : {'offset':2066,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x17},# 0x00
						0x18 : {'offset':2004,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x18},# 0x00
						0x19 : {'offset':2006,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x19},# 0x00
						0x1A : {'offset':2008,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x1A},# 0x00
						0x1B : {'offset':2010,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x1B},# 0x00
						0x1C : {'offset':2012,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x1C},# 0x00
						0x1D : {'offset':2014,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x1D},# 0x00
						0x1E : {'offset':2016,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x1E},# 0x00
						0x1F : {'offset':2018,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x1F},# 0x00
						0x20 : {'offset':2020,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x20},# 0x00
						0x21 : {'offset':2022,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x21},# 0x00
						0x22 : {'offset':2024,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x22},# 0x00
						0x23 : {'offset':2026,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x23},# 0x00
						0x24 : {'offset':2028,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x24},# 0x00
						0x25 : {'offset':2030,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x25},# 0x00
						0x26 : {'offset':2032,'bit':7,'bits':8,'parameter':'Tk11 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x26},# 0x00
						0x27 : {'offset':2034,'bit':7,'bits':16,'parameter':'Tk11 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x35,'subid':0x27},# 0x00
					},
	0x36 :  {
						# Track 12 Tone Adjust
						0x00 : {'offset':2148,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x00},# 0x00
						0x01 : {'offset':2149,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x01},# 0x00
						0x02 : {'offset':2150,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x02},# 0x00
						0x03 : {'offset':2152,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x03},# 0x00
						0x04 : {'offset':2153,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x04},# 0x00
						0x05 : {'offset':2154,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x05},# 0x00
						0x06 : {'offset':2156,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x06},# 0x00
						0x07 : {'offset':2157,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x07},# 0x00
						0x08 : {'offset':2158,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x08},# 0x00
						0x09 : {'offset':2160,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x09},# 0x00
						0x0A : {'offset':2161,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x0A},# 0x00
						0x0B : {'offset':2162,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x0B},# 0x00
						0x0C : {'offset':2164,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x0C},# 0x00
						0x0D : {'offset':2165,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x0D},# 0x00
						0x0E : {'offset':2166,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x0E},# 0x00
						0x0F : {'offset':2168,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x0F},# 0x00
						0x10 : {'offset':2169,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x10},# 0x00
						0x11 : {'offset':2170,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x11},# 0x00
						0x12 : {'offset':2172,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x12},# 0x00
						0x13 : {'offset':2173,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x13},# 0x00
						0x14 : {'offset':2174,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x14},# 0x00
						0x15 : {'offset':2176,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x15},# 0x00
						0x16 : {'offset':2177,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x16},# 0x00
						0x17 : {'offset':2178,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x17},# 0x00
						0x18 : {'offset':2116,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x18},# 0x00
						0x19 : {'offset':2118,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x19},# 0x00
						0x1A : {'offset':2120,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x1A},# 0x00
						0x1B : {'offset':2122,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x1B},# 0x00
						0x1C : {'offset':2124,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x1C},# 0x00
						0x1D : {'offset':2126,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x1D},# 0x00
						0x1E : {'offset':2128,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x1E},# 0x00
						0x1F : {'offset':2130,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x1F},# 0x00
						0x20 : {'offset':2132,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x20},# 0x00
						0x21 : {'offset':2134,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x21},# 0x00
						0x22 : {'offset':2136,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x22},# 0x00
						0x23 : {'offset':2138,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x23},# 0x00
						0x24 : {'offset':2140,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x24},# 0x00
						0x25 : {'offset':2142,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x25},# 0x00
						0x26 : {'offset':2144,'bit':7,'bits':8,'parameter':'Tk12 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x26},# 0x00
						0x27 : {'offset':2146,'bit':7,'bits':16,'parameter':'Tk12 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x36,'subid':0x27},# 0x00
					},
	0x37 :  {
						# Track 13 Tone Adjust
						0x00 : {'offset':2260,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x00},# 0x00
						0x01 : {'offset':2261,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x01},# 0x00
						0x02 : {'offset':2262,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x02},# 0x00
						0x03 : {'offset':2264,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x03},# 0x00
						0x04 : {'offset':2265,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x04},# 0x00
						0x05 : {'offset':2266,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x05},# 0x00
						0x06 : {'offset':2268,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x06},# 0x00
						0x07 : {'offset':2269,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x07},# 0x00
						0x08 : {'offset':2270,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x08},# 0x00
						0x09 : {'offset':2272,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x09},# 0x00
						0x0A : {'offset':2273,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x0A},# 0x00
						0x0B : {'offset':2274,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x0B},# 0x00
						0x0C : {'offset':2276,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x0C},# 0x00
						0x0D : {'offset':2277,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x0D},# 0x00
						0x0E : {'offset':2278,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x0E},# 0x00
						0x0F : {'offset':2280,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x0F},# 0x00
						0x10 : {'offset':2281,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x10},# 0x00
						0x11 : {'offset':2282,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x11},# 0x00
						0x12 : {'offset':2284,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x12},# 0x00
						0x13 : {'offset':2285,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x13},# 0x00
						0x14 : {'offset':2286,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x14},# 0x00
						0x15 : {'offset':2288,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x15},# 0x00
						0x16 : {'offset':2289,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x16},# 0x00
						0x17 : {'offset':2290,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x17},# 0x00
						0x18 : {'offset':2228,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x18},# 0x00
						0x19 : {'offset':2230,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x19},# 0x00
						0x1A : {'offset':2232,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x1A},# 0x00
						0x1B : {'offset':2234,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x1B},# 0x00
						0x1C : {'offset':2236,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x1C},# 0x00
						0x1D : {'offset':2238,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x1D},# 0x00
						0x1E : {'offset':2240,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x1E},# 0x00
						0x1F : {'offset':2242,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x1F},# 0x00
						0x20 : {'offset':2244,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x20},# 0x00
						0x21 : {'offset':2246,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x21},# 0x00
						0x22 : {'offset':2248,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x22},# 0x00
						0x23 : {'offset':2250,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x23},# 0x00
						0x24 : {'offset':2252,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x24},# 0x00
						0x25 : {'offset':2254,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x25},# 0x00
						0x26 : {'offset':2256,'bit':7,'bits':8,'parameter':'Tk13 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x26},# 0x00
						0x27 : {'offset':2258,'bit':7,'bits':16,'parameter':'Tk13 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x37,'subid':0x27},# 0x00
					},
	0x38 :  {
						# Track 14 Tone Adjust
						0x00 : {'offset':2372,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x00},# 0x00
						0x01 : {'offset':2373,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x01},# 0x00
						0x02 : {'offset':2374,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x02},# 0x00
						0x03 : {'offset':2376,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x03},# 0x00
						0x04 : {'offset':2377,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x04},# 0x00
						0x05 : {'offset':2378,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x05},# 0x00
						0x06 : {'offset':2380,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x06},# 0x00
						0x07 : {'offset':2381,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x07},# 0x00
						0x08 : {'offset':2382,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x08},# 0x00
						0x09 : {'offset':2384,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x09},# 0x00
						0x0A : {'offset':2385,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x0A},# 0x00
						0x0B : {'offset':2386,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x0B},# 0x00
						0x0C : {'offset':2388,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x0C},# 0x00
						0x0D : {'offset':2389,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x0D},# 0x00
						0x0E : {'offset':2390,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x0E},# 0x00
						0x0F : {'offset':2392,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x0F},# 0x00
						0x10 : {'offset':2393,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x10},# 0x00
						0x11 : {'offset':2394,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x11},# 0x00
						0x12 : {'offset':2396,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x12},# 0x00
						0x13 : {'offset':2397,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x13},# 0x00
						0x14 : {'offset':2398,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x14},# 0x00
						0x15 : {'offset':2400,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x15},# 0x00
						0x16 : {'offset':2401,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x16},# 0x00
						0x17 : {'offset':2402,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x17},# 0x00
						0x18 : {'offset':2340,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x18},# 0x00
						0x19 : {'offset':2342,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x19},# 0x00
						0x1A : {'offset':2344,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x1A},# 0x00
						0x1B : {'offset':2346,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x1B},# 0x00
						0x1C : {'offset':2348,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x1C},# 0x00
						0x1D : {'offset':2350,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x1D},# 0x00
						0x1E : {'offset':2352,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x1E},# 0x00
						0x1F : {'offset':2354,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x1F},# 0x00
						0x20 : {'offset':2356,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x20},# 0x00
						0x21 : {'offset':2358,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x21},# 0x00
						0x22 : {'offset':2360,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x22},# 0x00
						0x23 : {'offset':2362,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x23},# 0x00
						0x24 : {'offset':2364,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x24},# 0x00
						0x25 : {'offset':2366,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x25},# 0x00
						0x26 : {'offset':2368,'bit':7,'bits':8,'parameter':'Tk14 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x26},# 0x00
						0x27 : {'offset':2370,'bit':7,'bits':16,'parameter':'Tk14 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x38,'subid':0x27},# 0x00
					},
	0x39 :  {
						# Track 15 Tone Adjust
						0x00 : {'offset':2484,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x00},# 0x00
						0x01 : {'offset':2485,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x01},# 0x00
						0x02 : {'offset':2486,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x02},# 0x00
						0x03 : {'offset':2488,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x03},# 0x00
						0x04 : {'offset':2489,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x04},# 0x00
						0x05 : {'offset':2490,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x05},# 0x00
						0x06 : {'offset':2492,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x06},# 0x00
						0x07 : {'offset':2493,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x07},# 0x00
						0x08 : {'offset':2494,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x08},# 0x00
						0x09 : {'offset':2496,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x09},# 0x00
						0x0A : {'offset':2497,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x0A},# 0x00
						0x0B : {'offset':2498,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x0B},# 0x00
						0x0C : {'offset':2500,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x0C},# 0x00
						0x0D : {'offset':2501,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x0D},# 0x00
						0x0E : {'offset':2502,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x0E},# 0x00
						0x0F : {'offset':2504,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x0F},# 0x00
						0x10 : {'offset':2505,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x10},# 0x00
						0x11 : {'offset':2506,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x11},# 0x00
						0x12 : {'offset':2508,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x12},# 0x00
						0x13 : {'offset':2509,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x13},# 0x00
						0x14 : {'offset':2510,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x14},# 0x00
						0x15 : {'offset':2512,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x15},# 0x00
						0x16 : {'offset':2513,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x16},# 0x00
						0x17 : {'offset':2514,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x17},# 0x00
						0x18 : {'offset':2452,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x18},# 0x00
						0x19 : {'offset':2454,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x19},# 0x00
						0x1A : {'offset':2456,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x1A},# 0x00
						0x1B : {'offset':2458,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x1B},# 0x00
						0x1C : {'offset':2460,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x1C},# 0x00
						0x1D : {'offset':2462,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x1D},# 0x00
						0x1E : {'offset':2464,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x1E},# 0x00
						0x1F : {'offset':2466,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x1F},# 0x00
						0x20 : {'offset':2468,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x20},# 0x00
						0x21 : {'offset':2470,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x21},# 0x00
						0x22 : {'offset':2472,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x22},# 0x00
						0x23 : {'offset':2474,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x23},# 0x00
						0x24 : {'offset':2476,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x24},# 0x00
						0x25 : {'offset':2478,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x25},# 0x00
						0x26 : {'offset':2480,'bit':7,'bits':8,'parameter':'Tk15 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x26},# 0x00
						0x27 : {'offset':2482,'bit':7,'bits':16,'parameter':'Tk15 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x39,'subid':0x27},# 0x00
					},
	0x3A :  {
						# Track 16 Tone Adjust
						0x00 : {'offset':2596,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x00},# 0x00
						0x01 : {'offset':2597,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 1 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x01},# 0x00
						0x02 : {'offset':2598,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Switch 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x02},# 0x00
						0x03 : {'offset':2600,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x03},# 0x00
						0x04 : {'offset':2601,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 2 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x04},# 0x00
						0x05 : {'offset':2602,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Switch 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x05},# 0x00
						0x06 : {'offset':2604,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x06},# 0x00
						0x07 : {'offset':2605,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 3 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x07},# 0x00
						0x08 : {'offset':2606,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Switch 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x08},# 0x00
						0x09 : {'offset':2608,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x09},# 0x00
						0x0A : {'offset':2609,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 4 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x0A},# 0x00
						0x0B : {'offset':2610,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Switch 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x0B},# 0x00
						0x0C : {'offset':2612,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x0C},# 0x00
						0x0D : {'offset':2613,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 5 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x0D},# 0x00
						0x0E : {'offset':2614,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Switch 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x0E},# 0x00
						0x0F : {'offset':2616,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x0F},# 0x00
						0x10 : {'offset':2617,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 6 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x10},# 0x00
						0x11 : {'offset':2618,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Switch 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x11},# 0x00
						0x12 : {'offset':2620,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x12},# 0x00
						0x13 : {'offset':2621,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 7 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x13},# 0x00
						0x14 : {'offset':2622,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Switch 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x14},# 0x00
						0x15 : {'offset':2624,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x15},# 0x00
						0x16 : {'offset':2625,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Switch 8 Off/On','range':{0: 'Off', 1: 'On'},'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x16},# 0x00
						0x17 : {'offset':2626,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Switch 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x17},# 0x00
						0x18 : {'offset':2564,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Slider 1 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x18},# 0x00
						0x19 : {'offset':2566,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Slider 1 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x19},# 0x00
						0x1A : {'offset':2568,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Slider 2 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x1A},# 0x00
						0x1B : {'offset':2570,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Slider 2 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x1B},# 0x00
						0x1C : {'offset':2572,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Slider 3 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x1C},# 0x00
						0x1D : {'offset':2574,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Slider 3 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x1D},# 0x00
						0x1E : {'offset':2576,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Slider 4 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x1E},# 0x00
						0x1F : {'offset':2578,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Slider 4 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x1F},# 0x00
						0x20 : {'offset':2580,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Slider 5 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x20},# 0x00
						0x21 : {'offset':2582,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Slider 5 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x21},# 0x00
						0x22 : {'offset':2584,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Slider 6 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x22},# 0x00
						0x23 : {'offset':2586,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Slider 6 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x23},# 0x00
						0x24 : {'offset':2588,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Slider 7 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x24},# 0x00
						0x25 : {'offset':2590,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Slider 7 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x25},# 0x00
						0x26 : {'offset':2592,'bit':7,'bits':8,'parameter':'Tk16 Tone Adjust Slider 8 Assign','range':(0,0x4D),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x26},# 0x00
						0x27 : {'offset':2594,'bit':7,'bits':16,'parameter':'Tk16 Tone Adjust Slider 8 Value','range':(-0x3FFF,0x3FFE),'bias':0,'step':None,'mode':0x04,'id':0x3A,'subid':0x27},# 0x00
					},
	0x3B :  {
						# Table 11
						0x00 : {'offset':1,'bit':7,'bits':8,'parameter':'Current Track','range':(0, 0x10),'bias':0,'step':None,'mode':0x04,'id':0x3B,'subid':0x00},
						0x01 : {'offset':4,'bit':7,'bits':16,'parameter':'Tempo','range':(0xFA0, 0x7530),'bias':0,'step':None,'mode':0x04,'id':0x3B,'subid':0x01},
					},
	0x65 :  {
						# Insert Effect 1-5 Parameters
						0x00 : {'offset': 88,'bit':7,'bits':8,'parameter':'IFX1 Effect Type','range':(0,0xC1),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x00},
						0x01 : {'offset':164,'bit':7,'bits':8,'parameter':'IFX2 Effect Type','range':(0,0xC1),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x01},
						0x02 : {'offset':240,'bit':7,'bits':8,'parameter':'IFX3 Effect Type','range':(0,0xC1),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x02},
						0x03 : {'offset':316,'bit':7,'bits':8,'parameter':'IFX4 Effect Type','range':(0,0xC1),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x03},
						0x04 : {'offset':392,'bit':7,'bits':8,'parameter':'IFX5 Effect Type','range':(0,0xAB),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x04},
						0x05 : {'offset': 89,'bit':6,'bits':1,'parameter':'IFX1 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x05},
						0x06 : {'offset':165,'bit':6,'bits':1,'parameter':'IFX2 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x06},
						0x07 : {'offset':241,'bit':6,'bits':1,'parameter':'IFX3 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x07},
						0x08 : {'offset':317,'bit':6,'bits':1,'parameter':'IFX4 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x08},
						0x09 : {'offset':393,'bit':6,'bits':1,'parameter':'IFX5 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x09},
						0x0A : {'offset': 92,'bit':7,'bits':8,'parameter':'IFX1 Pan','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x0A},
						0x0B : {'offset':168,'bit':7,'bits':8,'parameter':'IFX2 Pan','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x0B},
						0x0C : {'offset':244,'bit':7,'bits':8,'parameter':'IFX3 Pan','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x0C},
						0x0D : {'offset':320,'bit':7,'bits':8,'parameter':'IFX4 Pan','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x0D},
						0x0E : {'offset':396,'bit':7,'bits':8,'parameter':'IFX5 Pan','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x0E},
						0x0F : {'offset': 93,'bit':3,'bits':4,'parameter':'IFX1 Bus Select','range':{00:'L/R', 07:'Off'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x0F},
						0x10 : {'offset':169,'bit':3,'bits':4,'parameter':'IFX2 Bus Select','range':{00:'L/R', 07:'Off'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x10},
						0x11 : {'offset':245,'bit':3,'bits':4,'parameter':'IFX3 Bus Select','range':{00:'L/R', 07:'Off'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x11},
						0x12 : {'offset':321,'bit':3,'bits':4,'parameter':'IFX4 Bus Select','range':{00:'L/R', 07:'Off'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x12},
						0x13 : {'offset':397,'bit':3,'bits':4,'parameter':'IFX5 Bus Select','range':{00:'L/R', 07:'Off'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x13},
						0x14 : {'offset': 94,'bit':7,'bits':8,'parameter':'IFX1 Send 1 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x14},
						0x15 : {'offset':170,'bit':7,'bits':8,'parameter':'IFX2 Send 1 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x15},
						0x16 : {'offset':246,'bit':7,'bits':8,'parameter':'IFX3 Send 1 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x16},
						0x17 : {'offset':322,'bit':7,'bits':8,'parameter':'IFX4 Send 1 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x17},
						0x18 : {'offset':398,'bit':7,'bits':8,'parameter':'IFX5 Send 1 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x18},
						0x19 : {'offset': 95,'bit':7,'bits':8,'parameter':'IFX1 Send 2 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x19},
						0x1A : {'offset':171,'bit':7,'bits':8,'parameter':'IFX2 Send 2 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x1A},
						0x1B : {'offset':247,'bit':7,'bits':8,'parameter':'IFX3 Send 2 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x1B},
						0x1C : {'offset':323,'bit':7,'bits':8,'parameter':'IFX4 Send 2 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x1C},
						0x1D : {'offset':399,'bit':7,'bits':8,'parameter':'IFX5 Send 2 Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x1D},
						0x1E : {'offset': 93,'bit':5,'bits':2,'parameter':'IFX1 FX Control','range':{0:'Off',01:'FX Ctrl1',02:'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x1E},
						0x1F : {'offset':169,'bit':5,'bits':2,'parameter':'IFX2 FX Control','range':{0:'Off',01:'FX Ctrl1',02:'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x1F},
						0x20 : {'offset':245,'bit':5,'bits':2,'parameter':'IFX3 FX Control','range':{0:'Off',01:'FX Ctrl1',02:'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x20},
						0x21 : {'offset':321,'bit':5,'bits':2,'parameter':'IFX4 FX Control','range':{0:'Off',01:'FX Ctrl1',02:'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x21},
						0x22 : {'offset':397,'bit':5,'bits':2,'parameter':'IFX5 FX Control','range':{0:'Off',01:'FX Ctrl1',02:'FX Ctrl2'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x22},
						0x28 : {'offset': 89,'bit':7,'bits':1,'parameter':'IFX1 Chain','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x28},
						0x29 : {'offset':165,'bit':7,'bits':1,'parameter':'IFX2 Chain','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x29},
						0x2A : {'offset':241,'bit':7,'bits':1,'parameter':'IFX3 Chain','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x2A},
						0x2B : {'offset':317,'bit':7,'bits':1,'parameter':'IFX4 Chain','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x2B},
						0x2C : {'offset': 90,'bit':7,'bits':8,'parameter':'IFX1 Chain To','range':{0:'IF2',1:'IFX3',2:'IFX4',3:'IFX5'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x2C},
						0x2D : {'offset':166,'bit':7,'bits':8,'parameter':'IFX2 Chain To','range':{0:'IF3',1:'IFX4',2:'IFX5'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x2D},
						0x2E : {'offset':242,'bit':7,'bits':8,'parameter':'IFX3 Chain To','range':{0:'IF4',1:'IFX5'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x2E},
						0x2F : {'offset':89,'bit':5,'bits':6,'parameter':'IFX1 Channel','range':{0:'Ch01',1:'Ch02',2:'Ch03',3:'Ch04',4:'Ch05',5:'Ch06',6:'Ch07',7:'Ch08',8:'Ch09',9:'Ch10',10:'Ch11',11:'Ch12',12:'Ch13',13:'Ch14',14:'Ch15',15:'Ch16',16:'G ch',17:'All-R'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x2F},# 0x00
						0x30 : {'offset':165,'bit':5,'bits':6,'parameter':'IFX2 Channel','range':{0:'Ch01',1:'Ch02',2:'Ch03',3:'Ch04',4:'Ch05',5:'Ch06',6:'Ch07',7:'Ch08',8:'Ch09',9:'Ch10',10:'Ch11',11:'Ch12',12:'Ch13',13:'Ch14',14:'Ch15',15:'Ch16',16:'G ch',17:'All-R'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x30},# 0x00
						0x31 : {'offset':241,'bit':5,'bits':6,'parameter':'IFX3 Channel','range':{0:'Ch01',1:'Ch02',2:'Ch03',3:'Ch04',4:'Ch05',5:'Ch06',6:'Ch07',7:'Ch08',8:'Ch09',9:'Ch10',10:'Ch11',11:'Ch12',12:'Ch13',13:'Ch14',14:'Ch15',15:'Ch16',16:'G ch',17:'All-R'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x31},# 0x00
						0x32 : {'offset':317,'bit':5,'bits':6,'parameter':'IFX4 Channel','range':{0:'Ch01',1:'Ch02',2:'Ch03',3:'Ch04',4:'Ch05',5:'Ch06',6:'Ch07',7:'Ch08',8:'Ch09',9:'Ch10',10:'Ch11',11:'Ch12',12:'Ch13',13:'Ch14',14:'Ch15',15:'Ch16',16:'G ch',17:'All-R'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x32},# 0x00
						0x33 : {'offset':393,'bit':5,'bits':6,'parameter':'IFX5 Channel','range':{0:'Ch01',1:'Ch02',2:'Ch03',3:'Ch04',4:'Ch05',5:'Ch06',6:'Ch07',7:'Ch08',8:'Ch09',9:'Ch10',10:'Ch11',11:'Ch12',12:'Ch13',13:'Ch14',14:'Ch15',15:'Ch16',16:'G ch',17:'All-R'},'bias':0,'step':None,'mode':0x04,'id':0x65,'subid':0x33},# 0x00
					},
	0x66 :  {
						# Insert Effect 1 Parameter Structure
						0x00 : {'offset':24,'bit':7,'bits':8*64,'parameter':'IFX1 Effect Parameter Structure','range':None,'bias':0,'step':None,'mode':0x04,'id':0x66,'subid':0xFF},
					},
	0x67 :  {
						# Insert Effect 2 Parameter Structure
						0x00 : {'offset':100,'bit':7,'bits':8*64,'parameter':'IFX2 Effect Parameter Structure','range':None,'bias':0,'step':None,'mode':0x04,'id':0x67,'subid':0xFF},
					},
	0x68 :  {
						# Insert Effect 3 Parameter Structure
						0x00 : {'offset':176,'bit':7,'bits':8*64,'parameter':'IFX3 Effect Parameter Structure','range':None,'bias':0,'step':None,'mode':0x04,'id':0x68,'subid':0xFF},
					},
	0x69 :  {
						# Insert Effect 4 Parameter Structure
						0x00 : {'offset':252,'bit':7,'bits':8*64,'parameter':'IFX4 Effect Parameter Structure','range':None,'bias':0,'step':None,'mode':0x04,'id':0x69,'subid':0xFF},
					},
	0x6A :  {
						# Insert Effect 5 Parameter Structure
						0x00 : {'offset':328,'bit':7,'bits':8*64,'parameter':'IFX5 Effect Parameter Structure','range':None,'bias':0,'step':None,'mode':0x04,'id':0x6A,'subid':0xFF},
					},
	0x6B :  {
						0x00 : {'offset':468,'bit':7,'bits':8,'parameter':'MFX1 Effect Type','range':(0,0xC1),'bias':0,'step':None,'mode':0x04,'id':0x6B,'subid':0x00},
						0x01 : {'offset':536,'bit':7,'bits':8,'parameter':'MFX2 Effect Type','range':(0,0xC1),'bias':0,'step':None,'mode':0x04,'id':0x6B,'subid':0x01},
						0x02 : {'offset':469,'bit':6,'bits':1,'parameter':'MFX1 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x6B,'subid':0x02},
						0x03 : {'offset':537,'bit':6,'bits':1,'parameter':'MFX2 On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x6B,'subid':0x03},
						0x04 : {'offset':540,'bit':7,'bits':8,'parameter':'MFX1 Return Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x6B,'subid':0x04},
						0x05 : {'offset':541,'bit':7,'bits':8,'parameter':'MFX2 Return Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x6B,'subid':0x05},
						0x06 : {'offset':542,'bit':1,'bits':1,'parameter':'MFX Chain On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x6B,'subid':0x06},
						0x07 : {'offset':542,'bit':0,'bits':1,'parameter':'MFX Chain Direction','range':{0:'MFX1->MFX2', 1:'MFX2->MFX1'},'bias':0,'step':None,'mode':0x04,'id':0x6B,'subid':0x07},
						0x08 : {'offset':543,'bit':7,'bits':8,'parameter':'MFX Chain Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x6B,'subid':0x08},
					},
	0x6C :  {
						# Master Effect 1 Parameter Structure
						0x00 : {'offset':404,'bit':7,'bits':8*64,'parameter':'MFX1 Effect Parameter Structure','range':None,'bias':0,'step':None,'mode':0x04,'id':0x6C,'subid':0xFF},
					},
	0x6D :  {
						# Master Effect 2 Parameter Structure
						0x00 : {'offset':472,'bit':7,'bits':8*64,'parameter':'MFX2 Effect Parameter Structure','range':None,'bias':0,'step':None,'mode':0x04,'id':0x6D,'subid':0xFF},
					},
	0x6E :  {
						0x00 : {'offset':608,'bit':7,'bits':8,'parameter':'TFX Effect Type','range':(0,0xAB),'bias':0,'step':None,'mode':0x04,'id':0x6E,'subid':0x00},
						0x01 : {'offset':609,'bit':6,'bits':1,'parameter':'TFX On/Off','range':{0:'Off',1:'On'},'bias':0,'step':None,'mode':0x04,'id':0x6E,'subid':0x01},
						0x02 : {'offset':612,'bit':7,'bits':8,'parameter':'TFX Master Level','range':(0,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x6E,'subid':0x02},
					},
	0x6F :  {
						# Total Effect Parameter Structure
						0x00 : {'offset':544,'bit':7,'bits':8*64,'parameter':'TFX Effect Parameter Structure','range':None,'bias':0,'step':None,'mode':0x04,'id':0x6F,'subid':0xFF},
					},
	0xFF :  {
						# No message for these
						0x00 : {'offset':0,'bit':7,'bits':8*24,'parameter':'Song Name','range':(0x20,0x7F),'bias':0,'step':None,'mode':0x04,'id':0x7F,'subid':0x00},
					},
}

def list_table10_members():
	current = 0
	table10keys = [k for k in mode4param_dict if k not in (0x1B,0x1C,0x1D,0x1E,0x1F,0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2A,0x3B)]
#	l1 = [mode4param_dict[k1][k2] for k1 in table10keys for k2 in mode4param_dict[k1].keys]
	l = [(p['offset'],p['bit'],p) for p in [mode4param_dict[k1][k2] for k1 in table10keys for k2 in mode4param_dict[k1].keys()]]
	l.sort()
	for offset,bit,p in l:
		bits = p['bits']
		start = offset*8+1+bit-min(bits,8)
		start_bit = start % 8
		if start<current:
			print 'Error:',current,start,offset,p['parameter']
#			return
		while start > current:
			reserved = start - current
			current_bit = current % 8
			roffset = current >> 3
#			print current,start,roffset,current_bit,start_bit
			if current_bit == 0:
				if reserved >= 8:
					reserved_bits = 8
					print "\t\tMember('_reserved%04d',(%d,%d),%d,None,'Reserved',None)," % (roffset,roffset,7,reserved_bits)
					current += reserved_bits
				else:
					reserved_bits = start_bit
					print "\t\tMember('_reserved%04d_%d',(%d,%d),%d,None,'Reserved',None)," % (roffset,start_bit-1,roffset,start_bit-1,reserved_bits)
					current += reserved_bits
			elif start_bit == 0 or reserved >= 8:
				reserved_bits = 8 - current_bit
				print "\t\tMember('_reserved%04d_%d',(%d,%d),%d,None,'Reserved',None)," % (roffset,7,roffset,7,reserved_bits)
				current += reserved_bits
			else:
				reserved_bits = start_bit - current_bit
				print "\t\tMember('_reserved%04d_%d',(%d,%d),%d,None,'Reserved',None)," % (roffset,start_bit-1,roffset,start_bit-1,reserved_bits)
				current += reserved_bits
				
					
		rng = p['range']
		rngstr = '???'
		if isinstance(rng,tuple):
			if rng[0] >= 0:
				if rng[1] < 256:
					rngstr = '(0x%02X,0x%02X)' % rng
				elif rng[1] < 4096:
					rngstr = '(0x%03X,0x%03X)' % rng
				else:
					rngstr = '(0x%04X,0x%04X)' % rng
			else:
				if rng[1] < 256:
					rngstr = '(-0x%02X,0x%02X)' % (-rng[0],rng[1])
				elif rng[1] < 4096:
					rngstr = '(-0x%03X,0x%03X)' % (-rng[0],rng[1])
				else:
					rngstr = '(-0x%04X,0x%04X)' % (-rng[0],rng[1])
		elif isinstance(rng,dict):
			keys = rng.keys()
			keys.sort()
			rngstr = '{%s}' % (','.join(['%d:%s' % (k,repr(rng[k])) for k in keys]))
		else:
			rngstr = 'None'
		if bits % 8:
			print "\t\tMember('o%04d_%d',(%d,%d),%d,%s,'%s',(4,0x%02X,0x%02X),None)," % (offset,bit,offset,bit,bits,rngstr,p['parameter'],p['id'],p['subid'])
		else:
			print "\t\tMember('o%04d',(%d,%d),%d,%s,'%s',(4,0x%02X,0x%02X),None)," % (offset,offset,bit,bits,rngstr,p['parameter'],p['id'],p['subid'])
		current += bits
	
if __name__ == '__main__':
	list_table10_members()
